/* CellDataFunctionHelper.c generated by valac 0.56.1, the Vala compiler
 * generated from CellDataFunctionHelper.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>,
 *              Victor Eduardo <victoreduardm@gmail.com>
 */

#define _XOPEN_SOURCE

#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "io.elementary.music-core.h"
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <granite.h>
#include <time.h>
#include <gobject/gvaluecollector.h>

#define MUSIC_CELL_DATA_FUNCTION_HELPER_NOT_AVAILABLE ""
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define MUSIC_TYPE_CELL_DATA_FUNCTION_HELPER (music_cell_data_function_helper_get_type ())
#define MUSIC_CELL_DATA_FUNCTION_HELPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_CELL_DATA_FUNCTION_HELPER, MusicCellDataFunctionHelper))
#define MUSIC_CELL_DATA_FUNCTION_HELPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_CELL_DATA_FUNCTION_HELPER, MusicCellDataFunctionHelperClass))
#define MUSIC_IS_CELL_DATA_FUNCTION_HELPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_CELL_DATA_FUNCTION_HELPER))
#define MUSIC_IS_CELL_DATA_FUNCTION_HELPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_CELL_DATA_FUNCTION_HELPER))
#define MUSIC_CELL_DATA_FUNCTION_HELPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_CELL_DATA_FUNCTION_HELPER, MusicCellDataFunctionHelperClass))

typedef struct _MusicCellDataFunctionHelper MusicCellDataFunctionHelper;
typedef struct _MusicCellDataFunctionHelperClass MusicCellDataFunctionHelperClass;
typedef struct _MusicCellDataFunctionHelperPrivate MusicCellDataFunctionHelperPrivate;

#define MUSIC_TYPE_GENERIC_LIST (music_generic_list_get_type ())
#define MUSIC_GENERIC_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_GENERIC_LIST, MusicGenericList))
#define MUSIC_GENERIC_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_GENERIC_LIST, MusicGenericListClass))
#define MUSIC_IS_GENERIC_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_GENERIC_LIST))
#define MUSIC_IS_GENERIC_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_GENERIC_LIST))
#define MUSIC_GENERIC_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_GENERIC_LIST, MusicGenericListClass))

typedef struct _MusicGenericList MusicGenericList;
typedef struct _MusicGenericListClass MusicGenericListClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef enum  {
	MUSIC_LIST_COLUMN_ICON = 0,
	MUSIC_LIST_COLUMN_NUMBER,
	MUSIC_LIST_COLUMN_TRACK,
	MUSIC_LIST_COLUMN_TITLE,
	MUSIC_LIST_COLUMN_LENGTH,
	MUSIC_LIST_COLUMN_ARTIST,
	MUSIC_LIST_COLUMN_ALBUM,
	MUSIC_LIST_COLUMN_ALBUM_ARTIST,
	MUSIC_LIST_COLUMN_COMPOSER,
	MUSIC_LIST_COLUMN_GENRE,
	MUSIC_LIST_COLUMN_YEAR,
	MUSIC_LIST_COLUMN_GROUPING,
	MUSIC_LIST_COLUMN_BITRATE,
	MUSIC_LIST_COLUMN_RATING,
	MUSIC_LIST_COLUMN_PLAY_COUNT,
	MUSIC_LIST_COLUMN_SKIP_COUNT,
	MUSIC_LIST_COLUMN_DATE_ADDED,
	MUSIC_LIST_COLUMN_LAST_PLAYED,
	MUSIC_LIST_COLUMN_BPM,
	MUSIC_LIST_COLUMN_FILE_LOCATION,
	MUSIC_LIST_COLUMN_FILE_SIZE,
	MUSIC_LIST_COLUMN_N_COLUMNS
} MusicListColumn;

#define MUSIC_TYPE_LIST_COLUMN (music_list_column_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))

#define MUSIC_TYPE_RATING_CELL_RENDERER (music_rating_cell_renderer_get_type ())
#define MUSIC_RATING_CELL_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_RATING_CELL_RENDERER, MusicRatingCellRenderer))
#define MUSIC_RATING_CELL_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_RATING_CELL_RENDERER, MusicRatingCellRendererClass))
#define MUSIC_IS_RATING_CELL_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_RATING_CELL_RENDERER))
#define MUSIC_IS_RATING_CELL_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_RATING_CELL_RENDERER))
#define MUSIC_RATING_CELL_RENDERER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_RATING_CELL_RENDERER, MusicRatingCellRendererClass))

typedef struct _MusicRatingCellRenderer MusicRatingCellRenderer;
typedef struct _MusicRatingCellRendererClass MusicRatingCellRendererClass;
typedef struct _MusicParamSpecCellDataFunctionHelper MusicParamSpecCellDataFunctionHelper;

struct _MusicCellDataFunctionHelper {
	GTypeInstance parent_instance;
	volatile int ref_count;
	MusicCellDataFunctionHelperPrivate * priv;
};

struct _MusicCellDataFunctionHelperClass {
	GTypeClass parent_class;
	void (*finalize) (MusicCellDataFunctionHelper *self);
};

struct _MusicCellDataFunctionHelperPrivate {
	MusicGenericList* view;
};

struct _MusicParamSpecCellDataFunctionHelper {
	GParamSpec parent_instance;
};

static gint MusicCellDataFunctionHelper_private_offset;
static gpointer music_cell_data_function_helper_parent_class = NULL;

VALA_EXTERN gpointer music_cell_data_function_helper_ref (gpointer instance);
VALA_EXTERN void music_cell_data_function_helper_unref (gpointer instance);
VALA_EXTERN GParamSpec* music_param_spec_cell_data_function_helper (const gchar* name,
                                                        const gchar* nick,
                                                        const gchar* blurb,
                                                        GType object_type,
                                                        GParamFlags flags);
VALA_EXTERN void music_value_set_cell_data_function_helper (GValue* value,
                                                gpointer v_object);
VALA_EXTERN void music_value_take_cell_data_function_helper (GValue* value,
                                                 gpointer v_object);
VALA_EXTERN gpointer music_value_get_cell_data_function_helper (const GValue* value);
VALA_EXTERN GType music_cell_data_function_helper_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicCellDataFunctionHelper, music_cell_data_function_helper_unref)
VALA_EXTERN GType music_generic_list_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicGenericList, g_object_unref)
VALA_EXTERN MusicCellDataFunctionHelper* music_cell_data_function_helper_new (MusicGenericList* view);
VALA_EXTERN MusicCellDataFunctionHelper* music_cell_data_function_helper_construct (GType object_type,
                                                                        MusicGenericList* view);
VALA_EXTERN void music_cell_data_function_helper_icon_func (MusicCellDataFunctionHelper* self,
                                                GtkCellLayout* layout,
                                                GtkCellRenderer* renderer,
                                                GtkTreeModel* model,
                                                GtkTreeIter* iter);
VALA_EXTERN MusicMedia* music_generic_list_get_object_from_index (MusicGenericList* self,
                                                      gint index);
VALA_EXTERN gint music_generic_list_get_index_from_iter (GtkTreeIter* iter);
VALA_EXTERN GType music_list_column_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void music_cell_data_function_helper_spinner_func (MusicCellDataFunctionHelper* self,
                                                   GtkCellLayout* layout,
                                                   GtkCellRenderer* renderer,
                                                   GtkTreeModel* model,
                                                   GtkTreeIter* iter);
VALA_EXTERN void music_cell_data_function_helper_file_size_func (GtkCellLayout* layout,
                                                     GtkCellRenderer* cell,
                                                     GtkTreeModel* tree_model,
                                                     GtkTreeIter* iter);
VALA_EXTERN void music_cell_data_function_helper_number_func (GtkCellLayout* layout,
                                                  GtkCellRenderer* cell,
                                                  GtkTreeModel* tree_model,
                                                  GtkTreeIter* iter);
static inline void music_cell_data_function_helper_set_renderer_number (GtkCellRendererText* renderer,
                                                          GtkTreeIter* iter,
                                                          GtkTreeModel* model,
                                                          gint column);
VALA_EXTERN void music_cell_data_function_helper_intelligent_func (GtkCellLayout* layout,
                                                       GtkCellRenderer* cell,
                                                       GtkTreeModel* tree_model,
                                                       GtkTreeIter* iter);
VALA_EXTERN void music_cell_data_function_helper_string_func (GtkCellLayout* layout,
                                                  GtkCellRenderer* cell,
                                                  GtkTreeModel* tree_model,
                                                  GtkTreeIter* iter);
VALA_EXTERN void music_cell_data_function_helper_bitrate_func (GtkCellLayout* layout,
                                                   GtkCellRenderer* cell,
                                                   GtkTreeModel* tree_model,
                                                   GtkTreeIter* iter);
VALA_EXTERN void music_cell_data_function_helper_length_func (GtkCellLayout* layout,
                                                  GtkCellRenderer* cell,
                                                  GtkTreeModel* tree_model,
                                                  GtkTreeIter* iter);
VALA_EXTERN void music_cell_data_function_helper_date_func (GtkCellLayout* layout,
                                                GtkCellRenderer* cell,
                                                GtkTreeModel* tree_model,
                                                GtkTreeIter* iter);
VALA_EXTERN gchar* music_cell_data_function_helper_get_date_string (guint n);
VALA_EXTERN void music_cell_data_function_helper_rating_func (GtkCellLayout* layout,
                                                  GtkCellRenderer* cell,
                                                  GtkTreeModel* tree_model,
                                                  GtkTreeIter* iter);
VALA_EXTERN GType music_rating_cell_renderer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicRatingCellRenderer, g_object_unref)
VALA_EXTERN void music_rating_cell_renderer_set_rating (MusicRatingCellRenderer* self,
                                            guint value);
static void music_cell_data_function_helper_finalize (MusicCellDataFunctionHelper * obj);
static GType music_cell_data_function_helper_get_type_once (void);

static inline gpointer
music_cell_data_function_helper_get_instance_private (MusicCellDataFunctionHelper* self)
{
	return G_STRUCT_MEMBER_P (self, MusicCellDataFunctionHelper_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

MusicCellDataFunctionHelper*
music_cell_data_function_helper_construct (GType object_type,
                                           MusicGenericList* view)
{
	MusicCellDataFunctionHelper* self = NULL;
	MusicGenericList* _tmp0_;
	g_return_val_if_fail (view != NULL, NULL);
	self = (MusicCellDataFunctionHelper*) g_type_create_instance (object_type);
	_tmp0_ = _g_object_ref0 (view);
	_g_object_unref0 (self->priv->view);
	self->priv->view = _tmp0_;
	return self;
}

MusicCellDataFunctionHelper*
music_cell_data_function_helper_new (MusicGenericList* view)
{
	return music_cell_data_function_helper_construct (MUSIC_TYPE_CELL_DATA_FUNCTION_HELPER, view);
}

/**
     * For unique icon on each row
     */
void
music_cell_data_function_helper_icon_func (MusicCellDataFunctionHelper* self,
                                           GtkCellLayout* layout,
                                           GtkCellRenderer* renderer,
                                           GtkTreeModel* model,
                                           GtkTreeIter* iter)
{
	MusicMedia* m = NULL;
	MusicGenericList* _tmp0_;
	GtkTreeIter _tmp1_;
	MusicMedia* _tmp2_;
	MusicMedia* _tmp3_;
	MusicMedia* _tmp4_;
	MusicMedia* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	GtkCellRendererPixbuf* image_renderer = NULL;
	GtkCellRendererPixbuf* _tmp8_;
	GtkCellRendererPixbuf* _tmp9_;
	gboolean _tmp10_;
	gboolean _tmp11_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (layout != NULL);
	g_return_if_fail (renderer != NULL);
	g_return_if_fail (model != NULL);
	g_return_if_fail (iter != NULL);
	_tmp0_ = self->priv->view;
	_tmp1_ = *iter;
	_tmp2_ = music_generic_list_get_object_from_index (_tmp0_, music_generic_list_get_index_from_iter (&_tmp1_));
	_tmp3_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, MUSIC_TYPE_MEDIA) ? ((MusicMedia*) _tmp2_) : NULL;
	if (_tmp3_ == NULL) {
		_g_object_unref0 (_tmp2_);
	}
	m = _tmp3_;
	_tmp4_ = m;
	if (_tmp4_ == NULL) {
		_g_object_unref0 (m);
		return;
	}
	_tmp5_ = m;
	_tmp6_ = music_media_get_show_indicator (_tmp5_);
	_tmp7_ = _tmp6_;
	gtk_cell_renderer_set_visible (renderer, !_tmp7_);
	_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (renderer, gtk_cell_renderer_pixbuf_get_type ()) ? ((GtkCellRendererPixbuf*) renderer) : NULL);
	image_renderer = _tmp8_;
	_tmp9_ = image_renderer;
	g_return_if_fail (_tmp9_ != NULL);
	_tmp10_ = gtk_cell_renderer_get_visible (renderer);
	_tmp11_ = _tmp10_;
	if (_tmp11_) {
		GValue icon = {0};
		GtkTreeIter _tmp12_;
		GValue _tmp13_ = {0};
		GtkCellRendererPixbuf* _tmp14_;
		GObject* _tmp15_;
		_tmp12_ = *iter;
		gtk_tree_model_get_value (model, &_tmp12_, (gint) MUSIC_LIST_COLUMN_ICON, &_tmp13_);
		G_IS_VALUE (&icon) ? (g_value_unset (&icon), NULL) : NULL;
		icon = _tmp13_;
		_tmp14_ = image_renderer;
		_tmp15_ = g_value_get_object (&icon);
		g_object_set (_tmp14_, "gicon", G_TYPE_CHECK_INSTANCE_TYPE (_tmp15_, g_icon_get_type ()) ? ((GIcon*) _tmp15_) : NULL, NULL);
		G_IS_VALUE (&icon) ? (g_value_unset (&icon), NULL) : NULL;
	}
	_g_object_unref0 (image_renderer);
	_g_object_unref0 (m);
}

void
music_cell_data_function_helper_spinner_func (MusicCellDataFunctionHelper* self,
                                              GtkCellLayout* layout,
                                              GtkCellRenderer* renderer,
                                              GtkTreeModel* model,
                                              GtkTreeIter* iter)
{
	MusicMedia* m = NULL;
	MusicGenericList* _tmp0_;
	GtkTreeIter _tmp1_;
	MusicMedia* _tmp2_;
	MusicMedia* _tmp3_;
	MusicMedia* _tmp4_;
	MusicMedia* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	GtkCellRendererSpinner* spinner_renderer = NULL;
	GtkCellRendererSpinner* _tmp8_;
	GtkCellRendererSpinner* _tmp9_;
	GtkCellRendererSpinner* _tmp10_;
	GtkCellRendererSpinner* _tmp11_;
	guint _tmp12_;
	guint _tmp13_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (layout != NULL);
	g_return_if_fail (renderer != NULL);
	g_return_if_fail (model != NULL);
	g_return_if_fail (iter != NULL);
	_tmp0_ = self->priv->view;
	_tmp1_ = *iter;
	_tmp2_ = music_generic_list_get_object_from_index (_tmp0_, music_generic_list_get_index_from_iter (&_tmp1_));
	_tmp3_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, MUSIC_TYPE_MEDIA) ? ((MusicMedia*) _tmp2_) : NULL;
	if (_tmp3_ == NULL) {
		_g_object_unref0 (_tmp2_);
	}
	m = _tmp3_;
	_tmp4_ = m;
	if (_tmp4_ == NULL) {
		_g_object_unref0 (m);
		return;
	}
	_tmp5_ = m;
	_tmp6_ = music_media_get_show_indicator (_tmp5_);
	_tmp7_ = _tmp6_;
	gtk_cell_renderer_set_visible (renderer, _tmp7_);
	_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (renderer, gtk_cell_renderer_spinner_get_type ()) ? ((GtkCellRendererSpinner*) renderer) : NULL);
	spinner_renderer = _tmp8_;
	_tmp9_ = spinner_renderer;
	g_return_if_fail (_tmp9_ != NULL);
	_tmp10_ = spinner_renderer;
	g_object_set (_tmp10_, "active", TRUE, NULL);
	_tmp11_ = spinner_renderer;
	g_object_get (_tmp11_, "pulse", &_tmp12_, NULL);
	_tmp13_ = _tmp12_;
	g_object_set (_tmp11_, "pulse", _tmp13_ + 1, NULL);
	_g_object_unref0 (spinner_renderer);
	_g_object_unref0 (m);
}

inline void
music_cell_data_function_helper_file_size_func (GtkCellLayout* layout,
                                                GtkCellRenderer* cell,
                                                GtkTreeModel* tree_model,
                                                GtkTreeIter* iter)
{
	GValue val = {0};
	GtkTreeIter _tmp0_;
	GValue _tmp1_ = {0};
	guint64 n = 0ULL;
	gchar* _tmp2_ = NULL;
	g_return_if_fail (layout != NULL);
	g_return_if_fail (cell != NULL);
	g_return_if_fail (tree_model != NULL);
	g_return_if_fail (iter != NULL);
	_tmp0_ = *iter;
	gtk_tree_model_get_value (tree_model, &_tmp0_, (gint) MUSIC_LIST_COLUMN_FILE_SIZE, &_tmp1_);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	val = _tmp1_;
	n = g_value_get_uint64 (&val);
	if (n > ((guint64) 0)) {
		gchar* _tmp3_;
		_tmp3_ = g_format_size_full (n, G_FORMAT_SIZE_DEFAULT);
		_g_free0 (_tmp2_);
		_tmp2_ = _tmp3_;
	} else {
		gchar* _tmp4_;
		_tmp4_ = g_strdup (MUSIC_CELL_DATA_FUNCTION_HELPER_NOT_AVAILABLE);
		_g_free0 (_tmp2_);
		_tmp2_ = _tmp4_;
	}
	g_object_set (G_TYPE_CHECK_INSTANCE_CAST (cell, gtk_cell_renderer_text_get_type (), GtkCellRendererText), "text", _tmp2_, NULL);
	_g_free0 (_tmp2_);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
}

inline void
music_cell_data_function_helper_number_func (GtkCellLayout* layout,
                                             GtkCellRenderer* cell,
                                             GtkTreeModel* tree_model,
                                             GtkTreeIter* iter)
{
	GtkTreeIter _tmp0_;
	g_return_if_fail (layout != NULL);
	g_return_if_fail (cell != NULL);
	g_return_if_fail (tree_model != NULL);
	g_return_if_fail (iter != NULL);
	_tmp0_ = *iter;
	music_cell_data_function_helper_set_renderer_number (G_TYPE_CHECK_INSTANCE_TYPE (cell, gtk_cell_renderer_text_get_type ()) ? ((GtkCellRendererText*) cell) : NULL, &_tmp0_, tree_model, (gint) MUSIC_LIST_COLUMN_NUMBER);
}

inline void
music_cell_data_function_helper_intelligent_func (GtkCellLayout* layout,
                                                  GtkCellRenderer* cell,
                                                  GtkTreeModel* tree_model,
                                                  GtkTreeIter* iter)
{
	GtkTreeViewColumn* tvc = NULL;
	GtkTreeViewColumn* _tmp0_;
	GtkTreeViewColumn* _tmp1_;
	gint column = 0;
	GtkTreeViewColumn* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	GtkTreeIter _tmp5_;
	g_return_if_fail (layout != NULL);
	g_return_if_fail (cell != NULL);
	g_return_if_fail (tree_model != NULL);
	g_return_if_fail (iter != NULL);
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (layout, gtk_tree_view_column_get_type ()) ? ((GtkTreeViewColumn*) layout) : NULL);
	tvc = _tmp0_;
	_tmp1_ = tvc;
	g_return_if_fail (_tmp1_ != NULL);
	_tmp2_ = tvc;
	_tmp3_ = gtk_tree_view_column_get_sort_column_id (_tmp2_);
	_tmp4_ = _tmp3_;
	column = _tmp4_;
	if (column < 0) {
		_g_object_unref0 (tvc);
		return;
	}
	_tmp5_ = *iter;
	music_cell_data_function_helper_set_renderer_number (G_TYPE_CHECK_INSTANCE_TYPE (cell, gtk_cell_renderer_text_get_type ()) ? ((GtkCellRendererText*) cell) : NULL, &_tmp5_, tree_model, column);
	_g_object_unref0 (tvc);
}

static inline void
music_cell_data_function_helper_set_renderer_number (GtkCellRendererText* renderer,
                                                     GtkTreeIter* iter,
                                                     GtkTreeModel* model,
                                                     gint column)
{
	GValue val = {0};
	GtkTreeIter _tmp0_;
	GValue _tmp1_ = {0};
	guint n = 0U;
	gchar* _tmp2_ = NULL;
	g_return_if_fail (renderer != NULL);
	g_return_if_fail (iter != NULL);
	g_return_if_fail (model != NULL);
	_tmp0_ = *iter;
	gtk_tree_model_get_value (model, &_tmp0_, column, &_tmp1_);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	val = _tmp1_;
	n = g_value_get_uint (&val);
	if (n > ((guint) 0)) {
		gchar* _tmp3_;
		_tmp3_ = g_strdup_printf ("%u", n);
		_g_free0 (_tmp2_);
		_tmp2_ = _tmp3_;
	} else {
		gchar* _tmp4_;
		_tmp4_ = g_strdup ("");
		_g_free0 (_tmp2_);
		_tmp2_ = _tmp4_;
	}
	g_object_set (renderer, "text", _tmp2_, NULL);
	_g_free0 (_tmp2_);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
}

inline void
music_cell_data_function_helper_string_func (GtkCellLayout* layout,
                                             GtkCellRenderer* cell,
                                             GtkTreeModel* tree_model,
                                             GtkTreeIter* iter)
{
	GtkTreeViewColumn* tvc = NULL;
	GtkTreeViewColumn* _tmp0_;
	GtkTreeViewColumn* _tmp1_;
	gint column = 0;
	GtkTreeViewColumn* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	GValue val = {0};
	GtkTreeIter _tmp5_;
	GValue _tmp6_ = {0};
	const gchar* _tmp7_;
	g_return_if_fail (layout != NULL);
	g_return_if_fail (cell != NULL);
	g_return_if_fail (tree_model != NULL);
	g_return_if_fail (iter != NULL);
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (layout, gtk_tree_view_column_get_type ()) ? ((GtkTreeViewColumn*) layout) : NULL);
	tvc = _tmp0_;
	_tmp1_ = tvc;
	g_return_if_fail (_tmp1_ != NULL);
	_tmp2_ = tvc;
	_tmp3_ = gtk_tree_view_column_get_sort_column_id (_tmp2_);
	_tmp4_ = _tmp3_;
	column = _tmp4_;
	if (column < 0) {
		_g_object_unref0 (tvc);
		return;
	}
	_tmp5_ = *iter;
	gtk_tree_model_get_value (tree_model, &_tmp5_, column, &_tmp6_);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	val = _tmp6_;
	_tmp7_ = g_value_get_string (&val);
	g_object_set (G_TYPE_CHECK_INSTANCE_CAST (cell, gtk_cell_renderer_text_get_type (), GtkCellRendererText), "text", _tmp7_, NULL);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	_g_object_unref0 (tvc);
}

inline void
music_cell_data_function_helper_bitrate_func (GtkCellLayout* layout,
                                              GtkCellRenderer* cell,
                                              GtkTreeModel* tree_model,
                                              GtkTreeIter* iter)
{
	GValue val = {0};
	GtkTreeIter _tmp0_;
	GValue _tmp1_ = {0};
	GtkCellRendererText* text_cell = NULL;
	GtkCellRendererText* _tmp2_;
	guint n = 0U;
	gchar* _tmp3_ = NULL;
	GtkCellRendererText* _tmp6_;
	g_return_if_fail (layout != NULL);
	g_return_if_fail (cell != NULL);
	g_return_if_fail (tree_model != NULL);
	g_return_if_fail (iter != NULL);
	_tmp0_ = *iter;
	gtk_tree_model_get_value (tree_model, &_tmp0_, (gint) MUSIC_LIST_COLUMN_BITRATE, &_tmp1_);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	val = _tmp1_;
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (cell, gtk_cell_renderer_text_get_type ()) ? ((GtkCellRendererText*) cell) : NULL);
	text_cell = _tmp2_;
	n = g_value_get_uint (&val);
	if (n <= ((guint) 0)) {
		gchar* _tmp4_;
		_tmp4_ = g_strdup (MUSIC_CELL_DATA_FUNCTION_HELPER_NOT_AVAILABLE);
		_g_free0 (_tmp3_);
		_tmp3_ = _tmp4_;
	} else {
		gchar* _tmp5_;
		_tmp5_ = g_strdup_printf (_ ("%u kbps"), n);
		_g_free0 (_tmp3_);
		_tmp3_ = _tmp5_;
	}
	_tmp6_ = text_cell;
	g_object_set (_tmp6_, "text", _tmp3_, NULL);
	_g_free0 (_tmp3_);
	_g_object_unref0 (text_cell);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
}

inline void
music_cell_data_function_helper_length_func (GtkCellLayout* layout,
                                             GtkCellRenderer* cell,
                                             GtkTreeModel* tree_model,
                                             GtkTreeIter* iter)
{
	GValue val = {0};
	GtkTreeIter _tmp0_;
	GValue _tmp1_ = {0};
	guint ms = 0U;
	GtkCellRendererText* text_cell = NULL;
	GtkCellRendererText* _tmp2_;
	gchar* _tmp3_ = NULL;
	GtkCellRendererText* _tmp6_;
	g_return_if_fail (layout != NULL);
	g_return_if_fail (cell != NULL);
	g_return_if_fail (tree_model != NULL);
	g_return_if_fail (iter != NULL);
	_tmp0_ = *iter;
	gtk_tree_model_get_value (tree_model, &_tmp0_, (gint) MUSIC_LIST_COLUMN_LENGTH, &_tmp1_);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	val = _tmp1_;
	ms = g_value_get_uint (&val);
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (cell, gtk_cell_renderer_text_get_type ()) ? ((GtkCellRendererText*) cell) : NULL);
	text_cell = _tmp2_;
	if (ms <= ((guint) 0)) {
		gchar* _tmp4_;
		_tmp4_ = g_strdup (MUSIC_CELL_DATA_FUNCTION_HELPER_NOT_AVAILABLE);
		_g_free0 (_tmp3_);
		_tmp3_ = _tmp4_;
	} else {
		gchar* _tmp5_;
		_tmp5_ = granite_date_time_seconds_to_time ((gint) (ms / MUSIC_TIME_UTILS_MILI_INV));
		_g_free0 (_tmp3_);
		_tmp3_ = _tmp5_;
	}
	_tmp6_ = text_cell;
	g_object_set (_tmp6_, "text", _tmp3_, NULL);
	_g_free0 (_tmp3_);
	_g_object_unref0 (text_cell);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
}

inline void
music_cell_data_function_helper_date_func (GtkCellLayout* layout,
                                           GtkCellRenderer* cell,
                                           GtkTreeModel* tree_model,
                                           GtkTreeIter* iter)
{
	GValue val = {0};
	GtkTreeIter _tmp0_;
	GValue _tmp1_ = {0};
	GtkCellRendererText* text_cell = NULL;
	GtkCellRendererText* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	g_return_if_fail (layout != NULL);
	g_return_if_fail (cell != NULL);
	g_return_if_fail (tree_model != NULL);
	g_return_if_fail (iter != NULL);
	_tmp0_ = *iter;
	gtk_tree_model_get_value (tree_model, &_tmp0_, (gint) MUSIC_LIST_COLUMN_DATE_ADDED, &_tmp1_);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	val = _tmp1_;
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (cell, gtk_cell_renderer_text_get_type ()) ? ((GtkCellRendererText*) cell) : NULL);
	text_cell = _tmp2_;
	_tmp3_ = music_cell_data_function_helper_get_date_string (g_value_get_uint (&val));
	_tmp4_ = _tmp3_;
	g_object_set (text_cell, "text", _tmp4_, NULL);
	_g_free0 (_tmp4_);
	_g_object_unref0 (text_cell);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
}

static void
g_time_local (time_t time,
              struct tm* result)
{
	struct tm _result_ = {0};
	struct tm _tmp0_ = {0};
	localtime_r (&time, &_tmp0_);
	_result_ = _tmp0_;
	*result = _result_;
	return;
}

inline gchar*
music_cell_data_function_helper_get_date_string (guint n)
{
	gchar* _tmp0_ = NULL;
	gchar* result;
	if (n == ((guint) 0)) {
		gchar* _tmp1_;
		_tmp1_ = g_strdup (_ ("Never"));
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp1_;
	} else {
		struct tm _tmp2_ = {0};
		gchar* _tmp3_;
		g_time_local ((time_t) n, &_tmp2_);
		_tmp3_ = music_time_utils_pretty_timestamp_from_time (&_tmp2_);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp3_;
	}
	result = _tmp0_;
	return result;
}

inline void
music_cell_data_function_helper_rating_func (GtkCellLayout* layout,
                                             GtkCellRenderer* cell,
                                             GtkTreeModel* tree_model,
                                             GtkTreeIter* iter)
{
	GValue val = {0};
	GtkTreeIter _tmp0_;
	GValue _tmp1_ = {0};
	MusicRatingCellRenderer* rating_cell = NULL;
	MusicRatingCellRenderer* _tmp2_;
	g_return_if_fail (layout != NULL);
	g_return_if_fail (cell != NULL);
	g_return_if_fail (tree_model != NULL);
	g_return_if_fail (iter != NULL);
	_tmp0_ = *iter;
	gtk_tree_model_get_value (tree_model, &_tmp0_, (gint) MUSIC_LIST_COLUMN_RATING, &_tmp1_);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	val = _tmp1_;
	_tmp2_ = _g_object_ref0 (MUSIC_IS_RATING_CELL_RENDERER (cell) ? ((MusicRatingCellRenderer*) cell) : NULL);
	rating_cell = _tmp2_;
	music_rating_cell_renderer_set_rating (rating_cell, g_value_get_uint (&val));
	_g_object_unref0 (rating_cell);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
}

static void
music_value_cell_data_function_helper_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
music_value_cell_data_function_helper_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		music_cell_data_function_helper_unref (value->data[0].v_pointer);
	}
}

static void
music_value_cell_data_function_helper_copy_value (const GValue* src_value,
                                                  GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = music_cell_data_function_helper_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
music_value_cell_data_function_helper_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
music_value_cell_data_function_helper_collect_value (GValue* value,
                                                     guint n_collect_values,
                                                     GTypeCValue* collect_values,
                                                     guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		MusicCellDataFunctionHelper * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = music_cell_data_function_helper_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
music_value_cell_data_function_helper_lcopy_value (const GValue* value,
                                                   guint n_collect_values,
                                                   GTypeCValue* collect_values,
                                                   guint collect_flags)
{
	MusicCellDataFunctionHelper ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = music_cell_data_function_helper_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
music_param_spec_cell_data_function_helper (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags)
{
	MusicParamSpecCellDataFunctionHelper* spec;
	g_return_val_if_fail (g_type_is_a (object_type, MUSIC_TYPE_CELL_DATA_FUNCTION_HELPER), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
music_value_get_cell_data_function_helper (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, MUSIC_TYPE_CELL_DATA_FUNCTION_HELPER), NULL);
	return value->data[0].v_pointer;
}

void
music_value_set_cell_data_function_helper (GValue* value,
                                           gpointer v_object)
{
	MusicCellDataFunctionHelper * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, MUSIC_TYPE_CELL_DATA_FUNCTION_HELPER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, MUSIC_TYPE_CELL_DATA_FUNCTION_HELPER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		music_cell_data_function_helper_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		music_cell_data_function_helper_unref (old);
	}
}

void
music_value_take_cell_data_function_helper (GValue* value,
                                            gpointer v_object)
{
	MusicCellDataFunctionHelper * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, MUSIC_TYPE_CELL_DATA_FUNCTION_HELPER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, MUSIC_TYPE_CELL_DATA_FUNCTION_HELPER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		music_cell_data_function_helper_unref (old);
	}
}

static void
music_cell_data_function_helper_class_init (MusicCellDataFunctionHelperClass * klass,
                                            gpointer klass_data)
{
	music_cell_data_function_helper_parent_class = g_type_class_peek_parent (klass);
	((MusicCellDataFunctionHelperClass *) klass)->finalize = music_cell_data_function_helper_finalize;
	g_type_class_adjust_private_offset (klass, &MusicCellDataFunctionHelper_private_offset);
}

static void
music_cell_data_function_helper_instance_init (MusicCellDataFunctionHelper * self,
                                               gpointer klass)
{
	self->priv = music_cell_data_function_helper_get_instance_private (self);
	self->ref_count = 1;
}

static void
music_cell_data_function_helper_finalize (MusicCellDataFunctionHelper * obj)
{
	MusicCellDataFunctionHelper * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_CELL_DATA_FUNCTION_HELPER, MusicCellDataFunctionHelper);
	g_signal_handlers_destroy (self);
	_g_object_unref0 (self->priv->view);
}

static GType
music_cell_data_function_helper_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { music_value_cell_data_function_helper_init, music_value_cell_data_function_helper_free_value, music_value_cell_data_function_helper_copy_value, music_value_cell_data_function_helper_peek_pointer, "p", music_value_cell_data_function_helper_collect_value, "p", music_value_cell_data_function_helper_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (MusicCellDataFunctionHelperClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_cell_data_function_helper_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicCellDataFunctionHelper), 0, (GInstanceInitFunc) music_cell_data_function_helper_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType music_cell_data_function_helper_type_id;
	music_cell_data_function_helper_type_id = g_type_register_fundamental (g_type_fundamental_next (), "MusicCellDataFunctionHelper", &g_define_type_info, &g_define_type_fundamental_info, 0);
	MusicCellDataFunctionHelper_private_offset = g_type_add_instance_private (music_cell_data_function_helper_type_id, sizeof (MusicCellDataFunctionHelperPrivate));
	return music_cell_data_function_helper_type_id;
}

GType
music_cell_data_function_helper_get_type (void)
{
	static volatile gsize music_cell_data_function_helper_type_id__once = 0;
	if (g_once_init_enter (&music_cell_data_function_helper_type_id__once)) {
		GType music_cell_data_function_helper_type_id;
		music_cell_data_function_helper_type_id = music_cell_data_function_helper_get_type_once ();
		g_once_init_leave (&music_cell_data_function_helper_type_id__once, music_cell_data_function_helper_type_id);
	}
	return music_cell_data_function_helper_type_id__once;
}

gpointer
music_cell_data_function_helper_ref (gpointer instance)
{
	MusicCellDataFunctionHelper * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
music_cell_data_function_helper_unref (gpointer instance)
{
	MusicCellDataFunctionHelper * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		MUSIC_CELL_DATA_FUNCTION_HELPER_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

