/* ListColumn.c generated by valac 0.56.1, the Vala compiler
 * generated from ListColumn.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Victor Eduardo <victoreduardm@gmail.com>
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include "io.elementary.music-core.h"
#include <gee.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	MUSIC_LIST_COLUMN_ICON = 0,
	MUSIC_LIST_COLUMN_NUMBER,
	MUSIC_LIST_COLUMN_TRACK,
	MUSIC_LIST_COLUMN_TITLE,
	MUSIC_LIST_COLUMN_LENGTH,
	MUSIC_LIST_COLUMN_ARTIST,
	MUSIC_LIST_COLUMN_ALBUM,
	MUSIC_LIST_COLUMN_ALBUM_ARTIST,
	MUSIC_LIST_COLUMN_COMPOSER,
	MUSIC_LIST_COLUMN_GENRE,
	MUSIC_LIST_COLUMN_YEAR,
	MUSIC_LIST_COLUMN_GROUPING,
	MUSIC_LIST_COLUMN_BITRATE,
	MUSIC_LIST_COLUMN_RATING,
	MUSIC_LIST_COLUMN_PLAY_COUNT,
	MUSIC_LIST_COLUMN_SKIP_COUNT,
	MUSIC_LIST_COLUMN_DATE_ADDED,
	MUSIC_LIST_COLUMN_LAST_PLAYED,
	MUSIC_LIST_COLUMN_BPM,
	MUSIC_LIST_COLUMN_FILE_LOCATION,
	MUSIC_LIST_COLUMN_FILE_SIZE,
	MUSIC_LIST_COLUMN_N_COLUMNS
} MusicListColumn;

#define MUSIC_TYPE_LIST_COLUMN (music_list_column_get_type ())

#define MUSIC_TYPE_PLAYBACK_MANAGER (music_playback_manager_get_type ())
#define MUSIC_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManager))
#define MUSIC_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManagerClass))
#define MUSIC_IS_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_PLAYBACK_MANAGER))
#define MUSIC_IS_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_PLAYBACK_MANAGER))
#define MUSIC_PLAYBACK_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManagerClass))

typedef struct _MusicPlaybackManager MusicPlaybackManager;
typedef struct _MusicPlaybackManagerClass MusicPlaybackManagerClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

VALA_EXTERN GType music_list_column_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gchar* music_list_column_to_string (MusicListColumn self);
VALA_EXTERN GType music_list_column_get_data_type (MusicListColumn self);
VALA_EXTERN GValue* music_list_column_get_value_for_media (MusicListColumn self,
                                               MusicMedia* m,
                                               gint media_row_index);
VALA_EXTERN GType music_playback_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicPlaybackManager, g_object_unref)
VALA_EXTERN MusicPlaybackManager* music_app_get_player (void);
VALA_EXTERN MusicMedia* music_playback_manager_get_current_media (MusicPlaybackManager* self);
VALA_EXTERN GeeCollection* music_list_column_get_all (void);

/**
 * Represents every possible column that can go in a media list.
 *
 * New column types must be appended at the end in order to ensure backwards
 * compatibility with older TreeViewSetup representations.
 */
/**
     * Returns a string representation of the column.
     */
gchar*
music_list_column_to_string (MusicListColumn self)
{
	gchar* result;
	switch (self) {
		case MUSIC_LIST_COLUMN_ICON:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup (" ");
			result = _tmp0_;
			return result;
		}
		case MUSIC_LIST_COLUMN_NUMBER:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup (C_ ("List column title", "#"));
			result = _tmp1_;
			return result;
		}
		case MUSIC_LIST_COLUMN_TRACK:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup (C_ ("List column title", "Track"));
			result = _tmp2_;
			return result;
		}
		case MUSIC_LIST_COLUMN_TITLE:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup (C_ ("List column title", "Title"));
			result = _tmp3_;
			return result;
		}
		case MUSIC_LIST_COLUMN_LENGTH:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup (C_ ("List column title", "Length"));
			result = _tmp4_;
			return result;
		}
		case MUSIC_LIST_COLUMN_ARTIST:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup (C_ ("List column title", "Artist"));
			result = _tmp5_;
			return result;
		}
		case MUSIC_LIST_COLUMN_ALBUM:
		{
			gchar* _tmp6_;
			_tmp6_ = g_strdup (C_ ("List column title", "Album"));
			result = _tmp6_;
			return result;
		}
		case MUSIC_LIST_COLUMN_ALBUM_ARTIST:
		{
			gchar* _tmp7_;
			_tmp7_ = g_strdup (C_ ("List column title", "Album Artist"));
			result = _tmp7_;
			return result;
		}
		case MUSIC_LIST_COLUMN_COMPOSER:
		{
			gchar* _tmp8_;
			_tmp8_ = g_strdup (C_ ("List column title", "Composer"));
			result = _tmp8_;
			return result;
		}
		case MUSIC_LIST_COLUMN_GENRE:
		{
			gchar* _tmp9_;
			_tmp9_ = g_strdup (C_ ("List column title", "Genre"));
			result = _tmp9_;
			return result;
		}
		case MUSIC_LIST_COLUMN_YEAR:
		{
			gchar* _tmp10_;
			_tmp10_ = g_strdup (C_ ("List column title", "Year"));
			result = _tmp10_;
			return result;
		}
		case MUSIC_LIST_COLUMN_GROUPING:
		{
			gchar* _tmp11_;
			_tmp11_ = g_strdup (C_ ("List column title", "Grouping"));
			result = _tmp11_;
			return result;
		}
		case MUSIC_LIST_COLUMN_BITRATE:
		{
			gchar* _tmp12_;
			_tmp12_ = g_strdup (C_ ("List column title", "Bitrate"));
			result = _tmp12_;
			return result;
		}
		case MUSIC_LIST_COLUMN_RATING:
		{
			gchar* _tmp13_;
			_tmp13_ = g_strdup (C_ ("List column title", "Rating"));
			result = _tmp13_;
			return result;
		}
		case MUSIC_LIST_COLUMN_PLAY_COUNT:
		{
			gchar* _tmp14_;
			_tmp14_ = g_strdup (C_ ("List column title", "Plays"));
			result = _tmp14_;
			return result;
		}
		case MUSIC_LIST_COLUMN_SKIP_COUNT:
		{
			gchar* _tmp15_;
			_tmp15_ = g_strdup (C_ ("List column title", "Skips"));
			result = _tmp15_;
			return result;
		}
		case MUSIC_LIST_COLUMN_DATE_ADDED:
		{
			gchar* _tmp16_;
			_tmp16_ = g_strdup (C_ ("List column title", "Date Added"));
			result = _tmp16_;
			return result;
		}
		case MUSIC_LIST_COLUMN_LAST_PLAYED:
		{
			gchar* _tmp17_;
			_tmp17_ = g_strdup (C_ ("List column title", "Last Played"));
			result = _tmp17_;
			return result;
		}
		case MUSIC_LIST_COLUMN_BPM:
		{
			gchar* _tmp18_;
			_tmp18_ = g_strdup (C_ ("List column title (beats per minute)", "BPM"));
			result = _tmp18_;
			return result;
		}
		case MUSIC_LIST_COLUMN_FILE_LOCATION:
		{
			gchar* _tmp19_;
			_tmp19_ = g_strdup (C_ ("List column title (file location)", "Location"));
			result = _tmp19_;
			return result;
		}
		case MUSIC_LIST_COLUMN_FILE_SIZE:
		{
			gchar* _tmp20_;
			_tmp20_ = g_strdup (C_ ("List column title", "File Size"));
			result = _tmp20_;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

GType
music_list_column_get_data_type (MusicListColumn self)
{
	GType result;
	switch (self) {
		case MUSIC_LIST_COLUMN_ICON:
		{
			result = g_icon_get_type ();
			return result;
		}
		case MUSIC_LIST_COLUMN_TITLE:
		case MUSIC_LIST_COLUMN_ARTIST:
		case MUSIC_LIST_COLUMN_ALBUM:
		case MUSIC_LIST_COLUMN_ALBUM_ARTIST:
		case MUSIC_LIST_COLUMN_COMPOSER:
		case MUSIC_LIST_COLUMN_GENRE:
		case MUSIC_LIST_COLUMN_GROUPING:
		case MUSIC_LIST_COLUMN_FILE_LOCATION:
		{
			result = G_TYPE_STRING;
			return result;
		}
		case MUSIC_LIST_COLUMN_NUMBER:
		case MUSIC_LIST_COLUMN_TRACK:
		case MUSIC_LIST_COLUMN_LENGTH:
		case MUSIC_LIST_COLUMN_YEAR:
		case MUSIC_LIST_COLUMN_BITRATE:
		case MUSIC_LIST_COLUMN_RATING:
		case MUSIC_LIST_COLUMN_PLAY_COUNT:
		case MUSIC_LIST_COLUMN_SKIP_COUNT:
		case MUSIC_LIST_COLUMN_DATE_ADDED:
		case MUSIC_LIST_COLUMN_LAST_PLAYED:
		case MUSIC_LIST_COLUMN_BPM:
		{
			result = G_TYPE_UINT;
			return result;
		}
		case MUSIC_LIST_COLUMN_FILE_SIZE:
		{
			result = G_TYPE_UINT64;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

/**
     * Returns the value of the data that should be displayed by the column in the view.
     *
     * media_row_index is only necessary for {@link ListColumn.NUMBER}.
     */
static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

GValue*
music_list_column_get_value_for_media (MusicListColumn self,
                                       MusicMedia* m,
                                       gint media_row_index)
{
	GValue* result;
	g_return_val_if_fail (m != NULL, NULL);
	switch (self) {
		case MUSIC_LIST_COLUMN_ICON:
		{
			GIcon* icon = NULL;
			MusicMedia* currently_playing = NULL;
			MusicPlaybackManager* _tmp0_;
			MusicPlaybackManager* _tmp1_;
			MusicMedia* _tmp2_;
			MusicMedia* _tmp3_;
			MusicMedia* _tmp4_;
			gboolean _tmp5_ = FALSE;
			MusicMedia* _tmp6_;
			GValue* _tmp12_ = NULL;
			_tmp0_ = music_app_get_player ();
			_tmp1_ = _tmp0_;
			_tmp2_ = music_playback_manager_get_current_media (_tmp1_);
			_tmp3_ = _tmp2_;
			_tmp4_ = _g_object_ref0 (_tmp3_);
			currently_playing = _tmp4_;
			_tmp6_ = currently_playing;
			if (m == _tmp6_) {
				MusicMedia* _tmp7_;
				_tmp7_ = currently_playing;
				_tmp5_ = _tmp7_ != NULL;
			} else {
				_tmp5_ = FALSE;
			}
			if (_tmp5_) {
				GThemedIcon* _tmp8_;
				_tmp8_ = (GThemedIcon*) g_themed_icon_new ("audio-volume-high-symbolic");
				_g_object_unref0 (icon);
				icon = (GIcon*) _tmp8_;
			} else {
				GIcon* _tmp9_;
				GIcon* _tmp10_;
				GIcon* _tmp11_;
				_tmp9_ = music_media_get_unique_status_image (m);
				_tmp10_ = _tmp9_;
				_tmp11_ = _g_object_ref0 (_tmp10_);
				_g_object_unref0 (icon);
				icon = _tmp11_;
			}
			_tmp12_ = g_new0 (GValue, 1);
			g_value_init (_tmp12_, g_icon_get_type ());
			g_value_take_object (_tmp12_, icon);
			result = _tmp12_;
			_g_object_unref0 (currently_playing);
			return result;
		}
		case MUSIC_LIST_COLUMN_NUMBER:
		{
			GValue* _tmp13_ = NULL;
			_vala_assert (media_row_index >= 0, "media_row_index >= 0");
			_tmp13_ = g_new0 (GValue, 1);
			g_value_init (_tmp13_, G_TYPE_UINT);
			g_value_set_uint (_tmp13_, ((guint) media_row_index) + 1);
			result = _tmp13_;
			return result;
		}
		case MUSIC_LIST_COLUMN_TRACK:
		{
			guint _tmp14_;
			guint _tmp15_;
			GValue* _tmp16_ = NULL;
			_tmp14_ = music_media_get_track (m);
			_tmp15_ = _tmp14_;
			_tmp16_ = g_new0 (GValue, 1);
			g_value_init (_tmp16_, G_TYPE_UINT);
			g_value_set_uint (_tmp16_, _tmp15_);
			result = _tmp16_;
			return result;
		}
		case MUSIC_LIST_COLUMN_TITLE:
		{
			gchar* _tmp17_;
			GValue* _tmp18_ = NULL;
			_tmp17_ = music_media_get_display_title (m);
			_tmp18_ = g_new0 (GValue, 1);
			g_value_init (_tmp18_, G_TYPE_STRING);
			g_value_take_string (_tmp18_, _tmp17_);
			result = _tmp18_;
			return result;
		}
		case MUSIC_LIST_COLUMN_LENGTH:
		{
			guint _tmp19_;
			guint _tmp20_;
			GValue* _tmp21_ = NULL;
			_tmp19_ = music_media_get_length (m);
			_tmp20_ = _tmp19_;
			_tmp21_ = g_new0 (GValue, 1);
			g_value_init (_tmp21_, G_TYPE_UINT);
			g_value_set_uint (_tmp21_, _tmp20_);
			result = _tmp21_;
			return result;
		}
		case MUSIC_LIST_COLUMN_ARTIST:
		{
			gchar* _tmp22_;
			GValue* _tmp23_ = NULL;
			_tmp22_ = music_media_get_display_artist (m);
			_tmp23_ = g_new0 (GValue, 1);
			g_value_init (_tmp23_, G_TYPE_STRING);
			g_value_take_string (_tmp23_, _tmp22_);
			result = _tmp23_;
			return result;
		}
		case MUSIC_LIST_COLUMN_ALBUM:
		{
			gchar* _tmp24_;
			GValue* _tmp25_ = NULL;
			_tmp24_ = music_media_get_display_album (m);
			_tmp25_ = g_new0 (GValue, 1);
			g_value_init (_tmp25_, G_TYPE_STRING);
			g_value_take_string (_tmp25_, _tmp24_);
			result = _tmp25_;
			return result;
		}
		case MUSIC_LIST_COLUMN_ALBUM_ARTIST:
		{
			gchar* _tmp26_;
			GValue* _tmp27_ = NULL;
			_tmp26_ = music_media_get_display_album_artist (m, FALSE);
			_tmp27_ = g_new0 (GValue, 1);
			g_value_init (_tmp27_, G_TYPE_STRING);
			g_value_take_string (_tmp27_, _tmp26_);
			result = _tmp27_;
			return result;
		}
		case MUSIC_LIST_COLUMN_COMPOSER:
		{
			gchar* _tmp28_;
			GValue* _tmp29_ = NULL;
			_tmp28_ = music_media_get_display_composer (m);
			_tmp29_ = g_new0 (GValue, 1);
			g_value_init (_tmp29_, G_TYPE_STRING);
			g_value_take_string (_tmp29_, _tmp28_);
			result = _tmp29_;
			return result;
		}
		case MUSIC_LIST_COLUMN_GENRE:
		{
			gchar* _tmp30_;
			GValue* _tmp31_ = NULL;
			_tmp30_ = music_media_get_display_genre (m);
			_tmp31_ = g_new0 (GValue, 1);
			g_value_init (_tmp31_, G_TYPE_STRING);
			g_value_take_string (_tmp31_, _tmp30_);
			result = _tmp31_;
			return result;
		}
		case MUSIC_LIST_COLUMN_YEAR:
		{
			guint _tmp32_;
			guint _tmp33_;
			GValue* _tmp34_ = NULL;
			_tmp32_ = music_media_get_year (m);
			_tmp33_ = _tmp32_;
			_tmp34_ = g_new0 (GValue, 1);
			g_value_init (_tmp34_, G_TYPE_UINT);
			g_value_set_uint (_tmp34_, _tmp33_);
			result = _tmp34_;
			return result;
		}
		case MUSIC_LIST_COLUMN_GROUPING:
		{
			const gchar* _tmp35_;
			const gchar* _tmp36_;
			GValue* _tmp37_ = NULL;
			_tmp35_ = music_media_get_grouping (m);
			_tmp36_ = _tmp35_;
			_tmp37_ = g_new0 (GValue, 1);
			g_value_init (_tmp37_, G_TYPE_STRING);
			g_value_set_string (_tmp37_, _tmp36_);
			result = _tmp37_;
			return result;
		}
		case MUSIC_LIST_COLUMN_BITRATE:
		{
			guint _tmp38_;
			guint _tmp39_;
			GValue* _tmp40_ = NULL;
			_tmp38_ = music_media_get_bitrate (m);
			_tmp39_ = _tmp38_;
			_tmp40_ = g_new0 (GValue, 1);
			g_value_init (_tmp40_, G_TYPE_UINT);
			g_value_set_uint (_tmp40_, _tmp39_);
			result = _tmp40_;
			return result;
		}
		case MUSIC_LIST_COLUMN_RATING:
		{
			guint _tmp41_;
			guint _tmp42_;
			GValue* _tmp43_ = NULL;
			_tmp41_ = music_media_get_rating (m);
			_tmp42_ = _tmp41_;
			_tmp43_ = g_new0 (GValue, 1);
			g_value_init (_tmp43_, G_TYPE_UINT);
			g_value_set_uint (_tmp43_, _tmp42_);
			result = _tmp43_;
			return result;
		}
		case MUSIC_LIST_COLUMN_PLAY_COUNT:
		{
			guint _tmp44_;
			guint _tmp45_;
			GValue* _tmp46_ = NULL;
			_tmp44_ = music_media_get_play_count (m);
			_tmp45_ = _tmp44_;
			_tmp46_ = g_new0 (GValue, 1);
			g_value_init (_tmp46_, G_TYPE_UINT);
			g_value_set_uint (_tmp46_, _tmp45_);
			result = _tmp46_;
			return result;
		}
		case MUSIC_LIST_COLUMN_SKIP_COUNT:
		{
			guint _tmp47_;
			guint _tmp48_;
			GValue* _tmp49_ = NULL;
			_tmp47_ = music_media_get_skip_count (m);
			_tmp48_ = _tmp47_;
			_tmp49_ = g_new0 (GValue, 1);
			g_value_init (_tmp49_, G_TYPE_UINT);
			g_value_set_uint (_tmp49_, _tmp48_);
			result = _tmp49_;
			return result;
		}
		case MUSIC_LIST_COLUMN_DATE_ADDED:
		{
			guint _tmp50_;
			guint _tmp51_;
			GValue* _tmp52_ = NULL;
			_tmp50_ = music_media_get_date_added (m);
			_tmp51_ = _tmp50_;
			_tmp52_ = g_new0 (GValue, 1);
			g_value_init (_tmp52_, G_TYPE_UINT);
			g_value_set_uint (_tmp52_, _tmp51_);
			result = _tmp52_;
			return result;
		}
		case MUSIC_LIST_COLUMN_LAST_PLAYED:
		{
			guint _tmp53_;
			guint _tmp54_;
			GValue* _tmp55_ = NULL;
			_tmp53_ = music_media_get_last_played (m);
			_tmp54_ = _tmp53_;
			_tmp55_ = g_new0 (GValue, 1);
			g_value_init (_tmp55_, G_TYPE_UINT);
			g_value_set_uint (_tmp55_, _tmp54_);
			result = _tmp55_;
			return result;
		}
		case MUSIC_LIST_COLUMN_BPM:
		{
			guint _tmp56_;
			guint _tmp57_;
			GValue* _tmp58_ = NULL;
			_tmp56_ = music_media_get_bpm (m);
			_tmp57_ = _tmp56_;
			_tmp58_ = g_new0 (GValue, 1);
			g_value_init (_tmp58_, G_TYPE_UINT);
			g_value_set_uint (_tmp58_, _tmp57_);
			result = _tmp58_;
			return result;
		}
		case MUSIC_LIST_COLUMN_FILE_LOCATION:
		{
			gchar* _tmp59_;
			GValue* _tmp60_ = NULL;
			_tmp59_ = music_media_get_display_location (m);
			_tmp60_ = g_new0 (GValue, 1);
			g_value_init (_tmp60_, G_TYPE_STRING);
			g_value_take_string (_tmp60_, _tmp59_);
			result = _tmp60_;
			return result;
		}
		case MUSIC_LIST_COLUMN_FILE_SIZE:
		{
			guint64 _tmp61_;
			guint64 _tmp62_;
			GValue* _tmp63_ = NULL;
			_tmp61_ = music_media_get_file_size (m);
			_tmp62_ = _tmp61_;
			_tmp63_ = g_new0 (GValue, 1);
			g_value_init (_tmp63_, G_TYPE_UINT64);
			g_value_set_uint64 (_tmp63_, _tmp62_);
			result = _tmp63_;
			return result;
		}
		default:
		break;
	}
	g_assert_not_reached ();
}

GeeCollection*
music_list_column_get_all (void)
{
	GeeLinkedList* list = NULL;
	GeeLinkedList* _tmp0_;
	GeeCollection* result;
	_tmp0_ = gee_linked_list_new (MUSIC_TYPE_LIST_COLUMN, NULL, NULL, NULL, NULL, NULL);
	list = _tmp0_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				GeeLinkedList* _tmp3_;
				if (!_tmp1_) {
					gint _tmp2_;
					_tmp2_ = i;
					i = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				if (!(i < ((gint) MUSIC_LIST_COLUMN_N_COLUMNS))) {
					break;
				}
				_tmp3_ = list;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp3_, (gpointer) ((gintptr) i));
			}
		}
	}
	result = (GeeCollection*) list;
	return result;
}

static GType
music_list_column_get_type_once (void)
{
	static const GEnumValue values[] = {{MUSIC_LIST_COLUMN_ICON, "MUSIC_LIST_COLUMN_ICON", "icon"}, {MUSIC_LIST_COLUMN_NUMBER, "MUSIC_LIST_COLUMN_NUMBER", "number"}, {MUSIC_LIST_COLUMN_TRACK, "MUSIC_LIST_COLUMN_TRACK", "track"}, {MUSIC_LIST_COLUMN_TITLE, "MUSIC_LIST_COLUMN_TITLE", "title"}, {MUSIC_LIST_COLUMN_LENGTH, "MUSIC_LIST_COLUMN_LENGTH", "length"}, {MUSIC_LIST_COLUMN_ARTIST, "MUSIC_LIST_COLUMN_ARTIST", "artist"}, {MUSIC_LIST_COLUMN_ALBUM, "MUSIC_LIST_COLUMN_ALBUM", "album"}, {MUSIC_LIST_COLUMN_ALBUM_ARTIST, "MUSIC_LIST_COLUMN_ALBUM_ARTIST", "album-artist"}, {MUSIC_LIST_COLUMN_COMPOSER, "MUSIC_LIST_COLUMN_COMPOSER", "composer"}, {MUSIC_LIST_COLUMN_GENRE, "MUSIC_LIST_COLUMN_GENRE", "genre"}, {MUSIC_LIST_COLUMN_YEAR, "MUSIC_LIST_COLUMN_YEAR", "year"}, {MUSIC_LIST_COLUMN_GROUPING, "MUSIC_LIST_COLUMN_GROUPING", "grouping"}, {MUSIC_LIST_COLUMN_BITRATE, "MUSIC_LIST_COLUMN_BITRATE", "bitrate"}, {MUSIC_LIST_COLUMN_RATING, "MUSIC_LIST_COLUMN_RATING", "rating"}, {MUSIC_LIST_COLUMN_PLAY_COUNT, "MUSIC_LIST_COLUMN_PLAY_COUNT", "play-count"}, {MUSIC_LIST_COLUMN_SKIP_COUNT, "MUSIC_LIST_COLUMN_SKIP_COUNT", "skip-count"}, {MUSIC_LIST_COLUMN_DATE_ADDED, "MUSIC_LIST_COLUMN_DATE_ADDED", "date-added"}, {MUSIC_LIST_COLUMN_LAST_PLAYED, "MUSIC_LIST_COLUMN_LAST_PLAYED", "last-played"}, {MUSIC_LIST_COLUMN_BPM, "MUSIC_LIST_COLUMN_BPM", "bpm"}, {MUSIC_LIST_COLUMN_FILE_LOCATION, "MUSIC_LIST_COLUMN_FILE_LOCATION", "file-location"}, {MUSIC_LIST_COLUMN_FILE_SIZE, "MUSIC_LIST_COLUMN_FILE_SIZE", "file-size"}, {MUSIC_LIST_COLUMN_N_COLUMNS, "MUSIC_LIST_COLUMN_N_COLUMNS", "n-columns"}, {0, NULL, NULL}};
	GType music_list_column_type_id;
	music_list_column_type_id = g_enum_register_static ("MusicListColumn", values);
	return music_list_column_type_id;
}

GType
music_list_column_get_type (void)
{
	static volatile gsize music_list_column_type_id__once = 0;
	if (g_once_init_enter (&music_list_column_type_id__once)) {
		GType music_list_column_type_id;
		music_list_column_type_id = music_list_column_get_type_once ();
		g_once_init_leave (&music_list_column_type_id__once, music_list_column_type_id);
	}
	return music_list_column_type_id__once;
}

