/* FileOperator.c generated by valac 0.56.1, the Vala compiler
 * generated from FileOperator.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Corentin Noël <corentin@elementary.io>
 */

#include "music-lib.h"
#include <glib.h>
#include "io.elementary.music-core.h"
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <tag_c.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>

enum  {
	MUSIC_FILE_OPERATOR_0_PROPERTY,
	MUSIC_FILE_OPERATOR_NUM_PROPERTIES
};
static GParamSpec* music_file_operator_properties[MUSIC_FILE_OPERATOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _taglib_file_free0(var) ((var == NULL) ? NULL : (var = (taglib_file_free (var), NULL)))
typedef struct _MusicFileOperatorSaveMediaData MusicFileOperatorSaveMediaData;
typedef struct _Block2Data Block2Data;
typedef struct _MusicFileOperatorCopyImportsAsyncData MusicFileOperatorCopyImportsAsyncData;
enum  {
	MUSIC_FILE_OPERATOR_IMPORT_CANCELLED_SIGNAL,
	MUSIC_FILE_OPERATOR_RESCAN_CANCELLED_SIGNAL,
	MUSIC_FILE_OPERATOR_NUM_SIGNALS
};
static guint music_file_operator_signals[MUSIC_FILE_OPERATOR_NUM_SIGNALS] = {0};

struct _MusicFileOperatorPrivate {
	gint queue_size;
	MusicFileOperatorImportType import_type;
	MusicStaticPlaylist* new_playlist;
	GeeTreeSet* all_new_imports;
	GeeTreeSet* import_errors;
	GeeHashMap* monitors;
};

struct _MusicFileOperatorSaveMediaData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MusicFileOperator* self;
	GeeCollection* to_save;
	GeeTreeSet* copy;
	GeeTreeSet* _tmp0_;
	GeeTreeSet* _tmp1_;
	MusicSettingsMain* main_settings;
	MusicSettingsMain* _tmp2_;
	GeeIterator* _s_it;
	GeeTreeSet* _tmp3_;
	GeeIterator* _tmp4_;
	GeeIterator* _tmp5_;
	MusicMedia* s;
	GeeIterator* _tmp6_;
	gpointer _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	MusicMedia* _tmp10_;
	gboolean _tmp11_;
	gboolean _tmp12_;
	MusicMedia* _tmp13_;
	gboolean _tmp14_;
	gboolean _tmp15_;
	MusicMedia* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	GFile* _tmp20_;
	GFile* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	MusicSettingsMain* _tmp24_;
	const gchar* _tmp25_;
	const gchar* _tmp26_;
	GSettings* _tmp27_;
	GSettings* _tmp28_;
	TagLib_File* tag_file;
	MusicMedia* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	GFile* _tmp33_;
	GFile* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	TagLib_File* _tmp37_;
	gboolean _tmp38_;
	gboolean _tmp39_;
	TagLib_File* _tmp40_;
	TagLib_File* _tmp41_;
	TagLib_Tag* _tmp42_;
	TagLib_Tag* _tmp43_;
	TagLib_File* _tmp44_;
	const TagLib_AudioProperties* _tmp45_;
	const TagLib_AudioProperties* _tmp46_;
	TagLib_File* _tmp47_;
	TagLib_Tag* _tmp48_;
	TagLib_Tag* _tmp49_;
	MusicMedia* _tmp50_;
	const gchar* _tmp51_;
	const gchar* _tmp52_;
	TagLib_File* _tmp53_;
	TagLib_Tag* _tmp54_;
	TagLib_Tag* _tmp55_;
	MusicMedia* _tmp56_;
	const gchar* _tmp57_;
	const gchar* _tmp58_;
	TagLib_File* _tmp59_;
	TagLib_Tag* _tmp60_;
	TagLib_Tag* _tmp61_;
	MusicMedia* _tmp62_;
	const gchar* _tmp63_;
	const gchar* _tmp64_;
	TagLib_File* _tmp65_;
	TagLib_Tag* _tmp66_;
	TagLib_Tag* _tmp67_;
	MusicMedia* _tmp68_;
	const gchar* _tmp69_;
	const gchar* _tmp70_;
	TagLib_File* _tmp71_;
	TagLib_Tag* _tmp72_;
	TagLib_Tag* _tmp73_;
	MusicMedia* _tmp74_;
	const gchar* _tmp75_;
	const gchar* _tmp76_;
	TagLib_File* _tmp77_;
	TagLib_Tag* _tmp78_;
	TagLib_Tag* _tmp79_;
	MusicMedia* _tmp80_;
	guint _tmp81_;
	guint _tmp82_;
	TagLib_File* _tmp83_;
	TagLib_Tag* _tmp84_;
	TagLib_Tag* _tmp85_;
	MusicMedia* _tmp86_;
	guint _tmp87_;
	guint _tmp88_;
	TagLib_File* _tmp89_;
	MusicMedia* _tmp90_;
	gchar* _tmp91_;
	gchar* _tmp92_;
	gchar* _tmp93_;
	GSettings* _tmp94_;
	GSettings* _tmp95_;
	MusicMedia* _tmp96_;
};

struct _Block2Data {
	int _ref_count_;
	MusicFileOperator* self;
	MusicMedia* s;
};

struct _MusicFileOperatorCopyImportsAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MusicFileOperator* self;
	GeeTreeSet* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GeeIterator* _s_it;
	GeeTreeSet* _tmp3_;
	GeeIterator* _tmp4_;
	GeeIterator* _tmp5_;
	MusicMedia* s;
	GeeIterator* _tmp6_;
	gpointer _tmp7_;
	GCancellable* _tmp8_;
	MusicMedia* _tmp9_;
	gint _tmp10_;
	MusicLibrariesManager* _tmp11_;
	MusicLibrary* _tmp12_;
};

static gint MusicFileOperator_private_offset;
static gpointer music_file_operator_parent_class = NULL;

static void music_file_operator_media_imported (MusicFileOperator* self,
                                         MusicMedia* m);
static void _music_file_operator_media_imported_music_gstreamer_tagger_media_imported (MusicGStreamerTagger* _sender,
                                                                                MusicMedia* m,
                                                                                gpointer self);
static void music_file_operator_import_error (MusicFileOperator* self,
                                       const gchar* file);
static void _music_file_operator_import_error_music_gstreamer_tagger_import_error (MusicGStreamerTagger* _sender,
                                                                            const gchar* file_uri,
                                                                            GError* _error_,
                                                                            gpointer self);
static void music_file_operator_queue_finished (MusicFileOperator* self);
static void _music_file_operator_queue_finished_music_gstreamer_tagger_queue_finished (MusicGStreamerTagger* _sender,
                                                                                gpointer self);
static void music_file_operator_file_monitored_changed (MusicFileOperator* self,
                                                 GFile* file,
                                                 GFile* other_file,
                                                 GFileMonitorEvent event_type);
static void _music_file_operator_file_monitored_changed_g_file_monitor_changed (GFileMonitor* _sender,
                                                                         GFile* file,
                                                                         GFile* other_file,
                                                                         GFileMonitorEvent event_type,
                                                                         gpointer self);
static void __lambda18_ (MusicFileOperator* self);
static void ___lambda18__music_notification_manager_progress_canceled (MusicNotificationManager* _sender,
                                                                gpointer self);
static void music_file_operator_save_media_data_free (gpointer _data);
static gboolean music_file_operator_save_media_co (MusicFileOperatorSaveMediaData* _data_);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static gboolean _____lambda17_ (Block2Data* _data2_);
static gboolean ______lambda17__gsource_func (gpointer self);
static void music_file_operator_copy_imports_async_data_free (gpointer _data);
static gboolean music_file_operator_copy_imports_async_co (MusicFileOperatorCopyImportsAsyncData* _data_);
static void music_file_operator_finalize (GObject * obj);
static GType music_file_operator_get_type_once (void);

static inline gpointer
music_file_operator_get_instance_private (MusicFileOperator* self)
{
	return G_STRUCT_MEMBER_P (self, MusicFileOperator_private_offset);
}

static GType
music_file_operator_import_type_get_type_once (void)
{
	static const GEnumValue values[] = {{MUSIC_FILE_OPERATOR_IMPORT_TYPE_SET, "MUSIC_FILE_OPERATOR_IMPORT_TYPE_SET", "set"}, {MUSIC_FILE_OPERATOR_IMPORT_TYPE_RESCAN, "MUSIC_FILE_OPERATOR_IMPORT_TYPE_RESCAN", "rescan"}, {MUSIC_FILE_OPERATOR_IMPORT_TYPE_PLAYLIST, "MUSIC_FILE_OPERATOR_IMPORT_TYPE_PLAYLIST", "playlist"}, {MUSIC_FILE_OPERATOR_IMPORT_TYPE_IMPORT, "MUSIC_FILE_OPERATOR_IMPORT_TYPE_IMPORT", "import"}, {0, NULL, NULL}};
	GType music_file_operator_import_type_type_id;
	music_file_operator_import_type_type_id = g_enum_register_static ("MusicFileOperatorImportType", values);
	return music_file_operator_import_type_type_id;
}

GType
music_file_operator_import_type_get_type (void)
{
	static volatile gsize music_file_operator_import_type_type_id__once = 0;
	if (g_once_init_enter (&music_file_operator_import_type_type_id__once)) {
		GType music_file_operator_import_type_type_id;
		music_file_operator_import_type_type_id = music_file_operator_import_type_get_type_once ();
		g_once_init_leave (&music_file_operator_import_type_type_id__once, music_file_operator_import_type_type_id);
	}
	return music_file_operator_import_type_type_id__once;
}

static void
_music_file_operator_media_imported_music_gstreamer_tagger_media_imported (MusicGStreamerTagger* _sender,
                                                                           MusicMedia* m,
                                                                           gpointer self)
{
	music_file_operator_media_imported ((MusicFileOperator*) self, m);
}

static void
_music_file_operator_import_error_music_gstreamer_tagger_import_error (MusicGStreamerTagger* _sender,
                                                                       const gchar* file_uri,
                                                                       GError* _error_,
                                                                       gpointer self)
{
	music_file_operator_import_error ((MusicFileOperator*) self, file_uri);
}

static void
_music_file_operator_queue_finished_music_gstreamer_tagger_queue_finished (MusicGStreamerTagger* _sender,
                                                                           gpointer self)
{
	music_file_operator_queue_finished ((MusicFileOperator*) self);
}

static void
_music_file_operator_file_monitored_changed_g_file_monitor_changed (GFileMonitor* _sender,
                                                                    GFile* file,
                                                                    GFile* other_file,
                                                                    GFileMonitorEvent event_type,
                                                                    gpointer self)
{
	music_file_operator_file_monitored_changed ((MusicFileOperator*) self, file, other_file, event_type);
}

MusicFileOperator*
music_file_operator_construct (GType object_type)
{
	MusicFileOperator * self = NULL;
	GCancellable* _tmp0_;
	GeeTreeSet* _tmp1_;
	GeeTreeSet* _tmp2_;
	GeeHashMap* _tmp3_;
	GCancellable* _tmp4_;
	MusicGStreamerTagger* _tmp5_;
	MusicGStreamerTagger* _tmp6_;
	MusicGStreamerTagger* _tmp7_;
	MusicGStreamerTagger* _tmp8_;
	gchar* music_folder = NULL;
	MusicSettingsMain* _tmp9_;
	MusicSettingsMain* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	GFile* file = NULL;
	const gchar* _tmp15_;
	GFile* _tmp16_;
	GeeTreeSet* dirs = NULL;
	GeeTreeSet* _tmp17_;
	GeeTreeSet* _tmp18_;
	const gchar* _tmp19_;
	GFile* _tmp20_;
	GError* _inner_error0_ = NULL;
	self = (MusicFileOperator*) g_object_new (object_type, NULL);
	taglib_id3v2_set_default_text_encoding (TagLib_ID3v2_UTF8);
	_tmp0_ = g_cancellable_new ();
	_g_object_unref0 (self->cancellable);
	self->cancellable = _tmp0_;
	_tmp1_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->all_new_imports);
	self->priv->all_new_imports = _tmp1_;
	_tmp2_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->import_errors);
	self->priv->import_errors = _tmp2_;
	_tmp3_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, g_file_monitor_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->monitors);
	self->priv->monitors = _tmp3_;
	_tmp4_ = self->cancellable;
	_tmp5_ = music_gstreamer_tagger_new (_tmp4_);
	_g_object_unref0 (self->tagger);
	self->tagger = _tmp5_;
	_tmp6_ = self->tagger;
	g_signal_connect_object (_tmp6_, "media-imported", (GCallback) _music_file_operator_media_imported_music_gstreamer_tagger_media_imported, self, 0);
	_tmp7_ = self->tagger;
	g_signal_connect_object (_tmp7_, "import-error", (GCallback) _music_file_operator_import_error_music_gstreamer_tagger_import_error, self, 0);
	_tmp8_ = self->tagger;
	g_signal_connect_object (_tmp8_, "queue-finished", (GCallback) _music_file_operator_queue_finished_music_gstreamer_tagger_queue_finished, self, 0);
	_tmp9_ = music_settings_main_get_default ();
	_tmp10_ = _tmp9_;
	_tmp11_ = music_settings_main_get_music_folder (_tmp10_);
	_tmp12_ = _tmp11_;
	_tmp13_ = g_strdup (_tmp12_);
	_tmp14_ = _tmp13_;
	_g_object_unref0 (_tmp10_);
	music_folder = _tmp14_;
	_tmp15_ = music_folder;
	_tmp16_ = g_file_new_for_path (_tmp15_);
	file = _tmp16_;
	_tmp17_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
	dirs = _tmp17_;
	_tmp18_ = dirs;
	_tmp19_ = music_folder;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp18_, _tmp19_);
	_tmp20_ = file;
	music_file_operator_list_recursive_directory (self, _tmp20_, &dirs);
	{
		GeeIterator* _dir_it = NULL;
		GeeTreeSet* _tmp21_;
		GeeIterator* _tmp22_;
		_tmp21_ = dirs;
		_tmp22_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp21_);
		_dir_it = _tmp22_;
		while (TRUE) {
			GeeIterator* _tmp23_;
			gchar* dir = NULL;
			GeeIterator* _tmp24_;
			gpointer _tmp25_;
			GFile* dir_file = NULL;
			const gchar* _tmp26_;
			GFile* _tmp27_;
			_tmp23_ = _dir_it;
			if (!gee_iterator_next (_tmp23_)) {
				break;
			}
			_tmp24_ = _dir_it;
			_tmp25_ = gee_iterator_get (_tmp24_);
			dir = (gchar*) _tmp25_;
			_tmp26_ = dir;
			_tmp27_ = g_file_new_for_path (_tmp26_);
			dir_file = _tmp27_;
			{
				GFileMonitor* file_monitor = NULL;
				GFile* _tmp28_;
				GFileMonitor* _tmp29_;
				GeeHashMap* _tmp30_;
				const gchar* _tmp31_;
				GFileMonitor* _tmp32_;
				GFileMonitor* _tmp33_;
				_tmp28_ = dir_file;
				_tmp29_ = g_file_monitor (_tmp28_, G_FILE_MONITOR_SEND_MOVED, NULL, &_inner_error0_);
				file_monitor = _tmp29_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					goto __catch0_g_error;
				}
				_tmp30_ = self->priv->monitors;
				_tmp31_ = dir;
				_tmp32_ = file_monitor;
				gee_abstract_map_set ((GeeAbstractMap*) _tmp30_, _tmp31_, _tmp32_);
				_tmp33_ = file_monitor;
				g_signal_connect_object (_tmp33_, "changed", (GCallback) _music_file_operator_file_monitored_changed_g_file_monitor_changed, self, 0);
				_g_object_unref0 (file_monitor);
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* e = NULL;
				const gchar* _tmp34_;
				GError* _tmp35_;
				const gchar* _tmp36_;
				e = _inner_error0_;
				_inner_error0_ = NULL;
				_tmp34_ = dir;
				_tmp35_ = e;
				_tmp36_ = _tmp35_->message;
				g_warning ("FileOperator.vala:80: file %s: %s", _tmp34_, _tmp36_);
				_g_error_free0 (e);
			}
			__finally0:
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (dir_file);
				_g_free0 (dir);
				_g_object_unref0 (_dir_it);
				_g_object_unref0 (dirs);
				_g_object_unref0 (file);
				_g_free0 (music_folder);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
			_g_object_unref0 (dir_file);
			_g_free0 (dir);
		}
		_g_object_unref0 (_dir_it);
	}
	_g_object_unref0 (dirs);
	_g_object_unref0 (file);
	_g_free0 (music_folder);
	return self;
}

MusicFileOperator*
music_file_operator_new (void)
{
	return music_file_operator_construct (MUSIC_TYPE_FILE_OPERATOR);
}

gint
music_file_operator_list_recursive_directory (MusicFileOperator* self,
                                              GFile* music_folder,
                                              GeeTreeSet** dirs)
{
	GFileInfo* file_info = NULL;
	gint index = 0;
	GError* _inner_error0_ = NULL;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (music_folder != NULL, 0);
	g_return_val_if_fail (*dirs != NULL, 0);
	file_info = NULL;
	index = 0;
	{
		GFileEnumerator* enumerator = NULL;
		GFileEnumerator* _tmp0_;
		_tmp0_ = g_file_enumerate_children (music_folder, G_FILE_ATTRIBUTE_STANDARD_NAME "," G_FILE_ATTRIBUTE_STANDARD_TYPE "," G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE, 0, NULL, &_inner_error0_);
		enumerator = _tmp0_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		while (TRUE) {
			GFileInfo* _tmp1_ = NULL;
			GFileEnumerator* _tmp2_;
			GFileInfo* _tmp3_;
			GFileInfo* _tmp4_;
			GFileInfo* _tmp5_;
			GFile* file = NULL;
			GFileInfo* _tmp6_;
			const gchar* _tmp7_;
			GFile* _tmp8_;
			GFileInfo* _tmp9_;
			_tmp2_ = enumerator;
			_tmp3_ = g_file_enumerator_next_file (_tmp2_, NULL, &_inner_error0_);
			_tmp1_ = _tmp3_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (enumerator);
				goto __catch0_g_error;
			}
			_tmp4_ = _tmp1_;
			_tmp1_ = NULL;
			_g_object_unref0 (file_info);
			file_info = _tmp4_;
			_tmp5_ = file_info;
			if (!(_tmp5_ != NULL)) {
				_g_object_unref0 (_tmp1_);
				break;
			}
			_tmp6_ = file_info;
			_tmp7_ = g_file_info_get_name (_tmp6_);
			_tmp8_ = g_file_get_child (music_folder, _tmp7_);
			file = _tmp8_;
			_tmp9_ = file_info;
			if (g_file_info_get_file_type (_tmp9_) == G_FILE_TYPE_DIRECTORY) {
				GFile* _tmp10_;
				gchar* _tmp11_;
				gchar* _tmp12_;
				GFile* _tmp13_;
				_tmp10_ = file;
				_tmp11_ = g_file_get_uri (_tmp10_);
				_tmp12_ = _tmp11_;
				gee_abstract_collection_add ((GeeAbstractCollection*) (*dirs), _tmp12_);
				_g_free0 (_tmp12_);
				_tmp13_ = file;
				music_file_operator_list_recursive_directory (self, _tmp13_, dirs);
			}
			_g_object_unref0 (file);
			_g_object_unref0 (_tmp1_);
		}
		_g_object_unref0 (enumerator);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp14_;
		const gchar* _tmp15_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp14_ = err;
		_tmp15_ = _tmp14_->message;
		g_warning ("FileOperator.vala:99: Could not pre-scan music folder. Progress percen" \
"tage may be off: %s\n", _tmp15_);
		_g_error_free0 (err);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gint _tmp16_ = -1;
		_g_object_unref0 (file_info);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp16_;
	}
	result = index;
	_g_object_unref0 (file_info);
	return result;
}

static void
__lambda18_ (MusicFileOperator* self)
{
	GCancellable* _tmp0_;
	_tmp0_ = self->cancellable;
	g_cancellable_cancel (_tmp0_);
}

static void
___lambda18__music_notification_manager_progress_canceled (MusicNotificationManager* _sender,
                                                           gpointer self)
{
	__lambda18_ ((MusicFileOperator*) self);
}

void
music_file_operator_connect_to_manager (MusicFileOperator* self)
{
	MusicNotificationManager* _tmp0_;
	MusicNotificationManager* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = music_notification_manager_get_default ();
	_tmp1_ = _tmp0_;
	g_signal_connect_object (_tmp1_, "progress-canceled", (GCallback) ___lambda18__music_notification_manager_progress_canceled, self, 0);
	_g_object_unref0 (_tmp1_);
}

void
music_file_operator_reset_progress (MusicFileOperator* self,
                                    gint items)
{
	g_return_if_fail (self != NULL);
	self->index = 0;
	self->item_count = items;
}

static void
music_file_operator_save_media_data_free (gpointer _data)
{
	MusicFileOperatorSaveMediaData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->to_save);
	_g_object_unref0 (_data_->self);
	g_slice_free (MusicFileOperatorSaveMediaData, _data_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
music_file_operator_save_media (MusicFileOperator* self,
                                GeeCollection* to_save,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_)
{
	MusicFileOperatorSaveMediaData* _data_;
	MusicFileOperator* _tmp0_;
	GeeCollection* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (to_save != NULL);
	_data_ = g_slice_new0 (MusicFileOperatorSaveMediaData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, music_file_operator_save_media_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = _g_object_ref0 (to_save);
	_g_object_unref0 (_data_->to_save);
	_data_->to_save = _tmp1_;
	music_file_operator_save_media_co (_data_);
}

void
music_file_operator_save_media_finish (MusicFileOperator* self,
                                       GAsyncResult* _res_)
{
	MusicFileOperatorSaveMediaData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static gboolean
music_file_operator_save_media_co (MusicFileOperatorSaveMediaData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_data_->copy = _data_->_tmp0_;
	_data_->_tmp1_ = _data_->copy;
	gee_collection_add_all ((GeeCollection*) _data_->_tmp1_, _data_->to_save);
	_data_->_tmp2_ = music_settings_main_get_default ();
	_data_->main_settings = _data_->_tmp2_;
	{
		_data_->_tmp3_ = _data_->copy;
		_data_->_tmp4_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _data_->_tmp3_);
		_data_->_s_it = _data_->_tmp4_;
		while (TRUE) {
			_data_->_tmp5_ = _data_->_s_it;
			if (!gee_iterator_next (_data_->_tmp5_)) {
				break;
			}
			_data_->_tmp6_ = _data_->_s_it;
			_data_->_tmp7_ = gee_iterator_get (_data_->_tmp6_);
			_data_->s = (MusicMedia*) _data_->_tmp7_;
			_data_->_tmp10_ = _data_->s;
			_data_->_tmp11_ = music_media_get_is_temporary (_data_->_tmp10_);
			_data_->_tmp12_ = _data_->_tmp11_;
			if (_data_->_tmp12_) {
				_data_->_tmp9_ = TRUE;
			} else {
				_data_->_tmp13_ = _data_->s;
				_data_->_tmp14_ = music_media_get_is_preview (_data_->_tmp13_);
				_data_->_tmp15_ = _data_->_tmp14_;
				_data_->_tmp9_ = _data_->_tmp15_;
			}
			if (_data_->_tmp9_) {
				_data_->_tmp8_ = TRUE;
			} else {
				_data_->_tmp16_ = _data_->s;
				_data_->_tmp17_ = music_media_get_uri (_data_->_tmp16_);
				_data_->_tmp18_ = _data_->_tmp17_;
				_data_->_tmp19_ = _data_->_tmp18_;
				_data_->_tmp20_ = g_file_new_for_uri (_data_->_tmp19_);
				_data_->_tmp21_ = _data_->_tmp20_;
				_data_->_tmp22_ = g_file_get_path (_data_->_tmp21_);
				_data_->_tmp23_ = _data_->_tmp22_;
				_data_->_tmp24_ = _data_->main_settings;
				_data_->_tmp25_ = music_settings_main_get_music_folder (_data_->_tmp24_);
				_data_->_tmp26_ = _data_->_tmp25_;
				_data_->_tmp8_ = g_str_has_prefix (_data_->_tmp23_, _data_->_tmp26_) == FALSE;
				_g_free0 (_data_->_tmp23_);
				_g_object_unref0 (_data_->_tmp21_);
				_g_free0 (_data_->_tmp19_);
			}
			if (_data_->_tmp8_) {
				_g_object_unref0 (_data_->s);
				continue;
			}
			_data_->_tmp27_ = music_app_get_settings ();
			_data_->_tmp28_ = _data_->_tmp27_;
			if (g_settings_get_boolean (_data_->_tmp28_, "write-metadata-to-file")) {
				_data_->_tmp29_ = _data_->s;
				_data_->_tmp30_ = music_media_get_uri (_data_->_tmp29_);
				_data_->_tmp31_ = _data_->_tmp30_;
				_data_->_tmp32_ = _data_->_tmp31_;
				_data_->_tmp33_ = g_file_new_for_uri (_data_->_tmp32_);
				_data_->_tmp34_ = _data_->_tmp33_;
				_data_->_tmp35_ = g_file_get_path (_data_->_tmp34_);
				_data_->_tmp36_ = _data_->_tmp35_;
				_data_->_tmp37_ = taglib_file_new (_data_->_tmp36_);
				_taglib_file_free0 (_data_->tag_file);
				_data_->tag_file = _data_->_tmp37_;
				_g_free0 (_data_->_tmp36_);
				_g_object_unref0 (_data_->_tmp34_);
				_g_free0 (_data_->_tmp32_);
				_data_->_tmp40_ = _data_->tag_file;
				if (_data_->_tmp40_ != NULL) {
					_data_->_tmp41_ = _data_->tag_file;
					_data_->_tmp42_ = taglib_file_tag (_data_->_tmp41_);
					_data_->_tmp43_ = _data_->_tmp42_;
					_data_->_tmp39_ = _data_->_tmp43_ != NULL;
				} else {
					_data_->_tmp39_ = FALSE;
				}
				if (_data_->_tmp39_) {
					_data_->_tmp44_ = _data_->tag_file;
					_data_->_tmp45_ = taglib_file_audioproperties (_data_->_tmp44_);
					_data_->_tmp46_ = _data_->_tmp45_;
					_data_->_tmp38_ = _data_->_tmp46_ != NULL;
				} else {
					_data_->_tmp38_ = FALSE;
				}
				if (_data_->_tmp38_) {
					_data_->_tmp47_ = _data_->tag_file;
					_data_->_tmp48_ = taglib_file_tag (_data_->_tmp47_);
					_data_->_tmp49_ = _data_->_tmp48_;
					_data_->_tmp50_ = _data_->s;
					_data_->_tmp51_ = music_media_get_title (_data_->_tmp50_);
					_data_->_tmp52_ = _data_->_tmp51_;
					taglib_tag_set_title (_data_->_tmp49_, _data_->_tmp52_);
					_data_->_tmp53_ = _data_->tag_file;
					_data_->_tmp54_ = taglib_file_tag (_data_->_tmp53_);
					_data_->_tmp55_ = _data_->_tmp54_;
					_data_->_tmp56_ = _data_->s;
					_data_->_tmp57_ = music_media_get_artist (_data_->_tmp56_);
					_data_->_tmp58_ = _data_->_tmp57_;
					taglib_tag_set_artist (_data_->_tmp55_, _data_->_tmp58_);
					_data_->_tmp59_ = _data_->tag_file;
					_data_->_tmp60_ = taglib_file_tag (_data_->_tmp59_);
					_data_->_tmp61_ = _data_->_tmp60_;
					_data_->_tmp62_ = _data_->s;
					_data_->_tmp63_ = music_media_get_album (_data_->_tmp62_);
					_data_->_tmp64_ = _data_->_tmp63_;
					taglib_tag_set_album (_data_->_tmp61_, _data_->_tmp64_);
					_data_->_tmp65_ = _data_->tag_file;
					_data_->_tmp66_ = taglib_file_tag (_data_->_tmp65_);
					_data_->_tmp67_ = _data_->_tmp66_;
					_data_->_tmp68_ = _data_->s;
					_data_->_tmp69_ = music_media_get_genre (_data_->_tmp68_);
					_data_->_tmp70_ = _data_->_tmp69_;
					taglib_tag_set_genre (_data_->_tmp67_, _data_->_tmp70_);
					_data_->_tmp71_ = _data_->tag_file;
					_data_->_tmp72_ = taglib_file_tag (_data_->_tmp71_);
					_data_->_tmp73_ = _data_->_tmp72_;
					_data_->_tmp74_ = _data_->s;
					_data_->_tmp75_ = music_media_get_comment (_data_->_tmp74_);
					_data_->_tmp76_ = _data_->_tmp75_;
					taglib_tag_set_comment (_data_->_tmp73_, _data_->_tmp76_);
					_data_->_tmp77_ = _data_->tag_file;
					_data_->_tmp78_ = taglib_file_tag (_data_->_tmp77_);
					_data_->_tmp79_ = _data_->_tmp78_;
					_data_->_tmp80_ = _data_->s;
					_data_->_tmp81_ = music_media_get_year (_data_->_tmp80_);
					_data_->_tmp82_ = _data_->_tmp81_;
					taglib_tag_set_year (_data_->_tmp79_, _data_->_tmp82_);
					_data_->_tmp83_ = _data_->tag_file;
					_data_->_tmp84_ = taglib_file_tag (_data_->_tmp83_);
					_data_->_tmp85_ = _data_->_tmp84_;
					_data_->_tmp86_ = _data_->s;
					_data_->_tmp87_ = music_media_get_track (_data_->_tmp86_);
					_data_->_tmp88_ = _data_->_tmp87_;
					taglib_tag_set_track (_data_->_tmp85_, _data_->_tmp88_);
					_data_->_tmp89_ = _data_->tag_file;
					taglib_file_save (_data_->_tmp89_);
				} else {
					_data_->_tmp90_ = _data_->s;
					_data_->_tmp91_ = music_media_get_uri (_data_->_tmp90_);
					_data_->_tmp92_ = _data_->_tmp91_;
					_data_->_tmp93_ = _data_->_tmp92_;
					g_debug ("FileOperator.vala:139: Could not save %s.\n", _data_->_tmp93_);
					_g_free0 (_data_->_tmp93_);
				}
				_taglib_file_free0 (_data_->tag_file);
			}
			_data_->_tmp94_ = music_app_get_settings ();
			_data_->_tmp95_ = _data_->_tmp94_;
			if (g_settings_get_boolean (_data_->_tmp95_, "update-folder-hierarchy")) {
				_data_->_tmp96_ = _data_->s;
				music_file_operator_update_file_hierarchy (_data_->self, _data_->_tmp96_, TRUE, FALSE);
			}
			_g_object_unref0 (_data_->s);
		}
		_g_object_unref0 (_data_->_s_it);
	}
	_g_object_unref0 (_data_->main_settings);
	_g_object_unref0 (_data_->copy);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		MusicFileOperator* self;
		self = _data2_->self;
		_g_object_unref0 (_data2_->s);
		_g_object_unref0 (self);
		g_slice_free (Block2Data, _data2_);
	}
}

static gboolean
_____lambda17_ (Block2Data* _data2_)
{
	MusicFileOperator* self;
	MusicLibrariesManager* _tmp0_;
	MusicLibrary* _tmp1_;
	gboolean result;
	self = _data2_->self;
	_tmp0_ = music_libraries_manager;
	_tmp1_ = _tmp0_->local_library;
	music_library_update_media (_tmp1_, _data2_->s, FALSE, FALSE);
	result = FALSE;
	return result;
}

static gboolean
______lambda17__gsource_func (gpointer self)
{
	gboolean result;
	result = _____lambda17_ (self);
	return result;
}

gboolean
music_file_operator_update_file_hierarchy (MusicFileOperator* self,
                                           MusicMedia* s,
                                           gboolean delete_old,
                                           gboolean emit_update)
{
	Block2Data* _data2_;
	MusicMedia* _tmp0_;
	GError* _inner_error0_ = NULL;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (s != NULL, FALSE);
	_data2_ = g_slice_new0 (Block2Data);
	_data2_->_ref_count_ = 1;
	_data2_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (s);
	_g_object_unref0 (_data2_->s);
	_data2_->s = _tmp0_;
	{
		GFile* dest = NULL;
		GFile* _tmp1_;
		GFile* _tmp2_;
		GFile* original = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		GFile* _tmp6_;
		GFile* _tmp7_;
		gboolean success = FALSE;
		_tmp1_ = music_file_utils_get_new_destination (_data2_->s);
		dest = _tmp1_;
		_tmp2_ = dest;
		if (_tmp2_ == NULL) {
			result = TRUE;
			_g_object_unref0 (dest);
			block2_data_unref (_data2_);
			_data2_ = NULL;
			return result;
		}
		_tmp3_ = music_media_get_uri (_data2_->s);
		_tmp4_ = _tmp3_;
		_tmp5_ = _tmp4_;
		_tmp6_ = g_file_new_for_uri (_tmp5_);
		_tmp7_ = _tmp6_;
		_g_free0 (_tmp5_);
		original = _tmp7_;
		success = FALSE;
		if (!delete_old) {
			gchar* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
			GFile* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			gboolean _tmp14_ = FALSE;
			GFile* _tmp15_;
			GFile* _tmp16_;
			_tmp8_ = music_media_get_uri (_data2_->s);
			_tmp9_ = _tmp8_;
			_tmp10_ = _tmp9_;
			_tmp11_ = dest;
			_tmp12_ = g_file_get_uri (_tmp11_);
			_tmp13_ = _tmp12_;
			g_debug ("FileOperator.vala:159: Copying %s to %s", _tmp10_, _tmp13_);
			_g_free0 (_tmp13_);
			_g_free0 (_tmp10_);
			_tmp15_ = original;
			_tmp16_ = dest;
			_tmp14_ = g_file_copy (_tmp15_, _tmp16_, G_FILE_COPY_NONE, NULL, NULL, NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (original);
				_g_object_unref0 (dest);
				goto __catch0_g_error;
			}
			success = _tmp14_;
		} else {
			gchar* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			GFile* _tmp20_;
			gchar* _tmp21_;
			gchar* _tmp22_;
			gboolean _tmp23_ = FALSE;
			GFile* _tmp24_;
			GFile* _tmp25_;
			_tmp17_ = music_media_get_uri (_data2_->s);
			_tmp18_ = _tmp17_;
			_tmp19_ = _tmp18_;
			_tmp20_ = dest;
			_tmp21_ = g_file_get_uri (_tmp20_);
			_tmp22_ = _tmp21_;
			g_debug ("FileOperator.vala:162: Moving %s to %s", _tmp19_, _tmp22_);
			_g_free0 (_tmp22_);
			_g_free0 (_tmp19_);
			_tmp24_ = original;
			_tmp25_ = dest;
			_tmp23_ = g_file_move (_tmp24_, _tmp25_, G_FILE_COPY_NONE, NULL, NULL, NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (original);
				_g_object_unref0 (dest);
				goto __catch0_g_error;
			}
			success = _tmp23_;
		}
		if (success) {
			GFile* _tmp26_;
			gchar* _tmp27_;
			gchar* _tmp28_;
			g_debug ("FileOperator.vala:167: success copying file");
			_tmp26_ = dest;
			_tmp27_ = g_file_get_uri (_tmp26_);
			_tmp28_ = _tmp27_;
			music_media_set_uri (_data2_->s, _tmp28_);
			_g_free0 (_tmp28_);
			if (emit_update) {
				g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ______lambda17__gsource_func, block2_data_ref (_data2_), block2_data_unref);
			}
		} else {
			gchar* _tmp29_;
			gchar* _tmp30_;
			gchar* _tmp31_;
			GFile* _tmp32_;
			gchar* _tmp33_;
			gchar* _tmp34_;
			_tmp29_ = music_media_get_uri (_data2_->s);
			_tmp30_ = _tmp29_;
			_tmp31_ = _tmp30_;
			_tmp32_ = dest;
			_tmp33_ = g_file_get_path (_tmp32_);
			_tmp34_ = _tmp33_;
			g_warning ("FileOperator.vala:176: Failure: Could not copy imported media %s to me" \
"dia folder %s", _tmp31_, _tmp34_);
			_g_free0 (_tmp34_);
			_g_free0 (_tmp31_);
			result = FALSE;
			_g_object_unref0 (original);
			_g_object_unref0 (dest);
			block2_data_unref (_data2_);
			_data2_ = NULL;
			return result;
		}
		if (delete_old) {
			GeeTreeSet* dummy = NULL;
			GeeTreeSet* _tmp35_;
			gint old_folder_items = 0;
			GFile* _tmp36_;
			GFile* _tmp37_;
			GFile* _tmp38_;
			GeeTreeSet* _tmp39_;
			gint _tmp40_;
			_tmp35_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
			dummy = _tmp35_;
			_tmp36_ = original;
			_tmp37_ = g_file_get_parent (_tmp36_);
			_tmp38_ = _tmp37_;
			_tmp39_ = dummy;
			_tmp40_ = music_file_utils_count_music_files (_tmp38_, (GeeCollection*) _tmp39_);
			_g_object_unref0 (_tmp38_);
			old_folder_items = _tmp40_;
			if (old_folder_items == 0) {
				GFile* _tmp41_;
				GFile* _tmp42_;
				GFile* _tmp43_;
				gchar* _tmp44_;
				gchar* _tmp45_;
				GFile* _tmp46_;
				GFile* _tmp47_;
				GFile* _tmp48_;
				_tmp41_ = original;
				_tmp42_ = g_file_get_parent (_tmp41_);
				_tmp43_ = _tmp42_;
				_tmp44_ = g_file_get_path (_tmp43_);
				_tmp45_ = _tmp44_;
				g_message ("FileOperator.vala:187: going to delete %s because no files are in it\n", _tmp45_);
				_g_free0 (_tmp45_);
				_g_object_unref0 (_tmp43_);
				_tmp46_ = original;
				_tmp47_ = g_file_get_parent (_tmp46_);
				_tmp48_ = _tmp47_;
				g_file_delete (_tmp48_, NULL, &_inner_error0_);
				_g_object_unref0 (_tmp48_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					_g_object_unref0 (dummy);
					_g_object_unref0 (original);
					_g_object_unref0 (dest);
					goto __catch0_g_error;
				}
			}
			_g_object_unref0 (dummy);
		}
		_g_object_unref0 (original);
		_g_object_unref0 (dest);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		gchar* _tmp49_;
		gchar* _tmp50_;
		gchar* _tmp51_;
		GError* _tmp52_;
		const gchar* _tmp53_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp49_ = music_media_get_uri (_data2_->s);
		_tmp50_ = _tmp49_;
		_tmp51_ = _tmp50_;
		_tmp52_ = err;
		_tmp53_ = _tmp52_->message;
		g_warning ("FileOperator.vala:192: Could not copy imported media %s to media folde" \
"r: %s\n", _tmp51_, _tmp53_);
		_g_free0 (_tmp51_);
		result = FALSE;
		_g_error_free0 (err);
		block2_data_unref (_data2_);
		_data2_ = NULL;
		return result;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp54_ = FALSE;
		block2_data_unref (_data2_);
		_data2_ = NULL;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp54_;
	}
	result = TRUE;
	block2_data_unref (_data2_);
	_data2_ = NULL;
	return result;
}

void
music_file_operator_remove_media (MusicFileOperator* self,
                                  GeeCollection* to_remove)
{
	GeeTreeSet* dummy_list = NULL;
	GeeTreeSet* _tmp0_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (to_remove != NULL);
	_tmp0_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
	dummy_list = _tmp0_;
	{
		GeeIterator* _s_it = NULL;
		GeeIterator* _tmp1_;
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) to_remove);
		_s_it = _tmp1_;
		while (TRUE) {
			GeeIterator* _tmp2_;
			MusicMedia* s = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			_tmp2_ = _s_it;
			if (!gee_iterator_next (_tmp2_)) {
				break;
			}
			_tmp3_ = _s_it;
			_tmp4_ = gee_iterator_get (_tmp3_);
			s = (MusicMedia*) _tmp4_;
			{
				GFile* file = NULL;
				MusicMedia* _tmp5_;
				gchar* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
				GFile* _tmp9_;
				GFile* _tmp10_;
				GFile* _tmp11_;
				gint old_folder_items = 0;
				GFile* _tmp12_;
				GFile* _tmp13_;
				GFile* _tmp14_;
				GeeTreeSet* _tmp15_;
				gint _tmp16_;
				_tmp5_ = s;
				_tmp6_ = music_media_get_uri (_tmp5_);
				_tmp7_ = _tmp6_;
				_tmp8_ = _tmp7_;
				_tmp9_ = g_file_new_for_uri (_tmp8_);
				_tmp10_ = _tmp9_;
				_g_free0 (_tmp8_);
				file = _tmp10_;
				_tmp11_ = file;
				g_file_trash (_tmp11_, NULL, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					_g_object_unref0 (file);
					goto __catch0_g_error;
				}
				_tmp12_ = file;
				_tmp13_ = g_file_get_parent (_tmp12_);
				_tmp14_ = _tmp13_;
				_tmp15_ = dummy_list;
				_tmp16_ = music_file_utils_count_music_files (_tmp14_, (GeeCollection*) _tmp15_);
				_g_object_unref0 (_tmp14_);
				old_folder_items = _tmp16_;
				if (old_folder_items == 0) {
					GFile* _tmp17_;
					GFile* _tmp18_;
					GFile* _tmp19_;
					gchar* _tmp20_;
					gchar* _tmp21_;
					gint old_folder_parent_items = 0;
					GFile* _tmp22_;
					GFile* _tmp23_;
					GFile* _tmp24_;
					GFile* _tmp25_;
					GFile* _tmp26_;
					GeeTreeSet* _tmp27_;
					gint _tmp28_;
					_tmp17_ = file;
					_tmp18_ = g_file_get_parent (_tmp17_);
					_tmp19_ = _tmp18_;
					_tmp20_ = g_file_get_path (_tmp19_);
					_tmp21_ = _tmp20_;
					g_debug ("FileOperator.vala:208: going to delete %s because no files are in it\n", _tmp21_);
					_g_free0 (_tmp21_);
					_g_object_unref0 (_tmp19_);
					_tmp22_ = file;
					_tmp23_ = g_file_get_parent (_tmp22_);
					_tmp24_ = _tmp23_;
					_tmp25_ = g_file_get_parent (_tmp24_);
					_tmp26_ = _tmp25_;
					_tmp27_ = dummy_list;
					_tmp28_ = music_file_utils_count_music_files (_tmp26_, (GeeCollection*) _tmp27_);
					_g_object_unref0 (_tmp26_);
					_g_object_unref0 (_tmp24_);
					old_folder_parent_items = _tmp28_;
					if (old_folder_parent_items == 0) {
						GFile* _tmp29_;
						GFile* _tmp30_;
						GFile* _tmp31_;
						GFile* _tmp32_;
						GFile* _tmp33_;
						gchar* _tmp34_;
						gchar* _tmp35_;
						_tmp29_ = file;
						_tmp30_ = g_file_get_parent (_tmp29_);
						_tmp31_ = _tmp30_;
						_tmp32_ = g_file_get_parent (_tmp31_);
						_tmp33_ = _tmp32_;
						_tmp34_ = g_file_get_path (_tmp33_);
						_tmp35_ = _tmp34_;
						g_debug ("FileOperator.vala:212: going to delete %s because no files are in it\n", _tmp35_);
						_g_free0 (_tmp35_);
						_g_object_unref0 (_tmp33_);
						_g_object_unref0 (_tmp31_);
					}
				}
				_g_object_unref0 (file);
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* err = NULL;
				MusicMedia* _tmp36_;
				gchar* _tmp37_;
				gchar* _tmp38_;
				gchar* _tmp39_;
				GError* _tmp40_;
				const gchar* _tmp41_;
				err = _inner_error0_;
				_inner_error0_ = NULL;
				_tmp36_ = s;
				_tmp37_ = music_media_get_uri (_tmp36_);
				_tmp38_ = _tmp37_;
				_tmp39_ = _tmp38_;
				_tmp40_ = err;
				_tmp41_ = _tmp40_->message;
				g_warning ("FileOperator.vala:216: Could not move file %s to trash: %s (you could " \
"be using a file system which is not supported)\n", _tmp39_, _tmp41_);
				_g_free0 (_tmp39_);
				_g_error_free0 (err);
			}
			__finally0:
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (s);
				_g_object_unref0 (_s_it);
				_g_object_unref0 (dummy_list);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
			_g_object_unref0 (s);
		}
		_g_object_unref0 (_s_it);
	}
	_g_object_unref0 (dummy_list);
}

static void
music_file_operator_file_monitored_changed (MusicFileOperator* self,
                                            GFile* file,
                                            GFile* other_file,
                                            GFileMonitorEvent event_type)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	switch (event_type) {
		case G_FILE_MONITOR_EVENT_DELETED:
		{
			MusicMedia* media = NULL;
			MusicLibrariesManager* _tmp0_;
			MusicLibrary* _tmp1_;
			MusicMedia* _tmp2_;
			MusicMedia* _tmp3_;
			GFileMonitor* monitor = NULL;
			GeeHashMap* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
			gpointer _tmp10_;
			GFileMonitor* _tmp11_;
			GFileMonitor* _tmp12_;
			_tmp0_ = music_libraries_manager;
			_tmp1_ = _tmp0_->local_library;
			_tmp2_ = music_library_media_from_file (_tmp1_, file);
			media = _tmp2_;
			_tmp3_ = media;
			if (_tmp3_ != NULL) {
				MusicLibrariesManager* _tmp4_;
				MusicLibrary* _tmp5_;
				MusicMedia* _tmp6_;
				_tmp4_ = music_libraries_manager;
				_tmp5_ = _tmp4_->local_library;
				_tmp6_ = media;
				music_library_remove_media (_tmp5_, _tmp6_, FALSE);
			}
			_tmp7_ = self->priv->monitors;
			_tmp8_ = g_file_get_uri (file);
			_tmp9_ = _tmp8_;
			_tmp10_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp7_, _tmp9_);
			_tmp11_ = (GFileMonitor*) _tmp10_;
			_g_free0 (_tmp9_);
			monitor = _tmp11_;
			_tmp12_ = monitor;
			if (_tmp12_ != NULL) {
				GeeTreeSet* medias_to_remove = NULL;
				GeeTreeSet* _tmp13_;
				MusicLibrariesManager* _tmp32_;
				MusicLibrary* _tmp33_;
				GeeTreeSet* _tmp34_;
				GFileMonitor* _tmp35_;
				GeeHashMap* _tmp36_;
				gchar* _tmp37_;
				gchar* _tmp38_;
				_tmp13_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
				medias_to_remove = _tmp13_;
				{
					GeeIterator* _m_it = NULL;
					MusicLibrariesManager* _tmp14_;
					MusicLibrary* _tmp15_;
					GeeCollection* _tmp16_;
					GeeCollection* _tmp17_;
					GeeIterator* _tmp18_;
					GeeIterator* _tmp19_;
					_tmp14_ = music_libraries_manager;
					_tmp15_ = _tmp14_->local_library;
					_tmp16_ = music_library_get_medias (_tmp15_);
					_tmp17_ = _tmp16_;
					_tmp18_ = gee_iterable_iterator ((GeeIterable*) _tmp17_);
					_tmp19_ = _tmp18_;
					_g_object_unref0 (_tmp17_);
					_m_it = _tmp19_;
					while (TRUE) {
						GeeIterator* _tmp20_;
						MusicMedia* m = NULL;
						GeeIterator* _tmp21_;
						gpointer _tmp22_;
						MusicMedia* _tmp23_;
						gchar* _tmp24_;
						gchar* _tmp25_;
						gchar* _tmp26_;
						gchar* _tmp27_;
						gchar* _tmp28_;
						gboolean _tmp29_;
						_tmp20_ = _m_it;
						if (!gee_iterator_next (_tmp20_)) {
							break;
						}
						_tmp21_ = _m_it;
						_tmp22_ = gee_iterator_get (_tmp21_);
						m = (MusicMedia*) _tmp22_;
						_tmp23_ = m;
						_tmp24_ = music_media_get_uri (_tmp23_);
						_tmp25_ = _tmp24_;
						_tmp26_ = _tmp25_;
						_tmp27_ = g_file_get_uri (file);
						_tmp28_ = _tmp27_;
						_tmp29_ = g_str_has_prefix (_tmp26_, _tmp28_);
						_g_free0 (_tmp28_);
						_g_free0 (_tmp26_);
						if (_tmp29_) {
							GeeTreeSet* _tmp30_;
							MusicMedia* _tmp31_;
							_tmp30_ = medias_to_remove;
							_tmp31_ = m;
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp30_, _tmp31_);
						}
						_g_object_unref0 (m);
					}
					_g_object_unref0 (_m_it);
				}
				_tmp32_ = music_libraries_manager;
				_tmp33_ = _tmp32_->local_library;
				_tmp34_ = medias_to_remove;
				music_library_remove_medias (_tmp33_, (GeeCollection*) _tmp34_, FALSE);
				_tmp35_ = monitor;
				g_file_monitor_cancel (_tmp35_);
				_tmp36_ = self->priv->monitors;
				_tmp37_ = g_file_get_uri (file);
				_tmp38_ = _tmp37_;
				gee_abstract_map_unset ((GeeAbstractMap*) _tmp36_, _tmp38_, NULL);
				_g_free0 (_tmp38_);
				_g_object_unref0 (medias_to_remove);
			}
			_g_object_unref0 (monitor);
			_g_object_unref0 (media);
			break;
		}
		case G_FILE_MONITOR_EVENT_CREATED:
		{
			{
				GFileInfo* info = NULL;
				GFileInfo* _tmp39_;
				gboolean _tmp40_ = FALSE;
				GFileInfo* _tmp41_;
				_tmp39_ = g_file_query_info (file, G_FILE_ATTRIBUTE_STANDARD_TYPE "," G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
				info = _tmp39_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					goto __catch0_g_error;
				}
				_tmp41_ = info;
				if (g_file_info_get_file_type (_tmp41_) == G_FILE_TYPE_REGULAR) {
					GFileInfo* _tmp42_;
					const gchar* _tmp43_;
					_tmp42_ = info;
					_tmp43_ = g_file_info_get_content_type (_tmp42_);
					_tmp40_ = music_file_utils_is_valid_content_type (_tmp43_, NULL, (gint) 0);
				} else {
					_tmp40_ = FALSE;
				}
				if (_tmp40_) {
					GeeTreeSet* list = NULL;
					GeeTreeSet* _tmp44_;
					GeeTreeSet* _tmp45_;
					gchar* _tmp46_;
					gchar* _tmp47_;
					GeeTreeSet* _tmp48_;
					_tmp44_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
					list = _tmp44_;
					_tmp45_ = list;
					_tmp46_ = g_file_get_uri (file);
					_tmp47_ = _tmp46_;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp45_, _tmp47_);
					_g_free0 (_tmp47_);
					_tmp48_ = list;
					music_file_operator_import_files (self, (GeeCollection*) _tmp48_, MUSIC_FILE_OPERATOR_IMPORT_TYPE_IMPORT);
					_g_object_unref0 (list);
				} else {
					GFileInfo* _tmp49_;
					_tmp49_ = info;
					if (g_file_info_get_file_type (_tmp49_) == G_FILE_TYPE_DIRECTORY) {
						GeeTreeSet* list = NULL;
						GeeTreeSet* _tmp50_;
						GeeTreeSet* _tmp51_;
						GeeTreeSet* _tmp52_;
						_tmp50_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
						list = _tmp50_;
						_tmp51_ = list;
						music_file_utils_count_music_files (file, (GeeCollection*) _tmp51_);
						_tmp52_ = list;
						music_file_operator_import_files (self, (GeeCollection*) _tmp52_, MUSIC_FILE_OPERATOR_IMPORT_TYPE_IMPORT);
						_g_object_unref0 (list);
					}
				}
				_g_object_unref0 (info);
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* e = NULL;
				GError* _tmp53_;
				const gchar* _tmp54_;
				e = _inner_error0_;
				_inner_error0_ = NULL;
				_tmp53_ = e;
				_tmp54_ = _tmp53_->message;
				g_critical ("FileOperator.vala:254: %s", _tmp54_);
				_g_error_free0 (e);
			}
			__finally0:
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
			break;
		}
		case G_FILE_MONITOR_EVENT_MOVED:
		{
			MusicMedia* media = NULL;
			MusicLibrariesManager* _tmp55_;
			MusicLibrary* _tmp56_;
			MusicMedia* _tmp57_;
			MusicMedia* _tmp58_;
			MusicLibrariesManager* _tmp59_;
			MusicLibrary* _tmp60_;
			MusicMedia* _tmp61_;
			_tmp55_ = music_libraries_manager;
			_tmp56_ = _tmp55_->local_library;
			_tmp57_ = music_library_media_from_file (_tmp56_, file);
			media = _tmp57_;
			_tmp58_ = media;
			music_media_set_file (_tmp58_, other_file);
			_tmp59_ = music_libraries_manager;
			_tmp60_ = _tmp59_->local_library;
			_tmp61_ = media;
			music_library_update_media (_tmp60_, _tmp61_, TRUE, FALSE);
			_g_object_unref0 (media);
			break;
		}
		default:
		break;
	}
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	string_length = (glong) _tmp1_;
	if (start < ((glong) 0)) {
		start = string_length + start;
	}
	if (end < ((glong) 0)) {
		end = string_length + end;
	}
	if (start >= ((glong) 0)) {
		_tmp2_ = start <= string_length;
	} else {
		_tmp2_ = FALSE;
	}
	g_return_val_if_fail (_tmp2_, NULL);
	if (end >= ((glong) 0)) {
		_tmp3_ = end <= string_length;
	} else {
		_tmp3_ = FALSE;
	}
	g_return_val_if_fail (_tmp3_, NULL);
	g_return_val_if_fail (start <= end, NULL);
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
	result = _tmp4_;
	return result;
}

static gint
string_last_index_of (const gchar* self,
                      const gchar* needle,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (needle != NULL, 0);
	_tmp0_ = g_strrstr (((gchar*) self) + start_index, (gchar*) needle);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	if (_tmp1_ != NULL) {
		gchar* _tmp2_;
		_tmp2_ = _result_;
		result = (gint) (_tmp2_ - ((gchar*) self));
		return result;
	} else {
		result = -1;
		return result;
	}
}

gchar*
music_file_operator_get_extension (MusicFileOperator* self,
                                   const gchar* name)
{
	gint _tmp0_;
	gint _tmp1_;
	gchar* _tmp2_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	_tmp0_ = strlen (name);
	_tmp1_ = _tmp0_;
	_tmp2_ = string_slice (name, (glong) string_last_index_of (name, ".", 0), (glong) _tmp1_);
	result = _tmp2_;
	return result;
}

void
music_file_operator_import_files (MusicFileOperator* self,
                                  GeeCollection* files,
                                  MusicFileOperatorImportType type)
{
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (files != NULL);
	self->priv->import_type = type;
	_tmp0_ = gee_collection_get_size (files);
	_tmp1_ = _tmp0_;
	self->priv->queue_size = self->priv->queue_size + _tmp1_;
	_tmp2_ = gee_collection_get_size (files);
	_tmp3_ = _tmp2_;
	if (_tmp3_ == 0) {
		music_file_operator_queue_finished (self);
	} else {
		MusicGStreamerTagger* _tmp4_;
		_tmp4_ = self->tagger;
		music_gstreamer_tagger_discoverer_import_media (_tmp4_, files);
	}
}

static void
music_file_operator_media_imported (MusicFileOperator* self,
                                    MusicMedia* m)
{
	GeeTreeSet* _tmp0_;
	MusicLibrariesManager* _tmp1_;
	MusicLibrary* _tmp2_;
	gint _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (m != NULL);
	_tmp0_ = self->priv->all_new_imports;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, m);
	_tmp1_ = music_libraries_manager;
	_tmp2_ = _tmp1_->local_library;
	music_library_add_media (_tmp2_, m);
	_tmp3_ = self->index;
	self->index = _tmp3_ + 1;
	if (self->index == self->priv->queue_size) {
		music_file_operator_queue_finished (self);
	}
}

static void
music_file_operator_import_error (MusicFileOperator* self,
                                  const gchar* file)
{
	gint _tmp0_;
	GeeTreeSet* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	_tmp0_ = self->index;
	self->index = _tmp0_ + 1;
	_tmp1_ = self->priv->import_errors;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, file);
	if (self->index == self->priv->queue_size) {
		music_file_operator_queue_finished (self);
	}
}

static void
music_file_operator_queue_finished (MusicFileOperator* self)
{
	GeeTreeSet* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GeeTreeSet* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gboolean _tmp31_ = FALSE;
	gboolean _tmp32_ = FALSE;
	GeeTreeSet* _tmp39_;
	GeeTreeSet* _tmp40_;
	GCancellable* _tmp41_;
	g_return_if_fail (self != NULL);
	self->priv->queue_size = 0;
	_tmp0_ = self->priv->import_errors;
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_ > 0) {
		MusicNotImportedDialog* not_imported_dialog = NULL;
		GeeTreeSet* _tmp3_;
		MusicSettingsMain* _tmp4_;
		MusicSettingsMain* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		MusicNotImportedDialog* _tmp8_;
		MusicNotImportedDialog* _tmp9_;
		MusicNotImportedDialog* _tmp10_;
		_tmp3_ = self->priv->import_errors;
		_tmp4_ = music_settings_main_get_default ();
		_tmp5_ = _tmp4_;
		_tmp6_ = music_settings_main_get_music_folder (_tmp5_);
		_tmp7_ = _tmp6_;
		_tmp8_ = music_not_imported_dialog_new ((GeeCollection*) _tmp3_, _tmp7_);
		g_object_ref_sink (_tmp8_);
		_tmp9_ = _tmp8_;
		_g_object_unref0 (_tmp5_);
		not_imported_dialog = _tmp9_;
		_tmp10_ = not_imported_dialog;
		gtk_widget_show ((GtkWidget*) _tmp10_);
		_g_object_unref0 (not_imported_dialog);
	}
	_tmp11_ = self->priv->all_new_imports;
	_tmp12_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp11_);
	_tmp13_ = _tmp12_;
	if (_tmp13_ > 0) {
		MusicLibraryWindow* _tmp14_;
		MusicLibraryWindow* _tmp15_;
		_tmp14_ = music_app_get_main_window ();
		_tmp15_ = _tmp14_;
		music_library_window_show_notification (_tmp15_, _ ("Import Complete"), _ ("Your Library Has Been Imported."), NULL, G_NOTIFICATION_PRIORITY_LOW, "music");
	}
	if (self->priv->import_type == MUSIC_FILE_OPERATOR_IMPORT_TYPE_PLAYLIST) {
		MusicStaticPlaylist* _tmp16_;
		GeeTreeSet* _tmp17_;
		MusicStaticPlaylist* _tmp18_;
		MusicLibrariesManager* _tmp19_;
		MusicLibrary* _tmp20_;
		GeeCollection* _tmp21_;
		GeeCollection* _tmp22_;
		MusicStaticPlaylist* _tmp23_;
		const gchar* _tmp24_;
		const gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		MusicLibrariesManager* _tmp28_;
		MusicLibrary* _tmp29_;
		MusicStaticPlaylist* _tmp30_;
		_tmp16_ = self->priv->new_playlist;
		_tmp17_ = self->priv->all_new_imports;
		music_playlist_add_medias ((MusicPlaylist*) _tmp16_, (GeeCollection*) _tmp17_);
		_tmp18_ = self->priv->new_playlist;
		_tmp19_ = music_libraries_manager;
		_tmp20_ = _tmp19_->local_library;
		_tmp21_ = music_library_get_playlists (_tmp20_);
		_tmp22_ = _tmp21_;
		_tmp23_ = self->priv->new_playlist;
		_tmp24_ = music_playlist_get_name ((MusicPlaylist*) _tmp23_);
		_tmp25_ = _tmp24_;
		_tmp26_ = music_playlists_utils_get_new_playlist_name (_tmp22_, _tmp25_);
		_tmp27_ = _tmp26_;
		music_playlist_set_name ((MusicPlaylist*) _tmp18_, _tmp27_);
		_g_free0 (_tmp27_);
		_g_object_unref0 (_tmp22_);
		_tmp28_ = music_libraries_manager;
		_tmp29_ = _tmp28_->local_library;
		_tmp30_ = self->priv->new_playlist;
		music_library_add_playlist (_tmp29_, _tmp30_);
	}
	if (self->priv->import_type == MUSIC_FILE_OPERATOR_IMPORT_TYPE_IMPORT) {
		_tmp32_ = TRUE;
	} else {
		_tmp32_ = self->priv->import_type == MUSIC_FILE_OPERATOR_IMPORT_TYPE_PLAYLIST;
	}
	if (_tmp32_) {
		GSettings* _tmp33_;
		GSettings* _tmp34_;
		_tmp33_ = music_app_get_settings ();
		_tmp34_ = _tmp33_;
		_tmp31_ = g_settings_get_boolean (_tmp34_, "copy-imported-music");
	} else {
		_tmp31_ = FALSE;
	}
	if (_tmp31_) {
		MusicNotificationManager* _tmp35_;
		MusicNotificationManager* _tmp36_;
		_tmp35_ = music_notification_manager_get_default ();
		_tmp36_ = _tmp35_;
		g_signal_emit_by_name (_tmp36_, "update-progress", _ ("<b>Copying</b> files to <b>Music Folder</b>…"), 0.0);
		_g_object_unref0 (_tmp36_);
		music_file_operator_copy_imports_async (self, NULL, NULL);
	} else {
		MusicLibrariesManager* _tmp37_;
		MusicLibrary* _tmp38_;
		_tmp37_ = music_libraries_manager;
		_tmp38_ = _tmp37_->local_library;
		music_library_finish_file_operations (_tmp38_);
	}
	_tmp39_ = self->priv->all_new_imports;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp39_);
	_tmp40_ = self->priv->import_errors;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp40_);
	_tmp41_ = self->cancellable;
	g_cancellable_reset (_tmp41_);
}

static void
music_file_operator_copy_imports_async_data_free (gpointer _data)
{
	MusicFileOperatorCopyImportsAsyncData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (MusicFileOperatorCopyImportsAsyncData, _data_);
}

void
music_file_operator_copy_imports_async (MusicFileOperator* self,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_)
{
	MusicFileOperatorCopyImportsAsyncData* _data_;
	MusicFileOperator* _tmp0_;
	g_return_if_fail (self != NULL);
	_data_ = g_slice_new0 (MusicFileOperatorCopyImportsAsyncData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, music_file_operator_copy_imports_async_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	music_file_operator_copy_imports_async_co (_data_);
}

void
music_file_operator_copy_imports_finish (MusicFileOperator* self,
                                         GAsyncResult* _res_)
{
	MusicFileOperatorCopyImportsAsyncData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static gboolean
music_file_operator_copy_imports_async_co (MusicFileOperatorCopyImportsAsyncData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = _data_->self->priv->all_new_imports;
	_data_->_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp0_);
	_data_->_tmp2_ = _data_->_tmp1_;
	music_file_operator_reset_progress (_data_->self, _data_->_tmp2_);
	{
		_data_->_tmp3_ = _data_->self->priv->all_new_imports;
		_data_->_tmp4_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _data_->_tmp3_);
		_data_->_s_it = _data_->_tmp4_;
		while (TRUE) {
			_data_->_tmp5_ = _data_->_s_it;
			if (!gee_iterator_next (_data_->_tmp5_)) {
				break;
			}
			_data_->_tmp6_ = _data_->_s_it;
			_data_->_tmp7_ = gee_iterator_get (_data_->_tmp6_);
			_data_->s = (MusicMedia*) _data_->_tmp7_;
			_data_->_tmp8_ = _data_->self->cancellable;
			if (!g_cancellable_is_cancelled (_data_->_tmp8_)) {
				_data_->_tmp9_ = _data_->s;
				music_file_operator_update_file_hierarchy (_data_->self, _data_->_tmp9_, FALSE, TRUE);
			}
			_data_->self->index = _data_->self->index + 1;
			_data_->_tmp10_ = _data_->self->index;
			_g_object_unref0 (_data_->s);
		}
		_g_object_unref0 (_data_->_s_it);
	}
	_data_->_tmp11_ = music_libraries_manager;
	_data_->_tmp12_ = _data_->_tmp11_->local_library;
	music_library_finish_file_operations (_data_->_tmp12_);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
music_file_operator_class_init (MusicFileOperatorClass * klass,
                                gpointer klass_data)
{
	music_file_operator_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicFileOperator_private_offset);
	G_OBJECT_CLASS (klass)->finalize = music_file_operator_finalize;
	music_file_operator_signals[MUSIC_FILE_OPERATOR_IMPORT_CANCELLED_SIGNAL] = g_signal_new ("import-cancelled", MUSIC_TYPE_FILE_OPERATOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	music_file_operator_signals[MUSIC_FILE_OPERATOR_RESCAN_CANCELLED_SIGNAL] = g_signal_new ("rescan-cancelled", MUSIC_TYPE_FILE_OPERATOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
music_file_operator_instance_init (MusicFileOperator * self,
                                   gpointer klass)
{
	self->priv = music_file_operator_get_instance_private (self);
	self->priv->queue_size = 0;
}

static void
music_file_operator_finalize (GObject * obj)
{
	MusicFileOperator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_FILE_OPERATOR, MusicFileOperator);
	_g_object_unref0 (self->tagger);
	_g_object_unref0 (self->cancellable);
	_g_object_unref0 (self->priv->new_playlist);
	_g_object_unref0 (self->priv->all_new_imports);
	_g_object_unref0 (self->priv->import_errors);
	_g_object_unref0 (self->priv->monitors);
	G_OBJECT_CLASS (music_file_operator_parent_class)->finalize (obj);
}

static GType
music_file_operator_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicFileOperatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_file_operator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicFileOperator), 0, (GInstanceInitFunc) music_file_operator_instance_init, NULL };
	GType music_file_operator_type_id;
	music_file_operator_type_id = g_type_register_static (G_TYPE_OBJECT, "MusicFileOperator", &g_define_type_info, 0);
	MusicFileOperator_private_offset = g_type_add_instance_private (music_file_operator_type_id, sizeof (MusicFileOperatorPrivate));
	return music_file_operator_type_id;
}

GType
music_file_operator_get_type (void)
{
	static volatile gsize music_file_operator_type_id__once = 0;
	if (g_once_init_enter (&music_file_operator_type_id__once)) {
		GType music_file_operator_type_id;
		music_file_operator_type_id = music_file_operator_get_type_once ();
		g_once_init_leave (&music_file_operator_type_id__once, music_file_operator_type_id);
	}
	return music_file_operator_type_id__once;
}

