/* CoverImport.c generated by valac 0.56.1, the Vala compiler
 * generated from CoverImport.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "music-lib.h"
#include <gst/pbutils/pbutils.h>
#include "io.elementary.music-core.h"
#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gst/gst.h>
#include <gst/tag/tag.h>

#define MUSIC_COVER_IMPORT_DISCOVERER_TIMEOUT 5

enum  {
	MUSIC_COVER_IMPORT_0_PROPERTY,
	MUSIC_COVER_IMPORT_NUM_PROPERTIES
};
static GParamSpec* music_cover_import_properties[MUSIC_COVER_IMPORT_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block18Data Block18Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
#define _gst_sample_unref0(var) ((var == NULL) ? NULL : (var = (gst_sample_unref (var), NULL)))
#define _gst_buffer_unref0(var) ((var == NULL) ? NULL : (var = (gst_buffer_unref (var), NULL)))
#define _gst_tag_list_unref0(var) ((var == NULL) ? NULL : (var = (gst_tag_list_unref (var), NULL)))
#define _gst_caps_unref0(var) ((var == NULL) ? NULL : (var = (gst_caps_unref (var), NULL)))

struct _MusicCoverImportPrivate {
	GstDiscoverer* discoverer;
	MusicAlbum* album;
	GRecMutex __lock_album;
};

struct _Block18Data {
	int _ref_count_;
	MusicCoverImport* self;
	MusicAlbum* album;
};

static gint MusicCoverImport_private_offset;
static gpointer music_cover_import_parent_class = NULL;

static Block18Data* block18_data_ref (Block18Data* _data18_);
static void block18_data_unref (void * _userdata_);
static void* __lambda34_ (Block18Data* _data18_);
static void music_cover_import_read_info (MusicCoverImport* self,
                                   GstDiscovererInfo* info);
static gpointer ___lambda34__gthread_func (gpointer self);
static GstSample* music_cover_import_get_cover_sample (GstTagList* tag_list);
static GdkPixbuf* music_cover_import_get_pixbuf_from_buffer (GstBuffer* buffer);
static GObject * music_cover_import_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
static void music_cover_import_finalize (GObject * obj);
static GType music_cover_import_get_type_once (void);

static inline gpointer
music_cover_import_get_instance_private (MusicCoverImport* self)
{
	return G_STRUCT_MEMBER_P (self, MusicCoverImport_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static Block18Data*
block18_data_ref (Block18Data* _data18_)
{
	g_atomic_int_inc (&_data18_->_ref_count_);
	return _data18_;
}

static void
block18_data_unref (void * _userdata_)
{
	Block18Data* _data18_;
	_data18_ = (Block18Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data18_->_ref_count_)) {
		MusicCoverImport* self;
		self = _data18_->self;
		_g_object_unref0 (_data18_->album);
		_g_object_unref0 (self);
		g_slice_free (Block18Data, _data18_);
	}
}

static void*
__lambda34_ (Block18Data* _data18_)
{
	MusicCoverImport* self;
	GError* _inner_error0_ = NULL;
	void* result;
	self = _data18_->self;
	{
		MusicAlbum* _tmp0_;
		_tmp0_ = self->priv->album;
		g_rec_mutex_lock (&self->priv->__lock_album);
		{
			{
				GeeIterator* _media_it = NULL;
				GeeCollection* _tmp1_;
				GeeCollection* _tmp2_;
				GeeIterator* _tmp3_;
				GeeIterator* _tmp4_;
				_tmp1_ = music_album_get_media (_data18_->album, (guint) 1);
				_tmp2_ = _tmp1_;
				_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
				_tmp4_ = _tmp3_;
				_g_object_unref0 (_tmp2_);
				_media_it = _tmp4_;
				while (TRUE) {
					GeeIterator* _tmp5_;
					MusicMedia* media = NULL;
					GeeIterator* _tmp6_;
					gpointer _tmp7_;
					_tmp5_ = _media_it;
					if (!gee_iterator_next (_tmp5_)) {
						break;
					}
					_tmp6_ = _media_it;
					_tmp7_ = gee_iterator_get (_tmp6_);
					media = (MusicMedia*) _tmp7_;
					{
						GstDiscovererInfo* info = NULL;
						GstDiscoverer* _tmp8_;
						MusicMedia* _tmp9_;
						gchar* _tmp10_;
						gchar* _tmp11_;
						gchar* _tmp12_;
						GstDiscovererInfo* _tmp13_;
						GstDiscovererInfo* _tmp14_;
						GstDiscovererInfo* _tmp15_;
						_tmp8_ = self->priv->discoverer;
						_tmp9_ = media;
						_tmp10_ = music_media_get_uri (_tmp9_);
						_tmp11_ = _tmp10_;
						_tmp12_ = _tmp11_;
						_tmp13_ = gst_discoverer_discover_uri (_tmp8_, _tmp12_, &_inner_error0_);
						_tmp14_ = _tmp13_;
						_g_free0 (_tmp12_);
						info = _tmp14_;
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							goto __catch1_g_error;
						}
						_tmp15_ = info;
						music_cover_import_read_info (self, _tmp15_);
						_g_object_unref0 (info);
					}
					goto __finally1;
					__catch1_g_error:
					{
						GError* err = NULL;
						const gchar* _tmp16_;
						const gchar* _tmp17_;
						GError* _tmp18_;
						const gchar* _tmp19_;
						err = _inner_error0_;
						_inner_error0_ = NULL;
						_tmp16_ = music_album_get_name (_data18_->album);
						_tmp17_ = _tmp16_;
						_tmp18_ = err;
						_tmp19_ = _tmp18_->message;
						g_critical ("CoverImport.vala:52: Error while importing cover for %s: %s", _tmp17_, _tmp19_);
						_g_error_free0 (err);
					}
					__finally1:
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						_g_object_unref0 (media);
						_g_object_unref0 (_media_it);
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return NULL;
					}
					_g_object_unref0 (media);
				}
				_g_object_unref0 (_media_it);
			}
		}
		__finally0:
		{
			MusicAlbum* _tmp20_;
			_tmp20_ = self->priv->album;
			g_rec_mutex_unlock (&self->priv->__lock_album);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	result = NULL;
	return result;
}

static gpointer
___lambda34__gthread_func (gpointer self)
{
	gpointer result;
	result = __lambda34_ (self);
	block18_data_unref (self);
	return result;
}

MusicCoverImport*
music_cover_import_construct (GType object_type,
                              MusicAlbum* album)
{
	MusicCoverImport * self = NULL;
	Block18Data* _data18_;
	MusicAlbum* _tmp0_;
	MusicAlbum* _tmp1_;
	GThread* _tmp2_;
	GThread* _tmp3_;
	g_return_val_if_fail (album != NULL, NULL);
	_data18_ = g_slice_new0 (Block18Data);
	_data18_->_ref_count_ = 1;
	_tmp0_ = _g_object_ref0 (album);
	_g_object_unref0 (_data18_->album);
	_data18_->album = _tmp0_;
	self = (MusicCoverImport*) g_object_new (object_type, NULL);
	_data18_->self = g_object_ref (self);
	_tmp1_ = _g_object_ref0 (_data18_->album);
	_g_object_unref0 (self->priv->album);
	self->priv->album = _tmp1_;
	_tmp2_ = g_thread_new (NULL, ___lambda34__gthread_func, block18_data_ref (_data18_));
	_tmp3_ = _tmp2_;
	_g_thread_unref0 (_tmp3_);
	block18_data_unref (_data18_);
	_data18_ = NULL;
	return self;
}

MusicCoverImport*
music_cover_import_new (MusicAlbum* album)
{
	return music_cover_import_construct (MUSIC_TYPE_COVER_IMPORT, album);
}

static gpointer
_gst_tag_list_ref0 (gpointer self)
{
	return self ? gst_tag_list_ref (self) : NULL;
}

static gpointer
_gst_buffer_ref0 (gpointer self)
{
	return self ? gst_buffer_ref (self) : NULL;
}

static void
music_cover_import_read_info (MusicCoverImport* self,
                              GstDiscovererInfo* info)
{
	gchar* uri = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean gstreamer_discovery_successful = FALSE;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (info != NULL);
	_tmp0_ = gst_discoverer_info_get_uri (info);
	_tmp1_ = g_strdup (_tmp0_);
	uri = _tmp1_;
	gstreamer_discovery_successful = FALSE;
	switch (gst_discoverer_info_get_result (info)) {
		case GST_DISCOVERER_OK:
		{
			gstreamer_discovery_successful = TRUE;
			break;
		}
		case GST_DISCOVERER_URI_INVALID:
		{
			const gchar* _tmp2_;
			_tmp2_ = uri;
			g_warning ("CoverImport.vala:69: GStreamer could not import '%s': invalid URI.", _tmp2_);
			break;
		}
		case GST_DISCOVERER_ERROR:
		{
			const gchar* _tmp3_;
			_tmp3_ = uri;
			g_warning ("CoverImport.vala:73: GStreamer could not import '%s'", _tmp3_);
			break;
		}
		case GST_DISCOVERER_TIMEOUT:
		{
			const gchar* _tmp4_;
			_tmp4_ = uri;
			g_warning ("CoverImport.vala:77: GStreamer could not import '%s': Discovery timed " \
"out.", _tmp4_);
			break;
		}
		case GST_DISCOVERER_BUSY:
		{
			const gchar* _tmp5_;
			_tmp5_ = uri;
			g_warning ("CoverImport.vala:81: GStreamer could not import '%s': Already discover" \
"ing a file.", _tmp5_);
			break;
		}
		case GST_DISCOVERER_MISSING_PLUGINS:
		{
			const gchar* _tmp6_;
			_tmp6_ = uri;
			g_warning ("CoverImport.vala:85: GStreamer could not import '%s': Missing plugins.", _tmp6_);
			break;
		}
		default:
		break;
	}
	if (gstreamer_discovery_successful) {
		GdkPixbuf* pixbuf = NULL;
		GstTagList* tag_list = NULL;
		GstTagList* _tmp7_;
		GstTagList* _tmp8_;
		GstSample* sample = NULL;
		GstTagList* _tmp9_;
		GstSample* _tmp10_;
		GstSample* _tmp11_;
		GstSample* _tmp14_;
		pixbuf = NULL;
		_tmp7_ = gst_discoverer_info_get_tags (info);
		_tmp8_ = _gst_tag_list_ref0 (_tmp7_);
		tag_list = _tmp8_;
		_tmp9_ = tag_list;
		_tmp10_ = music_cover_import_get_cover_sample (_tmp9_);
		sample = _tmp10_;
		_tmp11_ = sample;
		if (_tmp11_ == NULL) {
			GstTagList* _tmp12_;
			GstSample* _tmp13_ = NULL;
			_tmp12_ = tag_list;
			gst_tag_list_get_sample_index (_tmp12_, GST_TAG_PREVIEW_IMAGE, (guint) 0, &_tmp13_);
			_gst_sample_unref0 (sample);
			sample = _tmp13_;
		}
		_tmp14_ = sample;
		if (_tmp14_ != NULL) {
			GstBuffer* buffer = NULL;
			GstSample* _tmp15_;
			GstBuffer* _tmp16_;
			GstBuffer* _tmp17_;
			GstBuffer* _tmp18_;
			const gchar* _tmp26_;
			_tmp15_ = sample;
			_tmp16_ = gst_sample_get_buffer (_tmp15_);
			_tmp17_ = _gst_buffer_ref0 (_tmp16_);
			buffer = _tmp17_;
			_tmp18_ = buffer;
			if (_tmp18_ != NULL) {
				GstBuffer* _tmp19_;
				GdkPixbuf* _tmp20_;
				GdkPixbuf* _tmp21_;
				_tmp19_ = buffer;
				_tmp20_ = music_cover_import_get_pixbuf_from_buffer (_tmp19_);
				_g_object_unref0 (pixbuf);
				pixbuf = _tmp20_;
				_tmp21_ = pixbuf;
				if (_tmp21_ != NULL) {
					{
						MusicAlbum* _tmp22_;
						_tmp22_ = self->priv->album;
						g_rec_mutex_lock (&self->priv->__lock_album);
						{
							MusicAlbum* _tmp23_;
							GdkPixbuf* _tmp24_;
							_tmp23_ = self->priv->album;
							_tmp24_ = pixbuf;
							music_album_save_cover_pixbuf (_tmp23_, _tmp24_);
						}
						__finally0:
						{
							MusicAlbum* _tmp25_;
							_tmp25_ = self->priv->album;
							g_rec_mutex_unlock (&self->priv->__lock_album);
						}
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							_gst_buffer_unref0 (buffer);
							_gst_sample_unref0 (sample);
							_gst_tag_list_unref0 (tag_list);
							_g_object_unref0 (pixbuf);
							_g_free0 (uri);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
							g_clear_error (&_inner_error0_);
							return;
						}
					}
				}
			}
			_tmp26_ = gst_discoverer_info_get_uri (info);
			g_debug ("CoverImport.vala:116: Final image buffer is NULL for '%s'", _tmp26_);
			_gst_buffer_unref0 (buffer);
		} else {
			const gchar* _tmp27_;
			_tmp27_ = gst_discoverer_info_get_uri (info);
			g_debug ("CoverImport.vala:118: Image sample is NULL for '%s'", _tmp27_);
		}
		_gst_sample_unref0 (sample);
		_gst_tag_list_unref0 (tag_list);
		_g_object_unref0 (pixbuf);
	}
	_g_free0 (uri);
}

static gpointer
_gst_caps_ref0 (gpointer self)
{
	return self ? gst_caps_ref (self) : NULL;
}

static gpointer
_gst_sample_ref0 (gpointer self)
{
	return self ? gst_sample_ref (self) : NULL;
}

static GstSample*
music_cover_import_get_cover_sample (GstTagList* tag_list)
{
	GstSample* cover_sample = NULL;
	GstSample* sample = NULL;
	GstSample* result;
	g_return_val_if_fail (tag_list != NULL, NULL);
	cover_sample = NULL;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				GstSample* _tmp2_ = NULL;
				gboolean _tmp3_;
				GstCaps* caps = NULL;
				GstSample* _tmp4_;
				GstCaps* _tmp5_;
				GstCaps* _tmp6_;
				GstStructure* caps_struct = NULL;
				GstCaps* _tmp7_;
				GstStructure* _tmp8_;
				gint image_type = 0;
				GstStructure* _tmp9_;
				gint _tmp10_ = 0;
				gboolean _tmp11_ = FALSE;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp3_ = gst_tag_list_get_sample_index (tag_list, GST_TAG_IMAGE, (guint) i, &_tmp2_);
				_gst_sample_unref0 (sample);
				sample = _tmp2_;
				if (!_tmp3_) {
					break;
				}
				_tmp4_ = sample;
				_tmp5_ = gst_sample_get_caps (_tmp4_);
				_tmp6_ = _gst_caps_ref0 (_tmp5_);
				caps = _tmp6_;
				_tmp7_ = caps;
				_tmp8_ = gst_caps_get_structure (_tmp7_, (guint) 0);
				caps_struct = _tmp8_;
				image_type = (gint) GST_TAG_IMAGE_TYPE_UNDEFINED;
				_tmp9_ = caps_struct;
				gst_structure_get_enum (_tmp9_, "image-type", gst_tag_image_type_get_type (), &_tmp10_);
				image_type = _tmp10_;
				if (image_type == ((gint) GST_TAG_IMAGE_TYPE_UNDEFINED)) {
					GstSample* _tmp12_;
					_tmp12_ = cover_sample;
					_tmp11_ = _tmp12_ == NULL;
				} else {
					_tmp11_ = FALSE;
				}
				if (_tmp11_) {
					GstSample* _tmp13_;
					GstSample* _tmp14_;
					_tmp13_ = sample;
					_tmp14_ = _gst_sample_ref0 (_tmp13_);
					_gst_sample_unref0 (cover_sample);
					cover_sample = _tmp14_;
				} else {
					if (image_type == ((gint) GST_TAG_IMAGE_TYPE_FRONT_COVER)) {
						result = sample;
						_gst_caps_unref0 (caps);
						_gst_sample_unref0 (cover_sample);
						return result;
					}
				}
				_gst_caps_unref0 (caps);
			}
		}
	}
	result = cover_sample;
	_gst_sample_unref0 (sample);
	return result;
}

static GdkPixbuf*
music_cover_import_get_pixbuf_from_buffer (GstBuffer* buffer)
{
	GstMapInfo map_info = {0};
	GstMapInfo _tmp0_ = {0};
	gboolean _tmp1_;
	GdkPixbuf* pix = NULL;
	GstMapInfo _tmp15_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
	g_return_val_if_fail (buffer != NULL, NULL);
	_tmp1_ = gst_buffer_map (buffer, &_tmp0_, GST_MAP_READ);
	map_info = _tmp0_;
	if (!_tmp1_) {
		g_warning ("CoverImport.vala:145: Could not map memory buffer");
		result = NULL;
		return result;
	}
	pix = NULL;
	{
		GdkPixbufLoader* loader = NULL;
		GdkPixbufLoader* _tmp2_;
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_ = FALSE;
		GdkPixbufLoader* _tmp5_;
		GstMapInfo _tmp6_;
		guint8* _tmp7_;
		gint _tmp7__length1;
		_tmp2_ = gdk_pixbuf_loader_new ();
		loader = _tmp2_;
		_tmp5_ = loader;
		_tmp6_ = map_info;
		_tmp7_ = _tmp6_.data;
		_tmp7__length1 = _tmp6_.size;
		_tmp4_ = gdk_pixbuf_loader_write (_tmp5_, _tmp7_, (gsize) _tmp7__length1, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (loader);
			goto __catch0_g_error;
		}
		if (_tmp4_) {
			gboolean _tmp8_ = FALSE;
			GdkPixbufLoader* _tmp9_;
			_tmp9_ = loader;
			_tmp8_ = gdk_pixbuf_loader_close (_tmp9_, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (loader);
				goto __catch0_g_error;
			}
			_tmp3_ = _tmp8_;
		} else {
			_tmp3_ = FALSE;
		}
		if (_tmp3_) {
			GdkPixbufLoader* _tmp10_;
			GdkPixbuf* _tmp11_;
			GdkPixbuf* _tmp12_;
			_tmp10_ = loader;
			_tmp11_ = gdk_pixbuf_loader_get_pixbuf (_tmp10_);
			_tmp12_ = _g_object_ref0 (_tmp11_);
			_g_object_unref0 (pix);
			pix = _tmp12_;
		}
		_g_object_unref0 (loader);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp13_ = err;
		_tmp14_ = _tmp13_->message;
		g_warning ("CoverImport.vala:157: Error processing image data: %s", _tmp14_);
		_g_error_free0 (err);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (pix);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	_tmp15_ = map_info;
	gst_buffer_unmap (buffer, &_tmp15_);
	result = pix;
	return result;
}

static GObject *
music_cover_import_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicCoverImport * self;
	GError* _inner_error0_ = NULL;
	parent_class = G_OBJECT_CLASS (music_cover_import_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_COVER_IMPORT, MusicCoverImport);
	{
		GstDiscoverer* _tmp0_ = NULL;
		GstDiscoverer* _tmp1_;
		GstDiscoverer* _tmp2_;
		_tmp1_ = gst_discoverer_new ((GstClockTime) (MUSIC_COVER_IMPORT_DISCOVERER_TIMEOUT * GST_SECOND), &_inner_error0_);
		_tmp0_ = _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp2_ = _tmp0_;
		_tmp0_ = NULL;
		_g_object_unref0 (self->priv->discoverer);
		self->priv->discoverer = _tmp2_;
		_g_object_unref0 (_tmp0_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp3_ = err;
		_tmp4_ = _tmp3_->message;
		g_critical ("CoverImport.vala:39: Could not create Gst discoverer object: %s", _tmp4_);
		_g_error_free0 (err);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
	}
	return obj;
}

static void
music_cover_import_class_init (MusicCoverImportClass * klass,
                               gpointer klass_data)
{
	music_cover_import_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicCoverImport_private_offset);
	G_OBJECT_CLASS (klass)->constructor = music_cover_import_constructor;
	G_OBJECT_CLASS (klass)->finalize = music_cover_import_finalize;
}

static void
music_cover_import_instance_init (MusicCoverImport * self,
                                  gpointer klass)
{
	self->priv = music_cover_import_get_instance_private (self);
	g_rec_mutex_init (&self->priv->__lock_album);
}

static void
music_cover_import_finalize (GObject * obj)
{
	MusicCoverImport * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_COVER_IMPORT, MusicCoverImport);
	_g_object_unref0 (self->priv->discoverer);
	g_rec_mutex_clear (&self->priv->__lock_album);
	_g_object_unref0 (self->priv->album);
	G_OBJECT_CLASS (music_cover_import_parent_class)->finalize (obj);
}

static GType
music_cover_import_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicCoverImportClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_cover_import_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicCoverImport), 0, (GInstanceInitFunc) music_cover_import_instance_init, NULL };
	GType music_cover_import_type_id;
	music_cover_import_type_id = g_type_register_static (G_TYPE_OBJECT, "MusicCoverImport", &g_define_type_info, 0);
	MusicCoverImport_private_offset = g_type_add_instance_private (music_cover_import_type_id, sizeof (MusicCoverImportPrivate));
	return music_cover_import_type_id;
}

GType
music_cover_import_get_type (void)
{
	static volatile gsize music_cover_import_type_id__once = 0;
	if (g_once_init_enter (&music_cover_import_type_id__once)) {
		GType music_cover_import_type_id;
		music_cover_import_type_id = music_cover_import_get_type_once ();
		g_once_init_leave (&music_cover_import_type_id__once, music_cover_import_type_id);
	}
	return music_cover_import_type_id__once;
}

