/* DevicePreferences.c generated by valac 0.56.1, the Vala compiler
 * generated from DevicePreferences.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Corentin Noël <corentin@elementary.io>
 */

#include "music-lib.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <libgda/libgda.h>
#include "io.elementary.music-core.h"
#include <glib-object.h>

enum  {
	MUSIC_DEVICE_PREFERENCES_0_PROPERTY,
	MUSIC_DEVICE_PREFERENCES_SYNC_WHEN_MOUNTED_PROPERTY,
	MUSIC_DEVICE_PREFERENCES_LAST_SYNC_TIME_PROPERTY,
	MUSIC_DEVICE_PREFERENCES_SYNC_MUSIC_PROPERTY,
	MUSIC_DEVICE_PREFERENCES_SYNC_ALL_MUSIC_PROPERTY,
	MUSIC_DEVICE_PREFERENCES_MUSIC_PLAYLIST_PROPERTY,
	MUSIC_DEVICE_PREFERENCES_NUM_PROPERTIES
};
static GParamSpec* music_device_preferences_properties[MUSIC_DEVICE_PREFERENCES_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_GValue_free0(var) ((var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _MusicDevicePreferencesPrivate {
	gchar* id;
	GdaConnection* connection;
};

static gint MusicDevicePreferences_private_offset;
static gpointer music_device_preferences_parent_class = NULL;

static GValue* music_device_preferences_query_field (MusicDevicePreferences* self,
                                              const gchar* field);
static void _vala_GValue_free (GValue* self);
static guint music_device_preferences_common_uint_getter (MusicDevicePreferences* self,
                                                   const gchar* field,
                                                   guint** temp);
static guint* _uint_dup (guint* self);
static void music_device_preferences_common_uint_setter (MusicDevicePreferences* self,
                                                  const gchar* field,
                                                  guint value,
                                                  guint** temp);
static void music_device_preferences_set_field (MusicDevicePreferences* self,
                                         const gchar* field,
                                         GValue* value);
static gboolean music_device_preferences_common_bool_getter (MusicDevicePreferences* self,
                                                      const gchar* field,
                                                      gboolean** temp);
static gboolean* _bool_dup (gboolean* self);
static void music_device_preferences_common_bool_setter (MusicDevicePreferences* self,
                                                  const gchar* field,
                                                  gboolean value,
                                                  gboolean** temp);
static GValue* _g_value_dup (GValue* self);
static void __vala_GValue_free0_ (gpointer var);
static inline void _g_slist_free___vala_GValue_free0_ (GSList* self);
static void _g_free0_ (gpointer var);
static inline void _g_slist_free__g_free0_ (GSList* self);
static void music_device_preferences_finalize (GObject * obj);
static GType music_device_preferences_get_type_once (void);
static void _vala_music_device_preferences_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_music_device_preferences_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);

static inline gpointer
music_device_preferences_get_instance_private (MusicDevicePreferences* self)
{
	return G_STRUCT_MEMBER_P (self, MusicDevicePreferences_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_vala_GValue_free (GValue* self)
{
	g_boxed_free (G_TYPE_VALUE, self);
}

MusicDevicePreferences*
music_device_preferences_construct (GType object_type,
                                    MusicDevice* device,
                                    GdaConnection* connection)
{
	MusicDevicePreferences * self = NULL;
	gchar* _tmp0_;
	GdaConnection* _tmp1_;
	GValue* _tmp2_;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (device != NULL, NULL);
	g_return_val_if_fail (connection != NULL, NULL);
	self = (MusicDevicePreferences*) g_object_new (object_type, NULL);
	_tmp0_ = music_device_get_unique_identifier (device);
	_g_free0 (self->priv->id);
	self->priv->id = _tmp0_;
	_tmp1_ = _g_object_ref0 (connection);
	_g_object_unref0 (self->priv->connection);
	self->priv->connection = _tmp1_;
	_tmp2_ = music_device_preferences_query_field (self, "sync_music");
	if (((gpointer) _tmp2_) == NULL) {
		{
			GdaSqlBuilder* builder = NULL;
			GdaSqlBuilder* _tmp3_;
			GdaSqlBuilder* _tmp4_;
			GdaSqlBuilder* _tmp5_;
			const gchar* _tmp6_;
			GValue* _tmp7_ = NULL;
			GdaStatement* _tmp8_ = NULL;
			GdaSqlBuilder* _tmp9_;
			GdaStatement* _tmp10_;
			_tmp3_ = gda_sql_builder_new (GDA_SQL_STATEMENT_INSERT);
			builder = _tmp3_;
			_tmp4_ = builder;
			gda_sql_builder_set_table (_tmp4_, MUSIC_DATABASE_DEVICES_TABLE_NAME);
			_tmp5_ = builder;
			_tmp6_ = self->priv->id;
			_tmp7_ = g_new0 (GValue, 1);
			g_value_init (_tmp7_, G_TYPE_STRING);
			g_value_set_string (_tmp7_, _tmp6_);
			gda_sql_builder_add_field_value_as_gvalue (_tmp5_, "unique_id", _tmp7_);
			__vala_GValue_free0 (_tmp7_);
			_tmp9_ = builder;
			_tmp10_ = gda_sql_builder_get_statement (_tmp9_, &_inner_error0_);
			_tmp8_ = _tmp10_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (builder);
				goto __catch0_g_error;
			}
			gda_connection_statement_execute_non_select (connection, _tmp8_, NULL, NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (_tmp8_);
				_g_object_unref0 (builder);
				goto __catch0_g_error;
			}
			_g_object_unref0 (_tmp8_);
			_g_object_unref0 (builder);
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp11_;
			const gchar* _tmp12_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp11_ = e;
			_tmp12_ = _tmp11_->message;
			g_warning ("DevicePreferences.vala:121: Could not save media: %s", _tmp12_);
			_g_error_free0 (e);
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	return self;
}

MusicDevicePreferences*
music_device_preferences_new (MusicDevice* device,
                              GdaConnection* connection)
{
	return music_device_preferences_construct (MUSIC_TYPE_DEVICE_PREFERENCES, device, connection);
}

static guint*
_uint_dup (guint* self)
{
	guint* dup;
	dup = g_new0 (guint, 1);
	memcpy (dup, self, sizeof (guint));
	return dup;
}

static gpointer
__uint_dup0 (gpointer self)
{
	return self ? _uint_dup (self) : NULL;
}

static guint
music_device_preferences_common_uint_getter (MusicDevicePreferences* self,
                                             const gchar* field,
                                             guint** temp)
{
	GValue* _result_ = NULL;
	GValue* _tmp0_;
	GValue* _tmp1_;
	GValue* _tmp4_;
	guint _tmp5_;
	guint* _tmp6_;
	guint result;
	g_return_val_if_fail (self != NULL, 0U);
	g_return_val_if_fail (field != NULL, 0U);
	if ((*temp) != NULL) {
		result = *(*temp);
		return result;
	}
	_tmp0_ = music_device_preferences_query_field (self, field);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	if (G_VALUE_TYPE (_tmp1_) == gda_null_get_type ()) {
		guint _tmp2_;
		guint* _tmp3_;
		_tmp2_ = (guint) 0;
		_tmp3_ = __uint_dup0 (&_tmp2_);
		_g_free0 (*temp);
		*temp = _tmp3_;
		result = *(*temp);
		__vala_GValue_free0 (_result_);
		return result;
	}
	_tmp4_ = _result_;
	_tmp5_ = (guint) g_value_get_int (_tmp4_);
	_tmp6_ = __uint_dup0 (&_tmp5_);
	_g_free0 (*temp);
	*temp = _tmp6_;
	result = *(*temp);
	__vala_GValue_free0 (_result_);
	return result;
}

static void
music_device_preferences_common_uint_setter (MusicDevicePreferences* self,
                                             const gchar* field,
                                             guint value,
                                             guint** temp)
{
	guint* _tmp0_;
	GValue _tmp1_ = {0};
	g_return_if_fail (self != NULL);
	g_return_if_fail (field != NULL);
	_tmp0_ = __uint_dup0 (&value);
	_g_free0 (*temp);
	*temp = _tmp0_;
	g_value_init (&_tmp1_, G_TYPE_UINT);
	g_value_set_uint (&_tmp1_, value);
	music_device_preferences_set_field (self, field, &_tmp1_);
	G_IS_VALUE (&_tmp1_) ? (g_value_unset (&_tmp1_), NULL) : NULL;
}

static gboolean*
_bool_dup (gboolean* self)
{
	gboolean* dup;
	dup = g_new0 (gboolean, 1);
	memcpy (dup, self, sizeof (gboolean));
	return dup;
}

static gpointer
__bool_dup0 (gpointer self)
{
	return self ? _bool_dup (self) : NULL;
}

static gboolean
music_device_preferences_common_bool_getter (MusicDevicePreferences* self,
                                             const gchar* field,
                                             gboolean** temp)
{
	GValue* _result_ = NULL;
	GValue* _tmp0_;
	GValue* _tmp1_;
	GValue* _tmp4_;
	gboolean _tmp5_;
	gboolean* _tmp6_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (field != NULL, FALSE);
	if ((*temp) != NULL) {
		result = *(*temp);
		return result;
	}
	_tmp0_ = music_device_preferences_query_field (self, field);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	if (G_VALUE_TYPE (_tmp1_) == gda_null_get_type ()) {
		gboolean _tmp2_;
		gboolean* _tmp3_;
		_tmp2_ = FALSE;
		_tmp3_ = __bool_dup0 (&_tmp2_);
		_g_free0 (*temp);
		*temp = _tmp3_;
		result = *(*temp);
		__vala_GValue_free0 (_result_);
		return result;
	}
	_tmp4_ = _result_;
	_tmp5_ = g_value_get_int (_tmp4_) == 1;
	_tmp6_ = __bool_dup0 (&_tmp5_);
	_g_free0 (*temp);
	*temp = _tmp6_;
	result = *(*temp);
	__vala_GValue_free0 (_result_);
	return result;
}

static void
music_device_preferences_common_bool_setter (MusicDevicePreferences* self,
                                             const gchar* field,
                                             gboolean value,
                                             gboolean** temp)
{
	gboolean* _tmp0_;
	GValue _tmp1_ = {0};
	g_return_if_fail (self != NULL);
	g_return_if_fail (field != NULL);
	_tmp0_ = __bool_dup0 (&value);
	_g_free0 (*temp);
	*temp = _tmp0_;
	g_value_init (&_tmp1_, G_TYPE_BOOLEAN);
	g_value_set_boolean (&_tmp1_, value);
	music_device_preferences_set_field (self, field, &_tmp1_);
	G_IS_VALUE (&_tmp1_) ? (g_value_unset (&_tmp1_), NULL) : NULL;
}

static GValue*
_g_value_dup (GValue* self)
{
	return g_boxed_copy (G_TYPE_VALUE, self);
}

static gpointer
__g_value_dup0 (gpointer self)
{
	return self ? _g_value_dup (self) : NULL;
}

static GValue*
music_device_preferences_query_field (MusicDevicePreferences* self,
                                      const gchar* field)
{
	GError* _inner_error0_ = NULL;
	GValue* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (field != NULL, NULL);
	{
		GdaSqlBuilder* sql = NULL;
		GdaSqlBuilder* _tmp0_;
		GdaSqlBuilder* _tmp1_;
		GdaSqlBuilder* _tmp2_;
		GdaSqlBuilder* _tmp3_;
		GdaSqlBuilderId id_field = 0U;
		GdaSqlBuilder* _tmp4_;
		GdaSqlBuilderId id_param = 0U;
		GdaSqlBuilder* _tmp5_;
		const gchar* _tmp6_;
		GValue* _tmp7_ = NULL;
		GdaSqlBuilderId _tmp8_;
		GdaSqlBuilderId id_cond = 0U;
		GdaSqlBuilder* _tmp9_;
		GdaSqlBuilder* _tmp10_;
		GdaStatement* _tmp11_ = NULL;
		GdaSqlBuilder* _tmp12_;
		GdaStatement* _tmp13_;
		GdaDataModel* data_model = NULL;
		GdaConnection* _tmp14_;
		GdaDataModel* _tmp15_;
		GValue* _tmp16_ = NULL;
		GdaDataModel* _tmp17_;
		GdaDataModel* _tmp18_;
		GValue* _tmp19_;
		_tmp0_ = gda_sql_builder_new (GDA_SQL_STATEMENT_SELECT);
		sql = _tmp0_;
		_tmp1_ = sql;
		gda_sql_builder_select_add_target (_tmp1_, MUSIC_DATABASE_DEVICES_TABLE_NAME, NULL);
		_tmp2_ = sql;
		_tmp3_ = sql;
		gda_sql_builder_add_field_value_id (_tmp2_, gda_sql_builder_add_id (_tmp3_, field), (GdaSqlBuilderId) 0);
		_tmp4_ = sql;
		id_field = gda_sql_builder_add_id (_tmp4_, "unique_id");
		_tmp5_ = sql;
		_tmp6_ = self->priv->id;
		_tmp7_ = g_new0 (GValue, 1);
		g_value_init (_tmp7_, G_TYPE_STRING);
		g_value_set_string (_tmp7_, _tmp6_);
		_tmp8_ = gda_sql_builder_add_expr_value (_tmp5_, NULL, _tmp7_);
		__vala_GValue_free0 (_tmp7_);
		id_param = _tmp8_;
		_tmp9_ = sql;
		id_cond = gda_sql_builder_add_cond (_tmp9_, GDA_SQL_OPERATOR_TYPE_EQ, id_field, id_param, (GdaSqlBuilderId) 0);
		_tmp10_ = sql;
		gda_sql_builder_set_where (_tmp10_, id_cond);
		_tmp12_ = sql;
		_tmp13_ = gda_sql_builder_get_statement (_tmp12_, &_inner_error0_);
		_tmp11_ = _tmp13_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (sql);
			goto __catch0_g_error;
		}
		_tmp14_ = self->priv->connection;
		_tmp15_ = gda_connection_statement_execute_select (_tmp14_, _tmp11_, NULL, &_inner_error0_);
		data_model = _tmp15_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (_tmp11_);
			_g_object_unref0 (sql);
			goto __catch0_g_error;
		}
		_tmp17_ = data_model;
		_tmp18_ = data_model;
		_tmp16_ = gda_data_model_get_value_at (_tmp17_, gda_data_model_get_column_index (_tmp18_, field), 0, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (data_model);
			_g_object_unref0 (_tmp11_);
			_g_object_unref0 (sql);
			goto __catch0_g_error;
		}
		_tmp19_ = __g_value_dup0 (_tmp16_);
		result = _tmp19_;
		_g_object_unref0 (data_model);
		_g_object_unref0 (_tmp11_);
		_g_object_unref0 (sql);
		return result;
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp20_;
		const gchar* _tmp21_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp20_ = e;
		_tmp21_ = _tmp20_->message;
		g_critical ("DevicePreferences.vala:176: Could not query field %s: %s", field, _tmp21_);
		result = NULL;
		_g_error_free0 (e);
		return result;
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

static void
__vala_GValue_free0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL));
}

static inline void
_g_slist_free___vala_GValue_free0_ (GSList* self)
{
	g_slist_free_full (self, (GDestroyNotify) __vala_GValue_free0_);
}

static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}

static inline void
_g_slist_free__g_free0_ (GSList* self)
{
	g_slist_free_full (self, (GDestroyNotify) _g_free0_);
}

static void
music_device_preferences_set_field (MusicDevicePreferences* self,
                                    const gchar* field,
                                    GValue* value)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (field != NULL);
	g_return_if_fail (value != NULL);
	{
		GSList* col_names = NULL;
		gchar* _tmp0_;
		GSList* values = NULL;
		GValue _tmp1_;
		GValue _tmp2_;
		GValue* _tmp3_;
		GdaConnection* _tmp4_;
		const gchar* _tmp5_;
		GValue _tmp6_ = {0};
		col_names = NULL;
		_tmp0_ = g_strdup (field);
		col_names = g_slist_append (col_names, _tmp0_);
		values = NULL;
		_tmp1_ = *value;
		_tmp2_ = _tmp1_;
		_tmp3_ = __g_value_dup0 (&_tmp2_);
		values = g_slist_append (values, _tmp3_);
		_tmp4_ = self->priv->connection;
		_tmp5_ = self->priv->id;
		g_value_init (&_tmp6_, G_TYPE_STRING);
		g_value_set_string (&_tmp6_, _tmp5_);
		gda_connection_update_row_in_table_v (_tmp4_, MUSIC_DATABASE_DEVICES_TABLE_NAME, "unique_id", &_tmp6_, col_names, values, &_inner_error0_);
		G_IS_VALUE (&_tmp6_) ? (g_value_unset (&_tmp6_), NULL) : NULL;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
			(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
			goto __catch0_g_error;
		}
		(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
		(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp7_ = e;
		_tmp8_ = _tmp7_->message;
		g_critical ("DevicePreferences.vala:189: Could not set field %s: %s", field, _tmp8_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

gboolean
music_device_preferences_get_sync_when_mounted (MusicDevicePreferences* self)
{
	gboolean result;
	gboolean* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	music_device_preferences_common_bool_getter (self, "sync_when_mounted", &self->_sync_when_mounted);
	_tmp0_ = self->_sync_when_mounted;
	result = *_tmp0_;
	return result;
}

void
music_device_preferences_set_sync_when_mounted (MusicDevicePreferences* self,
                                                gboolean value)
{
	g_return_if_fail (self != NULL);
	music_device_preferences_common_bool_setter (self, "sync_when_mounted", value, &self->_sync_when_mounted);
	g_object_notify_by_pspec ((GObject *) self, music_device_preferences_properties[MUSIC_DEVICE_PREFERENCES_SYNC_WHEN_MOUNTED_PROPERTY]);
}

guint
music_device_preferences_get_last_sync_time (MusicDevicePreferences* self)
{
	guint result;
	guint* _tmp0_;
	g_return_val_if_fail (self != NULL, 0U);
	music_device_preferences_common_uint_getter (self, "last_sync_time", &self->_last_sync_time);
	_tmp0_ = self->_last_sync_time;
	result = *_tmp0_;
	return result;
}

void
music_device_preferences_set_last_sync_time (MusicDevicePreferences* self,
                                             guint value)
{
	g_return_if_fail (self != NULL);
	music_device_preferences_common_uint_setter (self, "last_sync_time", value, &self->_last_sync_time);
	g_object_notify_by_pspec ((GObject *) self, music_device_preferences_properties[MUSIC_DEVICE_PREFERENCES_LAST_SYNC_TIME_PROPERTY]);
}

gboolean
music_device_preferences_get_sync_music (MusicDevicePreferences* self)
{
	gboolean result;
	gboolean* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	music_device_preferences_common_bool_getter (self, "sync_music", &self->_sync_music);
	_tmp0_ = self->_sync_music;
	result = *_tmp0_;
	return result;
}

void
music_device_preferences_set_sync_music (MusicDevicePreferences* self,
                                         gboolean value)
{
	g_return_if_fail (self != NULL);
	music_device_preferences_common_bool_setter (self, "sync_music", value, &self->_sync_music);
	g_object_notify_by_pspec ((GObject *) self, music_device_preferences_properties[MUSIC_DEVICE_PREFERENCES_SYNC_MUSIC_PROPERTY]);
}

gboolean
music_device_preferences_get_sync_all_music (MusicDevicePreferences* self)
{
	gboolean result;
	gboolean* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	music_device_preferences_common_bool_getter (self, "sync_all_music", &self->_sync_all_music);
	_tmp0_ = self->_sync_all_music;
	result = *_tmp0_;
	return result;
}

void
music_device_preferences_set_sync_all_music (MusicDevicePreferences* self,
                                             gboolean value)
{
	g_return_if_fail (self != NULL);
	music_device_preferences_common_bool_setter (self, "sync_all_music", value, &self->_sync_all_music);
	g_object_notify_by_pspec ((GObject *) self, music_device_preferences_properties[MUSIC_DEVICE_PREFERENCES_SYNC_ALL_MUSIC_PROPERTY]);
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		g_clear_error (&_inner_error0_);
		g_assert_not_reached ();
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

static gint64
int64_parse (const gchar* str,
             guint _base)
{
	gint64 result;
	g_return_val_if_fail (str != NULL, 0LL);
	result = g_ascii_strtoll (str, NULL, _base);
	return result;
}

MusicPlaylist*
music_device_preferences_get_music_playlist (MusicDevicePreferences* self)
{
	MusicPlaylist* result;
	GValue* _result_ = NULL;
	GValue* _tmp0_;
	GValue* _tmp1_;
	gchar* playlist_string = NULL;
	GValue* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean _tmp5_ = FALSE;
	const gchar* _tmp6_;
	const gchar* _tmp8_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = music_device_preferences_query_field (self, "music_playlist");
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	if (G_VALUE_TYPE (_tmp1_) == gda_null_get_type ()) {
		result = NULL;
		__vala_GValue_free0 (_result_);
		return result;
	}
	_tmp2_ = _result_;
	_tmp3_ = g_value_get_string (_tmp2_);
	_tmp4_ = g_strdup (_tmp3_);
	playlist_string = _tmp4_;
	_tmp6_ = playlist_string;
	if (g_strcmp0 (_tmp6_, "") == 0) {
		_tmp5_ = TRUE;
	} else {
		const gchar* _tmp7_;
		_tmp7_ = playlist_string;
		_tmp5_ = _tmp7_ == NULL;
	}
	if (_tmp5_) {
		result = NULL;
		_g_free0 (playlist_string);
		__vala_GValue_free0 (_result_);
		return result;
	}
	_tmp8_ = playlist_string;
	if (string_contains (_tmp8_, "p")) {
		const gchar* _tmp9_;
		gchar* _tmp10_;
		MusicLibrariesManager* _tmp11_;
		MusicLibrary* _tmp12_;
		const gchar* _tmp13_;
		MusicStaticPlaylist* _tmp14_;
		_tmp9_ = playlist_string;
		_tmp10_ = string_replace (_tmp9_, "p", "");
		_g_free0 (playlist_string);
		playlist_string = _tmp10_;
		_tmp11_ = music_libraries_manager;
		_tmp12_ = _tmp11_->local_library;
		_tmp13_ = playlist_string;
		_tmp14_ = music_library_playlist_from_id (_tmp12_, int64_parse (_tmp13_, (guint) 0));
		result = (MusicPlaylist*) _tmp14_;
		_g_free0 (playlist_string);
		__vala_GValue_free0 (_result_);
		return result;
	} else {
		const gchar* _tmp15_;
		gchar* _tmp16_;
		MusicLibrariesManager* _tmp17_;
		MusicLibrary* _tmp18_;
		const gchar* _tmp19_;
		MusicSmartPlaylist* _tmp20_;
		_tmp15_ = playlist_string;
		_tmp16_ = string_replace (_tmp15_, "s", "");
		_g_free0 (playlist_string);
		playlist_string = _tmp16_;
		_tmp17_ = music_libraries_manager;
		_tmp18_ = _tmp17_->local_library;
		_tmp19_ = playlist_string;
		_tmp20_ = music_library_smart_playlist_from_id (_tmp18_, int64_parse (_tmp19_, (guint) 0));
		result = (MusicPlaylist*) _tmp20_;
		_g_free0 (playlist_string);
		__vala_GValue_free0 (_result_);
		return result;
	}
}

void
music_device_preferences_set_music_playlist (MusicDevicePreferences* self,
                                             MusicPlaylist* value)
{
	gchar* playlist_string = NULL;
	gchar* _tmp0_;
	const gchar* _tmp7_;
	GValue _tmp8_ = {0};
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup ("");
	playlist_string = _tmp0_;
	if (value != NULL) {
		if (G_TYPE_CHECK_INSTANCE_TYPE (value, MUSIC_TYPE_STATIC_PLAYLIST)) {
			gint64 _tmp1_;
			gint64 _tmp2_;
			gchar* _tmp3_;
			_tmp1_ = music_playlist_get_rowid (value);
			_tmp2_ = _tmp1_;
			_tmp3_ = g_strdup_printf ("p%lld", _tmp2_);
			_g_free0 (playlist_string);
			playlist_string = _tmp3_;
		} else {
			gint64 _tmp4_;
			gint64 _tmp5_;
			gchar* _tmp6_;
			_tmp4_ = music_playlist_get_rowid (value);
			_tmp5_ = _tmp4_;
			_tmp6_ = g_strdup_printf ("s%lld", _tmp5_);
			_g_free0 (playlist_string);
			playlist_string = _tmp6_;
		}
	}
	_tmp7_ = playlist_string;
	g_value_init (&_tmp8_, G_TYPE_STRING);
	g_value_set_string (&_tmp8_, _tmp7_);
	music_device_preferences_set_field (self, "music_playlist", &_tmp8_);
	G_IS_VALUE (&_tmp8_) ? (g_value_unset (&_tmp8_), NULL) : NULL;
	_g_free0 (playlist_string);
	g_object_notify_by_pspec ((GObject *) self, music_device_preferences_properties[MUSIC_DEVICE_PREFERENCES_MUSIC_PLAYLIST_PROPERTY]);
}

static void
music_device_preferences_class_init (MusicDevicePreferencesClass * klass,
                                     gpointer klass_data)
{
	music_device_preferences_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicDevicePreferences_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_music_device_preferences_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_music_device_preferences_set_property;
	G_OBJECT_CLASS (klass)->finalize = music_device_preferences_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_DEVICE_PREFERENCES_SYNC_WHEN_MOUNTED_PROPERTY, music_device_preferences_properties[MUSIC_DEVICE_PREFERENCES_SYNC_WHEN_MOUNTED_PROPERTY] = g_param_spec_boolean ("sync-when-mounted", "sync-when-mounted", "sync-when-mounted", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_DEVICE_PREFERENCES_LAST_SYNC_TIME_PROPERTY, music_device_preferences_properties[MUSIC_DEVICE_PREFERENCES_LAST_SYNC_TIME_PROPERTY] = g_param_spec_uint ("last-sync-time", "last-sync-time", "last-sync-time", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_DEVICE_PREFERENCES_SYNC_MUSIC_PROPERTY, music_device_preferences_properties[MUSIC_DEVICE_PREFERENCES_SYNC_MUSIC_PROPERTY] = g_param_spec_boolean ("sync-music", "sync-music", "sync-music", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_DEVICE_PREFERENCES_SYNC_ALL_MUSIC_PROPERTY, music_device_preferences_properties[MUSIC_DEVICE_PREFERENCES_SYNC_ALL_MUSIC_PROPERTY] = g_param_spec_boolean ("sync-all-music", "sync-all-music", "sync-all-music", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_DEVICE_PREFERENCES_MUSIC_PLAYLIST_PROPERTY, music_device_preferences_properties[MUSIC_DEVICE_PREFERENCES_MUSIC_PLAYLIST_PROPERTY] = g_param_spec_object ("music-playlist", "music-playlist", "music-playlist", MUSIC_TYPE_PLAYLIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
music_device_preferences_instance_init (MusicDevicePreferences * self,
                                        gpointer klass)
{
	self->priv = music_device_preferences_get_instance_private (self);
	self->_sync_when_mounted = NULL;
	self->_last_sync_time = NULL;
	self->_sync_music = NULL;
	self->_sync_all_music = NULL;
}

static void
music_device_preferences_finalize (GObject * obj)
{
	MusicDevicePreferences * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_DEVICE_PREFERENCES, MusicDevicePreferences);
	_g_free0 (self->priv->id);
	_g_free0 (self->_sync_when_mounted);
	_g_free0 (self->_last_sync_time);
	_g_free0 (self->_sync_music);
	_g_free0 (self->_sync_all_music);
	_g_object_unref0 (self->priv->connection);
	G_OBJECT_CLASS (music_device_preferences_parent_class)->finalize (obj);
}

static GType
music_device_preferences_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicDevicePreferencesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_device_preferences_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicDevicePreferences), 0, (GInstanceInitFunc) music_device_preferences_instance_init, NULL };
	GType music_device_preferences_type_id;
	music_device_preferences_type_id = g_type_register_static (G_TYPE_OBJECT, "MusicDevicePreferences", &g_define_type_info, 0);
	MusicDevicePreferences_private_offset = g_type_add_instance_private (music_device_preferences_type_id, sizeof (MusicDevicePreferencesPrivate));
	return music_device_preferences_type_id;
}

GType
music_device_preferences_get_type (void)
{
	static volatile gsize music_device_preferences_type_id__once = 0;
	if (g_once_init_enter (&music_device_preferences_type_id__once)) {
		GType music_device_preferences_type_id;
		music_device_preferences_type_id = music_device_preferences_get_type_once ();
		g_once_init_leave (&music_device_preferences_type_id__once, music_device_preferences_type_id);
	}
	return music_device_preferences_type_id__once;
}

static void
_vala_music_device_preferences_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	MusicDevicePreferences * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_DEVICE_PREFERENCES, MusicDevicePreferences);
	switch (property_id) {
		case MUSIC_DEVICE_PREFERENCES_SYNC_WHEN_MOUNTED_PROPERTY:
		g_value_set_boolean (value, music_device_preferences_get_sync_when_mounted (self));
		break;
		case MUSIC_DEVICE_PREFERENCES_LAST_SYNC_TIME_PROPERTY:
		g_value_set_uint (value, music_device_preferences_get_last_sync_time (self));
		break;
		case MUSIC_DEVICE_PREFERENCES_SYNC_MUSIC_PROPERTY:
		g_value_set_boolean (value, music_device_preferences_get_sync_music (self));
		break;
		case MUSIC_DEVICE_PREFERENCES_SYNC_ALL_MUSIC_PROPERTY:
		g_value_set_boolean (value, music_device_preferences_get_sync_all_music (self));
		break;
		case MUSIC_DEVICE_PREFERENCES_MUSIC_PLAYLIST_PROPERTY:
		g_value_take_object (value, music_device_preferences_get_music_playlist (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_music_device_preferences_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	MusicDevicePreferences * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_DEVICE_PREFERENCES, MusicDevicePreferences);
	switch (property_id) {
		case MUSIC_DEVICE_PREFERENCES_SYNC_WHEN_MOUNTED_PROPERTY:
		music_device_preferences_set_sync_when_mounted (self, g_value_get_boolean (value));
		break;
		case MUSIC_DEVICE_PREFERENCES_LAST_SYNC_TIME_PROPERTY:
		music_device_preferences_set_last_sync_time (self, g_value_get_uint (value));
		break;
		case MUSIC_DEVICE_PREFERENCES_SYNC_MUSIC_PROPERTY:
		music_device_preferences_set_sync_music (self, g_value_get_boolean (value));
		break;
		case MUSIC_DEVICE_PREFERENCES_SYNC_ALL_MUSIC_PROPERTY:
		music_device_preferences_set_sync_all_music (self, g_value_get_boolean (value));
		break;
		case MUSIC_DEVICE_PREFERENCES_MUSIC_PLAYLIST_PROPERTY:
		music_device_preferences_set_music_playlist (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

