/* LocalStaticPlaylist.c generated by valac 0.56.1, the Vala compiler
 * generated from LocalStaticPlaylist.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "music-lib.h"
#include <libgda/libgda.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "io.elementary.music-core.h"
#include <glib-object.h>
#include <gee.h>

enum  {
	MUSIC_LOCAL_STATIC_PLAYLIST_0_PROPERTY,
	MUSIC_LOCAL_STATIC_PLAYLIST_NAME_PROPERTY,
	MUSIC_LOCAL_STATIC_PLAYLIST_NUM_PROPERTIES
};
static GParamSpec* music_local_static_playlist_properties[MUSIC_LOCAL_STATIC_PLAYLIST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_GValue_free0(var) ((var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

struct _MusicLocalStaticPlaylistPrivate {
	GdaConnection* connection;
	gchar* _name;
};

static gint MusicLocalStaticPlaylist_private_offset;
static gpointer music_local_static_playlist_parent_class = NULL;

static void _vala_GValue_free (GValue* self);
static void music_local_static_playlist_update_database (MusicLocalStaticPlaylist* self);
static void __vala_GValue_free0_ (gpointer var);
static inline void _g_slist_free___vala_GValue_free0_ (GSList* self);
static void _g_free0_ (gpointer var);
static inline void _g_slist_free__g_free0_ (GSList* self);
static GObject * music_local_static_playlist_constructor (GType type,
                                                   guint n_construct_properties,
                                                   GObjectConstructParam * construct_properties);
static void _music_local_static_playlist___lambda19_ (MusicLocalStaticPlaylist* self,
                                               const gchar* old_name);
static void __music_local_static_playlist___lambda19__music_playlist_updated (MusicPlaylist* _sender,
                                                                       const gchar* old_name,
                                                                       gpointer self);
static void music_local_static_playlist_finalize (GObject * obj);
static GType music_local_static_playlist_get_type_once (void);
static void _vala_music_local_static_playlist_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec);
static void _vala_music_local_static_playlist_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
music_local_static_playlist_get_instance_private (MusicLocalStaticPlaylist* self)
{
	return G_STRUCT_MEMBER_P (self, MusicLocalStaticPlaylist_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_vala_GValue_free (GValue* self)
{
	g_boxed_free (G_TYPE_VALUE, self);
}

static gint64
int64_parse (const gchar* str,
             guint _base)
{
	gint64 result;
	g_return_val_if_fail (str != NULL, 0LL);
	result = g_ascii_strtoll (str, NULL, _base);
	return result;
}

MusicLocalStaticPlaylist*
music_local_static_playlist_construct (GType object_type,
                                       gint64 rowid,
                                       GdaConnection* connection)
{
	MusicLocalStaticPlaylist * self = NULL;
	GdaConnection* _tmp0_;
	gchar* all = NULL;
	GValue* _tmp1_;
	GValue* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar** _tmp6_;
	gchar** _tmp7_;
	g_return_val_if_fail (connection != NULL, NULL);
	self = (MusicLocalStaticPlaylist*) music_static_playlist_construct (object_type);
	music_playlist_set_rowid ((MusicPlaylist*) self, rowid);
	_tmp0_ = _g_object_ref0 (connection);
	_g_object_unref0 (self->priv->connection);
	self->priv->connection = _tmp0_;
	_tmp1_ = music_database_query_field (rowid, connection, MUSIC_DATABASE_PLAYLISTS_TABLE_NAME, "media");
	_tmp2_ = _tmp1_;
	_tmp3_ = g_value_dup_string (_tmp2_);
	_tmp4_ = _tmp3_;
	__vala_GValue_free0 (_tmp2_);
	all = _tmp4_;
	_tmp5_ = all;
	_tmp7_ = _tmp6_ = g_strsplit (_tmp5_, ";", 0);
	{
		gchar** id_collection = NULL;
		gint id_collection_length1 = 0;
		gint _id_collection_size_ = 0;
		gint id_it = 0;
		id_collection = _tmp7_;
		id_collection_length1 = _vala_array_length (_tmp6_);
		for (id_it = 0; id_it < id_collection_length1; id_it = id_it + 1) {
			gchar* _tmp8_;
			gchar* id = NULL;
			_tmp8_ = g_strdup (id_collection[id_it]);
			id = _tmp8_;
			{
				GeeArrayList* _tmp9_;
				GeeArrayList* _tmp10_;
				MusicLibrariesManager* _tmp11_;
				MusicLibrary* _tmp12_;
				const gchar* _tmp13_;
				MusicMedia* _tmp14_;
				MusicMedia* _tmp15_;
				_tmp9_ = music_playlist_get_medias ((MusicPlaylist*) self);
				_tmp10_ = _tmp9_;
				_tmp11_ = music_libraries_manager;
				_tmp12_ = _tmp11_->local_library;
				_tmp13_ = id;
				_tmp14_ = music_library_media_from_id (_tmp12_, int64_parse (_tmp13_, (guint) 0));
				_tmp15_ = _tmp14_;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, _tmp15_);
				_g_object_unref0 (_tmp15_);
				_g_free0 (id);
			}
		}
		id_collection = (_vala_array_free (id_collection, id_collection_length1, (GDestroyNotify) g_free), NULL);
	}
	_g_free0 (all);
	return self;
}

MusicLocalStaticPlaylist*
music_local_static_playlist_new (gint64 rowid,
                                 GdaConnection* connection)
{
	return music_local_static_playlist_construct (MUSIC_TYPE_LOCAL_STATIC_PLAYLIST, rowid, connection);
}

static void
__vala_GValue_free0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL));
}

static inline void
_g_slist_free___vala_GValue_free0_ (GSList* self)
{
	g_slist_free_full (self, (GDestroyNotify) __vala_GValue_free0_);
}

static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}

static inline void
_g_slist_free__g_free0_ (GSList* self)
{
	g_slist_free_full (self, (GDestroyNotify) _g_free0_);
}

static void
music_local_static_playlist_update_database (MusicLocalStaticPlaylist* self)
{
	GValue rowid_value = {0};
	GValue _tmp0_ = {0};
	gint64 _tmp1_;
	gint64 _tmp2_;
	GSList* col_names = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GSList* values = NULL;
	GString* sb = NULL;
	GString* _tmp5_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	GValue* _tmp23_ = NULL;
	GString* _tmp24_;
	const gchar* _tmp25_;
	GValue* _tmp26_ = NULL;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_value_init (&_tmp0_, G_TYPE_INT64);
	rowid_value = _tmp0_;
	_tmp1_ = music_playlist_get_rowid ((MusicPlaylist*) self);
	_tmp2_ = _tmp1_;
	g_value_set_int64 (&rowid_value, _tmp2_);
	col_names = NULL;
	_tmp3_ = g_strdup ("name");
	col_names = g_slist_append (col_names, _tmp3_);
	_tmp4_ = g_strdup ("media");
	col_names = g_slist_append (col_names, _tmp4_);
	values = NULL;
	_tmp5_ = g_string_new ("");
	sb = _tmp5_;
	{
		GeeArrayList* _m_list = NULL;
		GeeArrayList* _tmp6_;
		GeeArrayList* _tmp7_;
		gint _m_size = 0;
		GeeArrayList* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		gint _m_index = 0;
		_tmp6_ = music_playlist_get_medias ((MusicPlaylist*) self);
		_tmp7_ = _tmp6_;
		_m_list = _tmp7_;
		_tmp8_ = _m_list;
		_tmp9_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp8_);
		_tmp10_ = _tmp9_;
		_m_size = _tmp10_;
		_m_index = -1;
		while (TRUE) {
			gint _tmp11_;
			gint _tmp12_;
			MusicMedia* m = NULL;
			GeeArrayList* _tmp13_;
			gpointer _tmp14_;
			GString* _tmp15_;
			GString* _tmp17_;
			MusicMedia* _tmp18_;
			gint64 _tmp19_;
			gint64 _tmp20_;
			_m_index = _m_index + 1;
			_tmp11_ = _m_index;
			_tmp12_ = _m_size;
			if (!(_tmp11_ < _tmp12_)) {
				break;
			}
			_tmp13_ = _m_list;
			_tmp14_ = gee_abstract_list_get ((GeeAbstractList*) _tmp13_, _m_index);
			m = (MusicMedia*) _tmp14_;
			_tmp15_ = sb;
			if (_tmp15_->len != ((gssize) 0)) {
				GString* _tmp16_;
				_tmp16_ = sb;
				g_string_append_c (_tmp16_, ';');
			}
			_tmp17_ = sb;
			_tmp18_ = m;
			_tmp19_ = music_media_get_rowid (_tmp18_);
			_tmp20_ = _tmp19_;
			g_string_append_printf (_tmp17_, "%lld", _tmp20_);
			_g_object_unref0 (m);
		}
	}
	_tmp21_ = music_playlist_get_name ((MusicPlaylist*) self);
	_tmp22_ = _tmp21_;
	_tmp23_ = g_new0 (GValue, 1);
	g_value_init (_tmp23_, G_TYPE_STRING);
	g_value_set_string (_tmp23_, _tmp22_);
	values = g_slist_append (values, _tmp23_);
	_tmp24_ = sb;
	_tmp25_ = _tmp24_->str;
	_tmp26_ = g_new0 (GValue, 1);
	g_value_init (_tmp26_, G_TYPE_STRING);
	g_value_set_string (_tmp26_, _tmp25_);
	values = g_slist_append (values, _tmp26_);
	{
		GdaConnection* _tmp27_;
		GValue _tmp28_;
		GSList* _tmp29_;
		GSList* _tmp30_;
		_tmp27_ = self->priv->connection;
		_tmp28_ = rowid_value;
		_tmp29_ = col_names;
		_tmp30_ = values;
		gda_connection_update_row_in_table_v (_tmp27_, MUSIC_DATABASE_PLAYLISTS_TABLE_NAME, "rowid", &_tmp28_, _tmp29_, _tmp30_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp31_;
		const gchar* _tmp32_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp31_ = e;
		_tmp32_ = _tmp31_->message;
		g_critical ("LocalStaticPlaylist.vala:85: %s", _tmp32_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_string_free0 (sb);
		(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
		(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
		G_IS_VALUE (&rowid_value) ? (g_value_unset (&rowid_value), NULL) : NULL;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_g_string_free0 (sb);
	(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
	(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
	G_IS_VALUE (&rowid_value) ? (g_value_unset (&rowid_value), NULL) : NULL;
}

static const gchar*
music_local_static_playlist_real_get_name (MusicPlaylist* base)
{
	const gchar* result;
	MusicLocalStaticPlaylist* self;
	const gchar* _tmp0_;
	gint64 _tmp2_;
	gint64 _tmp3_;
	GdaConnection* _tmp4_;
	GValue* _tmp5_;
	GValue* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	self = (MusicLocalStaticPlaylist*) base;
	_tmp0_ = self->priv->_name;
	if (_tmp0_ != NULL) {
		const gchar* _tmp1_;
		_tmp1_ = self->priv->_name;
		result = _tmp1_;
		return result;
	}
	_tmp2_ = music_playlist_get_rowid ((MusicPlaylist*) self);
	_tmp3_ = _tmp2_;
	_tmp4_ = self->priv->connection;
	_tmp5_ = music_database_query_field (_tmp3_, _tmp4_, MUSIC_DATABASE_PLAYLISTS_TABLE_NAME, "name");
	_tmp6_ = _tmp5_;
	_tmp7_ = g_value_dup_string (_tmp6_);
	_g_free0 (self->priv->_name);
	self->priv->_name = _tmp7_;
	__vala_GValue_free0 (_tmp6_);
	_tmp8_ = self->priv->_name;
	result = _tmp8_;
	return result;
}

static void
music_local_static_playlist_real_set_name (MusicPlaylist* base,
                                           const gchar* value)
{
	MusicLocalStaticPlaylist* self;
	gchar* _tmp0_;
	gint64 _tmp1_;
	gint64 _tmp2_;
	GdaConnection* _tmp3_;
	GValue _tmp4_ = {0};
	self = (MusicLocalStaticPlaylist*) base;
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_name);
	self->priv->_name = _tmp0_;
	_tmp1_ = music_playlist_get_rowid ((MusicPlaylist*) self);
	_tmp2_ = _tmp1_;
	_tmp3_ = self->priv->connection;
	g_value_init (&_tmp4_, G_TYPE_STRING);
	g_value_set_string (&_tmp4_, value);
	music_database_set_field (_tmp2_, _tmp3_, MUSIC_DATABASE_PLAYLISTS_TABLE_NAME, "name", &_tmp4_);
	G_IS_VALUE (&_tmp4_) ? (g_value_unset (&_tmp4_), NULL) : NULL;
	g_object_notify_by_pspec ((GObject *) self, music_local_static_playlist_properties[MUSIC_LOCAL_STATIC_PLAYLIST_NAME_PROPERTY]);
}

static void
_music_local_static_playlist___lambda19_ (MusicLocalStaticPlaylist* self,
                                          const gchar* old_name)
{
	music_local_static_playlist_update_database (self);
}

static void
__music_local_static_playlist___lambda19__music_playlist_updated (MusicPlaylist* _sender,
                                                                  const gchar* old_name,
                                                                  gpointer self)
{
	_music_local_static_playlist___lambda19_ ((MusicLocalStaticPlaylist*) self, old_name);
}

static GObject *
music_local_static_playlist_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicLocalStaticPlaylist * self;
	parent_class = G_OBJECT_CLASS (music_local_static_playlist_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_LOCAL_STATIC_PLAYLIST, MusicLocalStaticPlaylist);
	g_signal_connect_object ((MusicPlaylist*) self, "updated", (GCallback) __music_local_static_playlist___lambda19__music_playlist_updated, self, 0);
	return obj;
}

static void
music_local_static_playlist_class_init (MusicLocalStaticPlaylistClass * klass,
                                        gpointer klass_data)
{
	music_local_static_playlist_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicLocalStaticPlaylist_private_offset);
	MUSIC_PLAYLIST_CLASS (klass)->get_name = music_local_static_playlist_real_get_name;
	MUSIC_PLAYLIST_CLASS (klass)->set_name = music_local_static_playlist_real_set_name;
	G_OBJECT_CLASS (klass)->get_property = _vala_music_local_static_playlist_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_music_local_static_playlist_set_property;
	G_OBJECT_CLASS (klass)->constructor = music_local_static_playlist_constructor;
	G_OBJECT_CLASS (klass)->finalize = music_local_static_playlist_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LOCAL_STATIC_PLAYLIST_NAME_PROPERTY, music_local_static_playlist_properties[MUSIC_LOCAL_STATIC_PLAYLIST_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
music_local_static_playlist_instance_init (MusicLocalStaticPlaylist * self,
                                           gpointer klass)
{
	self->priv = music_local_static_playlist_get_instance_private (self);
	self->priv->_name = NULL;
}

static void
music_local_static_playlist_finalize (GObject * obj)
{
	MusicLocalStaticPlaylist * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_LOCAL_STATIC_PLAYLIST, MusicLocalStaticPlaylist);
	_g_object_unref0 (self->priv->connection);
	_g_free0 (self->priv->_name);
	G_OBJECT_CLASS (music_local_static_playlist_parent_class)->finalize (obj);
}

static GType
music_local_static_playlist_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicLocalStaticPlaylistClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_local_static_playlist_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicLocalStaticPlaylist), 0, (GInstanceInitFunc) music_local_static_playlist_instance_init, NULL };
	GType music_local_static_playlist_type_id;
	music_local_static_playlist_type_id = g_type_register_static (MUSIC_TYPE_STATIC_PLAYLIST, "MusicLocalStaticPlaylist", &g_define_type_info, 0);
	MusicLocalStaticPlaylist_private_offset = g_type_add_instance_private (music_local_static_playlist_type_id, sizeof (MusicLocalStaticPlaylistPrivate));
	return music_local_static_playlist_type_id;
}

GType
music_local_static_playlist_get_type (void)
{
	static volatile gsize music_local_static_playlist_type_id__once = 0;
	if (g_once_init_enter (&music_local_static_playlist_type_id__once)) {
		GType music_local_static_playlist_type_id;
		music_local_static_playlist_type_id = music_local_static_playlist_get_type_once ();
		g_once_init_leave (&music_local_static_playlist_type_id__once, music_local_static_playlist_type_id);
	}
	return music_local_static_playlist_type_id__once;
}

static void
_vala_music_local_static_playlist_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec)
{
	MusicLocalStaticPlaylist * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_LOCAL_STATIC_PLAYLIST, MusicLocalStaticPlaylist);
	switch (property_id) {
		case MUSIC_LOCAL_STATIC_PLAYLIST_NAME_PROPERTY:
		g_value_set_string (value, music_playlist_get_name ((MusicPlaylist*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_music_local_static_playlist_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec)
{
	MusicLocalStaticPlaylist * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_LOCAL_STATIC_PLAYLIST, MusicLocalStaticPlaylist);
	switch (property_id) {
		case MUSIC_LOCAL_STATIC_PLAYLIST_NAME_PROPERTY:
		music_playlist_set_name ((MusicPlaylist*) self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

