/* PlaybackManager.c generated by valac 0.56.1, the Vala compiler
 * generated from PlaybackManager.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Corentin Noël <corentin@elementary.io>
 */

#include "music-lib.h"
#include <gee.h>
#include <glib-object.h>
#include "io.elementary.music-core.h"
#include <glib.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gst/gst.h>
#include <glib/gi18n-lib.h>

enum  {
	MUSIC_PLAYBACK_MANAGER_0_PROPERTY,
	MUSIC_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY,
	MUSIC_PLAYBACK_MANAGER_PLAYING_PROPERTY,
	MUSIC_PLAYBACK_MANAGER_VOLUME_PROPERTY,
	MUSIC_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY,
	MUSIC_PLAYBACK_MANAGER_NUM_PROPERTIES
};
static GParamSpec* music_playback_manager_properties[MUSIC_PLAYBACK_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block11Data Block11Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
enum  {
	MUSIC_PLAYBACK_MANAGER_CHANGING_PLAYER_SIGNAL,
	MUSIC_PLAYBACK_MANAGER_MEDIA_PLAYED_SIGNAL,
	MUSIC_PLAYBACK_MANAGER_PLAYBACK_STOPPED_SIGNAL,
	MUSIC_PLAYBACK_MANAGER_PLAYBACK_STARTED_SIGNAL,
	MUSIC_PLAYBACK_MANAGER_PLAYER_CHANGED_SIGNAL,
	MUSIC_PLAYBACK_MANAGER_QUEUE_CLEARED_SIGNAL,
	MUSIC_PLAYBACK_MANAGER_NUM_SIGNALS
};
static guint music_playback_manager_signals[MUSIC_PLAYBACK_MANAGER_NUM_SIGNALS] = {0};

struct _MusicPlaybackManagerPrivate {
	GeeTreeSet* playbacks;
	GRecMutex __lock_playbacks;
	GeeHashMap* _current;
	GeeHashMap* _current_shuffled;
	gint _current_index;
	gint _current_shuffled_index;
	gboolean _playing;
	gdouble saved_volume;
	gboolean _playing_queued_song;
	MusicMedia* _current_media;
};

struct _Block11Data {
	int _ref_count_;
	MusicPlaybackManager* self;
	MusicMedia* m;
};

static gint MusicPlaybackManager_private_offset;
static gpointer music_playback_manager_parent_class = NULL;

static void music_playback_manager_add_to_current (MusicPlaybackManager* self,
                                            MusicMedia* m);
static void music_playback_manager_reshuffle (MusicPlaybackManager* self);
static void music_playback_manager_set_current_media (MusicPlaybackManager* self,
                                               MusicMedia* value);
static MusicLibrary* music_playback_manager_get_library (MusicPlaybackManager* self);
static Block11Data* block11_data_ref (Block11Data* _data11_);
static void block11_data_unref (void * _userdata_);
static gboolean __lambda31_ (Block11Data* _data11_);
static gboolean ___lambda31__gsource_func (gpointer self);
static gboolean music_playback_manager_auto_genre_eq (MusicPlaybackManager* self,
                                               MusicEqualizerPreset* preset);
static void music_playback_manager_set_playing (MusicPlaybackManager* self,
                                         gboolean value);
static GVariant* _variant_new4 (gboolean value);
static GVariant* _variant_new5 (gboolean value);
static void g_cclosure_user_marshal_VOID__INT64 (GClosure * closure,
                                          GValue * return_value,
                                          guint n_param_values,
                                          const GValue * param_values,
                                          gpointer invocation_hint,
                                          gpointer marshal_data);
static GObject * music_playback_manager_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
static void music_playback_manager_finalize (GObject * obj);
static GType music_playback_manager_get_type_once (void);
static void _vala_music_playback_manager_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_music_playback_manager_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
music_playback_manager_get_instance_private (MusicPlaybackManager* self)
{
	return G_STRUCT_MEMBER_P (self, MusicPlaybackManager_private_offset);
}

static GType
music_playback_manager_shuffle_mode_get_type_once (void)
{
	static const GEnumValue values[] = {{MUSIC_PLAYBACK_MANAGER_SHUFFLE_MODE_OFF, "MUSIC_PLAYBACK_MANAGER_SHUFFLE_MODE_OFF", "off"}, {MUSIC_PLAYBACK_MANAGER_SHUFFLE_MODE_ALL, "MUSIC_PLAYBACK_MANAGER_SHUFFLE_MODE_ALL", "all"}, {0, NULL, NULL}};
	GType music_playback_manager_shuffle_mode_type_id;
	music_playback_manager_shuffle_mode_type_id = g_enum_register_static ("MusicPlaybackManagerShuffleMode", values);
	return music_playback_manager_shuffle_mode_type_id;
}

GType
music_playback_manager_shuffle_mode_get_type (void)
{
	static volatile gsize music_playback_manager_shuffle_mode_type_id__once = 0;
	if (g_once_init_enter (&music_playback_manager_shuffle_mode_type_id__once)) {
		GType music_playback_manager_shuffle_mode_type_id;
		music_playback_manager_shuffle_mode_type_id = music_playback_manager_shuffle_mode_get_type_once ();
		g_once_init_leave (&music_playback_manager_shuffle_mode_type_id__once, music_playback_manager_shuffle_mode_type_id);
	}
	return music_playback_manager_shuffle_mode_type_id__once;
}

static GType
music_playback_manager_repeat_mode_get_type_once (void)
{
	static const GEnumValue values[] = {{MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_OFF, "MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_OFF", "off"}, {MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_MEDIA, "MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_MEDIA", "media"}, {MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_ALL, "MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_ALL", "all"}, {MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_ALBUM, "MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_ALBUM", "album"}, {MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_ARTIST, "MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_ARTIST", "artist"}, {0, NULL, NULL}};
	GType music_playback_manager_repeat_mode_type_id;
	music_playback_manager_repeat_mode_type_id = g_enum_register_static ("MusicPlaybackManagerRepeatMode", values);
	return music_playback_manager_repeat_mode_type_id;
}

GType
music_playback_manager_repeat_mode_get_type (void)
{
	static volatile gsize music_playback_manager_repeat_mode_type_id__once = 0;
	if (g_once_init_enter (&music_playback_manager_repeat_mode_type_id__once)) {
		GType music_playback_manager_repeat_mode_type_id;
		music_playback_manager_repeat_mode_type_id = music_playback_manager_repeat_mode_get_type_once ();
		g_once_init_leave (&music_playback_manager_repeat_mode_type_id__once, music_playback_manager_repeat_mode_type_id);
	}
	return music_playback_manager_repeat_mode_type_id__once;
}

void
music_playback_manager_add_playback (MusicPlaybackManager* self,
                                     MusicPlayback* playback)
{
	GeeTreeSet* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (playback != NULL);
	_tmp0_ = self->priv->playbacks;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, playback);
}

void
music_playback_manager_queue_media (MusicPlaybackManager* self,
                                    GeeCollection* to_queue)
{
	gint _tmp0_;
	gint _tmp1_;
	MusicStaticPlaylist* _tmp10_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (to_queue != NULL);
	_tmp0_ = gee_collection_get_size (to_queue);
	_tmp1_ = _tmp0_;
	if (_tmp1_ < 1) {
		return;
	}
	{
		GeeIterator* _q_it = NULL;
		GeeIterator* _tmp2_;
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) to_queue);
		_q_it = _tmp2_;
		while (TRUE) {
			GeeIterator* _tmp3_;
			MusicMedia* q = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			MusicMedia* _tmp6_;
			const gchar* _tmp7_;
			const gchar* _tmp8_;
			MusicMedia* _tmp9_;
			_tmp3_ = _q_it;
			if (!gee_iterator_next (_tmp3_)) {
				break;
			}
			_tmp4_ = _q_it;
			_tmp5_ = gee_iterator_get (_tmp4_);
			q = (MusicMedia*) _tmp5_;
			_tmp6_ = q;
			_tmp7_ = music_media_get_title (_tmp6_);
			_tmp8_ = _tmp7_;
			g_debug ("PlaybackManager.vala:138: QUEUED: %s", _tmp8_);
			_tmp9_ = q;
			music_playback_manager_add_to_current (self, _tmp9_);
			_g_object_unref0 (q);
		}
		_g_object_unref0 (_q_it);
	}
	_tmp10_ = self->queue_playlist;
	music_playlist_add_medias ((MusicPlaylist*) _tmp10_, to_queue);
	music_playback_manager_reshuffle (self);
}

void
music_playback_manager_unqueue_media (MusicPlaybackManager* self,
                                      GeeCollection* to_unqueue)
{
	MusicStaticPlaylist* _tmp0_;
	GeeHashMap* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GeeHashMap* _tmp32_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (to_unqueue != NULL);
	_tmp0_ = self->queue_playlist;
	music_playlist_remove_medias ((MusicPlaylist*) _tmp0_, to_unqueue);
	_tmp1_ = self->priv->_current;
	_tmp2_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = gee_collection_get_size (to_unqueue);
	_tmp5_ = _tmp4_;
	if ((_tmp3_ - _tmp5_) > 0) {
		gboolean current_media_changed = FALSE;
		gboolean _tmp29_ = FALSE;
		current_media_changed = FALSE;
		while (TRUE) {
			gboolean _tmp6_ = FALSE;
			MusicMedia* _tmp7_;
			gint _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
			GeeHashMap* _tmp13_;
			gint _tmp14_;
			gint _tmp15_;
			GeeHashMap* _tmp16_;
			gint _tmp17_;
			gint _tmp18_;
			_tmp7_ = self->priv->_current_media;
			if (_tmp7_ != NULL) {
				MusicMedia* _tmp8_;
				_tmp8_ = self->priv->_current_media;
				_tmp6_ = gee_collection_contains (to_unqueue, _tmp8_);
			} else {
				_tmp6_ = FALSE;
			}
			if (!_tmp6_) {
				break;
			}
			current_media_changed = TRUE;
			_tmp9_ = music_playback_manager_get_current_index (self);
			_tmp10_ = _tmp9_;
			music_playback_manager_set_current_index (self, _tmp10_ + 1);
			_tmp11_ = music_playback_manager_get_current_index (self);
			_tmp12_ = _tmp11_;
			_tmp13_ = self->priv->_current;
			_tmp14_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp13_);
			_tmp15_ = _tmp14_;
			if (_tmp12_ >= _tmp15_) {
				music_playback_manager_set_current_index (self, 0);
			}
			_tmp16_ = self->priv->_current_shuffled;
			_tmp17_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp16_);
			_tmp18_ = _tmp17_;
			if (_tmp18_ == 0) {
				GeeHashMap* _tmp19_;
				gint _tmp20_;
				gint _tmp21_;
				gpointer _tmp22_;
				MusicMedia* _tmp23_;
				_tmp19_ = self->priv->_current;
				_tmp20_ = music_playback_manager_get_current_index (self);
				_tmp21_ = _tmp20_;
				_tmp22_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp19_, (gpointer) ((gintptr) _tmp21_));
				_tmp23_ = (MusicMedia*) _tmp22_;
				music_playback_manager_set_current_media (self, _tmp23_);
				_g_object_unref0 (_tmp23_);
			} else {
				GeeHashMap* _tmp24_;
				gint _tmp25_;
				gint _tmp26_;
				gpointer _tmp27_;
				MusicMedia* _tmp28_;
				_tmp24_ = self->priv->_current_shuffled;
				_tmp25_ = music_playback_manager_get_current_index (self);
				_tmp26_ = _tmp25_;
				_tmp27_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp24_, (gpointer) ((gintptr) _tmp26_));
				_tmp28_ = (MusicMedia*) _tmp27_;
				music_playback_manager_set_current_media (self, _tmp28_);
				_g_object_unref0 (_tmp28_);
			}
		}
		if (current_media_changed) {
			MusicMedia* _tmp30_;
			_tmp30_ = self->priv->_current_media;
			_tmp29_ = _tmp30_ != NULL;
		} else {
			_tmp29_ = FALSE;
		}
		if (_tmp29_) {
			MusicMedia* _tmp31_;
			_tmp31_ = self->priv->_current_media;
			music_playback_manager_play_media (self, _tmp31_);
		}
	} else {
		music_playback_manager_set_current_media (self, NULL);
		music_playback_manager_stop_playback (self);
	}
	_tmp32_ = self->priv->_current;
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp32_);
	{
		GeeArrayList* _q_list = NULL;
		MusicStaticPlaylist* _tmp33_;
		GeeArrayList* _tmp34_;
		GeeArrayList* _tmp35_;
		gint _q_size = 0;
		GeeArrayList* _tmp36_;
		gint _tmp37_;
		gint _tmp38_;
		gint _q_index = 0;
		_tmp33_ = self->queue_playlist;
		_tmp34_ = music_playlist_get_medias ((MusicPlaylist*) _tmp33_);
		_tmp35_ = _tmp34_;
		_q_list = _tmp35_;
		_tmp36_ = _q_list;
		_tmp37_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp36_);
		_tmp38_ = _tmp37_;
		_q_size = _tmp38_;
		_q_index = -1;
		while (TRUE) {
			gint _tmp39_;
			gint _tmp40_;
			MusicMedia* q = NULL;
			GeeArrayList* _tmp41_;
			gpointer _tmp42_;
			MusicMedia* _tmp43_;
			const gchar* _tmp44_;
			const gchar* _tmp45_;
			MusicMedia* _tmp46_;
			_q_index = _q_index + 1;
			_tmp39_ = _q_index;
			_tmp40_ = _q_size;
			if (!(_tmp39_ < _tmp40_)) {
				break;
			}
			_tmp41_ = _q_list;
			_tmp42_ = gee_abstract_list_get ((GeeAbstractList*) _tmp41_, _q_index);
			q = (MusicMedia*) _tmp42_;
			_tmp43_ = q;
			_tmp44_ = music_media_get_title (_tmp43_);
			_tmp45_ = _tmp44_;
			g_debug ("PlaybackManager.vala:175: REQUEUED: %s", _tmp45_);
			_tmp46_ = q;
			music_playback_manager_add_to_current (self, _tmp46_);
			_g_object_unref0 (q);
		}
	}
	music_playback_manager_reshuffle (self);
}

void
music_playback_manager_clear_queue (MusicPlaybackManager* self)
{
	MusicStaticPlaylist* _tmp0_;
	GeeHashMap* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->queue_playlist;
	music_playlist_clear ((MusicPlaylist*) _tmp0_);
	_tmp1_ = self->priv->_current;
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp1_);
	music_playback_manager_set_current_index (self, 0);
	music_playback_manager_reshuffle (self);
}

MusicMedia*
music_playback_manager_media_from_current_index (MusicPlaybackManager* self,
                                                 gint index_in_current)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	MusicMedia* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = music_app_get_settings ();
	_tmp1_ = _tmp0_;
	if (g_settings_get_enum (_tmp1_, "shuffle-mode") == ((gint) MUSIC_PLAYBACK_MANAGER_SHUFFLE_MODE_OFF)) {
		GeeHashMap* _tmp2_;
		gpointer _tmp3_;
		_tmp2_ = self->priv->_current;
		_tmp3_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp2_, (gpointer) ((gintptr) index_in_current));
		result = (MusicMedia*) _tmp3_;
		return result;
	} else {
		GeeHashMap* _tmp4_;
		gpointer _tmp5_;
		_tmp4_ = self->priv->_current_shuffled;
		_tmp5_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp4_, (gpointer) ((gintptr) index_in_current));
		result = (MusicMedia*) _tmp5_;
		return result;
	}
}

GeeCollection*
music_playback_manager_get_current_media_list (MusicPlaybackManager* self)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GeeCollection* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = music_app_get_settings ();
	_tmp1_ = _tmp0_;
	if (g_settings_get_enum (_tmp1_, "shuffle-mode") == ((gint) MUSIC_PLAYBACK_MANAGER_SHUFFLE_MODE_OFF)) {
		GeeHashMap* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		_tmp2_ = self->priv->_current_shuffled;
		_tmp3_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp2_);
		_tmp4_ = _tmp3_;
		result = _tmp4_;
		return result;
	} else {
		GeeHashMap* _tmp5_;
		GeeCollection* _tmp6_;
		GeeCollection* _tmp7_;
		_tmp5_ = self->priv->_current;
		_tmp6_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp5_);
		_tmp7_ = _tmp6_;
		result = _tmp7_;
		return result;
	}
}

static void
music_playback_manager_add_to_current (MusicPlaybackManager* self,
                                       MusicMedia* m)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (m != NULL);
	_tmp0_ = self->priv->_current;
	_tmp1_ = self->priv->_current;
	_tmp2_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp1_);
	_tmp3_ = _tmp2_;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp0_, (gpointer) ((gintptr) _tmp3_), m);
}

void
music_playback_manager_set_repeat_mode (MusicPlaybackManager* self,
                                        MusicPlaybackManagerRepeatMode mode)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = music_app_get_settings ();
	_tmp1_ = _tmp0_;
	if (g_settings_get_enum (_tmp1_, "repeat-mode") != ((gint) mode)) {
		GSettings* _tmp2_;
		GSettings* _tmp3_;
		_tmp2_ = music_app_get_settings ();
		_tmp3_ = _tmp2_;
		g_settings_set_enum (_tmp3_, "repeat-mode", (gint) mode);
	}
}

void
music_playback_manager_set_shuffle_mode (MusicPlaybackManager* self,
                                         MusicPlaybackManagerShuffleMode mode)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = music_app_get_settings ();
	_tmp1_ = _tmp0_;
	if (g_settings_get_enum (_tmp1_, "shuffle-mode") != ((gint) mode)) {
		GSettings* _tmp2_;
		GSettings* _tmp3_;
		_tmp2_ = music_app_get_settings ();
		_tmp3_ = _tmp2_;
		g_settings_set_enum (_tmp3_, "shuffle-mode", (gint) mode);
		music_playback_manager_reshuffle (self);
	}
}

/**
    * Regenerate the shuffled queue if needed
    */
static void
music_playback_manager_reshuffle (MusicPlaybackManager* self)
{
	GeeHashMap* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	g_return_if_fail (self != NULL);
	g_debug ("PlaybackManager.vala:227: Reshuffling");
	_tmp0_ = self->priv->_current_shuffled;
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp0_);
	self->priv->_current_shuffled_index = 0;
	_tmp1_ = music_app_get_settings ();
	_tmp2_ = _tmp1_;
	if (g_settings_get_enum (_tmp2_, "shuffle-mode") == ((gint) MUSIC_PLAYBACK_MANAGER_SHUFFLE_MODE_OFF)) {
		MusicMedia* _tmp3_;
		_tmp3_ = self->priv->_current_media;
		if (_tmp3_ != NULL) {
			{
				gint i = 0;
				i = 0;
				{
					gboolean _tmp4_ = FALSE;
					_tmp4_ = TRUE;
					while (TRUE) {
						GeeHashMap* _tmp6_;
						gint _tmp7_;
						gint _tmp8_;
						GeeHashMap* _tmp9_;
						gpointer _tmp10_;
						MusicMedia* _tmp11_;
						MusicMedia* _tmp12_;
						gboolean _tmp13_;
						if (!_tmp4_) {
							gint _tmp5_;
							i = i + 1;
							_tmp5_ = i;
						}
						_tmp4_ = FALSE;
						_tmp6_ = self->priv->_current;
						_tmp7_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp6_);
						_tmp8_ = _tmp7_;
						if (!(i < _tmp8_)) {
							break;
						}
						_tmp9_ = self->priv->_current;
						_tmp10_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp9_, (gpointer) ((gintptr) i));
						_tmp11_ = (MusicMedia*) _tmp10_;
						_tmp12_ = self->priv->_current_media;
						_tmp13_ = _tmp11_ == _tmp12_;
						_g_object_unref0 (_tmp11_);
						if (_tmp13_) {
							self->priv->_current_index = i;
							return;
						}
					}
				}
			}
		} else {
			self->priv->_current_index = 0;
		}
	} else {
		GSettings* _tmp14_;
		GSettings* _tmp15_;
		_tmp14_ = music_app_get_settings ();
		_tmp15_ = _tmp14_;
		if (g_settings_get_enum (_tmp15_, "shuffle-mode") == ((gint) MUSIC_PLAYBACK_MANAGER_SHUFFLE_MODE_ALL)) {
			GeeLinkedList* temp = NULL;
			GeeLinkedList* _tmp16_;
			gboolean current_media_found = FALSE;
			gboolean _tmp30_ = FALSE;
			MusicMedia* _tmp31_;
			_tmp16_ = gee_linked_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
			temp = _tmp16_;
			current_media_found = FALSE;
			{
				GeeIterator* _m_it = NULL;
				GeeHashMap* _tmp17_;
				GeeCollection* _tmp18_;
				GeeCollection* _tmp19_;
				GeeCollection* _tmp20_;
				GeeIterator* _tmp21_;
				GeeIterator* _tmp22_;
				_tmp17_ = self->priv->_current;
				_tmp18_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp17_);
				_tmp19_ = _tmp18_;
				_tmp20_ = _tmp19_;
				_tmp21_ = gee_iterable_iterator ((GeeIterable*) _tmp20_);
				_tmp22_ = _tmp21_;
				_g_object_unref0 (_tmp20_);
				_m_it = _tmp22_;
				while (TRUE) {
					GeeIterator* _tmp23_;
					MusicMedia* m = NULL;
					GeeIterator* _tmp24_;
					gpointer _tmp25_;
					MusicMedia* _tmp26_;
					MusicMedia* _tmp27_;
					_tmp23_ = _m_it;
					if (!gee_iterator_next (_tmp23_)) {
						break;
					}
					_tmp24_ = _m_it;
					_tmp25_ = gee_iterator_get (_tmp24_);
					m = (MusicMedia*) _tmp25_;
					_tmp26_ = self->priv->_current_media;
					_tmp27_ = m;
					if (_tmp26_ != _tmp27_) {
						GeeLinkedList* _tmp28_;
						MusicMedia* _tmp29_;
						_tmp28_ = temp;
						_tmp29_ = m;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp28_, _tmp29_);
					} else {
						current_media_found = TRUE;
					}
					_g_object_unref0 (m);
				}
				_g_object_unref0 (_m_it);
			}
			_tmp31_ = self->priv->_current_media;
			if (_tmp31_ != NULL) {
				_tmp30_ = current_media_found;
			} else {
				_tmp30_ = FALSE;
			}
			if (_tmp30_) {
				GeeHashMap* _tmp32_;
				MusicMedia* _tmp33_;
				_tmp32_ = self->priv->_current_shuffled;
				_tmp33_ = self->priv->_current_media;
				gee_abstract_map_set ((GeeAbstractMap*) _tmp32_, (gpointer) ((gintptr) 0), _tmp33_);
			} else {
				gboolean _tmp34_ = FALSE;
				MusicMedia* _tmp35_;
				_tmp35_ = self->priv->_current_media;
				if (_tmp35_ != NULL) {
					GeeHashMap* _tmp36_;
					gint _tmp37_;
					gint _tmp38_;
					_tmp36_ = self->priv->_current;
					_tmp37_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp36_);
					_tmp38_ = _tmp37_;
					_tmp34_ = _tmp38_ != 0;
				} else {
					_tmp34_ = FALSE;
				}
				if (_tmp34_) {
					GeeHashMap* _tmp39_;
					GeeHashMap* _tmp40_;
					gpointer _tmp41_;
					MusicMedia* _tmp42_;
					_tmp39_ = self->priv->_current_shuffled;
					_tmp40_ = self->priv->_current;
					_tmp41_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp40_, (gpointer) ((gintptr) 0));
					_tmp42_ = (MusicMedia*) _tmp41_;
					gee_abstract_map_set ((GeeAbstractMap*) _tmp39_, (gpointer) ((gintptr) 0), _tmp42_);
					_g_object_unref0 (_tmp42_);
				}
			}
			{
				gint _tmp43_ = 0;
				MusicMedia* _tmp44_;
				gint i = 0;
				_tmp44_ = self->priv->_current_media;
				if (_tmp44_ == NULL) {
					_tmp43_ = 0;
				} else {
					_tmp43_ = 1;
				}
				i = _tmp43_;
				{
					gboolean _tmp45_ = FALSE;
					_tmp45_ = TRUE;
					while (TRUE) {
						GeeHashMap* _tmp47_;
						gint _tmp48_;
						gint _tmp49_;
						gint n_media = 0;
						GeeLinkedList* _tmp50_;
						gint _tmp51_;
						gint _tmp52_;
						gint random = 0;
						GeeHashMap* _tmp53_;
						GeeLinkedList* _tmp54_;
						gpointer _tmp55_;
						MusicMedia* _tmp56_;
						GeeLinkedList* _tmp57_;
						GeeLinkedList* _tmp58_;
						gpointer _tmp59_;
						MusicMedia* _tmp60_;
						if (!_tmp45_) {
							gint _tmp46_;
							_tmp46_ = i;
							i = _tmp46_ + 1;
						}
						_tmp45_ = FALSE;
						_tmp47_ = self->priv->_current;
						_tmp48_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp47_);
						_tmp49_ = _tmp48_;
						if (!(i < _tmp49_)) {
							break;
						}
						_tmp50_ = temp;
						_tmp51_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp50_);
						_tmp52_ = _tmp51_;
						n_media = _tmp52_;
						if (n_media == 0) {
							break;
						}
						random = (gint) g_random_int_range ((gint32) 0, (gint32) n_media);
						_tmp53_ = self->priv->_current_shuffled;
						_tmp54_ = temp;
						_tmp55_ = gee_abstract_list_get ((GeeAbstractList*) _tmp54_, random);
						_tmp56_ = (MusicMedia*) _tmp55_;
						gee_abstract_map_set ((GeeAbstractMap*) _tmp53_, (gpointer) ((gintptr) i), _tmp56_);
						_g_object_unref0 (_tmp56_);
						_tmp57_ = temp;
						_tmp58_ = temp;
						_tmp59_ = gee_abstract_list_get ((GeeAbstractList*) _tmp58_, random);
						_tmp60_ = (MusicMedia*) _tmp59_;
						gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp57_, _tmp60_);
						_g_object_unref0 (_tmp60_);
					}
				}
			}
			_g_object_unref0 (temp);
		}
	}
}

MusicMedia*
music_playback_manager_get_next (MusicPlaybackManager* self,
                                 gboolean play)
{
	MusicMedia* rv = NULL;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	MusicStaticPlaylist* _tmp152_;
	GeeArrayList* _tmp153_;
	GeeArrayList* _tmp154_;
	MusicMedia* _tmp155_;
	MusicMedia* result;
	g_return_val_if_fail (self != NULL, NULL);
	rv = NULL;
	_tmp0_ = music_app_get_settings ();
	_tmp1_ = _tmp0_;
	if (g_settings_get_enum (_tmp1_, "shuffle-mode") != ((gint) MUSIC_PLAYBACK_MANAGER_SHUFFLE_MODE_OFF)) {
		GeeHashMap* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		GeeHashMap* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
		MusicMedia* _tmp15_;
		_tmp2_ = self->priv->_current_shuffled;
		_tmp3_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp2_);
		_tmp4_ = _tmp3_;
		g_debug ("PlaybackManager.vala:286: Shuffled size: %d", _tmp4_);
		_tmp5_ = self->priv->_current_shuffled;
		_tmp6_ = gee_map_get_is_empty ((GeeMap*) _tmp5_);
		_tmp7_ = _tmp6_;
		if (_tmp7_) {
			GeeHashMap* _tmp8_;
			gboolean _tmp9_;
			gboolean _tmp10_;
			_tmp8_ = self->priv->_current;
			_tmp9_ = gee_map_get_is_empty ((GeeMap*) _tmp8_);
			_tmp10_ = _tmp9_;
			if (_tmp10_) {
				MusicLibrary* _tmp11_;
				MusicLibrary* _tmp12_;
				GeeCollection* _tmp13_;
				GeeCollection* _tmp14_;
				_tmp11_ = music_playback_manager_get_library (self);
				_tmp12_ = _tmp11_;
				_tmp13_ = music_library_get_medias (_tmp12_);
				_tmp14_ = _tmp13_;
				music_playback_manager_queue_media (self, _tmp14_);
				_g_object_unref0 (_tmp14_);
			}
			music_playback_manager_reshuffle (self);
		}
		self->priv->_playing_queued_song = FALSE;
		_tmp15_ = self->priv->_current_media;
		if (_tmp15_ == NULL) {
			GeeHashMap* _tmp16_;
			gpointer _tmp17_;
			self->priv->_current_shuffled_index = 0;
			_tmp16_ = self->priv->_current_shuffled;
			_tmp17_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp16_, (gpointer) ((gintptr) 0));
			_g_object_unref0 (rv);
			rv = (MusicMedia*) _tmp17_;
		} else {
			GSettings* _tmp18_;
			GSettings* _tmp19_;
			_tmp18_ = music_app_get_settings ();
			_tmp19_ = _tmp18_;
			if (g_settings_get_enum (_tmp19_, "repeat-mode") == ((gint) MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_MEDIA)) {
				GeeHashMap* _tmp20_;
				gpointer _tmp21_;
				_tmp20_ = self->priv->_current_shuffled;
				_tmp21_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp20_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
				_g_object_unref0 (rv);
				rv = (MusicMedia*) _tmp21_;
			} else {
				GeeHashMap* _tmp22_;
				gint _tmp23_;
				gint _tmp24_;
				_tmp22_ = self->priv->_current_shuffled;
				_tmp23_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp22_);
				_tmp24_ = _tmp23_;
				if (self->priv->_current_shuffled_index == (_tmp24_ - 1)) {
					GSettings* _tmp25_;
					GSettings* _tmp26_;
					GeeHashMap* _tmp27_;
					gpointer _tmp28_;
					_tmp25_ = music_app_get_settings ();
					_tmp26_ = _tmp25_;
					if (g_settings_get_enum (_tmp26_, "repeat-mode") == ((gint) MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_ALL)) {
						self->priv->_current_shuffled_index = 0;
					} else {
						if (play) {
							music_playback_manager_stop_playback (self);
						}
						result = NULL;
						_g_object_unref0 (rv);
						return result;
					}
					_tmp27_ = self->priv->_current_shuffled;
					_tmp28_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp27_, (gpointer) ((gintptr) 0));
					_g_object_unref0 (rv);
					rv = (MusicMedia*) _tmp28_;
				} else {
					gboolean _tmp29_ = FALSE;
					if (self->priv->_current_shuffled_index >= 0) {
						GeeHashMap* _tmp30_;
						gint _tmp31_;
						gint _tmp32_;
						_tmp30_ = self->priv->_current_shuffled;
						_tmp31_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp30_);
						_tmp32_ = _tmp31_;
						_tmp29_ = self->priv->_current_shuffled_index < (_tmp32_ - 1);
					} else {
						_tmp29_ = FALSE;
					}
					if (_tmp29_) {
						MusicMedia* next_current = NULL;
						GeeHashMap* _tmp33_;
						gpointer _tmp34_;
						MusicMedia* now_current = NULL;
						GeeHashMap* _tmp35_;
						gpointer _tmp36_;
						gboolean _tmp37_ = FALSE;
						GSettings* _tmp38_;
						GSettings* _tmp39_;
						GeeHashMap* _tmp76_;
						gpointer _tmp77_;
						_tmp33_ = self->priv->_current_shuffled;
						_tmp34_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp33_, (gpointer) ((gintptr) (self->priv->_current_shuffled_index + 1)));
						next_current = (MusicMedia*) _tmp34_;
						_tmp35_ = self->priv->_current_shuffled;
						_tmp36_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp35_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
						now_current = (MusicMedia*) _tmp36_;
						_tmp38_ = music_app_get_settings ();
						_tmp39_ = _tmp38_;
						if (g_settings_get_enum (_tmp39_, "repeat-mode") == ((gint) MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_ARTIST)) {
							MusicMedia* _tmp40_;
							const gchar* _tmp41_;
							const gchar* _tmp42_;
							MusicMedia* _tmp43_;
							const gchar* _tmp44_;
							const gchar* _tmp45_;
							_tmp40_ = next_current;
							_tmp41_ = music_media_get_artist (_tmp40_);
							_tmp42_ = _tmp41_;
							_tmp43_ = now_current;
							_tmp44_ = music_media_get_artist (_tmp43_);
							_tmp45_ = _tmp44_;
							_tmp37_ = g_strcmp0 (_tmp42_, _tmp45_) != 0;
						} else {
							_tmp37_ = FALSE;
						}
						if (_tmp37_) {
							while (TRUE) {
								GeeHashMap* _tmp46_;
								gpointer _tmp47_;
								MusicMedia* _tmp48_;
								const gchar* _tmp49_;
								const gchar* _tmp50_;
								MusicMedia* _tmp51_;
								const gchar* _tmp52_;
								const gchar* _tmp53_;
								gboolean _tmp54_;
								gint _tmp55_;
								_tmp46_ = self->priv->_current_shuffled;
								_tmp47_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp46_, (gpointer) ((gintptr) (self->priv->_current_shuffled_index - 1)));
								_tmp48_ = (MusicMedia*) _tmp47_;
								_tmp49_ = music_media_get_artist (_tmp48_);
								_tmp50_ = _tmp49_;
								_tmp51_ = self->priv->_current_media;
								_tmp52_ = music_media_get_artist (_tmp51_);
								_tmp53_ = _tmp52_;
								_tmp54_ = !(g_strcmp0 (_tmp50_, _tmp53_) == 0);
								_g_object_unref0 (_tmp48_);
								if (_tmp54_) {
									break;
								}
								_tmp55_ = self->priv->_current_shuffled_index;
								self->priv->_current_shuffled_index = _tmp55_ - 1;
							}
						} else {
							gboolean _tmp56_ = FALSE;
							GSettings* _tmp57_;
							GSettings* _tmp58_;
							_tmp57_ = music_app_get_settings ();
							_tmp58_ = _tmp57_;
							if (g_settings_get_enum (_tmp58_, "repeat-mode") == ((gint) MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_ALBUM)) {
								MusicMedia* _tmp59_;
								const gchar* _tmp60_;
								const gchar* _tmp61_;
								MusicMedia* _tmp62_;
								const gchar* _tmp63_;
								const gchar* _tmp64_;
								_tmp59_ = next_current;
								_tmp60_ = music_media_get_album (_tmp59_);
								_tmp61_ = _tmp60_;
								_tmp62_ = now_current;
								_tmp63_ = music_media_get_album (_tmp62_);
								_tmp64_ = _tmp63_;
								_tmp56_ = g_strcmp0 (_tmp61_, _tmp64_) != 0;
							} else {
								_tmp56_ = FALSE;
							}
							if (_tmp56_) {
								while (TRUE) {
									GeeHashMap* _tmp65_;
									gpointer _tmp66_;
									MusicMedia* _tmp67_;
									const gchar* _tmp68_;
									const gchar* _tmp69_;
									MusicMedia* _tmp70_;
									const gchar* _tmp71_;
									const gchar* _tmp72_;
									gboolean _tmp73_;
									gint _tmp74_;
									_tmp65_ = self->priv->_current_shuffled;
									_tmp66_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp65_, (gpointer) ((gintptr) (self->priv->_current_shuffled_index - 1)));
									_tmp67_ = (MusicMedia*) _tmp66_;
									_tmp68_ = music_media_get_album (_tmp67_);
									_tmp69_ = _tmp68_;
									_tmp70_ = self->priv->_current_media;
									_tmp71_ = music_media_get_album (_tmp70_);
									_tmp72_ = _tmp71_;
									_tmp73_ = !(g_strcmp0 (_tmp69_, _tmp72_) == 0);
									_g_object_unref0 (_tmp67_);
									if (_tmp73_) {
										break;
									}
									_tmp74_ = self->priv->_current_shuffled_index;
									self->priv->_current_shuffled_index = _tmp74_ - 1;
								}
							} else {
								gint _tmp75_;
								_tmp75_ = self->priv->_current_shuffled_index;
								self->priv->_current_shuffled_index = _tmp75_ + 1;
							}
						}
						_tmp76_ = self->priv->_current_shuffled;
						_tmp77_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp76_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
						_g_object_unref0 (rv);
						rv = (MusicMedia*) _tmp77_;
						_g_object_unref0 (now_current);
						_g_object_unref0 (next_current);
					} else {
						GeeHashMap* _tmp78_;
						gpointer _tmp79_;
						self->priv->_current_shuffled_index = 0;
						music_playback_manager_set_shuffle_mode (self, MUSIC_PLAYBACK_MANAGER_SHUFFLE_MODE_ALL);
						_tmp78_ = self->priv->_current_shuffled;
						_tmp79_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp78_, (gpointer) ((gintptr) 0));
						_g_object_unref0 (rv);
						rv = (MusicMedia*) _tmp79_;
					}
				}
			}
		}
	} else {
		GeeHashMap* _tmp80_;
		gboolean _tmp81_;
		gboolean _tmp82_;
		MusicMedia* _tmp87_;
		self->priv->_playing_queued_song = FALSE;
		_tmp80_ = self->priv->_current;
		_tmp81_ = gee_map_get_is_empty ((GeeMap*) _tmp80_);
		_tmp82_ = _tmp81_;
		if (_tmp82_) {
			MusicLibrary* _tmp83_;
			MusicLibrary* _tmp84_;
			GeeCollection* _tmp85_;
			GeeCollection* _tmp86_;
			_tmp83_ = music_playback_manager_get_library (self);
			_tmp84_ = _tmp83_;
			_tmp85_ = music_library_get_medias (_tmp84_);
			_tmp86_ = _tmp85_;
			music_playback_manager_queue_media (self, _tmp86_);
			_g_object_unref0 (_tmp86_);
		}
		_tmp87_ = self->priv->_current_media;
		if (_tmp87_ == NULL) {
			GeeHashMap* _tmp88_;
			gpointer _tmp89_;
			self->priv->_current_index = 0;
			_tmp88_ = self->priv->_current;
			_tmp89_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp88_, (gpointer) ((gintptr) 0));
			_g_object_unref0 (rv);
			rv = (MusicMedia*) _tmp89_;
		} else {
			GSettings* _tmp90_;
			GSettings* _tmp91_;
			_tmp90_ = music_app_get_settings ();
			_tmp91_ = _tmp90_;
			if (g_settings_get_enum (_tmp91_, "repeat-mode") == ((gint) MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_MEDIA)) {
				GeeHashMap* _tmp92_;
				gpointer _tmp93_;
				_tmp92_ = self->priv->_current;
				_tmp93_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp92_, (gpointer) ((gintptr) self->priv->_current_index));
				_g_object_unref0 (rv);
				rv = (MusicMedia*) _tmp93_;
			} else {
				GeeHashMap* _tmp94_;
				gint _tmp95_;
				gint _tmp96_;
				_tmp94_ = self->priv->_current;
				_tmp95_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp94_);
				_tmp96_ = _tmp95_;
				if (self->priv->_current_index == (_tmp96_ - 1)) {
					GSettings* _tmp97_;
					GSettings* _tmp98_;
					GeeHashMap* _tmp99_;
					gpointer _tmp100_;
					_tmp97_ = music_app_get_settings ();
					_tmp98_ = _tmp97_;
					if (g_settings_get_enum (_tmp98_, "repeat-mode") == ((gint) MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_ALL)) {
						self->priv->_current_index = 0;
					} else {
						if (play) {
							music_playback_manager_stop_playback (self);
						}
						result = NULL;
						_g_object_unref0 (rv);
						return result;
					}
					_tmp99_ = self->priv->_current;
					_tmp100_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp99_, (gpointer) ((gintptr) 0));
					_g_object_unref0 (rv);
					rv = (MusicMedia*) _tmp100_;
				} else {
					gboolean _tmp101_ = FALSE;
					if (self->priv->_current_index >= 0) {
						GeeHashMap* _tmp102_;
						gint _tmp103_;
						gint _tmp104_;
						_tmp102_ = self->priv->_current;
						_tmp103_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp102_);
						_tmp104_ = _tmp103_;
						_tmp101_ = self->priv->_current_index < (_tmp104_ - 1);
					} else {
						_tmp101_ = FALSE;
					}
					if (_tmp101_) {
						MusicMedia* next_current = NULL;
						GeeHashMap* _tmp105_;
						gpointer _tmp106_;
						MusicMedia* now_current = NULL;
						GeeHashMap* _tmp107_;
						gpointer _tmp108_;
						gboolean _tmp109_ = FALSE;
						GSettings* _tmp110_;
						GSettings* _tmp111_;
						GeeHashMap* _tmp148_;
						gpointer _tmp149_;
						_tmp105_ = self->priv->_current;
						_tmp106_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp105_, (gpointer) ((gintptr) (self->priv->_current_index + 1)));
						next_current = (MusicMedia*) _tmp106_;
						_tmp107_ = self->priv->_current;
						_tmp108_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp107_, (gpointer) ((gintptr) self->priv->_current_index));
						now_current = (MusicMedia*) _tmp108_;
						_tmp110_ = music_app_get_settings ();
						_tmp111_ = _tmp110_;
						if (g_settings_get_enum (_tmp111_, "repeat-mode") == ((gint) MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_ARTIST)) {
							MusicMedia* _tmp112_;
							const gchar* _tmp113_;
							const gchar* _tmp114_;
							MusicMedia* _tmp115_;
							const gchar* _tmp116_;
							const gchar* _tmp117_;
							_tmp112_ = next_current;
							_tmp113_ = music_media_get_artist (_tmp112_);
							_tmp114_ = _tmp113_;
							_tmp115_ = now_current;
							_tmp116_ = music_media_get_artist (_tmp115_);
							_tmp117_ = _tmp116_;
							_tmp109_ = g_strcmp0 (_tmp114_, _tmp117_) != 0;
						} else {
							_tmp109_ = FALSE;
						}
						if (_tmp109_) {
							while (TRUE) {
								GeeHashMap* _tmp118_;
								gpointer _tmp119_;
								MusicMedia* _tmp120_;
								const gchar* _tmp121_;
								const gchar* _tmp122_;
								MusicMedia* _tmp123_;
								const gchar* _tmp124_;
								const gchar* _tmp125_;
								gboolean _tmp126_;
								gint _tmp127_;
								_tmp118_ = self->priv->_current;
								_tmp119_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp118_, (gpointer) ((gintptr) (self->priv->_current_index - 1)));
								_tmp120_ = (MusicMedia*) _tmp119_;
								_tmp121_ = music_media_get_artist (_tmp120_);
								_tmp122_ = _tmp121_;
								_tmp123_ = self->priv->_current_media;
								_tmp124_ = music_media_get_artist (_tmp123_);
								_tmp125_ = _tmp124_;
								_tmp126_ = !(g_strcmp0 (_tmp122_, _tmp125_) == 0);
								_g_object_unref0 (_tmp120_);
								if (_tmp126_) {
									break;
								}
								_tmp127_ = self->priv->_current_index;
								self->priv->_current_index = _tmp127_ - 1;
							}
						} else {
							gboolean _tmp128_ = FALSE;
							GSettings* _tmp129_;
							GSettings* _tmp130_;
							_tmp129_ = music_app_get_settings ();
							_tmp130_ = _tmp129_;
							if (g_settings_get_enum (_tmp130_, "repeat-mode") == ((gint) MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_ALBUM)) {
								MusicMedia* _tmp131_;
								const gchar* _tmp132_;
								const gchar* _tmp133_;
								MusicMedia* _tmp134_;
								const gchar* _tmp135_;
								const gchar* _tmp136_;
								_tmp131_ = next_current;
								_tmp132_ = music_media_get_album (_tmp131_);
								_tmp133_ = _tmp132_;
								_tmp134_ = now_current;
								_tmp135_ = music_media_get_album (_tmp134_);
								_tmp136_ = _tmp135_;
								_tmp128_ = g_strcmp0 (_tmp133_, _tmp136_) != 0;
							} else {
								_tmp128_ = FALSE;
							}
							if (_tmp128_) {
								while (TRUE) {
									GeeHashMap* _tmp137_;
									gpointer _tmp138_;
									MusicMedia* _tmp139_;
									const gchar* _tmp140_;
									const gchar* _tmp141_;
									MusicMedia* _tmp142_;
									const gchar* _tmp143_;
									const gchar* _tmp144_;
									gboolean _tmp145_;
									gint _tmp146_;
									_tmp137_ = self->priv->_current;
									_tmp138_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp137_, (gpointer) ((gintptr) (self->priv->_current_index - 1)));
									_tmp139_ = (MusicMedia*) _tmp138_;
									_tmp140_ = music_media_get_album (_tmp139_);
									_tmp141_ = _tmp140_;
									_tmp142_ = self->priv->_current_media;
									_tmp143_ = music_media_get_album (_tmp142_);
									_tmp144_ = _tmp143_;
									_tmp145_ = !(g_strcmp0 (_tmp141_, _tmp144_) == 0);
									_g_object_unref0 (_tmp139_);
									if (_tmp145_) {
										break;
									}
									_tmp146_ = self->priv->_current_index;
									self->priv->_current_index = _tmp146_ - 1;
								}
							} else {
								gint _tmp147_;
								_tmp147_ = self->priv->_current_index;
								self->priv->_current_index = _tmp147_ + 1;
							}
						}
						_tmp148_ = self->priv->_current;
						_tmp149_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp148_, (gpointer) ((gintptr) self->priv->_current_index));
						_g_object_unref0 (rv);
						rv = (MusicMedia*) _tmp149_;
						_g_object_unref0 (now_current);
						_g_object_unref0 (next_current);
					} else {
						GeeHashMap* _tmp150_;
						gpointer _tmp151_;
						self->priv->_current_index = 0;
						_tmp150_ = self->priv->_current;
						_tmp151_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp150_, (gpointer) ((gintptr) 0));
						_g_object_unref0 (rv);
						rv = (MusicMedia*) _tmp151_;
					}
				}
			}
		}
	}
	_tmp152_ = self->queue_playlist;
	_tmp153_ = music_playlist_get_medias ((MusicPlaylist*) _tmp152_);
	_tmp154_ = _tmp153_;
	_tmp155_ = rv;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp154_, _tmp155_)) {
		self->priv->_playing_queued_song = TRUE;
	}
	if (play) {
		MusicMedia* _tmp156_;
		_tmp156_ = rv;
		music_playback_manager_play_media (self, _tmp156_);
	}
	result = rv;
	return result;
}

MusicMedia*
music_playback_manager_get_previous (MusicPlaybackManager* self,
                                     gboolean play)
{
	MusicMedia* rv = NULL;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	MusicStaticPlaylist* _tmp169_;
	GeeArrayList* _tmp170_;
	GeeArrayList* _tmp171_;
	MusicMedia* _tmp172_;
	MusicMedia* result;
	g_return_val_if_fail (self != NULL, NULL);
	rv = NULL;
	_tmp0_ = music_app_get_settings ();
	_tmp1_ = _tmp0_;
	if (g_settings_get_enum (_tmp1_, "shuffle-mode") != ((gint) MUSIC_PLAYBACK_MANAGER_SHUFFLE_MODE_OFF)) {
		GeeHashMap* _tmp2_;
		gboolean _tmp3_;
		gboolean _tmp4_;
		MusicMedia* _tmp12_;
		_tmp2_ = self->priv->_current_shuffled;
		_tmp3_ = gee_map_get_is_empty ((GeeMap*) _tmp2_);
		_tmp4_ = _tmp3_;
		if (_tmp4_) {
			GeeHashMap* _tmp5_;
			gboolean _tmp6_;
			gboolean _tmp7_;
			_tmp5_ = self->priv->_current;
			_tmp6_ = gee_map_get_is_empty ((GeeMap*) _tmp5_);
			_tmp7_ = _tmp6_;
			if (_tmp7_) {
				MusicLibrary* _tmp8_;
				MusicLibrary* _tmp9_;
				GeeCollection* _tmp10_;
				GeeCollection* _tmp11_;
				_tmp8_ = music_playback_manager_get_library (self);
				_tmp9_ = _tmp8_;
				_tmp10_ = music_library_get_medias (_tmp9_);
				_tmp11_ = _tmp10_;
				music_playback_manager_queue_media (self, _tmp11_);
				_g_object_unref0 (_tmp11_);
			}
			music_playback_manager_reshuffle (self);
		}
		self->priv->_playing_queued_song = FALSE;
		_tmp12_ = self->priv->_current_media;
		if (_tmp12_ == NULL) {
			GeeHashMap* _tmp13_;
			gint _tmp14_;
			gint _tmp15_;
			GeeHashMap* _tmp16_;
			gpointer _tmp17_;
			_tmp13_ = self->priv->_current_shuffled;
			_tmp14_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp13_);
			_tmp15_ = _tmp14_;
			self->priv->_current_shuffled_index = _tmp15_ - 1;
			_tmp16_ = self->priv->_current_shuffled;
			_tmp17_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp16_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
			_g_object_unref0 (rv);
			rv = (MusicMedia*) _tmp17_;
		} else {
			GSettings* _tmp18_;
			GSettings* _tmp19_;
			_tmp18_ = music_app_get_settings ();
			_tmp19_ = _tmp18_;
			if (g_settings_get_enum (_tmp19_, "repeat-mode") == ((gint) MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_MEDIA)) {
				GeeHashMap* _tmp20_;
				gpointer _tmp21_;
				_tmp20_ = self->priv->_current_shuffled;
				_tmp21_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp20_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
				_g_object_unref0 (rv);
				rv = (MusicMedia*) _tmp21_;
			} else {
				if (self->priv->_current_shuffled_index == 0) {
					GSettings* _tmp22_;
					GSettings* _tmp23_;
					GeeHashMap* _tmp27_;
					gpointer _tmp28_;
					_tmp22_ = music_app_get_settings ();
					_tmp23_ = _tmp22_;
					if (g_settings_get_enum (_tmp23_, "repeat-mode") == ((gint) MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_ALL)) {
						GeeHashMap* _tmp24_;
						gint _tmp25_;
						gint _tmp26_;
						_tmp24_ = self->priv->_current_shuffled;
						_tmp25_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp24_);
						_tmp26_ = _tmp25_;
						self->priv->_current_shuffled_index = _tmp26_ - 1;
					} else {
						music_playback_manager_stop_playback (self);
						result = NULL;
						_g_object_unref0 (rv);
						return result;
					}
					_tmp27_ = self->priv->_current_shuffled;
					_tmp28_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp27_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
					_g_object_unref0 (rv);
					rv = (MusicMedia*) _tmp28_;
				} else {
					gboolean _tmp29_ = FALSE;
					if (self->priv->_current_shuffled_index > 0) {
						GeeHashMap* _tmp30_;
						gint _tmp31_;
						gint _tmp32_;
						_tmp30_ = self->priv->_current_shuffled;
						_tmp31_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp30_);
						_tmp32_ = _tmp31_;
						_tmp29_ = self->priv->_current_shuffled_index < _tmp32_;
					} else {
						_tmp29_ = FALSE;
					}
					if (_tmp29_) {
						gboolean _tmp33_ = FALSE;
						GSettings* _tmp34_;
						GSettings* _tmp35_;
						GeeHashMap* _tmp80_;
						gpointer _tmp81_;
						_tmp34_ = music_app_get_settings ();
						_tmp35_ = _tmp34_;
						if (g_settings_get_enum (_tmp35_, "repeat-mode") == ((gint) MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_ARTIST)) {
							GeeHashMap* _tmp36_;
							gpointer _tmp37_;
							MusicMedia* _tmp38_;
							const gchar* _tmp39_;
							const gchar* _tmp40_;
							GeeHashMap* _tmp41_;
							gpointer _tmp42_;
							MusicMedia* _tmp43_;
							const gchar* _tmp44_;
							const gchar* _tmp45_;
							_tmp36_ = self->priv->_current_shuffled;
							_tmp37_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp36_, (gpointer) ((gintptr) (self->priv->_current_shuffled_index - 1)));
							_tmp38_ = (MusicMedia*) _tmp37_;
							_tmp39_ = music_media_get_artist (_tmp38_);
							_tmp40_ = _tmp39_;
							_tmp41_ = self->priv->_current_shuffled;
							_tmp42_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp41_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
							_tmp43_ = (MusicMedia*) _tmp42_;
							_tmp44_ = music_media_get_artist (_tmp43_);
							_tmp45_ = _tmp44_;
							_tmp33_ = g_strcmp0 (_tmp40_, _tmp45_) != 0;
							_g_object_unref0 (_tmp43_);
							_g_object_unref0 (_tmp38_);
						} else {
							_tmp33_ = FALSE;
						}
						if (_tmp33_) {
							while (TRUE) {
								GeeHashMap* _tmp46_;
								gpointer _tmp47_;
								MusicMedia* _tmp48_;
								const gchar* _tmp49_;
								const gchar* _tmp50_;
								MusicMedia* _tmp51_;
								const gchar* _tmp52_;
								const gchar* _tmp53_;
								gboolean _tmp54_;
								gint _tmp55_;
								_tmp46_ = self->priv->_current_shuffled;
								_tmp47_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp46_, (gpointer) ((gintptr) (self->priv->_current_shuffled_index + 1)));
								_tmp48_ = (MusicMedia*) _tmp47_;
								_tmp49_ = music_media_get_artist (_tmp48_);
								_tmp50_ = _tmp49_;
								_tmp51_ = self->priv->_current_media;
								_tmp52_ = music_media_get_artist (_tmp51_);
								_tmp53_ = _tmp52_;
								_tmp54_ = !(g_strcmp0 (_tmp50_, _tmp53_) == 0);
								_g_object_unref0 (_tmp48_);
								if (_tmp54_) {
									break;
								}
								self->priv->_current_shuffled_index = self->priv->_current_shuffled_index + 1;
								_tmp55_ = self->priv->_current_shuffled_index;
							}
						} else {
							gboolean _tmp56_ = FALSE;
							GSettings* _tmp57_;
							GSettings* _tmp58_;
							_tmp57_ = music_app_get_settings ();
							_tmp58_ = _tmp57_;
							if (g_settings_get_enum (_tmp58_, "repeat-mode") == ((gint) MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_ALBUM)) {
								GeeHashMap* _tmp59_;
								gpointer _tmp60_;
								MusicMedia* _tmp61_;
								const gchar* _tmp62_;
								const gchar* _tmp63_;
								GeeHashMap* _tmp64_;
								gpointer _tmp65_;
								MusicMedia* _tmp66_;
								const gchar* _tmp67_;
								const gchar* _tmp68_;
								_tmp59_ = self->priv->_current_shuffled;
								_tmp60_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp59_, (gpointer) ((gintptr) (self->priv->_current_shuffled_index - 1)));
								_tmp61_ = (MusicMedia*) _tmp60_;
								_tmp62_ = music_media_get_album (_tmp61_);
								_tmp63_ = _tmp62_;
								_tmp64_ = self->priv->_current_shuffled;
								_tmp65_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp64_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
								_tmp66_ = (MusicMedia*) _tmp65_;
								_tmp67_ = music_media_get_album (_tmp66_);
								_tmp68_ = _tmp67_;
								_tmp56_ = g_strcmp0 (_tmp63_, _tmp68_) != 0;
								_g_object_unref0 (_tmp66_);
								_g_object_unref0 (_tmp61_);
							} else {
								_tmp56_ = FALSE;
							}
							if (_tmp56_) {
								while (TRUE) {
									GeeHashMap* _tmp69_;
									gpointer _tmp70_;
									MusicMedia* _tmp71_;
									const gchar* _tmp72_;
									const gchar* _tmp73_;
									MusicMedia* _tmp74_;
									const gchar* _tmp75_;
									const gchar* _tmp76_;
									gboolean _tmp77_;
									gint _tmp78_;
									_tmp69_ = self->priv->_current_shuffled;
									_tmp70_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp69_, (gpointer) ((gintptr) (self->priv->_current_shuffled_index + 1)));
									_tmp71_ = (MusicMedia*) _tmp70_;
									_tmp72_ = music_media_get_album (_tmp71_);
									_tmp73_ = _tmp72_;
									_tmp74_ = self->priv->_current_media;
									_tmp75_ = music_media_get_album (_tmp74_);
									_tmp76_ = _tmp75_;
									_tmp77_ = !(g_strcmp0 (_tmp73_, _tmp76_) == 0);
									_g_object_unref0 (_tmp71_);
									if (_tmp77_) {
										break;
									}
									self->priv->_current_shuffled_index = self->priv->_current_shuffled_index + 1;
									_tmp78_ = self->priv->_current_shuffled_index;
								}
							} else {
								gint _tmp79_;
								self->priv->_current_shuffled_index = self->priv->_current_shuffled_index - 1;
								_tmp79_ = self->priv->_current_shuffled_index;
							}
						}
						_tmp80_ = self->priv->_current_shuffled;
						_tmp81_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp80_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
						_g_object_unref0 (rv);
						rv = (MusicMedia*) _tmp81_;
					} else {
						GeeHashMap* _tmp82_;
						gint _tmp83_;
						gint _tmp84_;
						GeeHashMap* _tmp85_;
						gpointer _tmp86_;
						_tmp82_ = self->priv->_current_shuffled;
						_tmp83_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp82_);
						_tmp84_ = _tmp83_;
						self->priv->_current_shuffled_index = _tmp84_ - 1;
						_tmp85_ = self->priv->_current_shuffled;
						_tmp86_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp85_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
						_g_object_unref0 (rv);
						rv = (MusicMedia*) _tmp86_;
					}
				}
			}
		}
	} else {
		GeeHashMap* _tmp87_;
		gboolean _tmp88_;
		gboolean _tmp89_;
		MusicMedia* _tmp94_;
		self->priv->_playing_queued_song = FALSE;
		_tmp87_ = self->priv->_current;
		_tmp88_ = gee_map_get_is_empty ((GeeMap*) _tmp87_);
		_tmp89_ = _tmp88_;
		if (_tmp89_) {
			MusicLibrary* _tmp90_;
			MusicLibrary* _tmp91_;
			GeeCollection* _tmp92_;
			GeeCollection* _tmp93_;
			_tmp90_ = music_playback_manager_get_library (self);
			_tmp91_ = _tmp90_;
			_tmp92_ = music_library_get_medias (_tmp91_);
			_tmp93_ = _tmp92_;
			music_playback_manager_queue_media (self, _tmp93_);
			_g_object_unref0 (_tmp93_);
		}
		_tmp94_ = self->priv->_current_media;
		if (_tmp94_ == NULL) {
			GeeHashMap* _tmp95_;
			gint _tmp96_;
			gint _tmp97_;
			GeeHashMap* _tmp98_;
			gpointer _tmp99_;
			_tmp95_ = self->priv->_current;
			_tmp96_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp95_);
			_tmp97_ = _tmp96_;
			self->priv->_current_index = _tmp97_ - 1;
			_tmp98_ = self->priv->_current;
			_tmp99_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp98_, (gpointer) ((gintptr) self->priv->_current_index));
			_g_object_unref0 (rv);
			rv = (MusicMedia*) _tmp99_;
		} else {
			GSettings* _tmp100_;
			GSettings* _tmp101_;
			_tmp100_ = music_app_get_settings ();
			_tmp101_ = _tmp100_;
			if (g_settings_get_enum (_tmp101_, "repeat-mode") == ((gint) MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_MEDIA)) {
				GeeHashMap* _tmp102_;
				gpointer _tmp103_;
				_tmp102_ = self->priv->_current;
				_tmp103_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp102_, (gpointer) ((gintptr) self->priv->_current_index));
				_g_object_unref0 (rv);
				rv = (MusicMedia*) _tmp103_;
			} else {
				if (self->priv->_current_index == 0) {
					GSettings* _tmp104_;
					GSettings* _tmp105_;
					GeeHashMap* _tmp109_;
					gpointer _tmp110_;
					_tmp104_ = music_app_get_settings ();
					_tmp105_ = _tmp104_;
					if (g_settings_get_enum (_tmp105_, "repeat-mode") == ((gint) MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_ALL)) {
						GeeHashMap* _tmp106_;
						gint _tmp107_;
						gint _tmp108_;
						_tmp106_ = self->priv->_current;
						_tmp107_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp106_);
						_tmp108_ = _tmp107_;
						self->priv->_current_index = _tmp108_ - 1;
					} else {
						music_playback_manager_stop_playback (self);
						result = NULL;
						_g_object_unref0 (rv);
						return result;
					}
					_tmp109_ = self->priv->_current;
					_tmp110_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp109_, (gpointer) ((gintptr) self->priv->_current_index));
					_g_object_unref0 (rv);
					rv = (MusicMedia*) _tmp110_;
				} else {
					gboolean _tmp111_ = FALSE;
					if (self->priv->_current_index > 0) {
						GeeHashMap* _tmp112_;
						gint _tmp113_;
						gint _tmp114_;
						_tmp112_ = self->priv->_current;
						_tmp113_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp112_);
						_tmp114_ = _tmp113_;
						_tmp111_ = self->priv->_current_index < _tmp114_;
					} else {
						_tmp111_ = FALSE;
					}
					if (_tmp111_) {
						gboolean _tmp115_ = FALSE;
						GSettings* _tmp116_;
						GSettings* _tmp117_;
						GeeHashMap* _tmp162_;
						gpointer _tmp163_;
						_tmp116_ = music_app_get_settings ();
						_tmp117_ = _tmp116_;
						if (g_settings_get_enum (_tmp117_, "repeat-mode") == ((gint) MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_ARTIST)) {
							GeeHashMap* _tmp118_;
							gpointer _tmp119_;
							MusicMedia* _tmp120_;
							const gchar* _tmp121_;
							const gchar* _tmp122_;
							GeeHashMap* _tmp123_;
							gpointer _tmp124_;
							MusicMedia* _tmp125_;
							const gchar* _tmp126_;
							const gchar* _tmp127_;
							_tmp118_ = self->priv->_current;
							_tmp119_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp118_, (gpointer) ((gintptr) (self->priv->_current_index - 1)));
							_tmp120_ = (MusicMedia*) _tmp119_;
							_tmp121_ = music_media_get_artist (_tmp120_);
							_tmp122_ = _tmp121_;
							_tmp123_ = self->priv->_current;
							_tmp124_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp123_, (gpointer) ((gintptr) self->priv->_current_index));
							_tmp125_ = (MusicMedia*) _tmp124_;
							_tmp126_ = music_media_get_artist (_tmp125_);
							_tmp127_ = _tmp126_;
							_tmp115_ = g_strcmp0 (_tmp122_, _tmp127_) != 0;
							_g_object_unref0 (_tmp125_);
							_g_object_unref0 (_tmp120_);
						} else {
							_tmp115_ = FALSE;
						}
						if (_tmp115_) {
							while (TRUE) {
								GeeHashMap* _tmp128_;
								gpointer _tmp129_;
								MusicMedia* _tmp130_;
								const gchar* _tmp131_;
								const gchar* _tmp132_;
								MusicMedia* _tmp133_;
								const gchar* _tmp134_;
								const gchar* _tmp135_;
								gboolean _tmp136_;
								gint _tmp137_;
								_tmp128_ = self->priv->_current;
								_tmp129_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp128_, (gpointer) ((gintptr) (self->priv->_current_index + 1)));
								_tmp130_ = (MusicMedia*) _tmp129_;
								_tmp131_ = music_media_get_artist (_tmp130_);
								_tmp132_ = _tmp131_;
								_tmp133_ = self->priv->_current_media;
								_tmp134_ = music_media_get_artist (_tmp133_);
								_tmp135_ = _tmp134_;
								_tmp136_ = !(g_strcmp0 (_tmp132_, _tmp135_) == 0);
								_g_object_unref0 (_tmp130_);
								if (_tmp136_) {
									break;
								}
								_tmp137_ = self->priv->_current_index;
								self->priv->_current_index = _tmp137_ + 1;
							}
						} else {
							gboolean _tmp138_ = FALSE;
							GSettings* _tmp139_;
							GSettings* _tmp140_;
							_tmp139_ = music_app_get_settings ();
							_tmp140_ = _tmp139_;
							if (g_settings_get_enum (_tmp140_, "repeat-mode") == ((gint) MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_ALBUM)) {
								GeeHashMap* _tmp141_;
								gpointer _tmp142_;
								MusicMedia* _tmp143_;
								const gchar* _tmp144_;
								const gchar* _tmp145_;
								GeeHashMap* _tmp146_;
								gpointer _tmp147_;
								MusicMedia* _tmp148_;
								const gchar* _tmp149_;
								const gchar* _tmp150_;
								_tmp141_ = self->priv->_current;
								_tmp142_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp141_, (gpointer) ((gintptr) (self->priv->_current_index - 1)));
								_tmp143_ = (MusicMedia*) _tmp142_;
								_tmp144_ = music_media_get_album (_tmp143_);
								_tmp145_ = _tmp144_;
								_tmp146_ = self->priv->_current;
								_tmp147_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp146_, (gpointer) ((gintptr) self->priv->_current_index));
								_tmp148_ = (MusicMedia*) _tmp147_;
								_tmp149_ = music_media_get_album (_tmp148_);
								_tmp150_ = _tmp149_;
								_tmp138_ = g_strcmp0 (_tmp145_, _tmp150_) != 0;
								_g_object_unref0 (_tmp148_);
								_g_object_unref0 (_tmp143_);
							} else {
								_tmp138_ = FALSE;
							}
							if (_tmp138_) {
								while (TRUE) {
									GeeHashMap* _tmp151_;
									gpointer _tmp152_;
									MusicMedia* _tmp153_;
									const gchar* _tmp154_;
									const gchar* _tmp155_;
									MusicMedia* _tmp156_;
									const gchar* _tmp157_;
									const gchar* _tmp158_;
									gboolean _tmp159_;
									gint _tmp160_;
									_tmp151_ = self->priv->_current;
									_tmp152_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp151_, (gpointer) ((gintptr) (self->priv->_current_index + 1)));
									_tmp153_ = (MusicMedia*) _tmp152_;
									_tmp154_ = music_media_get_album (_tmp153_);
									_tmp155_ = _tmp154_;
									_tmp156_ = self->priv->_current_media;
									_tmp157_ = music_media_get_album (_tmp156_);
									_tmp158_ = _tmp157_;
									_tmp159_ = !(g_strcmp0 (_tmp155_, _tmp158_) == 0);
									_g_object_unref0 (_tmp153_);
									if (_tmp159_) {
										break;
									}
									_tmp160_ = self->priv->_current_index;
									self->priv->_current_index = _tmp160_ + 1;
								}
							} else {
								gint _tmp161_;
								_tmp161_ = self->priv->_current_index;
								self->priv->_current_index = _tmp161_ - 1;
							}
						}
						_tmp162_ = self->priv->_current;
						_tmp163_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp162_, (gpointer) ((gintptr) self->priv->_current_index));
						_g_object_unref0 (rv);
						rv = (MusicMedia*) _tmp163_;
					} else {
						GeeHashMap* _tmp164_;
						gint _tmp165_;
						gint _tmp166_;
						GeeHashMap* _tmp167_;
						gpointer _tmp168_;
						_tmp164_ = self->priv->_current;
						_tmp165_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp164_);
						_tmp166_ = _tmp165_;
						self->priv->_current_index = _tmp166_ - 1;
						_tmp167_ = self->priv->_current;
						_tmp168_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp167_, (gpointer) ((gintptr) self->priv->_current_index));
						_g_object_unref0 (rv);
						rv = (MusicMedia*) _tmp168_;
					}
				}
			}
		}
	}
	_tmp169_ = self->queue_playlist;
	_tmp170_ = music_playlist_get_medias ((MusicPlaylist*) _tmp169_);
	_tmp171_ = _tmp170_;
	_tmp172_ = rv;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp171_, _tmp172_)) {
		self->priv->_playing_queued_song = TRUE;
	}
	if (play) {
		MusicMedia* _tmp173_;
		_tmp173_ = rv;
		music_playback_manager_play_media (self, _tmp173_);
	}
	result = rv;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static Block11Data*
block11_data_ref (Block11Data* _data11_)
{
	g_atomic_int_inc (&_data11_->_ref_count_);
	return _data11_;
}

static void
block11_data_unref (void * _userdata_)
{
	Block11Data* _data11_;
	_data11_ = (Block11Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data11_->_ref_count_)) {
		MusicPlaybackManager* self;
		self = _data11_->self;
		_g_object_unref0 (_data11_->m);
		_g_object_unref0 (self);
		g_slice_free (Block11Data, _data11_);
	}
}

static gboolean
__lambda31_ (Block11Data* _data11_)
{
	MusicPlaybackManager* self;
	gboolean _tmp0_ = FALSE;
	gboolean result;
	self = _data11_->self;
	if (_data11_->m != NULL) {
		MusicMedia* _tmp1_;
		_tmp1_ = self->priv->_current_media;
		_tmp0_ = _tmp1_ == _data11_->m;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		MusicHistoryPlaylist* _tmp2_;
		guint player_duration_s = 0U;
		MusicPlayback* _tmp3_;
		_tmp2_ = self->history_playlist;
		music_playlist_add_media ((MusicPlaylist*) _tmp2_, _data11_->m);
		_tmp3_ = self->player;
		player_duration_s = (guint) (music_playback_get_duration (_tmp3_) / MUSIC_TIME_UTILS_NANO_INV);
		if (player_duration_s > ((guint) 1)) {
			gint delta_s = 0;
			guint _tmp4_;
			guint _tmp5_;
			_tmp4_ = music_media_get_length (_data11_->m);
			_tmp5_ = _tmp4_;
			delta_s = ((gint) player_duration_s) - ((gint) (_tmp5_ / MUSIC_TIME_UTILS_MILI_INV));
			if (fabs ((gdouble) delta_s) > ((gdouble) 3)) {
				MusicLibrary* _tmp6_;
				MusicLibrary* _tmp7_;
				music_media_set_length (_data11_->m, (guint) (player_duration_s * MUSIC_TIME_UTILS_MILI_INV));
				_tmp6_ = music_playback_manager_get_library (self);
				_tmp7_ = _tmp6_;
				music_library_update_media (_tmp7_, _data11_->m, FALSE, FALSE);
			}
		}
	}
	result = FALSE;
	return result;
}

static gboolean
___lambda31__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda31_ (self);
	return result;
}

void
music_playback_manager_play_media (MusicPlaybackManager* self,
                                   MusicMedia* m)
{
	Block11Data* _data11_;
	MusicMedia* _tmp0_;
	gint64 old_id = 0LL;
	MusicMedia* _tmp1_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	gboolean found = FALSE;
	GFile* _tmp41_;
	GFile* _tmp42_;
	MusicPlayback* _tmp52_;
	gboolean _tmp53_;
	gboolean _tmp55_ = FALSE;
	gint64 _tmp56_;
	gint64 _tmp57_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (m != NULL);
	_data11_ = g_slice_new0 (Block11Data);
	_data11_->_ref_count_ = 1;
	_data11_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (m);
	_g_object_unref0 (_data11_->m);
	_data11_->m = _tmp0_;
	old_id = (gint64) -1;
	_tmp1_ = self->priv->_current_media;
	if (_tmp1_ != NULL) {
		MusicMedia* _tmp2_;
		gint64 _tmp3_;
		gint64 _tmp4_;
		_tmp2_ = self->priv->_current_media;
		_tmp3_ = music_media_get_rowid (_tmp2_);
		_tmp4_ = _tmp3_;
		old_id = _tmp4_;
	}
	music_playback_manager_set_current_media (self, _data11_->m);
	_tmp5_ = music_media_get_location_unknown (_data11_->m);
	_tmp6_ = _tmp5_;
	if (_tmp6_) {
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		GFile* _tmp10_;
		GFile* _tmp11_;
		gboolean _tmp12_;
		_tmp7_ = music_media_get_uri (_data11_->m);
		_tmp8_ = _tmp7_;
		_tmp9_ = _tmp8_;
		_tmp10_ = g_file_new_for_uri (_tmp9_);
		_tmp11_ = _tmp10_;
		_tmp12_ = g_file_query_exists (_tmp11_, NULL);
		_g_object_unref0 (_tmp11_);
		_g_free0 (_tmp9_);
		if (_tmp12_) {
			music_media_set_location_unknown (_data11_->m, FALSE);
			music_media_set_unique_status_image (_data11_->m, NULL);
		} else {
			music_playback_manager_stop_playback (self);
			block11_data_unref (_data11_);
			_data11_ = NULL;
			return;
		}
	}
	found = FALSE;
	{
		GeeTreeSet* _tmp13_;
		_tmp13_ = self->priv->playbacks;
		g_rec_mutex_lock (&self->priv->__lock_playbacks);
		{
			{
				GeeIterator* _playback_it = NULL;
				GeeTreeSet* _tmp14_;
				GeeIterator* _tmp15_;
				_tmp14_ = self->priv->playbacks;
				_tmp15_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp14_);
				_playback_it = _tmp15_;
				while (TRUE) {
					GeeIterator* _tmp16_;
					MusicPlayback* playback = NULL;
					GeeIterator* _tmp17_;
					gpointer _tmp18_;
					_tmp16_ = _playback_it;
					if (!gee_iterator_next (_tmp16_)) {
						break;
					}
					_tmp17_ = _playback_it;
					_tmp18_ = gee_iterator_get (_tmp17_);
					playback = (MusicPlayback*) _tmp18_;
					{
						GeeIterator* _supported_uri_it = NULL;
						MusicPlayback* _tmp19_;
						GeeCollection* _tmp20_;
						GeeCollection* _tmp21_;
						GeeIterator* _tmp22_;
						GeeIterator* _tmp23_;
						_tmp19_ = playback;
						_tmp20_ = music_playback_get_supported_uri (_tmp19_);
						_tmp21_ = _tmp20_;
						_tmp22_ = gee_iterable_iterator ((GeeIterable*) _tmp21_);
						_tmp23_ = _tmp22_;
						_g_object_unref0 (_tmp21_);
						_supported_uri_it = _tmp23_;
						while (TRUE) {
							GeeIterator* _tmp24_;
							gchar* supported_uri = NULL;
							GeeIterator* _tmp25_;
							gpointer _tmp26_;
							gchar* _tmp27_;
							gchar* _tmp28_;
							gchar* _tmp29_;
							const gchar* _tmp30_;
							gboolean _tmp31_;
							_tmp24_ = _supported_uri_it;
							if (!gee_iterator_next (_tmp24_)) {
								break;
							}
							_tmp25_ = _supported_uri_it;
							_tmp26_ = gee_iterator_get (_tmp25_);
							supported_uri = (gchar*) _tmp26_;
							_tmp27_ = music_media_get_uri (_data11_->m);
							_tmp28_ = _tmp27_;
							_tmp29_ = _tmp28_;
							_tmp30_ = supported_uri;
							_tmp31_ = g_str_has_prefix (_tmp29_, _tmp30_);
							_g_free0 (_tmp29_);
							if (_tmp31_) {
								MusicPlayback* _tmp32_;
								MusicPlayback* _tmp33_;
								MusicPlayback* _tmp34_;
								MusicPlayback* _tmp35_;
								_tmp32_ = self->player;
								self->priv->saved_volume = music_playback_get_volume (_tmp32_);
								g_signal_emit (self, music_playback_manager_signals[MUSIC_PLAYBACK_MANAGER_CHANGING_PLAYER_SIGNAL], 0);
								_tmp33_ = self->player;
								music_playback_set_state (_tmp33_, GST_STATE_NULL);
								found = TRUE;
								_tmp34_ = playback;
								_tmp35_ = _g_object_ref0 (_tmp34_);
								_g_object_unref0 (self->player);
								self->player = _tmp35_;
								music_playback_manager_set_volume (self, self->priv->saved_volume);
								g_signal_emit (self, music_playback_manager_signals[MUSIC_PLAYBACK_MANAGER_PLAYER_CHANGED_SIGNAL], 0);
								_g_free0 (supported_uri);
								break;
							}
							_g_free0 (supported_uri);
						}
						_g_object_unref0 (_supported_uri_it);
					}
					if (found == TRUE) {
						break;
					}
				}
				_g_object_unref0 (_playback_it);
			}
		}
		__finally0:
		{
			GeeTreeSet* _tmp36_;
			_tmp36_ = self->priv->playbacks;
			g_rec_mutex_unlock (&self->priv->__lock_playbacks);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			block11_data_unref (_data11_);
			_data11_ = NULL;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	if (!found) {
		GThemedIcon* _tmp37_;
		GThemedIcon* _tmp38_;
		MusicMedia* _tmp39_;
		MusicMedia* _tmp40_;
		_tmp37_ = (GThemedIcon*) g_themed_icon_new ("process-error-symbolic");
		_tmp38_ = _tmp37_;
		music_media_set_unique_status_image (_data11_->m, (GIcon*) _tmp38_);
		_g_object_unref0 (_tmp38_);
		_tmp39_ = music_playback_manager_get_next (self, TRUE);
		_tmp40_ = _tmp39_;
		_g_object_unref0 (_tmp40_);
		block11_data_unref (_data11_);
		_data11_ = NULL;
		return;
	}
	_tmp41_ = music_media_get_file (_data11_->m);
	_tmp42_ = _tmp41_;
	if (!g_file_query_exists (_tmp42_, NULL)) {
		GThemedIcon* _tmp43_;
		GThemedIcon* _tmp44_;
		MusicMedia* _tmp45_;
		MusicMedia* _tmp46_;
		_tmp43_ = (GThemedIcon*) g_themed_icon_new ("process-error-symbolic");
		_tmp44_ = _tmp43_;
		music_media_set_unique_status_image (_data11_->m, (GIcon*) _tmp44_);
		_g_object_unref0 (_tmp44_);
		music_media_set_location_unknown (_data11_->m, TRUE);
		_tmp45_ = music_playback_manager_get_next (self, TRUE);
		_tmp46_ = _tmp45_;
		_g_object_unref0 (_tmp46_);
		block11_data_unref (_data11_);
		_data11_ = NULL;
		return;
	} else {
		gboolean _tmp47_ = FALSE;
		gboolean _tmp48_;
		gboolean _tmp49_;
		_tmp48_ = music_media_get_location_unknown (_data11_->m);
		_tmp49_ = _tmp48_;
		if (_tmp49_) {
			GIcon* _tmp50_;
			GIcon* _tmp51_;
			_tmp50_ = music_media_get_unique_status_image (_data11_->m);
			_tmp51_ = _tmp50_;
			_tmp47_ = _tmp51_ != NULL;
		} else {
			_tmp47_ = FALSE;
		}
		if (_tmp47_) {
			music_media_set_unique_status_image (_data11_->m, NULL);
			music_media_set_location_unknown (_data11_->m, FALSE);
		}
	}
	music_playback_manager_change_gains_thread (self);
	_tmp52_ = self->player;
	music_playback_set_media (_tmp52_, _data11_->m);
	_tmp53_ = self->priv->_playing;
	if (!_tmp53_) {
		MusicPlayback* _tmp54_;
		_tmp54_ = self->player;
		music_playback_pause (_tmp54_);
	}
	_tmp56_ = music_media_get_rowid (_data11_->m);
	_tmp57_ = _tmp56_;
	if (_tmp57_ >= ((gint64) 0)) {
		MusicSettingsMain* _tmp58_;
		MusicSettingsMain* _tmp59_;
		_tmp58_ = music_settings_main_get_default ();
		_tmp59_ = _tmp58_;
		_tmp55_ = !music_settings_main_privacy_mode_enabled (_tmp59_);
		_g_object_unref0 (_tmp59_);
	} else {
		_tmp55_ = FALSE;
	}
	if (_tmp55_) {
		GSettings* _tmp60_;
		GSettings* _tmp61_;
		gint64 _tmp62_;
		gint64 _tmp63_;
		_tmp60_ = music_app_get_saved_state ();
		_tmp61_ = _tmp60_;
		_tmp62_ = music_media_get_rowid (_data11_->m);
		_tmp63_ = _tmp62_;
		g_settings_set_int64 (_tmp61_, "last-media-playing", _tmp63_);
	}
	if (_data11_->m != NULL) {
		g_signal_emit (self, music_playback_manager_signals[MUSIC_PLAYBACK_MANAGER_MEDIA_PLAYED_SIGNAL], 0, _data11_->m);
	}
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 1000, ___lambda31__gsource_func, block11_data_ref (_data11_), block11_data_unref);
	block11_data_unref (_data11_);
	_data11_ = NULL;
}

void
music_playback_manager_change_gains_thread (MusicPlaybackManager* self)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = music_app_get_equalizer_settings ();
	_tmp1_ = _tmp0_;
	if (g_settings_get_boolean (_tmp1_, "equalizer-enabled")) {
		gchar** custom_presets = NULL;
		GSettings* _tmp2_;
		GSettings* _tmp3_;
		gchar** _tmp4_;
		gchar** _tmp5_;
		gint custom_presets_length1;
		gint _custom_presets_size_;
		gchar** _tmp6_;
		gint _tmp6__length1;
		_tmp2_ = music_app_get_equalizer_settings ();
		_tmp3_ = _tmp2_;
		_tmp5_ = _tmp4_ = g_settings_get_strv (_tmp3_, "custom-presets");
		custom_presets = _tmp5_;
		custom_presets_length1 = _vala_array_length (_tmp4_);
		_custom_presets_size_ = custom_presets_length1;
		_tmp6_ = custom_presets;
		_tmp6__length1 = custom_presets_length1;
		if (_tmp6_ != NULL) {
			{
				gint i = 0;
				i = 0;
				{
					gboolean _tmp7_ = FALSE;
					_tmp7_ = TRUE;
					while (TRUE) {
						gchar** _tmp9_;
						gint _tmp9__length1;
						MusicEqualizerPreset* preset = NULL;
						gchar** _tmp10_;
						gint _tmp10__length1;
						const gchar* _tmp11_;
						MusicEqualizerPreset* _tmp12_;
						MusicEqualizerPreset* _tmp13_;
						if (!_tmp7_) {
							gint _tmp8_;
							_tmp8_ = i;
							i = _tmp8_ + 1;
						}
						_tmp7_ = FALSE;
						_tmp9_ = custom_presets;
						_tmp9__length1 = custom_presets_length1;
						if (!(i < _tmp9__length1)) {
							break;
						}
						_tmp10_ = custom_presets;
						_tmp10__length1 = custom_presets_length1;
						_tmp11_ = _tmp10_[i];
						_tmp12_ = music_equalizer_preset_new_from_string (_tmp11_);
						preset = _tmp12_;
						_tmp13_ = preset;
						if (music_playback_manager_auto_genre_eq (self, _tmp13_)) {
							_g_object_unref0 (preset);
							custom_presets = (_vala_array_free (custom_presets, custom_presets_length1, (GDestroyNotify) g_free), NULL);
							return;
						}
						_g_object_unref0 (preset);
					}
				}
			}
		}
		{
			GeeIterator* _preset_it = NULL;
			GeeCollection* _tmp14_;
			GeeCollection* _tmp15_;
			GeeIterator* _tmp16_;
			GeeIterator* _tmp17_;
			_tmp14_ = music_equalizer_get_default_presets ();
			_tmp15_ = _tmp14_;
			_tmp16_ = gee_iterable_iterator ((GeeIterable*) _tmp15_);
			_tmp17_ = _tmp16_;
			_g_object_unref0 (_tmp15_);
			_preset_it = _tmp17_;
			while (TRUE) {
				GeeIterator* _tmp18_;
				MusicEqualizerPreset* preset = NULL;
				GeeIterator* _tmp19_;
				gpointer _tmp20_;
				MusicEqualizerPreset* _tmp21_;
				_tmp18_ = _preset_it;
				if (!gee_iterator_next (_tmp18_)) {
					break;
				}
				_tmp19_ = _preset_it;
				_tmp20_ = gee_iterator_get (_tmp19_);
				preset = (MusicEqualizerPreset*) _tmp20_;
				_tmp21_ = preset;
				if (music_playback_manager_auto_genre_eq (self, _tmp21_)) {
					_g_object_unref0 (preset);
					_g_object_unref0 (_preset_it);
					custom_presets = (_vala_array_free (custom_presets, custom_presets_length1, (GDestroyNotify) g_free), NULL);
					return;
				}
				_g_object_unref0 (preset);
			}
			_g_object_unref0 (_preset_it);
		}
		custom_presets = (_vala_array_free (custom_presets, custom_presets_length1, (GDestroyNotify) g_free), NULL);
	}
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp22_ = FALSE;
			_tmp22_ = TRUE;
			while (TRUE) {
				MusicPlayback* _tmp24_;
				if (!_tmp22_) {
					gint _tmp23_;
					i = i + 1;
					_tmp23_ = i;
				}
				_tmp22_ = FALSE;
				if (!(i < 10)) {
					break;
				}
				_tmp24_ = self->player;
				music_playback_set_equalizer_gain (_tmp24_, i, 0);
			}
		}
	}
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

static gboolean
music_playback_manager_auto_genre_eq (MusicPlaybackManager* self,
                                      MusicEqualizerPreset* preset)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (preset != NULL, FALSE);
	if (preset != NULL) {
		MusicMedia* _tmp1_;
		_tmp1_ = self->priv->_current_media;
		_tmp0_ = _tmp1_ != NULL;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gchar* preset_name = NULL;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* media_genre = NULL;
		MusicMedia* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gboolean _tmp9_ = FALSE;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		gboolean match_genre = FALSE;
		gboolean automatic_enabled = FALSE;
		GSettings* _tmp14_;
		GSettings* _tmp15_;
		gchar* selected_preset = NULL;
		GSettings* _tmp16_;
		GSettings* _tmp17_;
		gchar* _tmp18_;
		gboolean _tmp19_ = FALSE;
		gboolean _tmp20_ = FALSE;
		_tmp2_ = music_equalizer_preset_get_name (preset);
		_tmp3_ = _tmp2_;
		_tmp4_ = g_utf8_strdown (_tmp3_, (gssize) -1);
		preset_name = _tmp4_;
		_tmp5_ = self->priv->_current_media;
		_tmp6_ = music_media_get_genre (_tmp5_);
		_tmp7_ = _tmp6_;
		_tmp8_ = g_utf8_strdown (_tmp7_, (gssize) -1);
		media_genre = _tmp8_;
		_tmp10_ = media_genre;
		_tmp11_ = preset_name;
		if (string_contains (_tmp10_, _tmp11_)) {
			_tmp9_ = TRUE;
		} else {
			const gchar* _tmp12_;
			const gchar* _tmp13_;
			_tmp12_ = preset_name;
			_tmp13_ = media_genre;
			_tmp9_ = string_contains (_tmp12_, _tmp13_);
		}
		match_genre = _tmp9_;
		_tmp14_ = music_app_get_equalizer_settings ();
		_tmp15_ = _tmp14_;
		automatic_enabled = g_settings_get_boolean (_tmp15_, "auto-switch-preset");
		_tmp16_ = music_app_get_equalizer_settings ();
		_tmp17_ = _tmp16_;
		_tmp18_ = g_settings_get_string (_tmp17_, "selected-preset");
		selected_preset = _tmp18_;
		if (automatic_enabled) {
			_tmp20_ = match_genre;
		} else {
			_tmp20_ = FALSE;
		}
		if (_tmp20_) {
			_tmp19_ = TRUE;
		} else {
			gboolean _tmp21_ = FALSE;
			if (!automatic_enabled) {
				const gchar* _tmp22_;
				const gchar* _tmp23_;
				const gchar* _tmp24_;
				_tmp22_ = music_equalizer_preset_get_name (preset);
				_tmp23_ = _tmp22_;
				_tmp24_ = selected_preset;
				_tmp21_ = g_strcmp0 (_tmp23_, _tmp24_) == 0;
			} else {
				_tmp21_ = FALSE;
			}
			_tmp19_ = _tmp21_;
		}
		if (_tmp19_) {
			{
				gint i = 0;
				i = 0;
				{
					gboolean _tmp25_ = FALSE;
					_tmp25_ = TRUE;
					while (TRUE) {
						MusicPlayback* _tmp27_;
						if (!_tmp25_) {
							gint _tmp26_;
							_tmp26_ = i;
							i = _tmp26_ + 1;
						}
						_tmp25_ = FALSE;
						if (!(i < 10)) {
							break;
						}
						_tmp27_ = self->player;
						music_playback_set_equalizer_gain (_tmp27_, i, music_equalizer_preset_get_gain (preset, i));
					}
				}
			}
			result = TRUE;
			_g_free0 (selected_preset);
			_g_free0 (media_genre);
			_g_free0 (preset_name);
			return result;
		}
		_g_free0 (selected_preset);
		_g_free0 (media_genre);
		_g_free0 (preset_name);
	}
	result = FALSE;
	return result;
}

void
music_playback_manager_stop_playback (MusicPlaybackManager* self)
{
	MusicPlayback* _tmp0_;
	gint64 was_playing = 0LL;
	MusicMedia* _tmp1_;
	MusicSettingsMain* _tmp5_;
	MusicSettingsMain* _tmp6_;
	gboolean _tmp7_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->player;
	music_playback_pause (_tmp0_);
	music_playback_manager_set_playing (self, FALSE);
	was_playing = (gint64) 0;
	_tmp1_ = self->priv->_current_media;
	if (_tmp1_ != NULL) {
		MusicMedia* _tmp2_;
		gint64 _tmp3_;
		gint64 _tmp4_;
		_tmp2_ = self->priv->_current_media;
		_tmp3_ = music_media_get_rowid (_tmp2_);
		_tmp4_ = _tmp3_;
		was_playing = _tmp4_;
	}
	_tmp5_ = music_settings_main_get_default ();
	_tmp6_ = _tmp5_;
	_tmp7_ = !music_settings_main_privacy_mode_enabled (_tmp6_);
	_g_object_unref0 (_tmp6_);
	if (_tmp7_) {
		GSettings* _tmp8_;
		GSettings* _tmp9_;
		_tmp8_ = music_app_get_saved_state ();
		_tmp9_ = _tmp8_;
		g_settings_set_int64 (_tmp9_, "last-media-playing", (gint64) 0);
	}
	music_playback_manager_set_current_media (self, NULL);
	g_signal_emit (self, music_playback_manager_signals[MUSIC_PLAYBACK_MANAGER_PLAYBACK_STOPPED_SIGNAL], 0, was_playing);
}

static GVariant*
_variant_new4 (gboolean value)
{
	return g_variant_ref_sink (g_variant_new_boolean (value));
}

void
music_playback_manager_start_playback (MusicPlaybackManager* self)
{
	MusicPlayback* _tmp0_;
	MusicLibraryWindow* _tmp1_;
	MusicLibraryWindow* _tmp2_;
	GAction* _tmp3_;
	GVariant* _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->player;
	music_playback_play (_tmp0_);
	music_playback_manager_set_playing (self, TRUE);
	_tmp1_ = music_app_get_main_window ();
	_tmp2_ = _tmp1_;
	_tmp3_ = g_action_map_lookup_action ((GActionMap*) _tmp2_, MUSIC_LIBRARY_WINDOW_ACTION_PLAY);
	_tmp4_ = _variant_new4 (TRUE);
	g_simple_action_set_state (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, g_simple_action_get_type (), GSimpleAction), _tmp4_);
	_g_variant_unref0 (_tmp4_);
	g_signal_emit (self, music_playback_manager_signals[MUSIC_PLAYBACK_MANAGER_PLAYBACK_STARTED_SIGNAL], 0);
}

static GVariant*
_variant_new5 (gboolean value)
{
	return g_variant_ref_sink (g_variant_new_boolean (value));
}

void
music_playback_manager_pause_playback (MusicPlaybackManager* self)
{
	MusicPlayback* _tmp0_;
	MusicLibraryWindow* _tmp1_;
	MusicLibraryWindow* _tmp2_;
	GAction* _tmp3_;
	GVariant* _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->player;
	music_playback_pause (_tmp0_);
	music_playback_manager_set_playing (self, FALSE);
	_tmp1_ = music_app_get_main_window ();
	_tmp2_ = _tmp1_;
	_tmp3_ = g_action_map_lookup_action ((GActionMap*) _tmp2_, MUSIC_LIBRARY_WINDOW_ACTION_PLAY);
	_tmp4_ = _variant_new5 (FALSE);
	g_simple_action_set_state (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, g_simple_action_get_type (), GSimpleAction), _tmp4_);
	_g_variant_unref0 (_tmp4_);
}

MusicPlaybackManager*
music_playback_manager_construct (GType object_type)
{
	MusicPlaybackManager * self = NULL;
	self = (MusicPlaybackManager*) g_object_new (object_type, NULL);
	return self;
}

MusicPlaybackManager*
music_playback_manager_new (void)
{
	return music_playback_manager_construct (MUSIC_TYPE_PLAYBACK_MANAGER);
}

static MusicLibrary*
music_playback_manager_get_library (MusicPlaybackManager* self)
{
	MusicLibrary* result;
	MusicLibrariesManager* _tmp0_;
	MusicLibrary* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = music_libraries_manager;
	_tmp1_ = _tmp0_->local_library;
	result = _tmp1_;
	return result;
}

gint
music_playback_manager_get_current_index (MusicPlaybackManager* self)
{
	gint result;
	GeeHashMap* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_current_shuffled;
	_tmp1_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == 0) {
		result = self->priv->_current_index;
		return result;
	} else {
		result = self->priv->_current_shuffled_index;
		return result;
	}
}

void
music_playback_manager_set_current_index (MusicPlaybackManager* self,
                                          gint value)
{
	GeeHashMap* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_if_fail (self != NULL);
	g_debug ("PlaybackManager.vala:71: Current index: %d", value);
	_tmp0_ = self->priv->_current_shuffled;
	_tmp1_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == 0) {
		self->priv->_current_index = value;
	} else {
		self->priv->_current_shuffled_index = value;
	}
	g_object_notify_by_pspec ((GObject *) self, music_playback_manager_properties[MUSIC_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY]);
}

gboolean
music_playback_manager_get_playing (MusicPlaybackManager* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_playing;
	return result;
}

static void
music_playback_manager_set_playing (MusicPlaybackManager* self,
                                    gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = music_playback_manager_get_playing (self);
	if (old_value != value) {
		self->priv->_playing = value;
		g_object_notify_by_pspec ((GObject *) self, music_playback_manager_properties[MUSIC_PLAYBACK_MANAGER_PLAYING_PROPERTY]);
	}
}

gdouble
music_playback_manager_get_volume (MusicPlaybackManager* self)
{
	gdouble result;
	MusicPlayback* _tmp0_;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->player;
	result = music_playback_get_volume (_tmp0_);
	return result;
}

void
music_playback_manager_set_volume (MusicPlaybackManager* self,
                                   gdouble value)
{
	MusicPlayback* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->saved_volume = value;
	_tmp0_ = self->player;
	music_playback_set_volume (_tmp0_, value);
	g_object_notify_by_pspec ((GObject *) self, music_playback_manager_properties[MUSIC_PLAYBACK_MANAGER_VOLUME_PROPERTY]);
}

MusicMedia*
music_playback_manager_get_current_media (MusicPlaybackManager* self)
{
	MusicMedia* result;
	MusicMedia* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_current_media;
	result = _tmp0_;
	return result;
}

static void
music_playback_manager_set_current_media (MusicPlaybackManager* self,
                                          MusicMedia* value)
{
	MusicMedia* old_value;
	g_return_if_fail (self != NULL);
	old_value = music_playback_manager_get_current_media (self);
	if (old_value != value) {
		MusicMedia* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_current_media);
		self->priv->_current_media = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_playback_manager_properties[MUSIC_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY]);
	}
}

static void
g_cclosure_user_marshal_VOID__INT64 (GClosure * closure,
                                     GValue * return_value,
                                     guint n_param_values,
                                     const GValue * param_values,
                                     gpointer invocation_hint,
                                     gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT64) (gpointer data1, gint64 arg_1, gpointer data2);
	register GMarshalFunc_VOID__INT64 callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 2);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__INT64) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_int64 (param_values + 1), data2);
}

static GObject *
music_playback_manager_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicPlaybackManager * self;
	MusicHistoryPlaylist* _tmp0_;
	MusicStaticPlaylist* _tmp1_;
	MusicStaticPlaylist* _tmp2_;
	MusicStaticPlaylist* _tmp3_;
	MusicStaticPlaylist* _tmp4_;
	MusicStaticPlaylist* _tmp5_;
	MusicStaticPlaylist* _tmp6_;
	GThemedIcon* _tmp7_;
	MusicStreamer* _tmp8_;
	GeeTreeSet* _tmp9_;
	MusicStreamer* _tmp10_;
	MusicStreamer* _tmp11_;
	MusicPlayback* _tmp12_;
	parent_class = G_OBJECT_CLASS (music_playback_manager_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManager);
	_tmp0_ = music_history_playlist_new ();
	_g_object_unref0 (self->history_playlist);
	self->history_playlist = _tmp0_;
	_tmp1_ = music_static_playlist_new ();
	_g_object_unref0 (self->queue_playlist);
	self->queue_playlist = _tmp1_;
	_tmp2_ = self->queue_playlist;
	music_playlist_set_name ((MusicPlaylist*) _tmp2_, C_ ("Name of the playlist", "Queue"));
	_tmp3_ = self->queue_playlist;
	music_static_playlist_set_read_only (_tmp3_, TRUE);
	_tmp4_ = self->queue_playlist;
	music_static_playlist_set_allow_duplicate (_tmp4_, TRUE);
	_tmp5_ = self->queue_playlist;
	music_static_playlist_set_show_badge (_tmp5_, TRUE);
	_tmp6_ = self->queue_playlist;
	_tmp7_ = (GThemedIcon*) g_themed_icon_new ("playlist-queue");
	_g_object_unref0 (((MusicPlaylist*) _tmp6_)->icon);
	((MusicPlaylist*) _tmp6_)->icon = (GIcon*) _tmp7_;
	_tmp8_ = music_streamer_new ();
	_g_object_unref0 (self->file_player);
	self->file_player = _tmp8_;
	_tmp9_ = self->priv->playbacks;
	_tmp10_ = self->file_player;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, (MusicPlayback*) _tmp10_);
	_tmp11_ = self->file_player;
	_tmp12_ = _g_object_ref0 ((MusicPlayback*) _tmp11_);
	_g_object_unref0 (self->player);
	self->player = _tmp12_;
	return obj;
}

static void
music_playback_manager_class_init (MusicPlaybackManagerClass * klass,
                                   gpointer klass_data)
{
	music_playback_manager_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicPlaybackManager_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_music_playback_manager_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_music_playback_manager_set_property;
	G_OBJECT_CLASS (klass)->constructor = music_playback_manager_constructor;
	G_OBJECT_CLASS (klass)->finalize = music_playback_manager_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY, music_playback_manager_properties[MUSIC_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY] = g_param_spec_int ("current-index", "current-index", "current-index", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_PLAYBACK_MANAGER_PLAYING_PROPERTY, music_playback_manager_properties[MUSIC_PLAYBACK_MANAGER_PLAYING_PROPERTY] = g_param_spec_boolean ("playing", "playing", "playing", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_PLAYBACK_MANAGER_VOLUME_PROPERTY, music_playback_manager_properties[MUSIC_PLAYBACK_MANAGER_VOLUME_PROPERTY] = g_param_spec_double ("volume", "volume", "volume", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY, music_playback_manager_properties[MUSIC_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY] = g_param_spec_object ("current-media", "current-media", "current-media", MUSIC_TYPE_MEDIA, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	music_playback_manager_signals[MUSIC_PLAYBACK_MANAGER_CHANGING_PLAYER_SIGNAL] = g_signal_new ("changing-player", MUSIC_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	music_playback_manager_signals[MUSIC_PLAYBACK_MANAGER_MEDIA_PLAYED_SIGNAL] = g_signal_new ("media-played", MUSIC_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, MUSIC_TYPE_MEDIA);
	music_playback_manager_signals[MUSIC_PLAYBACK_MANAGER_PLAYBACK_STOPPED_SIGNAL] = g_signal_new ("playback-stopped", MUSIC_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT64, G_TYPE_NONE, 1, G_TYPE_INT64);
	music_playback_manager_signals[MUSIC_PLAYBACK_MANAGER_PLAYBACK_STARTED_SIGNAL] = g_signal_new ("playback-started", MUSIC_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	music_playback_manager_signals[MUSIC_PLAYBACK_MANAGER_PLAYER_CHANGED_SIGNAL] = g_signal_new ("player-changed", MUSIC_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	music_playback_manager_signals[MUSIC_PLAYBACK_MANAGER_QUEUE_CLEARED_SIGNAL] = g_signal_new ("queue-cleared", MUSIC_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
music_playback_manager_instance_init (MusicPlaybackManager * self,
                                      gpointer klass)
{
	GeeTreeSet* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp2_;
	self->priv = music_playback_manager_get_instance_private (self);
	g_rec_mutex_init (&self->priv->__lock_playbacks);
	_tmp0_ = gee_tree_set_new (MUSIC_TYPE_PLAYBACK, NULL, NULL, NULL, NULL, NULL);
	self->priv->playbacks = _tmp0_;
	_tmp1_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	self->priv->_current = _tmp1_;
	_tmp2_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	self->priv->_current_shuffled = _tmp2_;
	self->priv->_playing = FALSE;
	self->priv->saved_volume = (gdouble) 1;
}

static void
music_playback_manager_finalize (GObject * obj)
{
	MusicPlaybackManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManager);
	g_rec_mutex_clear (&self->priv->__lock_playbacks);
	_g_object_unref0 (self->priv->playbacks);
	_g_object_unref0 (self->priv->_current);
	_g_object_unref0 (self->priv->_current_shuffled);
	_g_object_unref0 (self->queue_playlist);
	_g_object_unref0 (self->history_playlist);
	_g_object_unref0 (self->file_player);
	_g_object_unref0 (self->player);
	_g_object_unref0 (self->priv->_current_media);
	G_OBJECT_CLASS (music_playback_manager_parent_class)->finalize (obj);
}

/**
* Manages song playback, queue, repeating and shuffling
*
* Finds the appropriate {@link Music.Playback} to play a media
*/
static GType
music_playback_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicPlaybackManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_playback_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicPlaybackManager), 0, (GInstanceInitFunc) music_playback_manager_instance_init, NULL };
	GType music_playback_manager_type_id;
	music_playback_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "MusicPlaybackManager", &g_define_type_info, 0);
	MusicPlaybackManager_private_offset = g_type_add_instance_private (music_playback_manager_type_id, sizeof (MusicPlaybackManagerPrivate));
	return music_playback_manager_type_id;
}

GType
music_playback_manager_get_type (void)
{
	static volatile gsize music_playback_manager_type_id__once = 0;
	if (g_once_init_enter (&music_playback_manager_type_id__once)) {
		GType music_playback_manager_type_id;
		music_playback_manager_type_id = music_playback_manager_get_type_once ();
		g_once_init_leave (&music_playback_manager_type_id__once, music_playback_manager_type_id);
	}
	return music_playback_manager_type_id__once;
}

static void
_vala_music_playback_manager_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	MusicPlaybackManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManager);
	switch (property_id) {
		case MUSIC_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY:
		g_value_set_int (value, music_playback_manager_get_current_index (self));
		break;
		case MUSIC_PLAYBACK_MANAGER_PLAYING_PROPERTY:
		g_value_set_boolean (value, music_playback_manager_get_playing (self));
		break;
		case MUSIC_PLAYBACK_MANAGER_VOLUME_PROPERTY:
		g_value_set_double (value, music_playback_manager_get_volume (self));
		break;
		case MUSIC_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY:
		g_value_set_object (value, music_playback_manager_get_current_media (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_music_playback_manager_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	MusicPlaybackManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManager);
	switch (property_id) {
		case MUSIC_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY:
		music_playback_manager_set_current_index (self, g_value_get_int (value));
		break;
		case MUSIC_PLAYBACK_MANAGER_PLAYING_PROPERTY:
		music_playback_manager_set_playing (self, g_value_get_boolean (value));
		break;
		case MUSIC_PLAYBACK_MANAGER_VOLUME_PROPERTY:
		music_playback_manager_set_volume (self, g_value_get_double (value));
		break;
		case MUSIC_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY:
		music_playback_manager_set_current_media (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

