/* BrowserColumn.c generated by valac 0.56.1, the Vala compiler
 * generated from BrowserColumn.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Victor Eduardo <victoreduardm@gmail.com>
 */

#include "music-lib.h"
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <glib-object.h>
#include <pango/pango.h>
#include <gdk/gdk.h>
#include <gee.h>

enum  {
	MUSIC_BROWSER_COLUMN_0_PROPERTY,
	MUSIC_BROWSER_COLUMN_VISIBLE_PROPERTY,
	MUSIC_BROWSER_COLUMN_SHOW_SEPARATOR_PROPERTY,
	MUSIC_BROWSER_COLUMN_FIRST_ITEM_SELECTED_PROPERTY,
	MUSIC_BROWSER_COLUMN_CATEGORY_PROPERTY,
	MUSIC_BROWSER_COLUMN_MENU_ITEM_PROPERTY,
	MUSIC_BROWSER_COLUMN_NUM_PROPERTIES
};
static GParamSpec* music_browser_column_properties[MUSIC_BROWSER_COLUMN_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))
enum  {
	MUSIC_BROWSER_COLUMN_SELECTION_CHANGED_SIGNAL,
	MUSIC_BROWSER_COLUMN_ROW_ACTIVATED_SIGNAL,
	MUSIC_BROWSER_COLUMN_RESET_REQUESTED_SIGNAL,
	MUSIC_BROWSER_COLUMN_HEADER_CLICKED_SIGNAL,
	MUSIC_BROWSER_COLUMN_VISIBILITY_CHANGED_SIGNAL,
	MUSIC_BROWSER_COLUMN_NUM_SIGNALS
};
static guint music_browser_column_signals[MUSIC_BROWSER_COLUMN_NUM_SIGNALS] = {0};

struct _MusicBrowserColumnPrivate {
	GtkSeparator* separator;
	MusicBrowserColumnCategory _category;
	GtkCheckMenuItem* _menu_item;
	MusicColumnBrowser* miller_parent;
	GtkTreeView* view;
	MusicBrowserColumnModel* model;
	gchar* _selected;
};

static gint MusicBrowserColumn_private_offset;
static gpointer music_browser_column_parent_class = NULL;

static void music_browser_column_on_menu_item_toggled (MusicBrowserColumn* self);
static void _music_browser_column_on_menu_item_toggled_gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                                                             gpointer self);
static void music_browser_column_view_double_click (MusicBrowserColumn* self,
                                             GtkTreePath* path,
                                             GtkTreeViewColumn* column);
static void _music_browser_column_view_double_click_gtk_tree_view_row_activated (GtkTreeView* _sender,
                                                                          GtkTreePath* path,
                                                                          GtkTreeViewColumn* column,
                                                                          gpointer self);
static gboolean music_browser_column_on_header_clicked (MusicBrowserColumn* self,
                                                 GtkWidget* w,
                                                 GdkEventButton* e);
static gboolean _music_browser_column_on_header_clicked_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                                GdkEventButton* event,
                                                                                gpointer self);
static void music_browser_column_selected_item_changed (MusicBrowserColumn* self);
static void _music_browser_column_selected_item_changed_gtk_tree_selection_changed (GtkTreeSelection* _sender,
                                                                             gpointer self);
static void _vala_GtkTreePath_free (GtkTreePath* self);
static gboolean music_browser_column_select_proper_string (MusicBrowserColumn* self,
                                                    GtkTreeModel* tmodel,
                                                    GtkTreePath* path,
                                                    GtkTreeIter* item);
static gboolean _music_browser_column_select_proper_string_gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                                                 GtkTreePath* path,
                                                                                 GtkTreeIter* iter,
                                                                                 gpointer self);
static gboolean ___lambda5_ (MusicBrowserColumn* self);
static gboolean ____lambda5__gsource_func (gpointer self);
static void g_cclosure_user_marshal_VOID__ENUM_STRING (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data);
static void music_browser_column_finalize (GObject * obj);
static GType music_browser_column_get_type_once (void);
static void _vala_music_browser_column_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_music_browser_column_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);

static inline gpointer
music_browser_column_get_instance_private (MusicBrowserColumn* self)
{
	return G_STRUCT_MEMBER_P (self, MusicBrowserColumn_private_offset);
}

MusicBrowserColumnCategory
music_browser_column_category_first (void)
{
	MusicBrowserColumnCategory result;
	result = (MusicBrowserColumnCategory) 0;
	return result;
}

MusicBrowserColumnCategory
music_browser_column_category_last (void)
{
	MusicBrowserColumnCategory result;
	result = (MusicBrowserColumnCategory) (MUSIC_BROWSER_COLUMN_CATEGORY_N_CATEGORIES - 1);
	return result;
}

gchar*
music_browser_column_category_to_string (MusicBrowserColumnCategory self)
{
	gchar* result;
	switch (self) {
		case MUSIC_BROWSER_COLUMN_CATEGORY_GENRE:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup (_ ("Genres"));
			result = _tmp0_;
			return result;
		}
		case MUSIC_BROWSER_COLUMN_CATEGORY_ARTIST:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup (_ ("Artists"));
			result = _tmp1_;
			return result;
		}
		case MUSIC_BROWSER_COLUMN_CATEGORY_ALBUM:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup (_ ("Albums"));
			result = _tmp2_;
			return result;
		}
		case MUSIC_BROWSER_COLUMN_CATEGORY_YEAR:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup (_ ("Years"));
			result = _tmp3_;
			return result;
		}
		case MUSIC_BROWSER_COLUMN_CATEGORY_RATING:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup (_ ("Ratings"));
			result = _tmp4_;
			return result;
		}
		case MUSIC_BROWSER_COLUMN_CATEGORY_COMPOSER:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup (_ ("Composers"));
			result = _tmp5_;
			return result;
		}
		case MUSIC_BROWSER_COLUMN_CATEGORY_GROUPING:
		{
			gchar* _tmp6_;
			_tmp6_ = g_strdup (_ ("Groupings"));
			result = _tmp6_;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

static GType
music_browser_column_category_get_type_once (void)
{
	static const GEnumValue values[] = {{MUSIC_BROWSER_COLUMN_CATEGORY_RATING, "MUSIC_BROWSER_COLUMN_CATEGORY_RATING", "rating"}, {MUSIC_BROWSER_COLUMN_CATEGORY_GROUPING, "MUSIC_BROWSER_COLUMN_CATEGORY_GROUPING", "grouping"}, {MUSIC_BROWSER_COLUMN_CATEGORY_YEAR, "MUSIC_BROWSER_COLUMN_CATEGORY_YEAR", "year"}, {MUSIC_BROWSER_COLUMN_CATEGORY_GENRE, "MUSIC_BROWSER_COLUMN_CATEGORY_GENRE", "genre"}, {MUSIC_BROWSER_COLUMN_CATEGORY_COMPOSER, "MUSIC_BROWSER_COLUMN_CATEGORY_COMPOSER", "composer"}, {MUSIC_BROWSER_COLUMN_CATEGORY_ARTIST, "MUSIC_BROWSER_COLUMN_CATEGORY_ARTIST", "artist"}, {MUSIC_BROWSER_COLUMN_CATEGORY_ALBUM, "MUSIC_BROWSER_COLUMN_CATEGORY_ALBUM", "album"}, {MUSIC_BROWSER_COLUMN_CATEGORY_N_CATEGORIES, "MUSIC_BROWSER_COLUMN_CATEGORY_N_CATEGORIES", "n-categories"}, {0, NULL, NULL}};
	GType music_browser_column_category_type_id;
	music_browser_column_category_type_id = g_enum_register_static ("MusicBrowserColumnCategory", values);
	return music_browser_column_category_type_id;
}

GType
music_browser_column_category_get_type (void)
{
	static volatile gsize music_browser_column_category_type_id__once = 0;
	if (g_once_init_enter (&music_browser_column_category_type_id__once)) {
		GType music_browser_column_category_type_id;
		music_browser_column_category_type_id = music_browser_column_category_get_type_once ();
		g_once_init_leave (&music_browser_column_category_type_id__once, music_browser_column_category_type_id);
	}
	return music_browser_column_category_type_id__once;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_music_browser_column_on_menu_item_toggled_gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                                                        gpointer self)
{
	music_browser_column_on_menu_item_toggled ((MusicBrowserColumn*) self);
}

static void
_music_browser_column_view_double_click_gtk_tree_view_row_activated (GtkTreeView* _sender,
                                                                     GtkTreePath* path,
                                                                     GtkTreeViewColumn* column,
                                                                     gpointer self)
{
	music_browser_column_view_double_click ((MusicBrowserColumn*) self, path, column);
}

static gboolean
_music_browser_column_on_header_clicked_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                       GdkEventButton* event,
                                                                       gpointer self)
{
	gboolean result;
	result = music_browser_column_on_header_clicked ((MusicBrowserColumn*) self, _sender, event);
	return result;
}

MusicBrowserColumn*
music_browser_column_construct (GType object_type,
                                MusicColumnBrowser* miller_parent,
                                MusicBrowserColumnCategory category)
{
	MusicBrowserColumn * self = NULL;
	MusicColumnBrowser* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GtkCheckMenuItem* _tmp3_;
	GtkCheckMenuItem* _tmp4_;
	GtkTreeView* _tmp5_;
	MusicBrowserColumnModel* _tmp6_;
	GtkCellRendererText* cell = NULL;
	GtkCellRendererText* _tmp7_;
	GtkTreeView* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GtkScrolledWindow* scrolled = NULL;
	GtkScrolledWindow* _tmp11_;
	GtkTreeView* _tmp12_;
	GtkTreeView* _tmp13_;
	GtkCheckMenuItem* _tmp14_;
	GtkTreeView* _tmp15_;
	GtkTreeViewColumn* column = NULL;
	GtkTreeView* _tmp16_;
	GtkTreeViewColumn* _tmp17_;
	GtkTreeViewColumn* _tmp18_;
	GtkWidget* _tmp19_;
	GtkTreeView* _tmp20_;
	GtkTreeSelection* _tmp21_;
	g_return_val_if_fail (miller_parent != NULL, NULL);
	self = (MusicBrowserColumn*) g_object_new (object_type, NULL);
	_tmp0_ = _g_object_ref0 (miller_parent);
	_g_object_unref0 (self->priv->miller_parent);
	self->priv->miller_parent = _tmp0_;
	music_browser_column_set_category (self, category);
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_HORIZONTAL);
	_tmp1_ = music_browser_column_category_to_string (category);
	_tmp2_ = _tmp1_;
	_tmp3_ = (GtkCheckMenuItem*) gtk_check_menu_item_new_with_label (_tmp2_);
	g_object_ref_sink (_tmp3_);
	_tmp4_ = _tmp3_;
	music_browser_column_set_menu_item (self, _tmp4_);
	_g_object_unref0 (_tmp4_);
	_g_free0 (_tmp2_);
	music_browser_column_set_visible (self, FALSE);
	_tmp5_ = (GtkTreeView*) gtk_tree_view_new ();
	g_object_ref_sink (_tmp5_);
	_g_object_unref0 (self->priv->view);
	self->priv->view = _tmp5_;
	_tmp6_ = music_browser_column_model_new (category);
	_g_object_unref0 (self->priv->model);
	self->priv->model = _tmp6_;
	_tmp7_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
	g_object_ref_sink (_tmp7_);
	cell = _tmp7_;
	g_object_set (cell, "ellipsize", PANGO_ELLIPSIZE_END, NULL);
	_tmp8_ = self->priv->view;
	_tmp9_ = music_browser_column_category_to_string (category);
	_tmp10_ = _tmp9_;
	gtk_tree_view_insert_column_with_attributes (_tmp8_, -1, _tmp10_, (GtkCellRenderer*) cell, "text", 0, NULL, NULL);
	_g_free0 (_tmp10_);
	_tmp11_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
	g_object_ref_sink (_tmp11_);
	scrolled = _tmp11_;
	g_object_set ((GtkWidget*) scrolled, "expand", TRUE, NULL);
	_tmp12_ = self->priv->view;
	gtk_container_add ((GtkContainer*) scrolled, (GtkWidget*) _tmp12_);
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) scrolled);
	_tmp13_ = self->priv->view;
	gtk_tree_view_set_headers_clickable (_tmp13_, TRUE);
	_tmp14_ = self->priv->_menu_item;
	g_signal_connect_object (_tmp14_, "toggled", (GCallback) _music_browser_column_on_menu_item_toggled_gtk_check_menu_item_toggled, self, 0);
	_tmp15_ = self->priv->view;
	g_signal_connect_object (_tmp15_, "row-activated", (GCallback) _music_browser_column_view_double_click_gtk_tree_view_row_activated, self, 0);
	_tmp16_ = self->priv->view;
	_tmp17_ = gtk_tree_view_get_column (_tmp16_, 0);
	_tmp18_ = _g_object_ref0 (_tmp17_);
	column = _tmp18_;
	gtk_tree_view_column_set_alignment (column, 0.5f);
	_tmp19_ = gtk_tree_view_column_get_button (column);
	g_signal_connect_object (_tmp19_, "button-press-event", (GCallback) _music_browser_column_on_header_clicked_gtk_widget_button_press_event, self, 0);
	_tmp20_ = self->priv->view;
	_tmp21_ = gtk_tree_view_get_selection (_tmp20_);
	gtk_tree_selection_set_mode (_tmp21_, GTK_SELECTION_BROWSE);
	_g_object_unref0 (column);
	_g_object_unref0 (scrolled);
	_g_object_unref0 (cell);
	return self;
}

MusicBrowserColumn*
music_browser_column_new (MusicColumnBrowser* miller_parent,
                          MusicBrowserColumnCategory category)
{
	return music_browser_column_construct (MUSIC_TYPE_BROWSER_COLUMN, miller_parent, category);
}

static void
_music_browser_column_selected_item_changed_gtk_tree_selection_changed (GtkTreeSelection* _sender,
                                                                        gpointer self)
{
	music_browser_column_selected_item_changed ((MusicBrowserColumn*) self);
}

static void
music_browser_column_on_menu_item_toggled (MusicBrowserColumn* self)
{
	gboolean _tmp0_ = FALSE;
	GtkCheckMenuItem* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GtkCheckMenuItem* _tmp9_;
	guint _tmp10_;
	gint visible_columns = 0;
	GtkCheckMenuItem* _tmp22_;
	gboolean _tmp23_;
	gboolean _tmp24_;
	GtkCheckMenuItem* _tmp27_;
	gboolean _tmp28_;
	gboolean _tmp29_;
	GtkCheckMenuItem* _tmp42_;
	GtkTreeView* _tmp43_;
	GtkTreeSelection* _tmp44_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->_menu_item;
	_tmp2_ = gtk_widget_get_sensitive ((GtkWidget*) _tmp1_);
	_tmp3_ = _tmp2_;
	if (!_tmp3_) {
		_tmp0_ = TRUE;
	} else {
		GtkCheckMenuItem* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
		_tmp4_ = self->priv->_menu_item;
		_tmp5_ = gtk_check_menu_item_get_active (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = music_browser_column_get_visible (self);
		_tmp8_ = _tmp7_;
		_tmp0_ = _tmp6_ == _tmp8_;
	}
	if (_tmp0_) {
		return;
	}
	_tmp9_ = self->priv->_menu_item;
	g_signal_parse_name ("toggled", gtk_check_menu_item_get_type (), &_tmp10_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp9_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp10_, 0, NULL, (GCallback) _music_browser_column_on_menu_item_toggled_gtk_check_menu_item_toggled, self);
	visible_columns = 0;
	{
		GeeIterator* _col_it = NULL;
		MusicColumnBrowser* _tmp11_;
		GeeTreeSet* _tmp12_;
		GeeTreeSet* _tmp13_;
		GeeIterator* _tmp14_;
		_tmp11_ = self->priv->miller_parent;
		_tmp12_ = music_column_browser_get_columns (_tmp11_);
		_tmp13_ = _tmp12_;
		_tmp14_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp13_);
		_col_it = _tmp14_;
		while (TRUE) {
			GeeIterator* _tmp15_;
			MusicBrowserColumn* col = NULL;
			GeeIterator* _tmp16_;
			gpointer _tmp17_;
			MusicBrowserColumn* _tmp18_;
			gboolean _tmp19_;
			gboolean _tmp20_;
			_tmp15_ = _col_it;
			if (!gee_iterator_next (_tmp15_)) {
				break;
			}
			_tmp16_ = _col_it;
			_tmp17_ = gee_iterator_get (_tmp16_);
			col = (MusicBrowserColumn*) _tmp17_;
			_tmp18_ = col;
			_tmp19_ = music_browser_column_get_visible (_tmp18_);
			_tmp20_ = _tmp19_;
			if (_tmp20_) {
				gint _tmp21_;
				_tmp21_ = visible_columns;
				visible_columns = _tmp21_ + 1;
			}
			_g_object_unref0 (col);
		}
		_g_object_unref0 (_col_it);
	}
	_tmp22_ = self->priv->_menu_item;
	_tmp23_ = gtk_check_menu_item_get_active (_tmp22_);
	_tmp24_ = _tmp23_;
	if (_tmp24_) {
		gint _tmp25_;
		_tmp25_ = visible_columns;
		visible_columns = _tmp25_ + 1;
	} else {
		gint _tmp26_;
		_tmp26_ = visible_columns;
		visible_columns = _tmp26_ - 1;
	}
	_tmp27_ = self->priv->_menu_item;
	_tmp28_ = gtk_check_menu_item_get_active (_tmp27_);
	_tmp29_ = _tmp28_;
	music_browser_column_set_visible (self, _tmp29_);
	{
		GeeIterator* _col_it = NULL;
		MusicColumnBrowser* _tmp30_;
		GeeTreeSet* _tmp31_;
		GeeTreeSet* _tmp32_;
		GeeIterator* _tmp33_;
		_tmp30_ = self->priv->miller_parent;
		_tmp31_ = music_column_browser_get_columns (_tmp30_);
		_tmp32_ = _tmp31_;
		_tmp33_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp32_);
		_col_it = _tmp33_;
		while (TRUE) {
			GeeIterator* _tmp34_;
			MusicBrowserColumn* col = NULL;
			GeeIterator* _tmp35_;
			gpointer _tmp36_;
			MusicBrowserColumn* _tmp37_;
			gboolean _tmp38_;
			gboolean _tmp39_;
			_tmp34_ = _col_it;
			if (!gee_iterator_next (_tmp34_)) {
				break;
			}
			_tmp35_ = _col_it;
			_tmp36_ = gee_iterator_get (_tmp35_);
			col = (MusicBrowserColumn*) _tmp36_;
			_tmp37_ = col;
			_tmp38_ = music_browser_column_get_visible (_tmp37_);
			_tmp39_ = _tmp38_;
			if (_tmp39_) {
				MusicBrowserColumn* _tmp40_;
				GtkCheckMenuItem* _tmp41_;
				_tmp40_ = col;
				_tmp41_ = _tmp40_->priv->_menu_item;
				gtk_widget_set_sensitive ((GtkWidget*) _tmp41_, visible_columns > 1);
			}
			_g_object_unref0 (col);
		}
		_g_object_unref0 (_col_it);
	}
	_tmp42_ = self->priv->_menu_item;
	g_signal_connect_object (_tmp42_, "toggled", (GCallback) _music_browser_column_on_menu_item_toggled_gtk_check_menu_item_toggled, self, 0);
	_tmp43_ = self->priv->view;
	_tmp44_ = gtk_tree_view_get_selection (_tmp43_);
	g_signal_connect_object (_tmp44_, "changed", (GCallback) _music_browser_column_selected_item_changed_gtk_tree_selection_changed, self, G_CONNECT_AFTER);
}

void
music_browser_column_add_item (MusicBrowserColumn* self,
                               const gchar* text)
{
	GtkTreeIter iter = {0};
	MusicBrowserColumnModel* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	MusicBrowserColumnModel* _tmp2_;
	GtkTreeIter _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (text != NULL);
	_tmp0_ = self->priv->model;
	music_browser_column_model_append (_tmp0_, &_tmp1_);
	iter = _tmp1_;
	_tmp2_ = self->priv->model;
	_tmp3_ = iter;
	music_browser_column_model_set (_tmp2_, &_tmp3_, 0, text, NULL);
}

static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
	g_boxed_free (gtk_tree_path_get_type (), self);
}

void
music_browser_column_select_first_item (MusicBrowserColumn* self)
{
	MusicBrowserColumnModel* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->model;
	if (_tmp0_ == NULL) {
		return;
	}
	_tmp1_ = music_browser_column_get_first_item_selected (self);
	_tmp2_ = _tmp1_;
	if (!_tmp2_) {
		music_browser_column_set_selected (self, NULL, TRUE);
	} else {
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_ = FALSE;
		MusicBrowserColumnModel* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		_tmp5_ = self->priv->model;
		_tmp6_ = music_browser_column_model_get_n_items (_tmp5_);
		_tmp7_ = _tmp6_;
		if ((_tmp7_ + 1) >= 1) {
			gboolean _tmp8_;
			gboolean _tmp9_;
			_tmp8_ = music_browser_column_get_visible (self);
			_tmp9_ = _tmp8_;
			_tmp4_ = _tmp9_;
		} else {
			_tmp4_ = FALSE;
		}
		if (_tmp4_) {
			MusicLibraryWindow* _tmp10_;
			MusicLibraryWindow* _tmp11_;
			gboolean _tmp12_;
			gboolean _tmp13_;
			_tmp10_ = music_app_get_main_window ();
			_tmp11_ = _tmp10_;
			_tmp12_ = music_library_window_get_initialization_finished (_tmp11_);
			_tmp13_ = _tmp12_;
			_tmp3_ = _tmp13_;
		} else {
			_tmp3_ = FALSE;
		}
		if (_tmp3_) {
			GtkTreeView* _tmp14_;
			GtkTreePath* _tmp15_;
			GtkTreePath* _tmp16_;
			_tmp14_ = self->priv->view;
			_tmp15_ = gtk_tree_path_new_first ();
			_tmp16_ = _tmp15_;
			gtk_tree_view_scroll_to_cell (_tmp14_, _tmp16_, NULL, FALSE, 0.0f, 0.0f);
			__vala_GtkTreePath_free0 (_tmp16_);
		}
	}
}

/**
     * Since this is used to get the selected column item, when _selected is NULL it returns ""
     * to represent "All" in LibraryManager.do_search()
     */
gchar*
music_browser_column_get_selected (MusicBrowserColumn* self)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = self->priv->_selected;
	if (_tmp1_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp2_;
		gboolean _tmp3_;
		_tmp2_ = music_browser_column_get_visible (self);
		_tmp3_ = _tmp2_;
		_tmp0_ = !_tmp3_;
	}
	if (_tmp0_) {
		gchar* _tmp4_;
		_tmp4_ = g_strdup ("");
		result = _tmp4_;
		return result;
	}
	_tmp5_ = self->priv->_selected;
	_tmp6_ = g_strdup (_tmp5_);
	result = _tmp6_;
	return result;
}

static gboolean
_music_browser_column_select_proper_string_gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                                        GtkTreePath* path,
                                                                        GtkTreeIter* iter,
                                                                        gpointer self)
{
	gboolean result;
	result = music_browser_column_select_proper_string ((MusicBrowserColumn*) self, model, path, iter);
	return result;
}

void
music_browser_column_populate (MusicBrowserColumn* self,
                               GeeHashSet* items)
{
	GtkTreeView* _tmp0_;
	GtkTreeSelection* _tmp1_;
	MusicBrowserColumnCategory _tmp2_;
	MusicBrowserColumnModel* _tmp3_;
	GtkTreeView* _tmp4_;
	MusicBrowserColumnModel* _tmp5_;
	MusicBrowserColumnModel* _tmp6_;
	GtkTreeView* _tmp7_;
	MusicBrowserColumnModel* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gboolean _tmp11_;
	MusicBrowserColumnModel* _tmp12_;
	GtkTreeView* _tmp13_;
	GtkTreeSelection* _tmp14_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (items != NULL);
	gee_abstract_collection_remove ((GeeAbstractCollection*) items, "");
	_tmp0_ = self->priv->view;
	_tmp1_ = gtk_tree_view_get_selection (_tmp0_);
	g_object_freeze_notify ((GObject*) _tmp1_);
	_tmp2_ = self->priv->_category;
	_tmp3_ = music_browser_column_model_new (_tmp2_);
	_g_object_unref0 (self->priv->model);
	self->priv->model = _tmp3_;
	_tmp4_ = self->priv->view;
	gtk_tree_view_set_model (_tmp4_, NULL);
	_tmp5_ = self->priv->model;
	music_browser_column_model_append_items (_tmp5_, (GeeCollection*) items, FALSE);
	_tmp6_ = self->priv->model;
	gtk_tree_sortable_set_sort_column_id ((GtkTreeSortable*) _tmp6_, 0, GTK_SORT_ASCENDING);
	_tmp7_ = self->priv->view;
	_tmp8_ = self->priv->model;
	gtk_tree_view_set_model (_tmp7_, (GtkTreeModel*) _tmp8_);
	_tmp9_ = music_browser_column_get_selected (self);
	_tmp10_ = _tmp9_;
	_tmp11_ = !gee_abstract_collection_contains ((GeeAbstractCollection*) items, _tmp10_);
	_g_free0 (_tmp10_);
	if (_tmp11_) {
		_g_free0 (self->priv->_selected);
		self->priv->_selected = NULL;
	}
	_tmp12_ = self->priv->model;
	gtk_tree_model_foreach ((GtkTreeModel*) _tmp12_, _music_browser_column_select_proper_string_gtk_tree_model_foreach_func, self);
	_tmp13_ = self->priv->view;
	_tmp14_ = gtk_tree_view_get_selection (_tmp13_);
	g_object_thaw_notify ((GObject*) _tmp14_);
}

static gboolean
___lambda5_ (MusicBrowserColumn* self)
{
	MusicBrowserColumnCategory _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean result;
	_tmp0_ = self->priv->_category;
	_tmp1_ = music_browser_column_get_selected (self);
	_tmp2_ = _tmp1_;
	g_signal_emit (self, music_browser_column_signals[MUSIC_BROWSER_COLUMN_SELECTION_CHANGED_SIGNAL], 0, _tmp0_, _tmp2_);
	_g_free0 (_tmp2_);
	result = FALSE;
	return result;
}

static gboolean
____lambda5__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda5_ ((MusicBrowserColumn*) self);
	return result;
}

void
music_browser_column_set_selected (MusicBrowserColumn* self,
                                   const gchar* val,
                                   gboolean notify)
{
	gboolean _tmp0_ = FALSE;
	MusicBrowserColumnModel* _tmp1_;
	gchar* _tmp8_;
	MusicBrowserColumnModel* _tmp9_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->model;
	if (_tmp1_ != NULL) {
		gboolean _tmp2_ = FALSE;
		MusicLibraryWindow* _tmp3_;
		MusicLibraryWindow* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
		_tmp3_ = music_app_get_main_window ();
		_tmp4_ = _tmp3_;
		_tmp5_ = music_library_window_get_initialization_finished (_tmp4_);
		_tmp6_ = _tmp5_;
		if (!_tmp6_) {
			_tmp2_ = TRUE;
		} else {
			const gchar* _tmp7_;
			_tmp7_ = self->priv->_selected;
			_tmp2_ = g_strcmp0 (val, _tmp7_) == 0;
		}
		_tmp0_ = _tmp2_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		return;
	}
	_tmp8_ = g_strdup (val);
	_g_free0 (self->priv->_selected);
	self->priv->_selected = _tmp8_;
	_tmp9_ = self->priv->model;
	gtk_tree_model_foreach ((GtkTreeModel*) _tmp9_, _music_browser_column_select_proper_string_gtk_tree_model_foreach_func, self);
	if (notify) {
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE - 10, ____lambda5__gsource_func, g_object_ref (self), g_object_unref);
	}
}

static gboolean
music_browser_column_on_header_clicked (MusicBrowserColumn* self,
                                        GtkWidget* w,
                                        GdkEventButton* e)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (w != NULL, FALSE);
	g_return_val_if_fail (e != NULL, FALSE);
	if (e->button == ((guint) GDK_BUTTON_PRIMARY)) {
		music_browser_column_select_first_item (self);
	}
	g_signal_emit (self, music_browser_column_signals[MUSIC_BROWSER_COLUMN_HEADER_CLICKED_SIGNAL], 0, e);
	result = TRUE;
	return result;
}

static void
music_browser_column_selected_item_changed (MusicBrowserColumn* self)
{
	GtkTreeModel* temp_model = NULL;
	GtkTreeIter iter = {0};
	gchar* text = NULL;
	GtkTreeView* _tmp0_;
	GtkTreeSelection* _tmp1_;
	GtkTreeModel* _tmp2_ = NULL;
	GtkTreeIter _tmp3_ = {0};
	gboolean _tmp4_;
	GtkTreeModel* _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->view;
	_tmp1_ = gtk_tree_view_get_selection (_tmp0_);
	_tmp4_ = gtk_tree_selection_get_selected (_tmp1_, &_tmp2_, &_tmp3_);
	_g_object_unref0 (temp_model);
	_tmp5_ = _g_object_ref0 (_tmp2_);
	temp_model = _tmp5_;
	iter = _tmp3_;
	if (_tmp4_) {
		GtkTreeIter _tmp6_;
		void* _tmp7_;
		_tmp6_ = iter;
		_tmp7_ = _tmp6_.user_data;
		if (g_sequence_iter_get_position ((GSequenceIter*) _tmp7_) == 0) {
			music_browser_column_select_first_item (self);
		} else {
			GtkTreeModel* _tmp8_;
			GtkTreeIter _tmp9_;
			gchar* _tmp10_ = NULL;
			const gchar* _tmp11_;
			_tmp8_ = temp_model;
			_tmp9_ = iter;
			gtk_tree_model_get (_tmp8_, &_tmp9_, 0, &_tmp10_, -1);
			_g_free0 (text);
			text = _tmp10_;
			_tmp11_ = text;
			music_browser_column_set_selected (self, _tmp11_, TRUE);
		}
	}
	_g_free0 (text);
	_g_object_unref0 (temp_model);
}

static void
music_browser_column_view_double_click (MusicBrowserColumn* self,
                                        GtkTreePath* path,
                                        GtkTreeViewColumn* column)
{
	GtkTreeIter iter = {0};
	MusicBrowserColumnModel* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	GtkTreeIter _tmp2_;
	void* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (path != NULL);
	g_return_if_fail (column != NULL);
	_tmp0_ = self->priv->model;
	gtk_tree_model_get_iter ((GtkTreeModel*) _tmp0_, &_tmp1_, path);
	iter = _tmp1_;
	_tmp2_ = iter;
	_tmp3_ = _tmp2_.user_data;
	if (g_sequence_iter_get_position ((GSequenceIter*) _tmp3_) == 0) {
		g_signal_emit (self, music_browser_column_signals[MUSIC_BROWSER_COLUMN_RESET_REQUESTED_SIGNAL], 0);
	} else {
		GValue text = {0};
		MusicBrowserColumnModel* _tmp4_;
		GtkTreeIter _tmp5_;
		GValue _tmp6_ = {0};
		GValue _tmp7_;
		_tmp4_ = self->priv->model;
		_tmp5_ = iter;
		gtk_tree_model_get_value ((GtkTreeModel*) _tmp4_, &_tmp5_, 0, &_tmp6_);
		G_IS_VALUE (&text) ? (g_value_unset (&text), NULL) : NULL;
		text = _tmp6_;
		_tmp7_ = text;
		g_signal_emit (self, music_browser_column_signals[MUSIC_BROWSER_COLUMN_ROW_ACTIVATED_SIGNAL], 0, g_value_get_string (&_tmp7_));
		G_IS_VALUE (&text) ? (g_value_unset (&text), NULL) : NULL;
	}
}

static gboolean
music_browser_column_select_proper_string (MusicBrowserColumn* self,
                                           GtkTreeModel* tmodel,
                                           GtkTreePath* path,
                                           GtkTreeIter* item)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gchar* s = NULL;
	GtkTreeIter _tmp8_;
	gchar* _tmp9_ = NULL;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gboolean _tmp13_;
	GtkTreeView* _tmp34_;
	GtkTreeSelection* _tmp35_;
	GtkTreeIter _tmp36_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (tmodel != NULL, FALSE);
	g_return_val_if_fail (path != NULL, FALSE);
	g_return_val_if_fail (item != NULL, FALSE);
	_tmp0_ = music_browser_column_get_first_item_selected (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		GtkTreePath* first_path = NULL;
		GtkTreePath* _tmp2_;
		GtkTreeView* _tmp3_;
		GtkTreeSelection* _tmp4_;
		GtkTreePath* _tmp5_;
		GtkTreeView* _tmp6_;
		GtkTreePath* _tmp7_;
		_tmp2_ = gtk_tree_path_new_first ();
		first_path = _tmp2_;
		_tmp3_ = self->priv->view;
		_tmp4_ = gtk_tree_view_get_selection (_tmp3_);
		_tmp5_ = first_path;
		gtk_tree_selection_select_path (_tmp4_, _tmp5_);
		_tmp6_ = self->priv->view;
		_tmp7_ = first_path;
		gtk_tree_view_scroll_to_cell (_tmp6_, _tmp7_, NULL, TRUE, 0.0f, 0.0f);
		result = TRUE;
		__vala_GtkTreePath_free0 (first_path);
		return result;
	}
	_tmp8_ = *item;
	gtk_tree_model_get (tmodel, &_tmp8_, 0, &_tmp9_, -1);
	_g_free0 (s);
	s = _tmp9_;
	_tmp10_ = s;
	_tmp11_ = music_browser_column_get_selected (self);
	_tmp12_ = _tmp11_;
	_tmp13_ = g_strcmp0 (_tmp10_, _tmp12_) == 0;
	_g_free0 (_tmp12_);
	if (_tmp13_) {
		GtkTreeView* _tmp14_;
		GtkTreeSelection* _tmp15_;
		GtkTreeIter _tmp16_;
		gboolean scroll_to_center = FALSE;
		GtkTreePath* start = NULL;
		GtkTreePath* end = NULL;
		GtkTreeView* _tmp17_;
		GtkTreePath* _tmp18_ = NULL;
		GtkTreePath* _tmp19_ = NULL;
		gboolean _tmp20_;
		GtkTreeView* _tmp33_;
		_tmp14_ = self->priv->view;
		_tmp15_ = gtk_tree_view_get_selection (_tmp14_);
		_tmp16_ = *item;
		gtk_tree_selection_select_iter (_tmp15_, &_tmp16_);
		scroll_to_center = FALSE;
		_tmp17_ = self->priv->view;
		_tmp20_ = gtk_tree_view_get_visible_range (_tmp17_, &_tmp18_, &_tmp19_);
		__vala_GtkTreePath_free0 (start);
		start = _tmp18_;
		__vala_GtkTreePath_free0 (end);
		end = _tmp19_;
		if (_tmp20_) {
			gint start_index = 0;
			GtkTreePath* _tmp21_;
			gint _tmp22_ = 0;
			gint* _tmp23_;
			gint _tmp24_;
			gint end_index = 0;
			GtkTreePath* _tmp25_;
			gint _tmp26_ = 0;
			gint* _tmp27_;
			gint _tmp28_;
			gint current_index = 0;
			gint _tmp29_ = 0;
			gint* _tmp30_;
			gint _tmp31_;
			gboolean _tmp32_ = FALSE;
			_tmp21_ = start;
			_tmp23_ = gtk_tree_path_get_indices_with_depth (_tmp21_, &_tmp22_);
			_tmp24_ = _tmp23_[0];
			start_index = _tmp24_;
			_tmp25_ = end;
			_tmp27_ = gtk_tree_path_get_indices_with_depth (_tmp25_, &_tmp26_);
			_tmp28_ = _tmp27_[0];
			end_index = _tmp28_;
			_tmp30_ = gtk_tree_path_get_indices_with_depth (path, &_tmp29_);
			_tmp31_ = _tmp30_[0];
			current_index = _tmp31_;
			if (current_index < start_index) {
				_tmp32_ = TRUE;
			} else {
				_tmp32_ = current_index > end_index;
			}
			if (_tmp32_) {
				scroll_to_center = TRUE;
			}
		}
		_tmp33_ = self->priv->view;
		gtk_tree_view_scroll_to_cell (_tmp33_, path, NULL, scroll_to_center, 0.5f, 0.0f);
		result = TRUE;
		__vala_GtkTreePath_free0 (end);
		__vala_GtkTreePath_free0 (start);
		_g_free0 (s);
		return result;
	}
	_tmp34_ = self->priv->view;
	_tmp35_ = gtk_tree_view_get_selection (_tmp34_);
	_tmp36_ = *item;
	gtk_tree_selection_unselect_iter (_tmp35_, &_tmp36_);
	result = FALSE;
	_g_free0 (s);
	return result;
}

gboolean
music_browser_column_get_visible (MusicBrowserColumn* self)
{
	gboolean result;
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = gtk_widget_get_no_show_all ((GtkWidget*) self);
	_tmp1_ = _tmp0_;
	result = !_tmp1_;
	return result;
}

void
music_browser_column_set_visible (MusicBrowserColumn* self,
                                  gboolean value)
{
	gboolean show_column = FALSE;
	GtkCheckMenuItem* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	show_column = value;
	_tmp0_ = self->priv->_menu_item;
	gtk_check_menu_item_set_active (_tmp0_, show_column);
	gtk_widget_set_no_show_all ((GtkWidget*) self, !show_column);
	if (show_column) {
		gtk_widget_show_all ((GtkWidget*) self);
	} else {
		music_browser_column_select_first_item (self);
		gtk_widget_hide ((GtkWidget*) self);
	}
	_tmp1_ = gtk_widget_get_no_show_all ((GtkWidget*) self);
	_tmp2_ = _tmp1_;
	g_signal_emit (self, music_browser_column_signals[MUSIC_BROWSER_COLUMN_VISIBILITY_CHANGED_SIGNAL], 0, !_tmp2_);
	g_object_notify_by_pspec ((GObject *) self, music_browser_column_properties[MUSIC_BROWSER_COLUMN_VISIBLE_PROPERTY]);
}

void
music_browser_column_set_show_separator (MusicBrowserColumn* self,
                                         gboolean value)
{
	gboolean _tmp0_ = FALSE;
	GtkSeparator* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->separator;
	if (_tmp1_ != NULL) {
		GtkSeparator* _tmp2_;
		GtkContainer* _tmp3_;
		GtkContainer* _tmp4_;
		_tmp2_ = self->priv->separator;
		_tmp3_ = gtk_widget_get_parent ((GtkWidget*) _tmp2_);
		_tmp4_ = _tmp3_;
		_tmp0_ = _tmp4_ == G_TYPE_CHECK_INSTANCE_CAST (self, gtk_container_get_type (), GtkContainer);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GtkSeparator* _tmp5_;
		_tmp5_ = self->priv->separator;
		gtk_container_remove ((GtkContainer*) self, (GtkWidget*) _tmp5_);
		_g_object_unref0 (self->priv->separator);
		self->priv->separator = NULL;
	}
	if (value) {
		GtkSeparator* _tmp6_;
		GtkSeparator* _tmp7_;
		GtkSeparator* _tmp8_;
		GtkSeparator* _tmp9_;
		GtkSeparator* _tmp10_;
		_tmp6_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_VERTICAL);
		g_object_ref_sink (_tmp6_);
		_g_object_unref0 (self->priv->separator);
		self->priv->separator = _tmp6_;
		_tmp7_ = self->priv->separator;
		gtk_widget_set_hexpand ((GtkWidget*) _tmp7_, FALSE);
		_tmp8_ = self->priv->separator;
		gtk_widget_set_vexpand ((GtkWidget*) _tmp8_, TRUE);
		_tmp9_ = self->priv->separator;
		gtk_widget_show ((GtkWidget*) _tmp9_);
		_tmp10_ = self->priv->separator;
		gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp10_);
	}
	g_object_notify_by_pspec ((GObject *) self, music_browser_column_properties[MUSIC_BROWSER_COLUMN_SHOW_SEPARATOR_PROPERTY]);
}

gboolean
music_browser_column_get_first_item_selected (MusicBrowserColumn* self)
{
	gboolean result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_selected;
	result = _tmp0_ == NULL;
	return result;
}

MusicBrowserColumnCategory
music_browser_column_get_category (MusicBrowserColumn* self)
{
	MusicBrowserColumnCategory result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_category;
	return result;
}

void
music_browser_column_set_category (MusicBrowserColumn* self,
                                   MusicBrowserColumnCategory value)
{
	MusicBrowserColumnCategory old_value;
	g_return_if_fail (self != NULL);
	old_value = music_browser_column_get_category (self);
	if (old_value != value) {
		self->priv->_category = value;
		g_object_notify_by_pspec ((GObject *) self, music_browser_column_properties[MUSIC_BROWSER_COLUMN_CATEGORY_PROPERTY]);
	}
}

GtkCheckMenuItem*
music_browser_column_get_menu_item (MusicBrowserColumn* self)
{
	GtkCheckMenuItem* result;
	GtkCheckMenuItem* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_menu_item;
	result = _tmp0_;
	return result;
}

void
music_browser_column_set_menu_item (MusicBrowserColumn* self,
                                    GtkCheckMenuItem* value)
{
	GtkCheckMenuItem* old_value;
	g_return_if_fail (self != NULL);
	old_value = music_browser_column_get_menu_item (self);
	if (old_value != value) {
		GtkCheckMenuItem* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_menu_item);
		self->priv->_menu_item = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_browser_column_properties[MUSIC_BROWSER_COLUMN_MENU_ITEM_PROPERTY]);
	}
}

static void
g_cclosure_user_marshal_VOID__ENUM_STRING (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__ENUM_STRING) (gpointer data1, gint arg_1, const char* arg_2, gpointer data2);
	register GMarshalFunc_VOID__ENUM_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__ENUM_STRING) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_enum (param_values + 1), g_value_get_string (param_values + 2), data2);
}

static void
music_browser_column_class_init (MusicBrowserColumnClass * klass,
                                 gpointer klass_data)
{
	music_browser_column_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicBrowserColumn_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_music_browser_column_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_music_browser_column_set_property;
	G_OBJECT_CLASS (klass)->finalize = music_browser_column_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_BROWSER_COLUMN_VISIBLE_PROPERTY, music_browser_column_properties[MUSIC_BROWSER_COLUMN_VISIBLE_PROPERTY] = g_param_spec_boolean ("visible", "visible", "visible", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_BROWSER_COLUMN_SHOW_SEPARATOR_PROPERTY, music_browser_column_properties[MUSIC_BROWSER_COLUMN_SHOW_SEPARATOR_PROPERTY] = g_param_spec_boolean ("show-separator", "show-separator", "show-separator", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_BROWSER_COLUMN_FIRST_ITEM_SELECTED_PROPERTY, music_browser_column_properties[MUSIC_BROWSER_COLUMN_FIRST_ITEM_SELECTED_PROPERTY] = g_param_spec_boolean ("first-item-selected", "first-item-selected", "first-item-selected", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_BROWSER_COLUMN_CATEGORY_PROPERTY, music_browser_column_properties[MUSIC_BROWSER_COLUMN_CATEGORY_PROPERTY] = g_param_spec_enum ("category", "category", "category", MUSIC_BROWSER_COLUMN_TYPE_CATEGORY, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_BROWSER_COLUMN_MENU_ITEM_PROPERTY, music_browser_column_properties[MUSIC_BROWSER_COLUMN_MENU_ITEM_PROPERTY] = g_param_spec_object ("menu-item", "menu-item", "menu-item", gtk_check_menu_item_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	music_browser_column_signals[MUSIC_BROWSER_COLUMN_SELECTION_CHANGED_SIGNAL] = g_signal_new ("selection-changed", MUSIC_TYPE_BROWSER_COLUMN, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__ENUM_STRING, G_TYPE_NONE, 2, MUSIC_BROWSER_COLUMN_TYPE_CATEGORY, G_TYPE_STRING);
	music_browser_column_signals[MUSIC_BROWSER_COLUMN_ROW_ACTIVATED_SIGNAL] = g_signal_new ("row-activated", MUSIC_TYPE_BROWSER_COLUMN, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
	music_browser_column_signals[MUSIC_BROWSER_COLUMN_RESET_REQUESTED_SIGNAL] = g_signal_new ("reset-requested", MUSIC_TYPE_BROWSER_COLUMN, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	music_browser_column_signals[MUSIC_BROWSER_COLUMN_HEADER_CLICKED_SIGNAL] = g_signal_new ("header-clicked", MUSIC_TYPE_BROWSER_COLUMN, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOXED, G_TYPE_NONE, 1, gdk_event_get_type ());
	music_browser_column_signals[MUSIC_BROWSER_COLUMN_VISIBILITY_CHANGED_SIGNAL] = g_signal_new ("visibility-changed", MUSIC_TYPE_BROWSER_COLUMN, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
}

static void
music_browser_column_instance_init (MusicBrowserColumn * self,
                                    gpointer klass)
{
	self->priv = music_browser_column_get_instance_private (self);
}

static void
music_browser_column_finalize (GObject * obj)
{
	MusicBrowserColumn * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_BROWSER_COLUMN, MusicBrowserColumn);
	_g_object_unref0 (self->priv->separator);
	_g_object_unref0 (self->priv->_menu_item);
	_g_object_unref0 (self->priv->miller_parent);
	_g_object_unref0 (self->priv->view);
	_g_object_unref0 (self->priv->model);
	_g_free0 (self->priv->_selected);
	G_OBJECT_CLASS (music_browser_column_parent_class)->finalize (obj);
}

static GType
music_browser_column_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicBrowserColumnClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_browser_column_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicBrowserColumn), 0, (GInstanceInitFunc) music_browser_column_instance_init, NULL };
	GType music_browser_column_type_id;
	music_browser_column_type_id = g_type_register_static (gtk_grid_get_type (), "MusicBrowserColumn", &g_define_type_info, 0);
	MusicBrowserColumn_private_offset = g_type_add_instance_private (music_browser_column_type_id, sizeof (MusicBrowserColumnPrivate));
	return music_browser_column_type_id;
}

GType
music_browser_column_get_type (void)
{
	static volatile gsize music_browser_column_type_id__once = 0;
	if (g_once_init_enter (&music_browser_column_type_id__once)) {
		GType music_browser_column_type_id;
		music_browser_column_type_id = music_browser_column_get_type_once ();
		g_once_init_leave (&music_browser_column_type_id__once, music_browser_column_type_id);
	}
	return music_browser_column_type_id__once;
}

static void
_vala_music_browser_column_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	MusicBrowserColumn * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_BROWSER_COLUMN, MusicBrowserColumn);
	switch (property_id) {
		case MUSIC_BROWSER_COLUMN_VISIBLE_PROPERTY:
		g_value_set_boolean (value, music_browser_column_get_visible (self));
		break;
		case MUSIC_BROWSER_COLUMN_FIRST_ITEM_SELECTED_PROPERTY:
		g_value_set_boolean (value, music_browser_column_get_first_item_selected (self));
		break;
		case MUSIC_BROWSER_COLUMN_CATEGORY_PROPERTY:
		g_value_set_enum (value, music_browser_column_get_category (self));
		break;
		case MUSIC_BROWSER_COLUMN_MENU_ITEM_PROPERTY:
		g_value_set_object (value, music_browser_column_get_menu_item (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_music_browser_column_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	MusicBrowserColumn * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_BROWSER_COLUMN, MusicBrowserColumn);
	switch (property_id) {
		case MUSIC_BROWSER_COLUMN_VISIBLE_PROPERTY:
		music_browser_column_set_visible (self, g_value_get_boolean (value));
		break;
		case MUSIC_BROWSER_COLUMN_SHOW_SEPARATOR_PROPERTY:
		music_browser_column_set_show_separator (self, g_value_get_boolean (value));
		break;
		case MUSIC_BROWSER_COLUMN_CATEGORY_PROPERTY:
		music_browser_column_set_category (self, g_value_get_enum (value));
		break;
		case MUSIC_BROWSER_COLUMN_MENU_ITEM_PROPERTY:
		music_browser_column_set_menu_item (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

