/* TreeViewSetup.c generated by valac 0.56.1, the Vala compiler
 * generated from TreeViewSetup.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>,
 *              Victor Eduardo <victoreduardm@gmail.com>
 */

#include "music-lib.h"
#include <gtk/gtk.h>
#include <libgda/libgda.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>

#define MUSIC_TREE_VIEW_SETUP_ASCENDING_STRING "ASCENDING"
#define MUSIC_TREE_VIEW_SETUP_DESCENDING_STRING "DESCENDING"
#define MUSIC_TREE_VIEW_SETUP_COLUMN_SEP_STRING "<c_sep>"
#define MUSIC_TREE_VIEW_SETUP_VALUE_SEP_STRING "<v_sep>"
#define MUSIC_TREE_VIEW_SETUP_TYPE_DATA_KEY "setup-list-column-type"

enum  {
	MUSIC_TREE_VIEW_SETUP_0_PROPERTY,
	MUSIC_TREE_VIEW_SETUP_SORT_COLUMN_ID_PROPERTY,
	MUSIC_TREE_VIEW_SETUP_SORT_DIRECTION_PROPERTY,
	MUSIC_TREE_VIEW_SETUP_HINT_PROPERTY,
	MUSIC_TREE_VIEW_SETUP_CONNECTION_PROPERTY,
	MUSIC_TREE_VIEW_SETUP_UID_PROPERTY,
	MUSIC_TREE_VIEW_SETUP_NUM_PROPERTIES
};
static GParamSpec* music_tree_view_setup_properties[MUSIC_TREE_VIEW_SETUP_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef struct _Block26Data Block26Data;
#define __vala_GValue_free0(var) ((var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _MusicTreeViewSetupPrivate {
	MusicListColumn _sort_column_id;
	GtkSortType _sort_direction;
	MusicViewWrapperHint _hint;
	GdaConnection* _connection;
	gchar* _uid;
	GeeLinkedList* columns;
};

struct _Block26Data {
	int _ref_count_;
	MusicTreeViewSetup* self;
	GtkTreeViewColumn* column;
};

static gint MusicTreeViewSetup_private_offset;
static gpointer music_tree_view_setup_parent_class = NULL;

static void music_tree_view_setup_create_default_columns (MusicTreeViewSetup* self);
static void music_tree_view_setup_set_columns (MusicTreeViewSetup* self,
                                        GeeCollection* cols);
static gboolean music_tree_view_setup_import_columns (MusicTreeViewSetup* self,
                                               const gchar* cols);
static gint music_tree_view_setup_column_compare_func (MusicTreeViewSetup* self,
                                                GtkTreeViewColumn* column_a,
                                                GtkTreeViewColumn* column_b);
static gint _music_tree_view_setup_column_compare_func_gcompare_data_func (gconstpointer a,
                                                                    gconstpointer b,
                                                                    gpointer self);
static GtkTreeViewColumn* music_tree_view_setup_create_column (MusicTreeViewSetup* self,
                                                        MusicListColumn type,
                                                        gboolean visible);
static gchar* music_tree_view_setup_columns_to_string (MusicTreeViewSetup* self);
static Block26Data* block26_data_ref (Block26Data* _data26_);
static void block26_data_unref (void * _userdata_);
static void music_tree_view_setup_set_column_type (GtkTreeViewColumn* column,
                                            MusicListColumn type);
static void __lambda6_ (MusicTreeViewSetup* self);
static void music_tree_view_setup_set_field (MusicTreeViewSetup* self,
                                      const gchar* field,
                                      GValue* value);
static void ___lambda6__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static void __lambda7_ (Block26Data* _data26_);
static void ___lambda7__gtk_tree_view_column_clicked (GtkTreeViewColumn* _sender,
                                               gpointer self);
static MusicListColumn* _music_list_column_dup (MusicListColumn* self);
static void music_tree_view_setup_append_new_column (MusicTreeViewSetup* self,
                                              MusicListColumn column,
                                              gboolean initially_visible);
static gboolean music_tree_view_setup_exists (MusicTreeViewSetup* self);
static void _vala_GValue_free (GValue* self);
static GValue* music_tree_view_setup_query_field (MusicTreeViewSetup* self,
                                           const gchar* field);
static GValue* _g_value_dup (GValue* self);
static void __vala_GValue_free0_ (gpointer var);
static inline void _g_slist_free___vala_GValue_free0_ (GSList* self);
static void _g_free0_ (gpointer var);
static inline void _g_slist_free__g_free0_ (GSList* self);
static GObject * music_tree_view_setup_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties);
static void _music_tree_view_setup____lambda8_ (MusicTreeViewSetup* self);
static void __music_tree_view_setup____lambda8__g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void _music_tree_view_setup____lambda9_ (MusicTreeViewSetup* self);
static void __music_tree_view_setup____lambda9__g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void music_tree_view_setup_finalize (GObject * obj);
static GType music_tree_view_setup_get_type_once (void);
static void _vala_music_tree_view_setup_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_music_tree_view_setup_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
music_tree_view_setup_get_instance_private (MusicTreeViewSetup* self)
{
	return G_STRUCT_MEMBER_P (self, MusicTreeViewSetup_private_offset);
}

MusicTreeViewSetup*
music_tree_view_setup_construct (GType object_type,
                                 MusicViewWrapperHint hint,
                                 const gchar* uid,
                                 GdaConnection* connection)
{
	MusicTreeViewSetup * self = NULL;
	self = (MusicTreeViewSetup*) g_object_new (object_type, "connection", connection, "hint", hint, "uid", uid, NULL);
	return self;
}

MusicTreeViewSetup*
music_tree_view_setup_new (MusicViewWrapperHint hint,
                           const gchar* uid,
                           GdaConnection* connection)
{
	return music_tree_view_setup_construct (MUSIC_TYPE_TREE_VIEW_SETUP, hint, uid, connection);
}

GeeCollection*
music_tree_view_setup_get_columns (MusicTreeViewSetup* self)
{
	gboolean _tmp0_ = FALSE;
	GeeLinkedList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	GeeLinkedList* _tmp9_;
	GeeBidirList* _tmp10_;
	GeeBidirList* _tmp11_;
	GeeCollection* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = self->priv->columns;
	_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_ < 1) {
		_tmp0_ = TRUE;
	} else {
		GeeLinkedList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		_tmp4_ = self->priv->columns;
		_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
		_tmp6_ = _tmp5_;
		_tmp0_ = _tmp6_ != ((gint) MUSIC_LIST_COLUMN_N_COLUMNS);
	}
	if (_tmp0_) {
		MusicViewWrapperHint _tmp7_;
		GEnumValue* _tmp8_;
		_tmp7_ = self->priv->_hint;
		_tmp8_ = g_enum_get_value (g_type_class_ref (MUSIC_VIEW_WRAPPER_TYPE_HINT), _tmp7_);
		g_debug ("TreeViewSetup.vala:101: Creating a new TreeViewSetup for %s", (_tmp8_ != NULL) ? _tmp8_->value_name : NULL);
		music_tree_view_setup_create_default_columns (self);
	}
	_tmp9_ = self->priv->columns;
	_tmp10_ = gee_abstract_bidir_list_get_read_only_view ((GeeAbstractBidirList*) _tmp9_);
	_tmp11_ = _tmp10_;
	result = (GeeCollection*) _tmp11_;
	return result;
}

/**
     * Sets the list of columns that will be stored by the treeview setup.
     *
     * Each column must have been created using create_column(), or bad things
     * will happen. E.g. columns_to_string() will not work.
     */
static void
music_tree_view_setup_set_columns (MusicTreeViewSetup* self,
                                   GeeCollection* cols)
{
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (cols != NULL);
	_tmp0_ = self->priv->columns;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
	_tmp1_ = self->priv->columns;
	gee_collection_add_all ((GeeCollection*) _tmp1_, cols);
}

/**
     * Transforms the string representation of the columns into a real list of
     * treeview columns. This overwrites the previous list of columns.
     *
     * It the string cannot be parsed, //false// is returned and the previous
     * list of columns remains unmodified.
     *
     * @param cols string representation of columns created by columns_to_string().
     * @return Whether the string was succesfully parsed and imported.
     */
static gint
_music_tree_view_setup_column_compare_func_gcompare_data_func (gconstpointer a,
                                                               gconstpointer b,
                                                               gpointer self)
{
	gint result;
	result = music_tree_view_setup_column_compare_func ((MusicTreeViewSetup*) self, (GtkTreeViewColumn*) a, (GtkTreeViewColumn*) b);
	return result;
}

static gboolean
music_tree_view_setup_import_columns (MusicTreeViewSetup* self,
                                      const gchar* cols)
{
	gchar** col_strings = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint col_strings_length1;
	gint _col_strings_size_;
	GeeTreeSet* new_columns = NULL;
	GeeTreeSet* _tmp2_;
	GeeTreeSet* _tmp18_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (cols != NULL, FALSE);
	_tmp1_ = _tmp0_ = g_strsplit (cols, MUSIC_TREE_VIEW_SETUP_COLUMN_SEP_STRING, 0);
	col_strings = _tmp1_;
	col_strings_length1 = _vala_array_length (_tmp0_);
	_col_strings_size_ = col_strings_length1;
	_tmp2_ = gee_tree_set_new (gtk_tree_view_column_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _music_tree_view_setup_column_compare_func_gcompare_data_func, g_object_ref (self), g_object_unref);
	new_columns = _tmp2_;
	{
		gint index = 0;
		index = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gchar** _tmp5_;
				gint _tmp5__length1;
				gchar** pieces_of_column = NULL;
				gchar** _tmp6_;
				gint _tmp6__length1;
				const gchar* _tmp7_;
				gchar** _tmp8_;
				gchar** _tmp9_;
				gint pieces_of_column_length1;
				gint _pieces_of_column_size_;
				MusicListColumn type = 0;
				gchar** _tmp10_;
				gint _tmp10__length1;
				const gchar* _tmp11_;
				gint visible_val = 0;
				gchar** _tmp12_;
				gint _tmp12__length1;
				const gchar* _tmp13_;
				gboolean _tmp14_ = FALSE;
				GeeTreeSet* _tmp15_;
				GtkTreeViewColumn* _tmp16_;
				GtkTreeViewColumn* _tmp17_;
				if (!_tmp3_) {
					gint _tmp4_;
					index = index + 1;
					_tmp4_ = index;
				}
				_tmp3_ = FALSE;
				_tmp5_ = col_strings;
				_tmp5__length1 = col_strings_length1;
				if (!(index < (_tmp5__length1 - 1))) {
					break;
				}
				_tmp6_ = col_strings;
				_tmp6__length1 = col_strings_length1;
				_tmp7_ = _tmp6_[index];
				_tmp9_ = _tmp8_ = g_strsplit (_tmp7_, MUSIC_TREE_VIEW_SETUP_VALUE_SEP_STRING, 0);
				pieces_of_column = _tmp9_;
				pieces_of_column_length1 = _vala_array_length (_tmp8_);
				_pieces_of_column_size_ = pieces_of_column_length1;
				_tmp10_ = pieces_of_column;
				_tmp10__length1 = pieces_of_column_length1;
				_tmp11_ = _tmp10_[0];
				type = (MusicListColumn) atoi (_tmp11_);
				_tmp12_ = pieces_of_column;
				_tmp12__length1 = pieces_of_column_length1;
				_tmp13_ = _tmp12_[1];
				visible_val = atoi (_tmp13_);
				if (visible_val != 1) {
					_tmp14_ = visible_val != 0;
				} else {
					_tmp14_ = FALSE;
				}
				if (_tmp14_) {
					result = FALSE;
					pieces_of_column = (_vala_array_free (pieces_of_column, pieces_of_column_length1, (GDestroyNotify) g_free), NULL);
					_g_object_unref0 (new_columns);
					col_strings = (_vala_array_free (col_strings, col_strings_length1, (GDestroyNotify) g_free), NULL);
					return result;
				}
				_tmp15_ = new_columns;
				_tmp16_ = music_tree_view_setup_create_column (self, type, visible_val == 1);
				_tmp17_ = _tmp16_;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, _tmp17_);
				_g_object_unref0 (_tmp17_);
				pieces_of_column = (_vala_array_free (pieces_of_column, pieces_of_column_length1, (GDestroyNotify) g_free), NULL);
			}
		}
	}
	_tmp18_ = new_columns;
	music_tree_view_setup_set_columns (self, (GeeCollection*) _tmp18_);
	result = TRUE;
	_g_object_unref0 (new_columns);
	col_strings = (_vala_array_free (col_strings, col_strings_length1, (GDestroyNotify) g_free), NULL);
	return result;
}

static gchar*
music_tree_view_setup_columns_to_string (MusicTreeViewSetup* self)
{
	GString* columns_string = NULL;
	GString* _tmp0_;
	GeeCollection* columns = NULL;
	GeeCollection* _tmp1_;
	GString* _tmp21_;
	const gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_string_new ("");
	columns_string = _tmp0_;
	_tmp1_ = music_tree_view_setup_get_columns (self);
	columns = _tmp1_;
	{
		GeeIterator* _tvc_it = NULL;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
		_tmp2_ = columns;
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
		_tvc_it = _tmp3_;
		while (TRUE) {
			GeeIterator* _tmp4_;
			GtkTreeViewColumn* tvc = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			gint type = 0;
			GtkTreeViewColumn* _tmp7_;
			MusicListColumn* _tmp8_;
			MusicListColumn* _tmp9_;
			gint _tmp10_;
			GString* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			GString* _tmp14_;
			const gchar* _tmp15_ = NULL;
			GtkTreeViewColumn* _tmp16_;
			gboolean _tmp17_;
			gboolean _tmp18_;
			GString* _tmp19_;
			GString* _tmp20_;
			_tmp4_ = _tvc_it;
			if (!gee_iterator_next (_tmp4_)) {
				break;
			}
			_tmp5_ = _tvc_it;
			_tmp6_ = gee_iterator_get (_tmp5_);
			tvc = (GtkTreeViewColumn*) _tmp6_;
			_tmp7_ = tvc;
			_tmp8_ = music_tree_view_setup_get_column_type (_tmp7_);
			_tmp9_ = _tmp8_;
			_tmp10_ = *_tmp9_;
			_g_free0 (_tmp9_);
			type = _tmp10_;
			_tmp11_ = columns_string;
			_tmp12_ = g_strdup_printf ("%i", type);
			_tmp13_ = _tmp12_;
			g_string_append (_tmp11_, _tmp13_);
			_g_free0 (_tmp13_);
			_tmp14_ = columns_string;
			g_string_append (_tmp14_, MUSIC_TREE_VIEW_SETUP_VALUE_SEP_STRING);
			_tmp16_ = tvc;
			_tmp17_ = gtk_tree_view_column_get_visible (_tmp16_);
			_tmp18_ = _tmp17_;
			if (_tmp18_) {
				_tmp15_ = "1";
			} else {
				_tmp15_ = "0";
			}
			_tmp19_ = columns_string;
			g_string_append (_tmp19_, _tmp15_);
			_tmp20_ = columns_string;
			g_string_append (_tmp20_, MUSIC_TREE_VIEW_SETUP_COLUMN_SEP_STRING);
			_g_object_unref0 (tvc);
		}
		_g_object_unref0 (_tvc_it);
	}
	_tmp21_ = columns_string;
	_tmp22_ = _tmp21_->str;
	_tmp23_ = g_strdup (_tmp22_);
	result = _tmp23_;
	_g_object_unref0 (columns);
	_g_string_free0 (columns_string);
	return result;
}

/**
     * Creates a new treeview column for use in the views and treeview setups.
     *
     * Every column that goes into a list *must* be created by this method. Otherwise,
     * columns_to_string() won't work and bad things could happen.
     */
static Block26Data*
block26_data_ref (Block26Data* _data26_)
{
	g_atomic_int_inc (&_data26_->_ref_count_);
	return _data26_;
}

static void
block26_data_unref (void * _userdata_)
{
	Block26Data* _data26_;
	_data26_ = (Block26Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data26_->_ref_count_)) {
		MusicTreeViewSetup* self;
		self = _data26_->self;
		_g_object_unref0 (_data26_->column);
		_g_object_unref0 (self);
		g_slice_free (Block26Data, _data26_);
	}
}

static void
__lambda6_ (MusicTreeViewSetup* self)
{
	gchar* _tmp0_;
	GValue _tmp1_ = {0};
	_tmp0_ = music_tree_view_setup_columns_to_string (self);
	g_value_init (&_tmp1_, G_TYPE_STRING);
	g_value_take_string (&_tmp1_, _tmp0_);
	music_tree_view_setup_set_field (self, "columns", &_tmp1_);
	G_IS_VALUE (&_tmp1_) ? (g_value_unset (&_tmp1_), NULL) : NULL;
}

static void
___lambda6__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
	__lambda6_ ((MusicTreeViewSetup*) self);
}

static void
__lambda7_ (Block26Data* _data26_)
{
	MusicTreeViewSetup* self;
	GtkTreeViewColumn* _tmp0_;
	GtkTreeViewColumn* _tmp1_;
	MusicListColumn* _tmp2_;
	MusicListColumn* _tmp3_;
	self = _data26_->self;
	_tmp0_ = _data26_->column;
	music_tree_view_setup_set_sort_direction (self, gtk_tree_view_column_get_sort_order (_tmp0_));
	_tmp1_ = _data26_->column;
	_tmp2_ = music_tree_view_setup_get_column_type (_tmp1_);
	_tmp3_ = _tmp2_;
	music_tree_view_setup_set_sort_column_id (self, *_tmp3_);
	_g_free0 (_tmp3_);
}

static void
___lambda7__gtk_tree_view_column_clicked (GtkTreeViewColumn* _sender,
                                          gpointer self)
{
	__lambda7_ (self);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static GtkTreeViewColumn*
music_tree_view_setup_create_column (MusicTreeViewSetup* self,
                                     MusicListColumn type,
                                     gboolean visible)
{
	Block26Data* _data26_;
	GtkTreeViewColumn* _tmp0_;
	GtkTreeViewColumn* _tmp1_;
	GtkTreeViewColumn* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GtkTreeViewColumn* _tmp5_;
	MusicListColumn _tmp6_;
	GtkTreeViewColumn* _tmp9_;
	GtkTreeViewColumn* _tmp10_;
	GtkTreeViewColumn* _tmp11_;
	GtkTreeViewColumn* _tmp12_;
	GtkTreeViewColumn* result;
	g_return_val_if_fail (self != NULL, NULL);
	_data26_ = g_slice_new0 (Block26Data);
	_data26_->_ref_count_ = 1;
	_data26_->self = g_object_ref (self);
	_tmp0_ = gtk_tree_view_column_new ();
	g_object_ref_sink (_tmp0_);
	_data26_->column = _tmp0_;
	_tmp1_ = _data26_->column;
	music_tree_view_setup_set_column_type (_tmp1_, type);
	_tmp2_ = _data26_->column;
	_tmp3_ = music_list_column_to_string (type);
	_tmp4_ = _tmp3_;
	gtk_tree_view_column_set_title (_tmp2_, _tmp4_);
	_g_free0 (_tmp4_);
	_tmp5_ = _data26_->column;
	gtk_tree_view_column_set_visible (_tmp5_, visible);
	_tmp6_ = self->priv->_sort_column_id;
	if (type == _tmp6_) {
		GtkTreeViewColumn* _tmp7_;
		GtkSortType _tmp8_;
		_tmp7_ = _data26_->column;
		_tmp8_ = self->priv->_sort_direction;
		gtk_tree_view_column_set_sort_order (_tmp7_, _tmp8_);
	}
	_tmp9_ = _data26_->column;
	g_signal_connect_object ((GObject*) _tmp9_, "notify::visible", (GCallback) ___lambda6__g_object_notify, self, 0);
	_tmp10_ = _data26_->column;
	g_signal_connect_data (_tmp10_, "clicked", (GCallback) ___lambda7__gtk_tree_view_column_clicked, block26_data_ref (_data26_), (GClosureNotify) block26_data_unref, 0);
	_tmp11_ = _data26_->column;
	_tmp12_ = _g_object_ref0 (_tmp11_);
	result = _tmp12_;
	block26_data_unref (_data26_);
	_data26_ = NULL;
	return result;
}

static MusicListColumn*
_music_list_column_dup (MusicListColumn* self)
{
	MusicListColumn* dup;
	dup = g_new0 (MusicListColumn, 1);
	memcpy (dup, self, sizeof (MusicListColumn));
	return dup;
}

static gpointer
__music_list_column_dup0 (gpointer self)
{
	return self ? _music_list_column_dup (self) : NULL;
}

MusicListColumn*
music_tree_view_setup_get_column_type (GtkTreeViewColumn* column)
{
	gint type = 0;
	gconstpointer _tmp0_;
	MusicListColumn _tmp3_;
	MusicListColumn* _tmp4_;
	MusicListColumn* result;
	g_return_val_if_fail (column != NULL, NULL);
	_tmp0_ = g_object_get_data ((GObject*) column, MUSIC_TREE_VIEW_SETUP_TYPE_DATA_KEY);
	type = (gint) ((gintptr) _tmp0_);
	if (type < 0) {
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		_tmp1_ = gtk_tree_view_column_get_title (column);
		_tmp2_ = _tmp1_;
		g_critical ("TreeViewSetup.vala:204: get_column_type: Column '%s' has no associated" \
" type.", _tmp2_);
		g_return_val_if_reached (NULL);
	}
	_tmp3_ = (MusicListColumn) type;
	_tmp4_ = __music_list_column_dup0 (&_tmp3_);
	result = _tmp4_;
	return result;
}

static void
music_tree_view_setup_set_column_type (GtkTreeViewColumn* column,
                                       MusicListColumn type)
{
	g_return_if_fail (column != NULL);
	g_object_set_data_full ((GObject*) column, MUSIC_TREE_VIEW_SETUP_TYPE_DATA_KEY, (gpointer) ((gintptr) type), NULL);
}

static void
music_tree_view_setup_create_default_columns (MusicTreeViewSetup* self)
{
	GeeLinkedList* _tmp0_;
	MusicViewWrapperHint _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->columns;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
	_tmp1_ = self->priv->_hint;
	switch (_tmp1_) {
		case MUSIC_VIEW_WRAPPER_HINT_ALBUM_LIST:
		{
			music_tree_view_setup_append_new_column (self, MUSIC_LIST_COLUMN_ICON, TRUE);
			music_tree_view_setup_append_new_column (self, MUSIC_LIST_COLUMN_TITLE, TRUE);
			music_tree_view_setup_append_new_column (self, MUSIC_LIST_COLUMN_LENGTH, TRUE);
			break;
		}
		case MUSIC_VIEW_WRAPPER_HINT_CDROM:
		{
			music_tree_view_setup_append_new_column (self, MUSIC_LIST_COLUMN_ICON, TRUE);
			music_tree_view_setup_append_new_column (self, MUSIC_LIST_COLUMN_NUMBER, FALSE);
			music_tree_view_setup_append_new_column (self, MUSIC_LIST_COLUMN_TRACK, TRUE);
			music_tree_view_setup_append_new_column (self, MUSIC_LIST_COLUMN_TITLE, TRUE);
			music_tree_view_setup_append_new_column (self, MUSIC_LIST_COLUMN_LENGTH, TRUE);
			music_tree_view_setup_append_new_column (self, MUSIC_LIST_COLUMN_ARTIST, FALSE);
			music_tree_view_setup_append_new_column (self, MUSIC_LIST_COLUMN_ALBUM, FALSE);
			music_tree_view_setup_append_new_column (self, MUSIC_LIST_COLUMN_GENRE, FALSE);
			break;
		}
		default:
		{
			gboolean _tmp2_ = FALSE;
			MusicViewWrapperHint _tmp3_;
			gboolean num_column_visible = FALSE;
			music_tree_view_setup_append_new_column (self, MUSIC_LIST_COLUMN_ICON, TRUE);
			_tmp3_ = self->priv->_hint;
			if (_tmp3_ == MUSIC_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST) {
				_tmp2_ = TRUE;
			} else {
				MusicViewWrapperHint _tmp4_;
				_tmp4_ = self->priv->_hint;
				_tmp2_ = _tmp4_ == MUSIC_VIEW_WRAPPER_HINT_PLAYLIST;
			}
			num_column_visible = _tmp2_;
			music_tree_view_setup_append_new_column (self, MUSIC_LIST_COLUMN_NUMBER, num_column_visible);
			music_tree_view_setup_append_new_column (self, MUSIC_LIST_COLUMN_TRACK, FALSE);
			music_tree_view_setup_append_new_column (self, MUSIC_LIST_COLUMN_TITLE, TRUE);
			music_tree_view_setup_append_new_column (self, MUSIC_LIST_COLUMN_LENGTH, TRUE);
			music_tree_view_setup_append_new_column (self, MUSIC_LIST_COLUMN_ARTIST, TRUE);
			music_tree_view_setup_append_new_column (self, MUSIC_LIST_COLUMN_ALBUM, TRUE);
			music_tree_view_setup_append_new_column (self, MUSIC_LIST_COLUMN_ALBUM_ARTIST, FALSE);
			music_tree_view_setup_append_new_column (self, MUSIC_LIST_COLUMN_COMPOSER, FALSE);
			music_tree_view_setup_append_new_column (self, MUSIC_LIST_COLUMN_GENRE, TRUE);
			music_tree_view_setup_append_new_column (self, MUSIC_LIST_COLUMN_YEAR, FALSE);
			music_tree_view_setup_append_new_column (self, MUSIC_LIST_COLUMN_GROUPING, FALSE);
			music_tree_view_setup_append_new_column (self, MUSIC_LIST_COLUMN_BITRATE, FALSE);
			music_tree_view_setup_append_new_column (self, MUSIC_LIST_COLUMN_RATING, FALSE);
			music_tree_view_setup_append_new_column (self, MUSIC_LIST_COLUMN_PLAY_COUNT, FALSE);
			music_tree_view_setup_append_new_column (self, MUSIC_LIST_COLUMN_SKIP_COUNT, FALSE);
			music_tree_view_setup_append_new_column (self, MUSIC_LIST_COLUMN_DATE_ADDED, FALSE);
			music_tree_view_setup_append_new_column (self, MUSIC_LIST_COLUMN_LAST_PLAYED, FALSE);
			music_tree_view_setup_append_new_column (self, MUSIC_LIST_COLUMN_BPM, FALSE);
			music_tree_view_setup_append_new_column (self, MUSIC_LIST_COLUMN_FILE_LOCATION, FALSE);
			music_tree_view_setup_append_new_column (self, MUSIC_LIST_COLUMN_FILE_SIZE, FALSE);
			break;
		}
	}
}

static void
music_tree_view_setup_append_new_column (MusicTreeViewSetup* self,
                                         MusicListColumn column,
                                         gboolean initially_visible)
{
	GeeLinkedList* _tmp0_;
	GtkTreeViewColumn* _tmp1_;
	GtkTreeViewColumn* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->columns;
	_tmp1_ = music_tree_view_setup_create_column (self, column, initially_visible);
	_tmp2_ = _tmp1_;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, _tmp2_);
	_g_object_unref0 (_tmp2_);
}

static gint
music_tree_view_setup_column_compare_func (MusicTreeViewSetup* self,
                                           GtkTreeViewColumn* column_a,
                                           GtkTreeViewColumn* column_b)
{
	gint a = 0;
	MusicListColumn* _tmp0_;
	gint _tmp1_;
	gint b = 0;
	MusicListColumn* _tmp2_;
	gint _tmp3_;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (column_a != NULL, 0);
	g_return_val_if_fail (column_b != NULL, 0);
	_tmp0_ = music_tree_view_setup_get_column_type (column_a);
	_tmp1_ = (gint) (*_tmp0_);
	_g_free0 (_tmp0_);
	a = _tmp1_;
	_tmp2_ = music_tree_view_setup_get_column_type (column_b);
	_tmp3_ = (gint) (*_tmp2_);
	_g_free0 (_tmp2_);
	b = _tmp3_;
	result = ((gint) (a > b)) - ((gint) (a < b));
	return result;
}

static void
_vala_GValue_free (GValue* self)
{
	g_boxed_free (G_TYPE_VALUE, self);
}

static gboolean
music_tree_view_setup_exists (MusicTreeViewSetup* self)
{
	gboolean _tmp20_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	{
		GdaSqlBuilder* sql = NULL;
		GdaSqlBuilder* _tmp0_;
		GdaSqlBuilder* _tmp1_;
		GdaSqlBuilder* _tmp2_;
		GdaSqlBuilder* _tmp3_;
		GdaSqlBuilderId id_field = 0U;
		GdaSqlBuilder* _tmp4_;
		GdaSqlBuilderId id_param = 0U;
		GdaSqlBuilder* _tmp5_;
		const gchar* _tmp6_;
		GValue* _tmp7_ = NULL;
		GdaSqlBuilderId _tmp8_;
		GdaSqlBuilderId id_cond = 0U;
		GdaSqlBuilder* _tmp9_;
		GdaSqlBuilder* _tmp10_;
		GdaStatement* _tmp11_ = NULL;
		GdaSqlBuilder* _tmp12_;
		GdaStatement* _tmp13_;
		GdaDataModel* data_model = NULL;
		GdaConnection* _tmp14_;
		GdaDataModel* _tmp15_;
		GValue* _tmp16_ = NULL;
		GdaDataModel* _tmp17_;
		GdaDataModel* _tmp18_;
		_tmp0_ = gda_sql_builder_new (GDA_SQL_STATEMENT_SELECT);
		sql = _tmp0_;
		_tmp1_ = sql;
		gda_sql_builder_select_add_target (_tmp1_, MUSIC_DATABASE_COLUMNS_TABLE_NAME, NULL);
		_tmp2_ = sql;
		_tmp3_ = sql;
		gda_sql_builder_add_field_value_id (_tmp2_, gda_sql_builder_add_id (_tmp3_, "*"), (GdaSqlBuilderId) 0);
		_tmp4_ = sql;
		id_field = gda_sql_builder_add_id (_tmp4_, "unique_id");
		_tmp5_ = sql;
		_tmp6_ = self->priv->_uid;
		_tmp7_ = g_new0 (GValue, 1);
		g_value_init (_tmp7_, G_TYPE_STRING);
		g_value_set_string (_tmp7_, _tmp6_);
		_tmp8_ = gda_sql_builder_add_expr_value (_tmp5_, NULL, _tmp7_);
		__vala_GValue_free0 (_tmp7_);
		id_param = _tmp8_;
		_tmp9_ = sql;
		id_cond = gda_sql_builder_add_cond (_tmp9_, GDA_SQL_OPERATOR_TYPE_EQ, id_field, id_param, (GdaSqlBuilderId) 0);
		_tmp10_ = sql;
		gda_sql_builder_set_where (_tmp10_, id_cond);
		_tmp12_ = sql;
		_tmp13_ = gda_sql_builder_get_statement (_tmp12_, &_inner_error0_);
		_tmp11_ = _tmp13_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (sql);
			goto __catch0_g_error;
		}
		_tmp14_ = self->priv->_connection;
		_tmp15_ = gda_connection_statement_execute_select (_tmp14_, _tmp11_, NULL, &_inner_error0_);
		data_model = _tmp15_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (_tmp11_);
			_g_object_unref0 (sql);
			goto __catch0_g_error;
		}
		_tmp17_ = data_model;
		_tmp18_ = data_model;
		_tmp16_ = gda_data_model_get_value_at (_tmp17_, gda_data_model_get_column_index (_tmp18_, "unique_id"), 0, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (data_model);
			_g_object_unref0 (_tmp11_);
			_g_object_unref0 (sql);
			goto __catch0_g_error;
		}
		if (((gpointer) _tmp16_) == NULL) {
			result = FALSE;
			_g_object_unref0 (data_model);
			_g_object_unref0 (_tmp11_);
			_g_object_unref0 (sql);
			return result;
		}
		result = TRUE;
		_g_object_unref0 (data_model);
		_g_object_unref0 (_tmp11_);
		_g_object_unref0 (sql);
		return result;
	}
	goto __finally0;
	__catch0_g_error:
	{
		const gchar* _tmp19_;
		g_clear_error (&_inner_error0_);
		_tmp19_ = self->priv->_uid;
		g_debug ("TreeViewSetup.vala:301: Column %lld doesn't exist, a new one will be c" \
"reated", _tmp19_);
		result = FALSE;
		return result;
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return _tmp20_;
}

static GValue*
_g_value_dup (GValue* self)
{
	return g_boxed_copy (G_TYPE_VALUE, self);
}

static gpointer
__g_value_dup0 (gpointer self)
{
	return self ? _g_value_dup (self) : NULL;
}

static GValue*
music_tree_view_setup_query_field (MusicTreeViewSetup* self,
                                   const gchar* field)
{
	GError* _inner_error0_ = NULL;
	GValue* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (field != NULL, NULL);
	{
		GdaSqlBuilder* sql = NULL;
		GdaSqlBuilder* _tmp0_;
		GdaSqlBuilder* _tmp1_;
		GdaSqlBuilder* _tmp2_;
		GdaSqlBuilder* _tmp3_;
		GdaSqlBuilderId id_field = 0U;
		GdaSqlBuilder* _tmp4_;
		GdaSqlBuilderId id_param = 0U;
		GdaSqlBuilder* _tmp5_;
		const gchar* _tmp6_;
		GValue* _tmp7_ = NULL;
		GdaSqlBuilderId _tmp8_;
		GdaSqlBuilderId id_cond = 0U;
		GdaSqlBuilder* _tmp9_;
		GdaSqlBuilder* _tmp10_;
		GdaStatement* _tmp11_ = NULL;
		GdaSqlBuilder* _tmp12_;
		GdaStatement* _tmp13_;
		GdaDataModel* data_model = NULL;
		GdaConnection* _tmp14_;
		GdaDataModel* _tmp15_;
		GValue* _tmp16_ = NULL;
		GdaDataModel* _tmp17_;
		GdaDataModel* _tmp18_;
		GValue* _tmp19_;
		_tmp0_ = gda_sql_builder_new (GDA_SQL_STATEMENT_SELECT);
		sql = _tmp0_;
		_tmp1_ = sql;
		gda_sql_builder_select_add_target (_tmp1_, MUSIC_DATABASE_COLUMNS_TABLE_NAME, NULL);
		_tmp2_ = sql;
		_tmp3_ = sql;
		gda_sql_builder_add_field_value_id (_tmp2_, gda_sql_builder_add_id (_tmp3_, field), (GdaSqlBuilderId) 0);
		_tmp4_ = sql;
		id_field = gda_sql_builder_add_id (_tmp4_, "unique_id");
		_tmp5_ = sql;
		_tmp6_ = self->priv->_uid;
		_tmp7_ = g_new0 (GValue, 1);
		g_value_init (_tmp7_, G_TYPE_STRING);
		g_value_set_string (_tmp7_, _tmp6_);
		_tmp8_ = gda_sql_builder_add_expr_value (_tmp5_, NULL, _tmp7_);
		__vala_GValue_free0 (_tmp7_);
		id_param = _tmp8_;
		_tmp9_ = sql;
		id_cond = gda_sql_builder_add_cond (_tmp9_, GDA_SQL_OPERATOR_TYPE_EQ, id_field, id_param, (GdaSqlBuilderId) 0);
		_tmp10_ = sql;
		gda_sql_builder_set_where (_tmp10_, id_cond);
		_tmp12_ = sql;
		_tmp13_ = gda_sql_builder_get_statement (_tmp12_, &_inner_error0_);
		_tmp11_ = _tmp13_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (sql);
			goto __catch0_g_error;
		}
		_tmp14_ = self->priv->_connection;
		_tmp15_ = gda_connection_statement_execute_select (_tmp14_, _tmp11_, NULL, &_inner_error0_);
		data_model = _tmp15_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (_tmp11_);
			_g_object_unref0 (sql);
			goto __catch0_g_error;
		}
		_tmp17_ = data_model;
		_tmp18_ = data_model;
		_tmp16_ = gda_data_model_get_value_at (_tmp17_, gda_data_model_get_column_index (_tmp18_, field), 0, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (data_model);
			_g_object_unref0 (_tmp11_);
			_g_object_unref0 (sql);
			goto __catch0_g_error;
		}
		_tmp19_ = __g_value_dup0 (_tmp16_);
		result = _tmp19_;
		_g_object_unref0 (data_model);
		_g_object_unref0 (_tmp11_);
		_g_object_unref0 (sql);
		return result;
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp20_;
		const gchar* _tmp21_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp20_ = e;
		_tmp21_ = _tmp20_->message;
		g_critical ("TreeViewSetup.vala:318: Could not query field %s: %s", field, _tmp21_);
		result = NULL;
		_g_error_free0 (e);
		return result;
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

static void
__vala_GValue_free0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL));
}

static inline void
_g_slist_free___vala_GValue_free0_ (GSList* self)
{
	g_slist_free_full (self, (GDestroyNotify) __vala_GValue_free0_);
}

static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}

static inline void
_g_slist_free__g_free0_ (GSList* self)
{
	g_slist_free_full (self, (GDestroyNotify) _g_free0_);
}

static void
music_tree_view_setup_set_field (MusicTreeViewSetup* self,
                                 const gchar* field,
                                 GValue* value)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (field != NULL);
	g_return_if_fail (value != NULL);
	{
		GSList* col_names = NULL;
		gchar* _tmp0_;
		GSList* values = NULL;
		GValue _tmp1_;
		GValue _tmp2_;
		GValue* _tmp3_;
		GdaConnection* _tmp4_;
		const gchar* _tmp5_;
		GValue _tmp6_ = {0};
		col_names = NULL;
		_tmp0_ = g_strdup (field);
		col_names = g_slist_append (col_names, _tmp0_);
		values = NULL;
		_tmp1_ = *value;
		_tmp2_ = _tmp1_;
		_tmp3_ = __g_value_dup0 (&_tmp2_);
		values = g_slist_append (values, _tmp3_);
		_tmp4_ = self->priv->_connection;
		_tmp5_ = self->priv->_uid;
		g_value_init (&_tmp6_, G_TYPE_STRING);
		g_value_set_string (&_tmp6_, _tmp5_);
		gda_connection_update_row_in_table_v (_tmp4_, MUSIC_DATABASE_COLUMNS_TABLE_NAME, "unique_id", &_tmp6_, col_names, values, &_inner_error0_);
		G_IS_VALUE (&_tmp6_) ? (g_value_unset (&_tmp6_), NULL) : NULL;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
			(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
			goto __catch0_g_error;
		}
		(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
		(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp7_ = e;
		_tmp8_ = _tmp7_->message;
		g_critical ("TreeViewSetup.vala:331: Could not set field %s: %s", field, _tmp8_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

MusicListColumn
music_tree_view_setup_get_sort_column_id (MusicTreeViewSetup* self)
{
	MusicListColumn result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_sort_column_id;
	return result;
}

void
music_tree_view_setup_set_sort_column_id (MusicTreeViewSetup* self,
                                          MusicListColumn value)
{
	MusicListColumn old_value;
	g_return_if_fail (self != NULL);
	old_value = music_tree_view_setup_get_sort_column_id (self);
	if (old_value != value) {
		self->priv->_sort_column_id = value;
		g_object_notify_by_pspec ((GObject *) self, music_tree_view_setup_properties[MUSIC_TREE_VIEW_SETUP_SORT_COLUMN_ID_PROPERTY]);
	}
}

GtkSortType
music_tree_view_setup_get_sort_direction (MusicTreeViewSetup* self)
{
	GtkSortType result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_sort_direction;
	return result;
}

void
music_tree_view_setup_set_sort_direction (MusicTreeViewSetup* self,
                                          GtkSortType value)
{
	GtkSortType old_value;
	g_return_if_fail (self != NULL);
	old_value = music_tree_view_setup_get_sort_direction (self);
	if (old_value != value) {
		self->priv->_sort_direction = value;
		g_object_notify_by_pspec ((GObject *) self, music_tree_view_setup_properties[MUSIC_TREE_VIEW_SETUP_SORT_DIRECTION_PROPERTY]);
	}
}

MusicViewWrapperHint
music_tree_view_setup_get_hint (MusicTreeViewSetup* self)
{
	MusicViewWrapperHint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_hint;
	return result;
}

void
music_tree_view_setup_set_hint (MusicTreeViewSetup* self,
                                MusicViewWrapperHint value)
{
	MusicViewWrapperHint old_value;
	g_return_if_fail (self != NULL);
	old_value = music_tree_view_setup_get_hint (self);
	if (old_value != value) {
		self->priv->_hint = value;
		g_object_notify_by_pspec ((GObject *) self, music_tree_view_setup_properties[MUSIC_TREE_VIEW_SETUP_HINT_PROPERTY]);
	}
}

GdaConnection*
music_tree_view_setup_get_connection (MusicTreeViewSetup* self)
{
	GdaConnection* result;
	GdaConnection* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_connection;
	result = _tmp0_;
	return result;
}

static void
music_tree_view_setup_set_connection (MusicTreeViewSetup* self,
                                      GdaConnection* value)
{
	GdaConnection* old_value;
	g_return_if_fail (self != NULL);
	old_value = music_tree_view_setup_get_connection (self);
	if (old_value != value) {
		GdaConnection* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_connection);
		self->priv->_connection = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_tree_view_setup_properties[MUSIC_TREE_VIEW_SETUP_CONNECTION_PROPERTY]);
	}
}

const gchar*
music_tree_view_setup_get_uid (MusicTreeViewSetup* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_uid;
	result = _tmp0_;
	return result;
}

static void
music_tree_view_setup_set_uid (MusicTreeViewSetup* self,
                               const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = music_tree_view_setup_get_uid (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_uid);
		self->priv->_uid = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_tree_view_setup_properties[MUSIC_TREE_VIEW_SETUP_UID_PROPERTY]);
	}
}

static void
_music_tree_view_setup____lambda8_ (MusicTreeViewSetup* self)
{
	GtkSortType _tmp0_;
	GValue _tmp1_ = {0};
	_tmp0_ = self->priv->_sort_direction;
	g_value_init (&_tmp1_, G_TYPE_INT);
	g_value_set_int (&_tmp1_, (gint) _tmp0_);
	music_tree_view_setup_set_field (self, "sort_direction", &_tmp1_);
	G_IS_VALUE (&_tmp1_) ? (g_value_unset (&_tmp1_), NULL) : NULL;
}

static void
__music_tree_view_setup____lambda8__g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
	_music_tree_view_setup____lambda8_ ((MusicTreeViewSetup*) self);
}

static void
_music_tree_view_setup____lambda9_ (MusicTreeViewSetup* self)
{
	MusicListColumn _tmp0_;
	GValue _tmp1_ = {0};
	_tmp0_ = self->priv->_sort_column_id;
	g_value_init (&_tmp1_, G_TYPE_INT);
	g_value_set_int (&_tmp1_, (gint) _tmp0_);
	music_tree_view_setup_set_field (self, "sort_column_id", &_tmp1_);
	G_IS_VALUE (&_tmp1_) ? (g_value_unset (&_tmp1_), NULL) : NULL;
}

static void
__music_tree_view_setup____lambda9__g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
	_music_tree_view_setup____lambda9_ ((MusicTreeViewSetup*) self);
}

static GObject *
music_tree_view_setup_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicTreeViewSetup * self;
	MusicViewWrapperHint _tmp0_;
	const gchar* _tmp1_;
	GError* _inner_error0_ = NULL;
	parent_class = G_OBJECT_CLASS (music_tree_view_setup_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_TREE_VIEW_SETUP, MusicTreeViewSetup);
	_tmp0_ = self->priv->_hint;
	switch (_tmp0_) {
		case MUSIC_VIEW_WRAPPER_HINT_PLAYLIST:
		case MUSIC_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST:
		case MUSIC_VIEW_WRAPPER_HINT_SMART_PLAYLIST:
		{
			music_tree_view_setup_set_sort_column_id (self, MUSIC_LIST_COLUMN_NUMBER);
			break;
		}
		default:
		break;
	}
	_tmp1_ = self->priv->_uid;
	if (_tmp1_ != NULL) {
		if (music_tree_view_setup_exists (self) == FALSE) {
			{
				GdaSqlBuilder* builder = NULL;
				GdaSqlBuilder* _tmp2_;
				GdaSqlBuilder* _tmp3_;
				GdaSqlBuilder* _tmp4_;
				const gchar* _tmp5_;
				GValue* _tmp6_ = NULL;
				GdaStatement* _tmp7_ = NULL;
				GdaSqlBuilder* _tmp8_;
				GdaStatement* _tmp9_;
				GdaConnection* _tmp10_;
				_tmp2_ = gda_sql_builder_new (GDA_SQL_STATEMENT_INSERT);
				builder = _tmp2_;
				_tmp3_ = builder;
				gda_sql_builder_set_table (_tmp3_, MUSIC_DATABASE_COLUMNS_TABLE_NAME);
				_tmp4_ = builder;
				_tmp5_ = self->priv->_uid;
				_tmp6_ = g_new0 (GValue, 1);
				g_value_init (_tmp6_, G_TYPE_STRING);
				g_value_set_string (_tmp6_, _tmp5_);
				gda_sql_builder_add_field_value_as_gvalue (_tmp4_, "unique_id", _tmp6_);
				__vala_GValue_free0 (_tmp6_);
				_tmp8_ = builder;
				_tmp9_ = gda_sql_builder_get_statement (_tmp8_, &_inner_error0_);
				_tmp7_ = _tmp9_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					_g_object_unref0 (builder);
					goto __catch0_g_error;
				}
				_tmp10_ = self->priv->_connection;
				gda_connection_statement_execute_non_select (_tmp10_, _tmp7_, NULL, NULL, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					_g_object_unref0 (_tmp7_);
					_g_object_unref0 (builder);
					goto __catch0_g_error;
				}
				_g_object_unref0 (_tmp7_);
				_g_object_unref0 (builder);
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* e = NULL;
				GError* _tmp11_;
				const gchar* _tmp12_;
				e = _inner_error0_;
				_inner_error0_ = NULL;
				_tmp11_ = e;
				_tmp12_ = _tmp11_->message;
				g_warning ("TreeViewSetup.vala:70: Could not save treeviewsetup: %s", _tmp12_);
				_g_error_free0 (e);
			}
			__finally0:
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
			}
		} else {
			GValue* direction = NULL;
			GValue* _tmp13_;
			gboolean _tmp14_ = FALSE;
			GValue* _tmp15_;
			GValue* direction_column = NULL;
			GValue* _tmp18_;
			gboolean _tmp19_ = FALSE;
			GValue* _tmp20_;
			GValue* columns_var = NULL;
			GValue* _tmp23_;
			gboolean _tmp24_ = FALSE;
			GValue* _tmp25_;
			_tmp13_ = music_tree_view_setup_query_field (self, "sort_direction");
			direction = _tmp13_;
			_tmp15_ = direction;
			if (((gpointer) _tmp15_) != NULL) {
				GValue* _tmp16_;
				_tmp16_ = direction;
				_tmp14_ = G_VALUE_TYPE (_tmp16_) != gda_null_get_type ();
			} else {
				_tmp14_ = FALSE;
			}
			if (_tmp14_) {
				GValue* _tmp17_;
				_tmp17_ = direction;
				music_tree_view_setup_set_sort_direction (self, (GtkSortType) g_value_get_int (_tmp17_));
			}
			_tmp18_ = music_tree_view_setup_query_field (self, "sort_column_id");
			direction_column = _tmp18_;
			_tmp20_ = direction_column;
			if (((gpointer) _tmp20_) != NULL) {
				GValue* _tmp21_;
				_tmp21_ = direction_column;
				_tmp19_ = G_VALUE_TYPE (_tmp21_) != gda_null_get_type ();
			} else {
				_tmp19_ = FALSE;
			}
			if (_tmp19_) {
				GValue* _tmp22_;
				_tmp22_ = direction_column;
				music_tree_view_setup_set_sort_column_id (self, (MusicListColumn) g_value_get_int (_tmp22_));
			}
			_tmp23_ = music_tree_view_setup_query_field (self, "columns");
			columns_var = _tmp23_;
			_tmp25_ = columns_var;
			if (((gpointer) _tmp25_) != NULL) {
				GValue* _tmp26_;
				_tmp26_ = columns_var;
				_tmp24_ = G_VALUE_TYPE (_tmp26_) != gda_null_get_type ();
			} else {
				_tmp24_ = FALSE;
			}
			if (_tmp24_) {
				GValue* _tmp27_;
				const gchar* _tmp28_;
				_tmp27_ = columns_var;
				_tmp28_ = g_value_get_string (_tmp27_);
				music_tree_view_setup_import_columns (self, _tmp28_);
			}
			__vala_GValue_free0 (columns_var);
			__vala_GValue_free0 (direction_column);
			__vala_GValue_free0 (direction);
		}
		g_signal_connect_object ((GObject*) self, "notify::sort-direction", (GCallback) __music_tree_view_setup____lambda8__g_object_notify, self, 0);
		g_signal_connect_object ((GObject*) self, "notify::sort-column-id", (GCallback) __music_tree_view_setup____lambda9__g_object_notify, self, 0);
	}
	return obj;
}

static void
music_tree_view_setup_class_init (MusicTreeViewSetupClass * klass,
                                  gpointer klass_data)
{
	music_tree_view_setup_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicTreeViewSetup_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_music_tree_view_setup_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_music_tree_view_setup_set_property;
	G_OBJECT_CLASS (klass)->constructor = music_tree_view_setup_constructor;
	G_OBJECT_CLASS (klass)->finalize = music_tree_view_setup_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_TREE_VIEW_SETUP_SORT_COLUMN_ID_PROPERTY, music_tree_view_setup_properties[MUSIC_TREE_VIEW_SETUP_SORT_COLUMN_ID_PROPERTY] = g_param_spec_enum ("sort-column-id", "sort-column-id", "sort-column-id", MUSIC_TYPE_LIST_COLUMN, MUSIC_LIST_COLUMN_ARTIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_TREE_VIEW_SETUP_SORT_DIRECTION_PROPERTY, music_tree_view_setup_properties[MUSIC_TREE_VIEW_SETUP_SORT_DIRECTION_PROPERTY] = g_param_spec_enum ("sort-direction", "sort-direction", "sort-direction", gtk_sort_type_get_type (), GTK_SORT_ASCENDING, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_TREE_VIEW_SETUP_HINT_PROPERTY, music_tree_view_setup_properties[MUSIC_TREE_VIEW_SETUP_HINT_PROPERTY] = g_param_spec_enum ("hint", "hint", "hint", MUSIC_VIEW_WRAPPER_TYPE_HINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_TREE_VIEW_SETUP_CONNECTION_PROPERTY, music_tree_view_setup_properties[MUSIC_TREE_VIEW_SETUP_CONNECTION_PROPERTY] = g_param_spec_object ("connection", "connection", "connection", gda_connection_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_TREE_VIEW_SETUP_UID_PROPERTY, music_tree_view_setup_properties[MUSIC_TREE_VIEW_SETUP_UID_PROPERTY] = g_param_spec_string ("uid", "uid", "uid", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}

static void
music_tree_view_setup_instance_init (MusicTreeViewSetup * self,
                                     gpointer klass)
{
	GeeLinkedList* _tmp0_;
	self->priv = music_tree_view_setup_get_instance_private (self);
	self->priv->_sort_column_id = MUSIC_LIST_COLUMN_ARTIST;
	self->priv->_sort_direction = GTK_SORT_ASCENDING;
	self->priv->_connection = NULL;
	self->priv->_uid = NULL;
	_tmp0_ = gee_linked_list_new (gtk_tree_view_column_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	self->priv->columns = _tmp0_;
}

static void
music_tree_view_setup_finalize (GObject * obj)
{
	MusicTreeViewSetup * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_TREE_VIEW_SETUP, MusicTreeViewSetup);
	_g_object_unref0 (self->priv->_connection);
	_g_free0 (self->priv->_uid);
	_g_object_unref0 (self->priv->columns);
	G_OBJECT_CLASS (music_tree_view_setup_parent_class)->finalize (obj);
}

static GType
music_tree_view_setup_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicTreeViewSetupClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_tree_view_setup_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicTreeViewSetup), 0, (GInstanceInitFunc) music_tree_view_setup_instance_init, NULL };
	GType music_tree_view_setup_type_id;
	music_tree_view_setup_type_id = g_type_register_static (G_TYPE_OBJECT, "MusicTreeViewSetup", &g_define_type_info, 0);
	MusicTreeViewSetup_private_offset = g_type_add_instance_private (music_tree_view_setup_type_id, sizeof (MusicTreeViewSetupPrivate));
	return music_tree_view_setup_type_id;
}

GType
music_tree_view_setup_get_type (void)
{
	static volatile gsize music_tree_view_setup_type_id__once = 0;
	if (g_once_init_enter (&music_tree_view_setup_type_id__once)) {
		GType music_tree_view_setup_type_id;
		music_tree_view_setup_type_id = music_tree_view_setup_get_type_once ();
		g_once_init_leave (&music_tree_view_setup_type_id__once, music_tree_view_setup_type_id);
	}
	return music_tree_view_setup_type_id__once;
}

static void
_vala_music_tree_view_setup_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	MusicTreeViewSetup * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_TREE_VIEW_SETUP, MusicTreeViewSetup);
	switch (property_id) {
		case MUSIC_TREE_VIEW_SETUP_SORT_COLUMN_ID_PROPERTY:
		g_value_set_enum (value, music_tree_view_setup_get_sort_column_id (self));
		break;
		case MUSIC_TREE_VIEW_SETUP_SORT_DIRECTION_PROPERTY:
		g_value_set_enum (value, music_tree_view_setup_get_sort_direction (self));
		break;
		case MUSIC_TREE_VIEW_SETUP_HINT_PROPERTY:
		g_value_set_enum (value, music_tree_view_setup_get_hint (self));
		break;
		case MUSIC_TREE_VIEW_SETUP_CONNECTION_PROPERTY:
		g_value_set_object (value, music_tree_view_setup_get_connection (self));
		break;
		case MUSIC_TREE_VIEW_SETUP_UID_PROPERTY:
		g_value_set_string (value, music_tree_view_setup_get_uid (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_music_tree_view_setup_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	MusicTreeViewSetup * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_TREE_VIEW_SETUP, MusicTreeViewSetup);
	switch (property_id) {
		case MUSIC_TREE_VIEW_SETUP_SORT_COLUMN_ID_PROPERTY:
		music_tree_view_setup_set_sort_column_id (self, g_value_get_enum (value));
		break;
		case MUSIC_TREE_VIEW_SETUP_SORT_DIRECTION_PROPERTY:
		music_tree_view_setup_set_sort_direction (self, g_value_get_enum (value));
		break;
		case MUSIC_TREE_VIEW_SETUP_HINT_PROPERTY:
		music_tree_view_setup_set_hint (self, g_value_get_enum (value));
		break;
		case MUSIC_TREE_VIEW_SETUP_CONNECTION_PROPERTY:
		music_tree_view_setup_set_connection (self, g_value_get_object (value));
		break;
		case MUSIC_TREE_VIEW_SETUP_UID_PROPERTY:
		music_tree_view_setup_set_uid (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

