/* DeviceViewWrapper.c generated by valac 0.56.1, the Vala compiler
 * generated from DeviceViewWrapper.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Victor Eduardo <victoreduardm@gmail.com>
 */

#include "music-lib.h"
#include "io.elementary.music-core.h"
#include <glib.h>
#include <granite.h>
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

enum  {
	MUSIC_DEVICE_VIEW_WRAPPER_0_PROPERTY,
	MUSIC_DEVICE_VIEW_WRAPPER_D_PROPERTY,
	MUSIC_DEVICE_VIEW_WRAPPER_NUM_PROPERTIES
};
static GParamSpec* music_device_view_wrapper_properties[MUSIC_DEVICE_VIEW_WRAPPER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _MusicDeviceViewWrapperPrivate {
	MusicDevice* _d;
};

static gint MusicDeviceViewWrapper_private_offset;
static gpointer music_device_view_wrapper_parent_class = NULL;

static void music_device_view_wrapper_import_request (MusicDeviceViewWrapper* self,
                                               GeeCollection* to_import);
static void _music_device_view_wrapper_import_request_music_view_interface_import_requested (MusicViewInterface* _sender,
                                                                                      GeeCollection* to_import,
                                                                                      gpointer self);
static void _music_view_wrapper_add_media_async_music_library_media_added (MusicLibrary* _sender,
                                                                    GeeCollection* medias,
                                                                    gpointer self);
static void _music_view_wrapper_remove_media_async_music_library_media_removed (MusicLibrary* _sender,
                                                                         GeeCollection* medias,
                                                                         gpointer self);
static void _music_view_wrapper_update_media_async_music_library_media_updated (MusicLibrary* _sender,
                                                                         GeeCollection* medias,
                                                                         gpointer self);
static void music_device_view_wrapper_real_set_no_media_alert (MusicViewWrapper* base);
static void music_device_view_wrapper_real_set_device (MusicDeviceViewWrapper* self,
                                                MusicDevice* device);
static void music_device_view_wrapper_set_d (MusicDeviceViewWrapper* self,
                                      MusicDevice* value);
static void music_device_view_wrapper_sync_finished (MusicDeviceViewWrapper* self);
static void _music_device_view_wrapper_sync_finished_music_library_file_operations_done (MusicLibrary* _sender,
                                                                                  gpointer self);
static void music_device_view_wrapper_finalize (GObject * obj);
static GType music_device_view_wrapper_get_type_once (void);
static void _vala_music_device_view_wrapper_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec);
static void _vala_music_device_view_wrapper_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec);

static inline gpointer
music_device_view_wrapper_get_instance_private (MusicDeviceViewWrapper* self)
{
	return G_STRUCT_MEMBER_P (self, MusicDeviceViewWrapper_private_offset);
}

static void
_music_device_view_wrapper_import_request_music_view_interface_import_requested (MusicViewInterface* _sender,
                                                                                 GeeCollection* to_import,
                                                                                 gpointer self)
{
	music_device_view_wrapper_import_request ((MusicDeviceViewWrapper*) self, to_import);
}

static void
_music_view_wrapper_add_media_async_music_library_media_added (MusicLibrary* _sender,
                                                               GeeCollection* medias,
                                                               gpointer self)
{
	music_view_wrapper_add_media_async ((MusicViewWrapper*) self, medias, NULL, NULL);
}

static void
_music_view_wrapper_remove_media_async_music_library_media_removed (MusicLibrary* _sender,
                                                                    GeeCollection* medias,
                                                                    gpointer self)
{
	music_view_wrapper_remove_media_async ((MusicViewWrapper*) self, medias, NULL, NULL);
}

static void
_music_view_wrapper_update_media_async_music_library_media_updated (MusicLibrary* _sender,
                                                                    GeeCollection* medias,
                                                                    gpointer self)
{
	music_view_wrapper_update_media_async ((MusicViewWrapper*) self, medias, NULL, NULL);
}

MusicDeviceViewWrapper*
music_device_view_wrapper_construct (GType object_type,
                                     MusicTreeViewSetup* tvs,
                                     MusicDevice* d,
                                     MusicLibrary* library)
{
	MusicDeviceViewWrapper * self = NULL;
	MusicViewWrapperHint _tmp0_;
	MusicViewWrapperHint _tmp1_;
	MusicListView* _tmp2_;
	MusicListView* _tmp3_;
	GraniteWidgetsAlertView* _tmp4_;
	GraniteWidgetsAlertView* _tmp5_;
	MusicListView* _tmp6_;
	MusicListView* _tmp7_;
	g_return_val_if_fail (tvs != NULL, NULL);
	g_return_val_if_fail (d != NULL, NULL);
	g_return_val_if_fail (library != NULL, NULL);
	_tmp0_ = music_tree_view_setup_get_hint (tvs);
	_tmp1_ = _tmp0_;
	self = (MusicDeviceViewWrapper*) music_view_wrapper_construct (object_type, _tmp1_, library);
	_tmp2_ = music_list_view_new ((MusicViewWrapper*) self, tvs, FALSE);
	g_object_ref_sink (_tmp2_);
	_tmp3_ = _tmp2_;
	music_view_wrapper_set_list_view ((MusicViewWrapper*) self, _tmp3_);
	_g_object_unref0 (_tmp3_);
	_tmp4_ = granite_widgets_alert_view_new ("", "", "");
	g_object_ref_sink (_tmp4_);
	_tmp5_ = _tmp4_;
	music_view_wrapper_set_embedded_alert ((MusicViewWrapper*) self, _tmp5_);
	_g_object_unref0 (_tmp5_);
	music_view_wrapper_pack_views ((MusicViewWrapper*) self);
	_tmp6_ = music_view_wrapper_get_list_view ((MusicViewWrapper*) self);
	_tmp7_ = _tmp6_;
	g_signal_connect_object ((MusicViewInterface*) _tmp7_, "import-requested", (GCallback) _music_device_view_wrapper_import_request_music_view_interface_import_requested, self, 0);
	g_signal_connect_object (library, "media-added", (GCallback) _music_view_wrapper_add_media_async_music_library_media_added, (MusicViewWrapper*) self, 0);
	g_signal_connect_object (library, "media-removed", (GCallback) _music_view_wrapper_remove_media_async_music_library_media_removed, (MusicViewWrapper*) self, 0);
	g_signal_connect_object (library, "media-updated", (GCallback) _music_view_wrapper_update_media_async_music_library_media_updated, (MusicViewWrapper*) self, 0);
	music_device_view_wrapper_set_device (self, d);
	return self;
}

MusicDeviceViewWrapper*
music_device_view_wrapper_new (MusicTreeViewSetup* tvs,
                               MusicDevice* d,
                               MusicLibrary* library)
{
	return music_device_view_wrapper_construct (MUSIC_TYPE_DEVICE_VIEW_WRAPPER, tvs, d, library);
}

static void
music_device_view_wrapper_real_set_no_media_alert (MusicViewWrapper* base)
{
	MusicDeviceViewWrapper * self;
	GraniteWidgetsAlertView* _tmp0_;
	GraniteWidgetsAlertView* _tmp1_;
	GraniteWidgetsAlertView* _tmp2_;
	GraniteWidgetsAlertView* _tmp3_;
	MusicDevice* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GraniteWidgetsAlertView* _tmp7_;
	GraniteWidgetsAlertView* _tmp8_;
	MusicDevice* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	self = (MusicDeviceViewWrapper*) base;
	_tmp0_ = music_view_wrapper_get_embedded_alert ((MusicViewWrapper*) self);
	_tmp1_ = _tmp0_;
	granite_widgets_alert_view_set_icon_name (_tmp1_, "dialog-error");
	_tmp2_ = music_view_wrapper_get_embedded_alert ((MusicViewWrapper*) self);
	_tmp3_ = _tmp2_;
	_tmp4_ = self->priv->_d;
	_tmp5_ = music_device_get_empty_device_title (_tmp4_);
	_tmp6_ = _tmp5_;
	granite_widgets_alert_view_set_title (_tmp3_, _tmp6_);
	_g_free0 (_tmp6_);
	_tmp7_ = music_view_wrapper_get_embedded_alert ((MusicViewWrapper*) self);
	_tmp8_ = _tmp7_;
	_tmp9_ = self->priv->_d;
	_tmp10_ = music_device_get_empty_device_description (_tmp9_);
	_tmp11_ = _tmp10_;
	granite_widgets_alert_view_set_description (_tmp8_, _tmp11_);
	_g_free0 (_tmp11_);
}

static void
_music_device_view_wrapper_sync_finished_music_library_file_operations_done (MusicLibrary* _sender,
                                                                             gpointer self)
{
	music_device_view_wrapper_sync_finished ((MusicDeviceViewWrapper*) self);
}

static void
music_device_view_wrapper_real_set_device (MusicDeviceViewWrapper* self,
                                           MusicDevice* device)
{
	MusicLibrary* _tmp0_;
	MusicLibrary* _tmp1_;
	MusicLibrary* _tmp2_;
	MusicLibrary* _tmp3_;
	GeeCollection* _tmp4_;
	GeeCollection* _tmp5_;
	g_return_if_fail (device != NULL);
	music_device_view_wrapper_set_d (self, device);
	_tmp0_ = music_view_wrapper_get_library ((MusicViewWrapper*) self);
	_tmp1_ = _tmp0_;
	g_signal_connect_object (_tmp1_, "file-operations-done", (GCallback) _music_device_view_wrapper_sync_finished_music_library_file_operations_done, self, 0);
	_tmp2_ = music_view_wrapper_get_library ((MusicViewWrapper*) self);
	_tmp3_ = _tmp2_;
	_tmp4_ = music_library_get_medias (_tmp3_);
	_tmp5_ = _tmp4_;
	music_view_wrapper_set_media_async ((MusicViewWrapper*) self, _tmp5_, NULL, NULL);
	_g_object_unref0 (_tmp5_);
}

void
music_device_view_wrapper_set_device (MusicDeviceViewWrapper* self,
                                      MusicDevice* device)
{
	MusicDeviceViewWrapperClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_DEVICE_VIEW_WRAPPER_GET_CLASS (self);
	if (_klass_->set_device) {
		_klass_->set_device (self, device);
	}
}

static void
music_device_view_wrapper_import_request (MusicDeviceViewWrapper* self,
                                          GeeCollection* to_import)
{
	MusicLibrary* _tmp0_;
	MusicLibrary* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (to_import != NULL);
	_tmp0_ = music_view_wrapper_get_library ((MusicViewWrapper*) self);
	_tmp1_ = _tmp0_;
	if (!music_library_doing_file_operations (_tmp1_)) {
		MusicLibrariesManager* _tmp2_;
		_tmp2_ = music_libraries_manager;
		music_libraries_manager_transfer_to_local_library (_tmp2_, to_import);
	}
}

static void
music_device_view_wrapper_sync_finished (MusicDeviceViewWrapper* self)
{
	MusicViewWrapperHint _tmp0_;
	MusicViewWrapperHint _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = music_view_wrapper_get_hint ((MusicViewWrapper*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == MUSIC_VIEW_WRAPPER_HINT_DEVICE_AUDIO) {
		MusicLibrary* _tmp2_;
		MusicLibrary* _tmp3_;
		GeeCollection* _tmp4_;
		GeeCollection* _tmp5_;
		_tmp2_ = music_view_wrapper_get_library ((MusicViewWrapper*) self);
		_tmp3_ = _tmp2_;
		_tmp4_ = music_library_get_medias (_tmp3_);
		_tmp5_ = _tmp4_;
		music_view_wrapper_set_media_async ((MusicViewWrapper*) self, _tmp5_, NULL, NULL);
		_g_object_unref0 (_tmp5_);
	}
}

MusicDevice*
music_device_view_wrapper_get_d (MusicDeviceViewWrapper* self)
{
	MusicDevice* result;
	MusicDevice* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_d;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
music_device_view_wrapper_set_d (MusicDeviceViewWrapper* self,
                                 MusicDevice* value)
{
	MusicDevice* old_value;
	g_return_if_fail (self != NULL);
	old_value = music_device_view_wrapper_get_d (self);
	if (old_value != value) {
		MusicDevice* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_d);
		self->priv->_d = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_device_view_wrapper_properties[MUSIC_DEVICE_VIEW_WRAPPER_D_PROPERTY]);
	}
}

static void
music_device_view_wrapper_class_init (MusicDeviceViewWrapperClass * klass,
                                      gpointer klass_data)
{
	music_device_view_wrapper_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicDeviceViewWrapper_private_offset);
	((MusicViewWrapperClass *) klass)->set_no_media_alert = (void (*) (MusicViewWrapper*)) music_device_view_wrapper_real_set_no_media_alert;
	((MusicDeviceViewWrapperClass *) klass)->set_device = (void (*) (MusicDeviceViewWrapper*, MusicDevice*)) music_device_view_wrapper_real_set_device;
	G_OBJECT_CLASS (klass)->get_property = _vala_music_device_view_wrapper_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_music_device_view_wrapper_set_property;
	G_OBJECT_CLASS (klass)->finalize = music_device_view_wrapper_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_DEVICE_VIEW_WRAPPER_D_PROPERTY, music_device_view_wrapper_properties[MUSIC_DEVICE_VIEW_WRAPPER_D_PROPERTY] = g_param_spec_object ("d", "d", "d", MUSIC_TYPE_DEVICE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static void
music_device_view_wrapper_instance_init (MusicDeviceViewWrapper * self,
                                         gpointer klass)
{
	self->priv = music_device_view_wrapper_get_instance_private (self);
}

static void
music_device_view_wrapper_finalize (GObject * obj)
{
	MusicDeviceViewWrapper * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_DEVICE_VIEW_WRAPPER, MusicDeviceViewWrapper);
	_g_object_unref0 (self->priv->_d);
	G_OBJECT_CLASS (music_device_view_wrapper_parent_class)->finalize (obj);
}

static GType
music_device_view_wrapper_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicDeviceViewWrapperClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_device_view_wrapper_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicDeviceViewWrapper), 0, (GInstanceInitFunc) music_device_view_wrapper_instance_init, NULL };
	GType music_device_view_wrapper_type_id;
	music_device_view_wrapper_type_id = g_type_register_static (MUSIC_TYPE_VIEW_WRAPPER, "MusicDeviceViewWrapper", &g_define_type_info, 0);
	MusicDeviceViewWrapper_private_offset = g_type_add_instance_private (music_device_view_wrapper_type_id, sizeof (MusicDeviceViewWrapperPrivate));
	return music_device_view_wrapper_type_id;
}

GType
music_device_view_wrapper_get_type (void)
{
	static volatile gsize music_device_view_wrapper_type_id__once = 0;
	if (g_once_init_enter (&music_device_view_wrapper_type_id__once)) {
		GType music_device_view_wrapper_type_id;
		music_device_view_wrapper_type_id = music_device_view_wrapper_get_type_once ();
		g_once_init_leave (&music_device_view_wrapper_type_id__once, music_device_view_wrapper_type_id);
	}
	return music_device_view_wrapper_type_id__once;
}

static void
_vala_music_device_view_wrapper_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec)
{
	MusicDeviceViewWrapper * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_DEVICE_VIEW_WRAPPER, MusicDeviceViewWrapper);
	switch (property_id) {
		case MUSIC_DEVICE_VIEW_WRAPPER_D_PROPERTY:
		g_value_set_object (value, music_device_view_wrapper_get_d (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_music_device_view_wrapper_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec)
{
	MusicDeviceViewWrapper * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_DEVICE_VIEW_WRAPPER, MusicDeviceViewWrapper);
	switch (property_id) {
		case MUSIC_DEVICE_VIEW_WRAPPER_D_PROPERTY:
		music_device_view_wrapper_set_d (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

