/* MusicViewWrapper.c generated by valac 0.56.1, the Vala compiler
 * generated from MusicViewWrapper.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Victor Eduardo <victoreduardm@gmail.com>
 */

#include "music-lib.h"
#include <gee.h>
#include <glib-object.h>
#include "io.elementary.music-core.h"
#include <glib.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <granite.h>
#include <gtk/gtk.h>
#include <string.h>
#include <gdk/gdk.h>
#include <stdlib.h>

enum  {
	MUSIC_MUSIC_VIEW_WRAPPER_0_PROPERTY,
	MUSIC_MUSIC_VIEW_WRAPPER_NUM_PROPERTIES
};
static GParamSpec* music_music_view_wrapper_properties[MUSIC_MUSIC_VIEW_WRAPPER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _MusicMusicViewWrapperBuildAsyncData MusicMusicViewWrapperBuildAsyncData;

struct _MusicMusicViewWrapperPrivate {
	GeeHashMap* _devices;
};

struct _MusicMusicViewWrapperBuildAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MusicMusicViewWrapper* self;
	MusicTreeViewSetup* tvs;
	MusicTopDisplay* top_display;
	MusicAlbumsView* _tmp0_;
	MusicAlbumsView* _tmp1_;
	MusicTreeViewSetup* music_setup;
	MusicTreeViewSetup* _tmp2_;
	MusicTreeViewSetup* _tmp3_;
	MusicTreeViewSetup* _tmp4_;
	MusicListView* _tmp5_;
	MusicListView* _tmp6_;
	MusicListView* _tmp7_;
	MusicListView* _tmp8_;
	MusicMusicListView* _tmp9_;
	MusicMusicListView* _tmp10_;
	GraniteWidgetsWelcome* _tmp11_;
	GraniteWidgetsWelcome* _tmp12_;
	GraniteWidgetsWelcome* _tmp13_;
	GraniteWidgetsWelcome* _tmp14_;
	GraniteWidgetsWelcome* _tmp15_;
	GraniteWidgetsWelcome* _tmp16_;
	GraniteWidgetsWelcome* _tmp17_;
	GraniteWidgetsWelcome* _tmp18_;
	GeeHashMap* _tmp19_;
	GraniteWidgetsAlertView* _tmp20_;
	GraniteWidgetsAlertView* _tmp21_;
	GtkTargetEntry uris;
	GtkTargetEntry _tmp22_;
	GraniteWidgetsWelcome* _tmp23_;
	GraniteWidgetsWelcome* _tmp24_;
	GtkTargetEntry _tmp25_;
	GtkTargetEntry* _tmp26_;
	GtkTargetEntry* _tmp27_;
	gint _tmp27__length1;
	GraniteWidgetsWelcome* _tmp28_;
	GraniteWidgetsWelcome* _tmp29_;
	MusicLibrary* _tmp30_;
	MusicLibrary* _tmp31_;
	GeeCollection* _tmp32_;
	GeeCollection* _tmp33_;
};

static gint MusicMusicViewWrapper_private_offset;
static gpointer music_music_view_wrapper_parent_class = NULL;

static void music_music_view_wrapper_build_async (MusicMusicViewWrapper* self,
                                           MusicTreeViewSetup* tvs,
                                           MusicTopDisplay* top_display,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
static void music_music_view_wrapper_build_finish (MusicMusicViewWrapper* self,
                                            GAsyncResult* _res_);
static void music_music_view_wrapper_build_async_data_free (gpointer _data);
static gboolean music_music_view_wrapper_build_async_co (MusicMusicViewWrapperBuildAsyncData* _data_);
static gboolean _music_music_view_wrapper_build_async_co_gsource_func (gpointer self);
static void music_music_view_wrapper_welcome_screen_activated (MusicMusicViewWrapper* self,
                                                        gint index);
static void _music_music_view_wrapper_welcome_screen_activated_granite_widgets_welcome_activated (GraniteWidgetsWelcome* _sender,
                                                                                           gint index,
                                                                                           gpointer self);
static void __lambda161_ (MusicMusicViewWrapper* self,
                   GdkDragContext* ctx,
                   gint x,
                   gint y,
                   GtkSelectionData* sel,
                   guint info,
                   guint time);
static void ___lambda161__gtk_widget_drag_data_received (GtkWidget* _sender,
                                                  GdkDragContext* context,
                                                  gint x,
                                                  gint y,
                                                  GtkSelectionData* selection_data,
                                                  guint info,
                                                  guint time_,
                                                  gpointer self);
static void music_music_view_wrapper_connect_data_signals (MusicMusicViewWrapper* self);
static void music_music_view_wrapper_build_async_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_);
static void music_music_view_wrapper_on_device_added (MusicMusicViewWrapper* self,
                                               MusicDevice* d);
static void _music_music_view_wrapper_on_device_added_music_device_manager_device_added (MusicDeviceManager* _sender,
                                                                                  MusicDevice* d,
                                                                                  gpointer self);
static void music_music_view_wrapper_on_device_removed (MusicMusicViewWrapper* self,
                                                 MusicDevice* d);
static void _music_music_view_wrapper_on_device_removed_music_device_manager_device_removed (MusicDeviceManager* _sender,
                                                                                      MusicDevice* d,
                                                                                      gpointer self);
static void music_music_view_wrapper_on_device_name_changed (MusicMusicViewWrapper* self,
                                                      MusicDevice* d);
static void _music_music_view_wrapper_on_device_name_changed_music_device_manager_device_name_changed (MusicDeviceManager* _sender,
                                                                                                MusicDevice* d,
                                                                                                gpointer self);
static void _music_view_wrapper_add_media_async_music_library_media_added (MusicLibrary* _sender,
                                                                    GeeCollection* medias,
                                                                    gpointer self);
static void _music_view_wrapper_remove_media_async_music_library_media_removed (MusicLibrary* _sender,
                                                                         GeeCollection* medias,
                                                                         gpointer self);
static void _music_view_wrapper_update_media_async_music_library_media_updated (MusicLibrary* _sender,
                                                                         GeeCollection* medias,
                                                                         gpointer self);
static void music_music_view_wrapper_finalize (GObject * obj);
static GType music_music_view_wrapper_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
music_music_view_wrapper_get_instance_private (MusicMusicViewWrapper* self)
{
	return G_STRUCT_MEMBER_P (self, MusicMusicViewWrapper_private_offset);
}

MusicMusicViewWrapper*
music_music_view_wrapper_construct (GType object_type,
                                    MusicTreeViewSetup* tvs,
                                    MusicLibrary* library,
                                    MusicTopDisplay* top_display)
{
	MusicMusicViewWrapper * self = NULL;
	g_return_val_if_fail (library != NULL, NULL);
	g_return_val_if_fail (top_display != NULL, NULL);
	self = (MusicMusicViewWrapper*) music_view_wrapper_construct (object_type, MUSIC_VIEW_WRAPPER_HINT_MUSIC, library);
	music_music_view_wrapper_build_async (self, tvs, top_display, NULL, NULL);
	return self;
}

MusicMusicViewWrapper*
music_music_view_wrapper_new (MusicTreeViewSetup* tvs,
                              MusicLibrary* library,
                              MusicTopDisplay* top_display)
{
	return music_music_view_wrapper_construct (MUSIC_TYPE_MUSIC_VIEW_WRAPPER, tvs, library, top_display);
}

static void
music_music_view_wrapper_build_async_data_free (gpointer _data)
{
	MusicMusicViewWrapperBuildAsyncData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->tvs);
	_g_object_unref0 (_data_->top_display);
	_g_object_unref0 (_data_->self);
	g_slice_free (MusicMusicViewWrapperBuildAsyncData, _data_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
music_music_view_wrapper_build_async (MusicMusicViewWrapper* self,
                                      MusicTreeViewSetup* tvs,
                                      MusicTopDisplay* top_display,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_)
{
	MusicMusicViewWrapperBuildAsyncData* _data_;
	MusicMusicViewWrapper* _tmp0_;
	MusicTreeViewSetup* _tmp1_;
	MusicTopDisplay* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (top_display != NULL);
	_data_ = g_slice_new0 (MusicMusicViewWrapperBuildAsyncData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, music_music_view_wrapper_build_async_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = _g_object_ref0 (tvs);
	_g_object_unref0 (_data_->tvs);
	_data_->tvs = _tmp1_;
	_tmp2_ = _g_object_ref0 (top_display);
	_g_object_unref0 (_data_->top_display);
	_data_->top_display = _tmp2_;
	music_music_view_wrapper_build_async_co (_data_);
}

static void
music_music_view_wrapper_build_finish (MusicMusicViewWrapper* self,
                                       GAsyncResult* _res_)
{
	MusicMusicViewWrapperBuildAsyncData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static gboolean
_music_music_view_wrapper_build_async_co_gsource_func (gpointer self)
{
	gboolean result;
	result = music_music_view_wrapper_build_async_co (self);
	return result;
}

static void
_music_music_view_wrapper_welcome_screen_activated_granite_widgets_welcome_activated (GraniteWidgetsWelcome* _sender,
                                                                                      gint index,
                                                                                      gpointer self)
{
	music_music_view_wrapper_welcome_screen_activated ((MusicMusicViewWrapper*) self, index);
}

static void
__lambda161_ (MusicMusicViewWrapper* self,
              GdkDragContext* ctx,
              gint x,
              gint y,
              GtkSelectionData* sel,
              guint info,
              guint time)
{
	GeeTreeSet* files = NULL;
	GeeTreeSet* _tmp0_;
	MusicLibraryWindow* _tmp17_;
	MusicLibraryWindow* _tmp18_;
	MusicLocalLibrary* _tmp19_;
	MusicLocalLibrary* _tmp20_;
	GeeTreeSet* _tmp21_;
	g_return_if_fail (ctx != NULL);
	g_return_if_fail (sel != NULL);
	_tmp0_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
	files = _tmp0_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				gchar** _tmp3_;
				gchar** _tmp4_;
				gchar** _tmp5_;
				gint _tmp5__length1;
				gboolean _tmp6_;
				GFile* f = NULL;
				gchar** _tmp7_;
				gchar** _tmp8_;
				gchar** _tmp9_;
				gint _tmp9__length1;
				const gchar* _tmp10_;
				GFile* _tmp11_;
				GFile* _tmp12_;
				gchar* path = NULL;
				GFile* _tmp13_;
				gchar* _tmp14_;
				GeeTreeSet* _tmp15_;
				const gchar* _tmp16_;
				if (!_tmp1_) {
					gint _tmp2_;
					_tmp2_ = i;
					i = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				_tmp4_ = _tmp3_ = gtk_selection_data_get_uris (sel);
				_tmp5_ = _tmp4_;
				_tmp5__length1 = _vala_array_length (_tmp3_);
				_tmp6_ = !(i < _vala_array_length (_tmp3_));
				_tmp5_ = (_vala_array_free (_tmp5_, _tmp5__length1, (GDestroyNotify) g_free), NULL);
				if (_tmp6_) {
					break;
				}
				_tmp8_ = _tmp7_ = gtk_selection_data_get_uris (sel);
				_tmp9_ = _tmp8_;
				_tmp9__length1 = _vala_array_length (_tmp7_);
				_tmp10_ = _tmp9_[i];
				_tmp11_ = g_file_new_for_uri (_tmp10_);
				_tmp12_ = _tmp11_;
				_tmp9_ = (_vala_array_free (_tmp9_, _tmp9__length1, (GDestroyNotify) g_free), NULL);
				f = _tmp12_;
				_tmp13_ = f;
				_tmp14_ = g_file_get_uri (_tmp13_);
				path = _tmp14_;
				_tmp15_ = files;
				_tmp16_ = path;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, _tmp16_);
				_g_free0 (path);
				_g_object_unref0 (f);
			}
		}
	}
	_tmp17_ = music_app_get_main_window ();
	_tmp18_ = _tmp17_;
	_tmp19_ = music_library_window_get_library_manager (_tmp18_);
	_tmp20_ = _tmp19_;
	_tmp21_ = files;
	music_library_add_files_to_library ((MusicLibrary*) _tmp20_, (GeeCollection*) _tmp21_);
	_g_object_unref0 (files);
}

static void
___lambda161__gtk_widget_drag_data_received (GtkWidget* _sender,
                                             GdkDragContext* context,
                                             gint x,
                                             gint y,
                                             GtkSelectionData* selection_data,
                                             guint info,
                                             guint time_,
                                             gpointer self)
{
	__lambda161_ ((MusicMusicViewWrapper*) self, context, x, y, selection_data, info, time_);
}

static void
music_music_view_wrapper_build_async_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_)
{
	MusicMusicViewWrapperBuildAsyncData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	music_music_view_wrapper_build_async_co (_data_);
}

static gboolean
music_music_view_wrapper_build_async_co (MusicMusicViewWrapperBuildAsyncData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	g_idle_add_full (MUSIC_VIEW_WRAPPER_VIEW_CONSTRUCT_PRIORITY, _music_music_view_wrapper_build_async_co_gsource_func, _data_, NULL);
	_data_->_state_ = 1;
	return FALSE;
	_state_1:
	;
	_data_->_tmp0_ = music_albums_view_new ((MusicViewWrapper*) _data_->self);
	g_object_ref_sink (_data_->_tmp0_);
	_data_->_tmp1_ = _data_->_tmp0_;
	music_view_wrapper_set_grid_view ((MusicViewWrapper*) _data_->self, _data_->_tmp1_);
	_g_object_unref0 (_data_->_tmp1_);
	if (_data_->tvs == NULL) {
		_data_->_tmp2_ = music_tree_view_setup_new (MUSIC_VIEW_WRAPPER_HINT_MUSIC, NULL, NULL);
		_g_object_unref0 (_data_->music_setup);
		_data_->music_setup = _data_->_tmp2_;
	} else {
		_data_->_tmp3_ = _g_object_ref0 (_data_->tvs);
		_g_object_unref0 (_data_->music_setup);
		_data_->music_setup = _data_->_tmp3_;
	}
	_data_->_tmp4_ = _data_->music_setup;
	_data_->_tmp5_ = music_list_view_new ((MusicViewWrapper*) _data_->self, _data_->_tmp4_, TRUE);
	g_object_ref_sink (_data_->_tmp5_);
	_data_->_tmp6_ = _data_->_tmp5_;
	music_view_wrapper_set_list_view ((MusicViewWrapper*) _data_->self, _data_->_tmp6_);
	_g_object_unref0 (_data_->_tmp6_);
	_data_->_tmp7_ = music_view_wrapper_get_list_view ((MusicViewWrapper*) _data_->self);
	_data_->_tmp8_ = _data_->_tmp7_;
	_data_->_tmp9_ = music_list_view_get_list_view (_data_->_tmp8_);
	_data_->_tmp10_ = _data_->_tmp9_;
	music_top_display_set_list_view (_data_->top_display, _data_->_tmp10_);
	_data_->_tmp11_ = granite_widgets_welcome_new (_ ("Get Some Tunes"), _ ("Add music to your library."));
	g_object_ref_sink (_data_->_tmp11_);
	_data_->_tmp12_ = _data_->_tmp11_;
	music_view_wrapper_set_welcome_screen ((MusicViewWrapper*) _data_->self, _data_->_tmp12_);
	_g_object_unref0 (_data_->_tmp12_);
	_data_->_tmp13_ = music_view_wrapper_get_welcome_screen ((MusicViewWrapper*) _data_->self);
	_data_->_tmp14_ = _data_->_tmp13_;
	granite_widgets_welcome_append (_data_->_tmp14_, "document-import", _ ("Import Music"), _ ("Import music from a source into your library."));
	_data_->_tmp15_ = music_view_wrapper_get_welcome_screen ((MusicViewWrapper*) _data_->self);
	_data_->_tmp16_ = _data_->_tmp15_;
	granite_widgets_welcome_append (_data_->_tmp16_, "folder-music", _ ("Change Music Folder"), _ ("Load music from a folder, a network or an external disk."));
	_data_->_tmp17_ = music_view_wrapper_get_welcome_screen ((MusicViewWrapper*) _data_->self);
	_data_->_tmp18_ = _data_->_tmp17_;
	g_signal_connect_object (_data_->_tmp18_, "activated", (GCallback) _music_music_view_wrapper_welcome_screen_activated_granite_widgets_welcome_activated, _data_->self, 0);
	_data_->_tmp19_ = gee_hash_map_new (MUSIC_TYPE_DEVICE, NULL, NULL, G_TYPE_INT, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (_data_->self->priv->_devices);
	_data_->self->priv->_devices = _data_->_tmp19_;
	_data_->_tmp20_ = granite_widgets_alert_view_new ("", "", "");
	g_object_ref_sink (_data_->_tmp20_);
	_data_->_tmp21_ = _data_->_tmp20_;
	music_view_wrapper_set_embedded_alert ((MusicViewWrapper*) _data_->self, _data_->_tmp21_);
	_g_object_unref0 (_data_->_tmp21_);
	memset (&_data_->_tmp22_, 0, sizeof (GtkTargetEntry));
	_data_->_tmp22_.target = "text/uri-list";
	_data_->_tmp22_.flags = (guint) 0;
	_data_->_tmp22_.info = (guint) 0;
	_data_->uris = _data_->_tmp22_;
	_data_->_tmp23_ = music_view_wrapper_get_welcome_screen ((MusicViewWrapper*) _data_->self);
	_data_->_tmp24_ = _data_->_tmp23_;
	_data_->_tmp25_ = _data_->uris;
	_data_->_tmp26_ = g_new0 (GtkTargetEntry, 1);
	_data_->_tmp26_[0] = _data_->_tmp25_;
	_data_->_tmp27_ = _data_->_tmp26_;
	_data_->_tmp27__length1 = 1;
	gtk_drag_dest_set ((GtkWidget*) _data_->_tmp24_, GTK_DEST_DEFAULT_ALL, _data_->_tmp27_, (gint) 1, GDK_ACTION_COPY);
	_data_->_tmp27_ = (g_free (_data_->_tmp27_), NULL);
	_data_->_tmp28_ = music_view_wrapper_get_welcome_screen ((MusicViewWrapper*) _data_->self);
	_data_->_tmp29_ = _data_->_tmp28_;
	g_signal_connect_object ((GtkWidget*) _data_->_tmp29_, "drag-data-received", (GCallback) ___lambda161__gtk_widget_drag_data_received, _data_->self, 0);
	music_view_wrapper_pack_views ((MusicViewWrapper*) _data_->self);
	music_music_view_wrapper_connect_data_signals (_data_->self);
	_data_->_tmp30_ = music_view_wrapper_get_library ((MusicViewWrapper*) _data_->self);
	_data_->_tmp31_ = _data_->_tmp30_;
	_data_->_tmp32_ = music_library_get_medias (_data_->_tmp31_);
	_data_->_tmp33_ = _data_->_tmp32_;
	_data_->_state_ = 2;
	music_view_wrapper_set_media_async ((MusicViewWrapper*) _data_->self, _data_->_tmp33_, music_music_view_wrapper_build_async_ready, _data_);
	return FALSE;
	_state_2:
	music_view_wrapper_set_media_finish ((MusicViewWrapper*) _data_->self, _data_->_res_);
	_g_object_unref0 (_data_->_tmp33_);
	_g_object_unref0 (_data_->music_setup);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
_music_music_view_wrapper_on_device_added_music_device_manager_device_added (MusicDeviceManager* _sender,
                                                                             MusicDevice* d,
                                                                             gpointer self)
{
	music_music_view_wrapper_on_device_added ((MusicMusicViewWrapper*) self, d);
}

static void
_music_music_view_wrapper_on_device_removed_music_device_manager_device_removed (MusicDeviceManager* _sender,
                                                                                 MusicDevice* d,
                                                                                 gpointer self)
{
	music_music_view_wrapper_on_device_removed ((MusicMusicViewWrapper*) self, d);
}

static void
_music_music_view_wrapper_on_device_name_changed_music_device_manager_device_name_changed (MusicDeviceManager* _sender,
                                                                                           MusicDevice* d,
                                                                                           gpointer self)
{
	music_music_view_wrapper_on_device_name_changed ((MusicMusicViewWrapper*) self, d);
}

static void
_music_view_wrapper_add_media_async_music_library_media_added (MusicLibrary* _sender,
                                                               GeeCollection* medias,
                                                               gpointer self)
{
	music_view_wrapper_add_media_async ((MusicViewWrapper*) self, medias, NULL, NULL);
}

static void
_music_view_wrapper_remove_media_async_music_library_media_removed (MusicLibrary* _sender,
                                                                    GeeCollection* medias,
                                                                    gpointer self)
{
	music_view_wrapper_remove_media_async ((MusicViewWrapper*) self, medias, NULL, NULL);
}

static void
_music_view_wrapper_update_media_async_music_library_media_updated (MusicLibrary* _sender,
                                                                    GeeCollection* medias,
                                                                    gpointer self)
{
	music_view_wrapper_update_media_async ((MusicViewWrapper*) self, medias, NULL, NULL);
}

static void
music_music_view_wrapper_connect_data_signals (MusicMusicViewWrapper* self)
{
	MusicLibrary* _tmp0_;
	MusicLibrary* _tmp1_;
	MusicLibrariesManager* _tmp2_;
	MusicLibrary* _tmp3_;
	MusicLibrary* _tmp8_;
	MusicLibrary* _tmp9_;
	MusicLibrary* _tmp10_;
	MusicLibrary* _tmp11_;
	MusicLibrary* _tmp12_;
	MusicLibrary* _tmp13_;
	g_return_if_fail (self != NULL);
	_tmp0_ = music_view_wrapper_get_library ((MusicViewWrapper*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = music_libraries_manager;
	_tmp3_ = _tmp2_->local_library;
	if (_tmp1_ == _tmp3_) {
		MusicDeviceManager* device_manager = NULL;
		MusicDeviceManager* _tmp4_;
		MusicDeviceManager* _tmp5_;
		MusicDeviceManager* _tmp6_;
		MusicDeviceManager* _tmp7_;
		_tmp4_ = music_device_manager_get_default ();
		device_manager = _tmp4_;
		_tmp5_ = device_manager;
		g_signal_connect_object (_tmp5_, "device-added", (GCallback) _music_music_view_wrapper_on_device_added_music_device_manager_device_added, self, 0);
		_tmp6_ = device_manager;
		g_signal_connect_object (_tmp6_, "device-removed", (GCallback) _music_music_view_wrapper_on_device_removed_music_device_manager_device_removed, self, 0);
		_tmp7_ = device_manager;
		g_signal_connect_object (_tmp7_, "device-name-changed", (GCallback) _music_music_view_wrapper_on_device_name_changed_music_device_manager_device_name_changed, self, 0);
		_g_object_unref0 (device_manager);
	}
	_tmp8_ = music_view_wrapper_get_library ((MusicViewWrapper*) self);
	_tmp9_ = _tmp8_;
	g_signal_connect_object (_tmp9_, "media-added", (GCallback) _music_view_wrapper_add_media_async_music_library_media_added, (MusicViewWrapper*) self, 0);
	_tmp10_ = music_view_wrapper_get_library ((MusicViewWrapper*) self);
	_tmp11_ = _tmp10_;
	g_signal_connect_object (_tmp11_, "media-removed", (GCallback) _music_view_wrapper_remove_media_async_music_library_media_removed, (MusicViewWrapper*) self, 0);
	_tmp12_ = music_view_wrapper_get_library ((MusicViewWrapper*) self);
	_tmp13_ = _tmp12_;
	g_signal_connect_object (_tmp13_, "media-updated", (GCallback) _music_view_wrapper_update_media_async_music_library_media_updated, (MusicViewWrapper*) self, 0);
}

static void
music_music_view_wrapper_on_device_added (MusicMusicViewWrapper* self,
                                          MusicDevice* d)
{
	gint id = 0;
	GraniteWidgetsWelcome* _tmp0_;
	GraniteWidgetsWelcome* _tmp1_;
	GIcon* _tmp2_;
	GIcon* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gint _tmp10_;
	GeeHashMap* _tmp11_;
	GraniteWidgetsWelcome* _tmp12_;
	GraniteWidgetsWelcome* _tmp13_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (d != NULL);
	_tmp0_ = music_view_wrapper_get_welcome_screen ((MusicViewWrapper*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = music_device_get_icon (d);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_icon_to_string (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = music_device_get_display_name (d);
	_tmp7_ = _tmp6_;
	_tmp8_ = g_strdup_printf (_ ("Import all your Music from %s into your library."), _tmp7_);
	_tmp9_ = _tmp8_;
	_tmp10_ = granite_widgets_welcome_append (_tmp1_, _tmp5_, _ ("Import your Music"), _tmp9_);
	_g_free0 (_tmp9_);
	_g_free0 (_tmp7_);
	_g_free0 (_tmp5_);
	_g_object_unref0 (_tmp3_);
	id = _tmp10_;
	_tmp11_ = self->priv->_devices;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp11_, d, (gpointer) ((gintptr) id));
	_tmp12_ = music_view_wrapper_get_welcome_screen ((MusicViewWrapper*) self);
	_tmp13_ = _tmp12_;
	gtk_widget_show_all ((GtkWidget*) _tmp13_);
}

static void
music_music_view_wrapper_on_device_removed (MusicMusicViewWrapper* self,
                                            MusicDevice* d)
{
	gint id = 0;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	GeeHashMap* _tmp6_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (d != NULL);
	_tmp0_ = self->priv->_devices;
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, d);
	id = (gint) ((gintptr) _tmp1_);
	if (id > 0) {
		GraniteWidgetsWelcome* _tmp2_;
		GraniteWidgetsWelcome* _tmp3_;
		GeeHashMap* _tmp4_;
		gpointer _tmp5_;
		_tmp2_ = music_view_wrapper_get_welcome_screen ((MusicViewWrapper*) self);
		_tmp3_ = _tmp2_;
		_tmp4_ = self->priv->_devices;
		_tmp5_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp4_, d);
		granite_widgets_welcome_remove_item (_tmp3_, (guint) ((gint) ((gintptr) _tmp5_)));
	}
	_tmp6_ = self->priv->_devices;
	gee_abstract_map_unset ((GeeAbstractMap*) _tmp6_, d, (gpointer) ((gintptr) NULL));
}

static void
music_music_view_wrapper_on_device_name_changed (MusicMusicViewWrapper* self,
                                                 MusicDevice* d)
{
	GraniteWidgetsWelcome* _tmp0_;
	GraniteWidgetsWelcome* _tmp1_;
	GeeHashMap* _tmp2_;
	gpointer _tmp3_;
	GeeHashMap* _tmp4_;
	gint id = 0;
	GraniteWidgetsWelcome* _tmp5_;
	GraniteWidgetsWelcome* _tmp6_;
	GIcon* _tmp7_;
	GIcon* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gint _tmp15_;
	GeeHashMap* _tmp16_;
	GraniteWidgetsWelcome* _tmp17_;
	GraniteWidgetsWelcome* _tmp18_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (d != NULL);
	_tmp0_ = music_view_wrapper_get_welcome_screen ((MusicViewWrapper*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = self->priv->_devices;
	_tmp3_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp2_, d);
	granite_widgets_welcome_remove_item (_tmp1_, (guint) ((gint) ((gintptr) _tmp3_)));
	_tmp4_ = self->priv->_devices;
	gee_abstract_map_unset ((GeeAbstractMap*) _tmp4_, d, (gpointer) ((gintptr) NULL));
	_tmp5_ = music_view_wrapper_get_welcome_screen ((MusicViewWrapper*) self);
	_tmp6_ = _tmp5_;
	_tmp7_ = music_device_get_icon (d);
	_tmp8_ = _tmp7_;
	_tmp9_ = g_icon_to_string (_tmp8_);
	_tmp10_ = _tmp9_;
	_tmp11_ = music_device_get_display_name (d);
	_tmp12_ = _tmp11_;
	_tmp13_ = g_strdup_printf (_ ("Import all your Music from %s into your library."), _tmp12_);
	_tmp14_ = _tmp13_;
	_tmp15_ = granite_widgets_welcome_append (_tmp6_, _tmp10_, _ ("Import your Music"), _tmp14_);
	_g_free0 (_tmp14_);
	_g_free0 (_tmp12_);
	_g_free0 (_tmp10_);
	_g_object_unref0 (_tmp8_);
	id = _tmp15_;
	_tmp16_ = self->priv->_devices;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp16_, d, (gpointer) ((gintptr) id));
	_tmp17_ = music_view_wrapper_get_welcome_screen ((MusicViewWrapper*) self);
	_tmp18_ = _tmp17_;
	gtk_widget_show_all ((GtkWidget*) _tmp18_);
}

static void
music_music_view_wrapper_welcome_screen_activated (MusicMusicViewWrapper* self,
                                                   gint index)
{
	g_return_if_fail (self != NULL);
	if (index == 0) {
		MusicLibraryWindow* _tmp0_;
		MusicLibraryWindow* _tmp1_;
		_tmp0_ = music_app_get_main_window ();
		_tmp1_ = _tmp0_;
		music_library_window_action_import (_tmp1_);
	} else {
		if (index == 1) {
			MusicLibrary* _tmp2_;
			MusicLibrary* _tmp3_;
			_tmp2_ = music_view_wrapper_get_library ((MusicViewWrapper*) self);
			_tmp3_ = _tmp2_;
			if (!music_library_doing_file_operations (_tmp3_)) {
				GtkFileChooserNative* file_chooser = NULL;
				MusicLibraryWindow* _tmp4_;
				MusicLibraryWindow* _tmp5_;
				GtkFileChooserNative* _tmp6_;
				GtkFileChooserNative* _tmp7_;
				GtkFileChooserNative* _tmp8_;
				GtkFileChooserNative* _tmp9_;
				MusicSettingsMain* _tmp10_;
				MusicSettingsMain* _tmp11_;
				const gchar* _tmp12_;
				const gchar* _tmp13_;
				gchar* folder = NULL;
				GtkFileChooserNative* _tmp14_;
				GtkFileChooserNative* _tmp17_;
				const gchar* _tmp18_;
				_tmp4_ = music_app_get_main_window ();
				_tmp5_ = _tmp4_;
				_tmp6_ = gtk_file_chooser_native_new (_ ("Select Music Folder"), (GtkWindow*) _tmp5_, GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER, _ ("Open"), _ ("Cancel"));
				file_chooser = _tmp6_;
				_tmp7_ = file_chooser;
				gtk_file_chooser_set_local_only ((GtkFileChooser*) _tmp7_, TRUE);
				_tmp8_ = file_chooser;
				gtk_file_chooser_set_select_multiple ((GtkFileChooser*) _tmp8_, FALSE);
				_tmp9_ = file_chooser;
				_tmp10_ = music_settings_main_get_default ();
				_tmp11_ = _tmp10_;
				_tmp12_ = music_settings_main_get_music_folder (_tmp11_);
				_tmp13_ = _tmp12_;
				gtk_file_chooser_set_current_folder ((GtkFileChooser*) _tmp9_, _tmp13_);
				_g_object_unref0 (_tmp11_);
				folder = NULL;
				_tmp14_ = file_chooser;
				if (gtk_native_dialog_run ((GtkNativeDialog*) _tmp14_) == ((gint) GTK_RESPONSE_ACCEPT)) {
					GtkFileChooserNative* _tmp15_;
					gchar* _tmp16_;
					_tmp15_ = file_chooser;
					_tmp16_ = gtk_file_chooser_get_filename ((GtkFileChooser*) _tmp15_);
					_g_free0 (folder);
					folder = _tmp16_;
				}
				_tmp17_ = file_chooser;
				gtk_native_dialog_destroy ((GtkNativeDialog*) _tmp17_);
				_tmp18_ = folder;
				if (!music_string_is_empty (_tmp18_, TRUE)) {
					MusicLibraryWindow* _tmp19_;
					MusicLibraryWindow* _tmp20_;
					const gchar* _tmp21_;
					_tmp19_ = music_app_get_main_window ();
					_tmp20_ = _tmp19_;
					_tmp21_ = folder;
					music_library_window_set_music_folder (_tmp20_, _tmp21_);
				}
				_g_free0 (folder);
				_g_object_unref0 (file_chooser);
			}
		} else {
			{
				GeeIterator* _device_entry_it = NULL;
				GeeHashMap* _tmp22_;
				GeeSet* _tmp23_;
				GeeSet* _tmp24_;
				GeeSet* _tmp25_;
				GeeIterator* _tmp26_;
				GeeIterator* _tmp27_;
				_tmp22_ = self->priv->_devices;
				_tmp23_ = gee_abstract_map_get_entries ((GeeAbstractMap*) _tmp22_);
				_tmp24_ = _tmp23_;
				_tmp25_ = _tmp24_;
				_tmp26_ = gee_iterable_iterator ((GeeIterable*) _tmp25_);
				_tmp27_ = _tmp26_;
				_g_object_unref0 (_tmp25_);
				_device_entry_it = _tmp27_;
				while (TRUE) {
					GeeIterator* _tmp28_;
					GeeMapEntry* device_entry = NULL;
					GeeIterator* _tmp29_;
					gpointer _tmp30_;
					GeeMapEntry* _tmp31_;
					gconstpointer _tmp32_;
					gconstpointer _tmp33_;
					_tmp28_ = _device_entry_it;
					if (!gee_iterator_next (_tmp28_)) {
						break;
					}
					_tmp29_ = _device_entry_it;
					_tmp30_ = gee_iterator_get (_tmp29_);
					device_entry = (GeeMapEntry*) _tmp30_;
					_tmp31_ = device_entry;
					_tmp32_ = gee_map_entry_get_value (_tmp31_);
					_tmp33_ = _tmp32_;
					if (((gint) ((gintptr) _tmp33_)) == index) {
						MusicLibrariesManager* _tmp34_;
						GeeMapEntry* _tmp35_;
						gconstpointer _tmp36_;
						gconstpointer _tmp37_;
						MusicLibrary* _tmp38_;
						MusicLibrary* _tmp39_;
						GeeCollection* _tmp40_;
						GeeCollection* _tmp41_;
						_tmp34_ = music_libraries_manager;
						_tmp35_ = device_entry;
						_tmp36_ = gee_map_entry_get_key (_tmp35_);
						_tmp37_ = _tmp36_;
						_tmp38_ = music_device_get_library (G_TYPE_CHECK_INSTANCE_CAST ((MusicDevice*) _tmp37_, MUSIC_TYPE_DEVICE, MusicDevice));
						_tmp39_ = _tmp38_;
						_tmp40_ = music_library_get_medias (_tmp39_);
						_tmp41_ = _tmp40_;
						music_libraries_manager_transfer_to_local_library (_tmp34_, _tmp41_);
						_g_object_unref0 (_tmp41_);
						_g_object_unref0 (_tmp39_);
					}
					_g_object_unref0 (device_entry);
				}
				_g_object_unref0 (_device_entry_it);
			}
		}
	}
}

static void
music_music_view_wrapper_class_init (MusicMusicViewWrapperClass * klass,
                                     gpointer klass_data)
{
	music_music_view_wrapper_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicMusicViewWrapper_private_offset);
	G_OBJECT_CLASS (klass)->finalize = music_music_view_wrapper_finalize;
}

static void
music_music_view_wrapper_instance_init (MusicMusicViewWrapper * self,
                                        gpointer klass)
{
	self->priv = music_music_view_wrapper_get_instance_private (self);
}

static void
music_music_view_wrapper_finalize (GObject * obj)
{
	MusicMusicViewWrapper * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_MUSIC_VIEW_WRAPPER, MusicMusicViewWrapper);
	_g_object_unref0 (self->priv->_devices);
	G_OBJECT_CLASS (music_music_view_wrapper_parent_class)->finalize (obj);
}

static GType
music_music_view_wrapper_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicMusicViewWrapperClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_music_view_wrapper_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicMusicViewWrapper), 0, (GInstanceInitFunc) music_music_view_wrapper_instance_init, NULL };
	GType music_music_view_wrapper_type_id;
	music_music_view_wrapper_type_id = g_type_register_static (MUSIC_TYPE_VIEW_WRAPPER, "MusicMusicViewWrapper", &g_define_type_info, 0);
	MusicMusicViewWrapper_private_offset = g_type_add_instance_private (music_music_view_wrapper_type_id, sizeof (MusicMusicViewWrapperPrivate));
	return music_music_view_wrapper_type_id;
}

GType
music_music_view_wrapper_get_type (void)
{
	static volatile gsize music_music_view_wrapper_type_id__once = 0;
	if (g_once_init_enter (&music_music_view_wrapper_type_id__once)) {
		GType music_music_view_wrapper_type_id;
		music_music_view_wrapper_type_id = music_music_view_wrapper_get_type_once ();
		g_once_init_leave (&music_music_view_wrapper_type_id__once, music_music_view_wrapper_type_id);
	}
	return music_music_view_wrapper_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

