/* MediaMenu.c generated by valac 0.56.1, the Vala compiler
 * generated from MediaMenu.vala, do not modify */

/*
 * Copyright (c) 2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 */

#include "music-lib.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include "io.elementary.music-core.h"
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <granite.h>
#include <gdk/gdk.h>

enum  {
	MUSIC_MEDIA_MENU_0_PROPERTY,
	MUSIC_MEDIA_MENU_HINT_PROPERTY,
	MUSIC_MEDIA_MENU_GENERIC_LIST_PROPERTY,
	MUSIC_MEDIA_MENU_NUM_PROPERTIES
};
static GParamSpec* music_media_menu_properties[MUSIC_MEDIA_MENU_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block28Data Block28Data;
typedef struct _Block29Data Block29Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block30Data Block30Data;
typedef struct _Block31Data Block31Data;

struct _MusicMediaMenuPrivate {
	MusicViewWrapperHint _hint;
	MusicGenericList* _generic_list;
	GtkMenuItem* add_to_playlist;
	GtkMenuItem* contractor_entry;
	GtkMenuItem* edit_media;
	GtkMenuItem* import_to_library;
	GtkMenuItem* queue_media;
	MusicRatingMenuItem* rate_media;
	GtkMenuItem* remove_media;
};

struct _Block28Data {
	int _ref_count_;
	MusicMediaMenu* self;
	GeeCollection* selection;
};

struct _Block29Data {
	int _ref_count_;
	Block28Data * _data28_;
	MusicStaticPlaylist* playlist;
};

struct _Block30Data {
	int _ref_count_;
	MusicMediaMenu* self;
	GeeCollection* selected_media;
};

struct _Block31Data {
	int _ref_count_;
	MusicMediaMenu* self;
	GtkMenuItem* scroll_to_current;
};

static gint MusicMediaMenu_private_offset;
static gpointer music_media_menu_parent_class = NULL;

static Block28Data* block28_data_ref (Block28Data* _data28_);
static void block28_data_unref (void * _userdata_);
static void music_media_menu_media_menu_new_playlist_clicked (MusicMediaMenu* self);
static void _music_media_menu_media_menu_new_playlist_clicked_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                               gpointer self);
static Block29Data* block29_data_ref (Block29Data* _data29_);
static void block29_data_unref (void * _userdata_);
static void ____lambda43_ (Block29Data* _data29_);
static void _____lambda43__gtk_menu_item_activate (GtkMenuItem* _sender,
                                            gpointer self);
static void music_media_menu_edit_media_clicked (MusicMediaMenu* self);
static void music_media_menu_file_browse_clicked (MusicMediaMenu* self);
static void music_media_menu_import_to_library_clicked (MusicMediaMenu* self);
static void music_media_menu_queue_clicked (MusicMediaMenu* self);
static void music_media_menu_rate_media_clicked (MusicMediaMenu* self);
static void music_media_menu_remove_media_clicked (MusicMediaMenu* self);
static Block30Data* block30_data_ref (Block30Data* _data30_);
static void block30_data_unref (void * _userdata_);
static void ___lambda53_ (Block30Data* _data30_,
                   gboolean delete_files);
static void ____lambda53__music_remove_files_dialog_remove_media (MusicRemoveFilesDialog* _sender,
                                                           gboolean response,
                                                           gpointer self);
static GObject * music_media_menu_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties);
static Block31Data* block31_data_ref (Block31Data* _data31_);
static void block31_data_unref (void * _userdata_);
static void _music_media_menu___lambda60_ (MusicMediaMenu* self);
static void __music_media_menu___lambda60__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                            gpointer self);
static void _music_media_menu___lambda61_ (Block31Data* _data31_);
static void __music_media_menu___lambda61__music_playback_manager_playback_stopped (MusicPlaybackManager* _sender,
                                                                             gint64 was_playing,
                                                                             gpointer self);
static void _music_media_menu___lambda62_ (Block31Data* _data31_);
static void __music_media_menu___lambda62__music_playback_manager_playback_started (MusicPlaybackManager* _sender,
                                                                             gpointer self);
static void _music_media_menu_edit_media_clicked_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                  gpointer self);
static void _music_media_menu_file_browse_clicked_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                   gpointer self);
static void _music_media_menu_import_to_library_clicked_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                         gpointer self);
static void _music_media_menu_queue_clicked_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                             gpointer self);
static void _music_media_menu_rate_media_clicked_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                  gpointer self);
static void _music_media_menu_remove_media_clicked_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                    gpointer self);
static void music_media_menu_finalize (GObject * obj);
static GType music_media_menu_get_type_once (void);
static void _vala_music_media_menu_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_music_media_menu_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
music_media_menu_get_instance_private (MusicMediaMenu* self)
{
	return G_STRUCT_MEMBER_P (self, MusicMediaMenu_private_offset);
}

MusicMediaMenu*
music_media_menu_construct (GType object_type,
                            MusicGenericList* generic_list)
{
	MusicMediaMenu * self = NULL;
	MusicViewWrapperHint _tmp0_;
	MusicViewWrapperHint _tmp1_;
	g_return_val_if_fail (generic_list != NULL, NULL);
	_tmp0_ = music_generic_list_get_hint (generic_list);
	_tmp1_ = _tmp0_;
	self = (MusicMediaMenu*) g_object_new (object_type, "generic-list", generic_list, "hint", _tmp1_, NULL);
	return self;
}

MusicMediaMenu*
music_media_menu_new (MusicGenericList* generic_list)
{
	return music_media_menu_construct (MUSIC_TYPE_MEDIA_MENU, generic_list);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static Block28Data*
block28_data_ref (Block28Data* _data28_)
{
	g_atomic_int_inc (&_data28_->_ref_count_);
	return _data28_;
}

static void
block28_data_unref (void * _userdata_)
{
	Block28Data* _data28_;
	_data28_ = (Block28Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data28_->_ref_count_)) {
		MusicMediaMenu* self;
		self = _data28_->self;
		_g_object_unref0 (_data28_->selection);
		_g_object_unref0 (self);
		g_slice_free (Block28Data, _data28_);
	}
}

static void
_music_media_menu_media_menu_new_playlist_clicked_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                          gpointer self)
{
	music_media_menu_media_menu_new_playlist_clicked ((MusicMediaMenu*) self);
}

static Block29Data*
block29_data_ref (Block29Data* _data29_)
{
	g_atomic_int_inc (&_data29_->_ref_count_);
	return _data29_;
}

static void
block29_data_unref (void * _userdata_)
{
	Block29Data* _data29_;
	_data29_ = (Block29Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data29_->_ref_count_)) {
		MusicMediaMenu* self;
		self = _data29_->_data28_->self;
		_g_object_unref0 (_data29_->playlist);
		block28_data_unref (_data29_->_data28_);
		_data29_->_data28_ = NULL;
		g_slice_free (Block29Data, _data29_);
	}
}

static void
____lambda43_ (Block29Data* _data29_)
{
	Block28Data* _data28_;
	MusicMediaMenu* self;
	MusicStaticPlaylist* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp3_;
	_data28_ = _data29_->_data28_;
	self = _data28_->self;
	_tmp0_ = _data29_->playlist;
	_tmp1_ = gee_collection_get_read_only_view (_data28_->selection);
	_tmp2_ = _tmp1_;
	_tmp3_ = _tmp2_;
	music_playlist_add_medias ((MusicPlaylist*) _tmp0_, _tmp3_);
	_g_object_unref0 (_tmp3_);
}

static void
_____lambda43__gtk_menu_item_activate (GtkMenuItem* _sender,
                                       gpointer self)
{
	____lambda43_ (self);
}

void
music_media_menu_popup_media_menu (MusicMediaMenu* self,
                                   GeeCollection* selection)
{
	Block28Data* _data28_;
	GeeCollection* _tmp0_;
	GtkMenuItem* media_menu_new_playlist = NULL;
	GtkMenuItem* _tmp1_;
	GtkMenuItem* _tmp2_;
	GtkMenu* add_to_playlist_menu = NULL;
	GtkMenu* _tmp3_;
	GtkMenu* _tmp4_;
	GtkMenuItem* _tmp5_;
	GtkMenuItem* _tmp6_;
	MusicGenericList* _tmp7_;
	MusicViewWrapper* _tmp8_;
	MusicViewWrapper* _tmp9_;
	MusicLibrary* _tmp10_;
	MusicLibrary* _tmp11_;
	GtkMenu* _tmp39_;
	GtkMenuItem* _tmp40_;
	GtkMenu* _tmp41_;
	gint temporary_count = 0;
	gint total_count = 0;
	gint set_rating = 0;
	MusicRatingMenuItem* _tmp69_;
	GtkMenu* contractor_sub_menu = NULL;
	GtkMenu* _tmp70_;
	GtkMenuItem* _tmp71_;
	GtkMenu* _tmp72_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (selection != NULL);
	_data28_ = g_slice_new0 (Block28Data);
	_data28_->_ref_count_ = 1;
	_data28_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (selection);
	_g_object_unref0 (_data28_->selection);
	_data28_->selection = _tmp0_;
	_tmp1_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("New Playlist…"));
	g_object_ref_sink (_tmp1_);
	media_menu_new_playlist = _tmp1_;
	_tmp2_ = media_menu_new_playlist;
	g_signal_connect_object (_tmp2_, "activate", (GCallback) _music_media_menu_media_menu_new_playlist_clicked_gtk_menu_item_activate, self, 0);
	_tmp3_ = (GtkMenu*) gtk_menu_new ();
	g_object_ref_sink (_tmp3_);
	add_to_playlist_menu = _tmp3_;
	_tmp4_ = add_to_playlist_menu;
	_tmp5_ = media_menu_new_playlist;
	gtk_menu_shell_append ((GtkMenuShell*) _tmp4_, _tmp5_);
	_tmp6_ = media_menu_new_playlist;
	_tmp7_ = self->priv->_generic_list;
	_tmp8_ = music_generic_list_get_parent_wrapper (_tmp7_);
	_tmp9_ = _tmp8_;
	_tmp10_ = music_view_wrapper_get_library (_tmp9_);
	_tmp11_ = _tmp10_;
	gtk_widget_set_visible ((GtkWidget*) _tmp6_, music_library_support_playlists (_tmp11_));
	{
		GeeIterator* _playlist_it = NULL;
		MusicGenericList* _tmp12_;
		MusicViewWrapper* _tmp13_;
		MusicViewWrapper* _tmp14_;
		MusicLibrary* _tmp15_;
		MusicLibrary* _tmp16_;
		GeeCollection* _tmp17_;
		GeeCollection* _tmp18_;
		GeeIterator* _tmp19_;
		GeeIterator* _tmp20_;
		_tmp12_ = self->priv->_generic_list;
		_tmp13_ = music_generic_list_get_parent_wrapper (_tmp12_);
		_tmp14_ = _tmp13_;
		_tmp15_ = music_view_wrapper_get_library (_tmp14_);
		_tmp16_ = _tmp15_;
		_tmp17_ = music_library_get_playlists (_tmp16_);
		_tmp18_ = _tmp17_;
		_tmp19_ = gee_iterable_iterator ((GeeIterable*) _tmp18_);
		_tmp20_ = _tmp19_;
		_g_object_unref0 (_tmp18_);
		_playlist_it = _tmp20_;
		while (TRUE) {
			Block29Data* _data29_;
			GeeIterator* _tmp21_;
			GeeIterator* _tmp22_;
			gpointer _tmp23_;
			gboolean _tmp24_ = FALSE;
			MusicStaticPlaylist* _tmp25_;
			MusicGenericList* _tmp26_;
			MusicPlaylist* _tmp27_;
			MusicPlaylist* _tmp28_;
			GtkMenuItem* playlist_item = NULL;
			MusicStaticPlaylist* _tmp32_;
			const gchar* _tmp33_;
			const gchar* _tmp34_;
			GtkMenuItem* _tmp35_;
			GtkMenu* _tmp36_;
			GtkMenuItem* _tmp37_;
			GtkMenuItem* _tmp38_;
			_data29_ = g_slice_new0 (Block29Data);
			_data29_->_ref_count_ = 1;
			_data29_->_data28_ = block28_data_ref (_data28_);
			_tmp21_ = _playlist_it;
			if (!gee_iterator_next (_tmp21_)) {
				block29_data_unref (_data29_);
				_data29_ = NULL;
				break;
			}
			_tmp22_ = _playlist_it;
			_tmp23_ = gee_iterator_get (_tmp22_);
			_data29_->playlist = (MusicStaticPlaylist*) _tmp23_;
			_tmp25_ = _data29_->playlist;
			_tmp26_ = self->priv->_generic_list;
			_tmp27_ = music_generic_list_get_playlist (_tmp26_);
			_tmp28_ = _tmp27_;
			if (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, MUSIC_TYPE_PLAYLIST, MusicPlaylist) == _tmp28_) {
				_tmp24_ = TRUE;
			} else {
				MusicStaticPlaylist* _tmp29_;
				gboolean _tmp30_;
				gboolean _tmp31_;
				_tmp29_ = _data29_->playlist;
				_tmp30_ = music_static_playlist_get_read_only (_tmp29_);
				_tmp31_ = _tmp30_;
				_tmp24_ = _tmp31_ == TRUE;
			}
			if (_tmp24_) {
				block29_data_unref (_data29_);
				_data29_ = NULL;
				continue;
			}
			_tmp32_ = _data29_->playlist;
			_tmp33_ = music_playlist_get_name ((MusicPlaylist*) _tmp32_);
			_tmp34_ = _tmp33_;
			_tmp35_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_tmp34_);
			g_object_ref_sink (_tmp35_);
			playlist_item = _tmp35_;
			_tmp36_ = add_to_playlist_menu;
			_tmp37_ = playlist_item;
			gtk_menu_shell_append ((GtkMenuShell*) _tmp36_, _tmp37_);
			_tmp38_ = playlist_item;
			g_signal_connect_data (_tmp38_, "activate", (GCallback) _____lambda43__gtk_menu_item_activate, block29_data_ref (_data29_), (GClosureNotify) block29_data_unref, 0);
			_g_object_unref0 (playlist_item);
			block29_data_unref (_data29_);
			_data29_ = NULL;
		}
		_g_object_unref0 (_playlist_it);
	}
	_tmp39_ = add_to_playlist_menu;
	gtk_widget_show_all ((GtkWidget*) _tmp39_);
	_tmp40_ = self->priv->add_to_playlist;
	_tmp41_ = add_to_playlist_menu;
	gtk_menu_item_set_submenu (_tmp40_, _tmp41_);
	temporary_count = 0;
	total_count = 0;
	{
		GeeIterator* _m_it = NULL;
		GeeIterator* _tmp42_;
		_tmp42_ = gee_iterable_iterator ((GeeIterable*) _data28_->selection);
		_m_it = _tmp42_;
		while (TRUE) {
			GeeIterator* _tmp43_;
			MusicMedia* m = NULL;
			GeeIterator* _tmp44_;
			gpointer _tmp45_;
			MusicMedia* _tmp46_;
			gboolean _tmp47_;
			gboolean _tmp48_;
			gint _tmp50_;
			_tmp43_ = _m_it;
			if (!gee_iterator_next (_tmp43_)) {
				break;
			}
			_tmp44_ = _m_it;
			_tmp45_ = gee_iterator_get (_tmp44_);
			m = (MusicMedia*) _tmp45_;
			_tmp46_ = m;
			_tmp47_ = music_media_get_is_temporary (_tmp46_);
			_tmp48_ = _tmp47_;
			if (_tmp48_) {
				gint _tmp49_;
				_tmp49_ = temporary_count;
				temporary_count = _tmp49_ + 1;
			}
			_tmp50_ = total_count;
			total_count = _tmp50_ + 1;
			_g_object_unref0 (m);
		}
		_g_object_unref0 (_m_it);
	}
	if (temporary_count < 1) {
		GtkMenuItem* _tmp51_;
		_tmp51_ = self->priv->import_to_library;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp51_, FALSE);
	} else {
		GtkMenuItem* _tmp52_;
		_tmp52_ = self->priv->import_to_library;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp52_, TRUE);
		if (temporary_count != total_count) {
			GtkMenuItem* _tmp53_;
			gchar* _tmp54_;
			gchar* _tmp55_;
			_tmp53_ = self->priv->import_to_library;
			_tmp54_ = g_strdup_printf (_ ("Import %i of %i selected songs"), (gint) temporary_count, (gint) total_count);
			_tmp55_ = _tmp54_;
			gtk_menu_item_set_label (_tmp53_, _tmp55_);
			_g_free0 (_tmp55_);
		} else {
			GtkMenuItem* _tmp56_;
			gchar* _tmp57_;
			gchar* _tmp58_;
			_tmp56_ = self->priv->import_to_library;
			_tmp57_ = g_strdup_printf (ngettext ("Import %i song", "Import %i songs", (gulong) temporary_count), (gint) temporary_count);
			_tmp58_ = _tmp57_;
			gtk_menu_item_set_label (_tmp56_, _tmp58_);
			_g_free0 (_tmp58_);
		}
	}
	set_rating = -1;
	{
		GeeIterator* _m_it = NULL;
		GeeIterator* _tmp59_;
		_tmp59_ = gee_iterable_iterator ((GeeIterable*) _data28_->selection);
		_m_it = _tmp59_;
		while (TRUE) {
			GeeIterator* _tmp60_;
			MusicMedia* m = NULL;
			GeeIterator* _tmp61_;
			gpointer _tmp62_;
			_tmp60_ = _m_it;
			if (!gee_iterator_next (_tmp60_)) {
				break;
			}
			_tmp61_ = _m_it;
			_tmp62_ = gee_iterator_get (_tmp61_);
			m = (MusicMedia*) _tmp62_;
			if (set_rating == -1) {
				MusicMedia* _tmp63_;
				guint _tmp64_;
				guint _tmp65_;
				_tmp63_ = m;
				_tmp64_ = music_media_get_rating (_tmp63_);
				_tmp65_ = _tmp64_;
				set_rating = (gint) _tmp65_;
			} else {
				MusicMedia* _tmp66_;
				guint _tmp67_;
				guint _tmp68_;
				_tmp66_ = m;
				_tmp67_ = music_media_get_rating (_tmp66_);
				_tmp68_ = _tmp67_;
				if (((guint) set_rating) != _tmp68_) {
					set_rating = 0;
					_g_object_unref0 (m);
					break;
				}
			}
			_g_object_unref0 (m);
		}
		_g_object_unref0 (_m_it);
	}
	_tmp69_ = self->priv->rate_media;
	music_rating_menu_item_set_rating_value (_tmp69_, set_rating);
	_tmp70_ = (GtkMenu*) gtk_menu_new ();
	g_object_ref_sink (_tmp70_);
	contractor_sub_menu = _tmp70_;
	_tmp71_ = self->priv->contractor_entry;
	_tmp72_ = contractor_sub_menu;
	gtk_menu_item_set_submenu (_tmp71_, _tmp72_);
	{
		GeeHashSet* files = NULL;
		GeeHashSet* _tmp73_;
		gint _tmp74_;
		gint _tmp75_;
		GeeList* contracts = NULL;
		GeeHashSet* _tmp104_;
		gint _tmp105_ = 0;
		gpointer* _tmp106_;
		GFile** _tmp107_;
		gint _tmp107__length1;
		GeeList* _tmp108_;
		GeeList* _tmp109_;
		GtkMenuItem* _tmp122_;
		GtkMenu* _tmp123_;
		GList* _tmp124_;
		GList* _tmp125_;
		GtkMenu* _tmp126_;
		_tmp73_ = gee_hash_set_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
		files = _tmp73_;
		_tmp74_ = gee_collection_get_size (_data28_->selection);
		_tmp75_ = _tmp74_;
		g_debug ("MediaMenu.vala:217: Number of selected medias obtained by MusicListVie" \
"w class: %u\n", (guint) _tmp75_);
		{
			GeeIterator* _media_it = NULL;
			GeeIterator* _tmp76_;
			_tmp76_ = gee_iterable_iterator ((GeeIterable*) _data28_->selection);
			_media_it = _tmp76_;
			while (TRUE) {
				GeeIterator* _tmp77_;
				MusicMedia* media = NULL;
				GeeIterator* _tmp78_;
				gpointer _tmp79_;
				MusicMedia* _tmp80_;
				GFile* _tmp81_;
				GFile* _tmp82_;
				_tmp77_ = _media_it;
				if (!gee_iterator_next (_tmp77_)) {
					break;
				}
				_tmp78_ = _media_it;
				_tmp79_ = gee_iterator_get (_tmp78_);
				media = (MusicMedia*) _tmp79_;
				_tmp80_ = media;
				_tmp81_ = music_media_get_file (_tmp80_);
				_tmp82_ = _tmp81_;
				if (g_file_query_exists (_tmp82_, NULL)) {
					GeeHashSet* _tmp83_;
					MusicMedia* _tmp84_;
					GFile* _tmp85_;
					GFile* _tmp86_;
					gboolean _tmp87_ = FALSE;
					MusicMedia* _tmp88_;
					gboolean _tmp89_;
					gboolean _tmp90_;
					_tmp83_ = files;
					_tmp84_ = media;
					_tmp85_ = music_media_get_file (_tmp84_);
					_tmp86_ = _tmp85_;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp83_, _tmp86_);
					_tmp88_ = media;
					_tmp89_ = music_media_get_location_unknown (_tmp88_);
					_tmp90_ = _tmp89_;
					if (_tmp90_) {
						MusicMedia* _tmp91_;
						GIcon* _tmp92_;
						GIcon* _tmp93_;
						_tmp91_ = media;
						_tmp92_ = music_media_get_unique_status_image (_tmp91_);
						_tmp93_ = _tmp92_;
						_tmp87_ = _tmp93_ != NULL;
					} else {
						_tmp87_ = FALSE;
					}
					if (_tmp87_) {
						MusicMedia* _tmp94_;
						MusicMedia* _tmp95_;
						_tmp94_ = media;
						music_media_set_unique_status_image (_tmp94_, NULL);
						_tmp95_ = media;
						music_media_set_location_unknown (_tmp95_, FALSE);
					}
				} else {
					MusicMedia* _tmp96_;
					gchar* _tmp97_;
					gchar* _tmp98_;
					gchar* _tmp99_;
					MusicMedia* _tmp100_;
					GThemedIcon* _tmp101_;
					GThemedIcon* _tmp102_;
					MusicMedia* _tmp103_;
					_tmp96_ = media;
					_tmp97_ = music_media_get_uri (_tmp96_);
					_tmp98_ = _tmp97_;
					_tmp99_ = _tmp98_;
					g_warning ("MediaMenu.vala:227: File %s does not exist, ignoring it", _tmp99_);
					_g_free0 (_tmp99_);
					_tmp100_ = media;
					_tmp101_ = (GThemedIcon*) g_themed_icon_new ("process-error-symbolic");
					_tmp102_ = _tmp101_;
					music_media_set_unique_status_image (_tmp100_, (GIcon*) _tmp102_);
					_g_object_unref0 (_tmp102_);
					_tmp103_ = media;
					music_media_set_location_unknown (_tmp103_, TRUE);
				}
				_g_object_unref0 (media);
			}
			_g_object_unref0 (_media_it);
		}
		_tmp104_ = files;
		_tmp106_ = gee_collection_to_array ((GeeCollection*) _tmp104_, &_tmp105_);
		_tmp107_ = _tmp106_;
		_tmp107__length1 = _tmp105_;
		_tmp108_ = granite_services_contractor_proxy_get_contracts_for_files (_tmp107_, (gint) _tmp105_, &_inner_error0_);
		_tmp109_ = _tmp108_;
		_tmp107_ = (_vala_array_free (_tmp107_, _tmp107__length1, (GDestroyNotify) g_object_unref), NULL);
		contracts = _tmp109_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (files);
			goto __catch0_g_error;
		}
		{
			GeeList* _contract_list = NULL;
			GeeList* _tmp110_;
			gint _contract_size = 0;
			GeeList* _tmp111_;
			gint _tmp112_;
			gint _tmp113_;
			gint _contract_index = 0;
			_tmp110_ = contracts;
			_contract_list = _tmp110_;
			_tmp111_ = _contract_list;
			_tmp112_ = gee_collection_get_size ((GeeCollection*) _tmp111_);
			_tmp113_ = _tmp112_;
			_contract_size = _tmp113_;
			_contract_index = -1;
			while (TRUE) {
				gint _tmp114_;
				gint _tmp115_;
				GraniteServicesContract* contract = NULL;
				GeeList* _tmp116_;
				gpointer _tmp117_;
				MusicContractMenuItem* menu_item = NULL;
				GraniteServicesContract* _tmp118_;
				MusicContractMenuItem* _tmp119_;
				GtkMenu* _tmp120_;
				MusicContractMenuItem* _tmp121_;
				_contract_index = _contract_index + 1;
				_tmp114_ = _contract_index;
				_tmp115_ = _contract_size;
				if (!(_tmp114_ < _tmp115_)) {
					break;
				}
				_tmp116_ = _contract_list;
				_tmp117_ = gee_list_get (_tmp116_, _contract_index);
				contract = (GraniteServicesContract*) _tmp117_;
				_tmp118_ = contract;
				_tmp119_ = music_contract_menu_item_new (_tmp118_, _data28_->selection);
				g_object_ref_sink (_tmp119_);
				menu_item = _tmp119_;
				_tmp120_ = contractor_sub_menu;
				_tmp121_ = menu_item;
				gtk_menu_shell_append ((GtkMenuShell*) _tmp120_, (GtkMenuItem*) _tmp121_);
				_g_object_unref0 (menu_item);
				_g_object_unref0 (contract);
			}
		}
		_tmp122_ = self->priv->contractor_entry;
		_tmp123_ = contractor_sub_menu;
		_tmp124_ = gtk_container_get_children ((GtkContainer*) _tmp123_);
		_tmp125_ = _tmp124_;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp122_, g_list_length (_tmp125_) > ((guint) 0));
		(_tmp125_ == NULL) ? NULL : (_tmp125_ = (g_list_free (_tmp125_), NULL));
		_tmp126_ = contractor_sub_menu;
		gtk_widget_show_all ((GtkWidget*) _tmp126_);
		_g_object_unref0 (contracts);
		_g_object_unref0 (files);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp127_;
		const gchar* _tmp128_;
		GtkMenuItem* _tmp129_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp127_ = err;
		_tmp128_ = _tmp127_->message;
		g_warning ("MediaMenu.vala:243: Failed to obtain Contractor actions: %s", _tmp128_);
		_tmp129_ = self->priv->contractor_entry;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp129_, FALSE);
		_g_error_free0 (err);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (contractor_sub_menu);
		_g_object_unref0 (add_to_playlist_menu);
		_g_object_unref0 (media_menu_new_playlist);
		block28_data_unref (_data28_);
		_data28_ = NULL;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	gtk_menu_popup_at_pointer ((GtkMenu*) self, NULL);
	_g_object_unref0 (contractor_sub_menu);
	_g_object_unref0 (add_to_playlist_menu);
	_g_object_unref0 (media_menu_new_playlist);
	block28_data_unref (_data28_);
	_data28_ = NULL;
}

static void
music_media_menu_edit_media_clicked (MusicMediaMenu* self)
{
	GeeTreeSet* to_edit_med = NULL;
	GeeTreeSet* _tmp0_;
	GeeTreeSet* _tmp1_;
	MusicGenericList* _tmp2_;
	GeeCollection* _tmp3_;
	GeeCollection* _tmp4_;
	GeeTreeSet* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	MusicMedia* first_media = NULL;
	GeeTreeSet* _tmp8_;
	gpointer _tmp9_;
	gchar* music_folder_uri = NULL;
	MusicSettingsMain* _tmp10_;
	MusicSettingsMain* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	GFile* _tmp14_;
	GFile* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_ = FALSE;
	GeeTreeSet* _tmp20_;
	gint _tmp21_;
	gint _tmp22_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	to_edit_med = _tmp0_;
	_tmp1_ = to_edit_med;
	_tmp2_ = self->priv->_generic_list;
	_tmp3_ = music_generic_list_get_selected_medias (_tmp2_);
	_tmp4_ = _tmp3_;
	gee_collection_add_all ((GeeCollection*) _tmp1_, _tmp4_);
	_g_object_unref0 (_tmp4_);
	_tmp5_ = to_edit_med;
	_tmp6_ = gee_collection_get_is_empty ((GeeCollection*) _tmp5_);
	_tmp7_ = _tmp6_;
	if (_tmp7_) {
		_g_object_unref0 (to_edit_med);
		return;
	}
	_tmp8_ = to_edit_med;
	_tmp9_ = gee_abstract_sorted_set_first ((GeeAbstractSortedSet*) _tmp8_);
	first_media = (MusicMedia*) _tmp9_;
	_tmp10_ = music_settings_main_get_default ();
	_tmp11_ = _tmp10_;
	_tmp12_ = music_settings_main_get_music_folder (_tmp11_);
	_tmp13_ = _tmp12_;
	_tmp14_ = g_file_new_for_path (_tmp13_);
	_tmp15_ = _tmp14_;
	_tmp16_ = g_file_get_uri (_tmp15_);
	_tmp17_ = _tmp16_;
	_g_object_unref0 (_tmp15_);
	_g_object_unref0 (_tmp11_);
	music_folder_uri = _tmp17_;
	_tmp20_ = to_edit_med;
	_tmp21_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp20_);
	_tmp22_ = _tmp21_;
	if (_tmp22_ == 1) {
		MusicMedia* _tmp23_;
		GFile* _tmp24_;
		GFile* _tmp25_;
		_tmp23_ = first_media;
		_tmp24_ = music_media_get_file (_tmp23_);
		_tmp25_ = _tmp24_;
		_tmp19_ = !g_file_query_exists (_tmp25_, NULL);
	} else {
		_tmp19_ = FALSE;
	}
	if (_tmp19_) {
		MusicMedia* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		const gchar* _tmp30_;
		_tmp26_ = first_media;
		_tmp27_ = music_media_get_uri (_tmp26_);
		_tmp28_ = _tmp27_;
		_tmp29_ = _tmp28_;
		_tmp30_ = music_folder_uri;
		_tmp18_ = g_str_has_prefix (_tmp29_, _tmp30_);
		_g_free0 (_tmp29_);
	} else {
		_tmp18_ = FALSE;
	}
	if (_tmp18_) {
		MusicMedia* _tmp31_;
		GThemedIcon* _tmp32_;
		GThemedIcon* _tmp33_;
		MusicFileNotFoundDialog* fnfd = NULL;
		GeeTreeSet* _tmp34_;
		MusicFileNotFoundDialog* _tmp35_;
		MusicFileNotFoundDialog* _tmp36_;
		_tmp31_ = first_media;
		_tmp32_ = (GThemedIcon*) g_themed_icon_new ("process-error-symbolic");
		_tmp33_ = _tmp32_;
		music_media_set_unique_status_image (_tmp31_, (GIcon*) _tmp33_);
		_g_object_unref0 (_tmp33_);
		_tmp34_ = to_edit_med;
		_tmp35_ = music_file_not_found_dialog_new ((GeeCollection*) _tmp34_);
		g_object_ref_sink (_tmp35_);
		fnfd = _tmp35_;
		_tmp36_ = fnfd;
		gtk_window_present ((GtkWindow*) _tmp36_);
		_g_object_unref0 (fnfd);
	} else {
		MusicMediaEditor* media_editor = NULL;
		GeeTreeSet* _tmp37_;
		MusicMediaEditor* _tmp38_;
		MusicMediaEditor* _tmp39_;
		_tmp37_ = to_edit_med;
		_tmp38_ = music_media_editor_new (_tmp37_);
		g_object_ref_sink (_tmp38_);
		media_editor = _tmp38_;
		_tmp39_ = media_editor;
		gtk_widget_show_all ((GtkWidget*) _tmp39_);
		_g_object_unref0 (media_editor);
	}
	_g_free0 (music_folder_uri);
	_g_object_unref0 (first_media);
	_g_object_unref0 (to_edit_med);
}

static void
music_media_menu_file_browse_clicked (MusicMediaMenu* self)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	{
		GeeIterator* _media_it = NULL;
		MusicGenericList* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
		_tmp0_ = self->priv->_generic_list;
		_tmp1_ = music_generic_list_get_selected_medias (_tmp0_);
		_tmp2_ = _tmp1_;
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
		_tmp4_ = _tmp3_;
		_g_object_unref0 (_tmp2_);
		_media_it = _tmp4_;
		while (TRUE) {
			GeeIterator* _tmp5_;
			MusicMedia* media = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			_tmp5_ = _media_it;
			if (!gee_iterator_next (_tmp5_)) {
				break;
			}
			_tmp6_ = _media_it;
			_tmp7_ = gee_iterator_get (_tmp6_);
			media = (MusicMedia*) _tmp7_;
			{
				GtkWindow* main_window = NULL;
				GApplication* _tmp8_;
				GtkWindow* _tmp9_;
				GtkWindow* _tmp10_;
				GFile* _tmp11_;
				GFile* _tmp12_;
				GFile* _tmp13_;
				GFile* _tmp14_;
				gchar* _tmp15_;
				gchar* _tmp16_;
				_tmp8_ = g_application_get_default ();
				_tmp9_ = gtk_application_get_active_window (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_application_get_type (), GtkApplication));
				_tmp10_ = _g_object_ref0 (_tmp9_);
				main_window = _tmp10_;
				_tmp11_ = music_media_get_file (media);
				_tmp12_ = _tmp11_;
				_tmp13_ = g_file_get_parent (_tmp12_);
				_tmp14_ = _tmp13_;
				_tmp15_ = g_file_get_uri (_tmp14_);
				_tmp16_ = _tmp15_;
				gtk_show_uri_on_window (main_window, _tmp16_, (guint32) GDK_CURRENT_TIME, &_inner_error0_);
				_g_free0 (_tmp16_);
				_g_object_unref0 (_tmp14_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					_g_object_unref0 (main_window);
					goto __catch0_g_error;
				}
				_g_object_unref0 (main_window);
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* err = NULL;
				gchar* _tmp17_;
				gchar* _tmp18_;
				gchar* _tmp19_;
				GError* _tmp20_;
				const gchar* _tmp21_;
				err = _inner_error0_;
				_inner_error0_ = NULL;
				_tmp17_ = music_media_get_uri (media);
				_tmp18_ = _tmp17_;
				_tmp19_ = _tmp18_;
				_tmp20_ = err;
				_tmp21_ = _tmp20_->message;
				g_debug ("MediaMenu.vala:276: Could not browse media %s: %s\n", _tmp19_, _tmp21_);
				_g_free0 (_tmp19_);
				_g_error_free0 (err);
			}
			__finally0:
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (media);
				_g_object_unref0 (_media_it);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
			_g_object_unref0 (media);
			_g_object_unref0 (_media_it);
			return;
		}
		_g_object_unref0 (_media_it);
	}
}

static void
music_media_menu_import_to_library_clicked (MusicMediaMenu* self)
{
	MusicGenericList* _tmp0_;
	MusicGenericList* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp3_;
	GeeCollection* _tmp4_;
	GeeCollection* _tmp5_;
	GeeCollection* _tmp6_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_generic_list;
	_tmp1_ = self->priv->_generic_list;
	_tmp2_ = music_generic_list_get_selected_medias (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = gee_collection_get_read_only_view (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = _tmp5_;
	g_signal_emit_by_name (_tmp0_, "import-requested", _tmp6_);
	_g_object_unref0 (_tmp6_);
	_g_object_unref0 (_tmp3_);
}

static void
music_media_menu_media_menu_new_playlist_clicked (MusicMediaMenu* self)
{
	MusicStaticPlaylist* p = NULL;
	MusicStaticPlaylist* _tmp0_;
	MusicGenericList* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp3_;
	GeeCollection* _tmp4_;
	GeeCollection* _tmp5_;
	GeeCollection* _tmp6_;
	MusicGenericList* _tmp7_;
	MusicViewWrapper* _tmp8_;
	MusicViewWrapper* _tmp9_;
	MusicLibrary* _tmp10_;
	MusicLibrary* _tmp11_;
	GeeCollection* _tmp12_;
	GeeCollection* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	MusicGenericList* _tmp16_;
	MusicViewWrapper* _tmp17_;
	MusicViewWrapper* _tmp18_;
	MusicLibrary* _tmp19_;
	MusicLibrary* _tmp20_;
	g_return_if_fail (self != NULL);
	_tmp0_ = music_static_playlist_new ();
	p = _tmp0_;
	_tmp1_ = self->priv->_generic_list;
	_tmp2_ = music_generic_list_get_selected_medias (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = gee_collection_get_read_only_view (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = _tmp5_;
	music_playlist_add_medias ((MusicPlaylist*) p, _tmp6_);
	_g_object_unref0 (_tmp6_);
	_g_object_unref0 (_tmp3_);
	_tmp7_ = self->priv->_generic_list;
	_tmp8_ = music_generic_list_get_parent_wrapper (_tmp7_);
	_tmp9_ = _tmp8_;
	_tmp10_ = music_view_wrapper_get_library (_tmp9_);
	_tmp11_ = _tmp10_;
	_tmp12_ = music_library_get_playlists (_tmp11_);
	_tmp13_ = _tmp12_;
	_tmp14_ = music_playlists_utils_get_new_playlist_name (_tmp13_, NULL);
	_tmp15_ = _tmp14_;
	music_playlist_set_name ((MusicPlaylist*) p, _tmp15_);
	_g_free0 (_tmp15_);
	_g_object_unref0 (_tmp13_);
	_tmp16_ = self->priv->_generic_list;
	_tmp17_ = music_generic_list_get_parent_wrapper (_tmp16_);
	_tmp18_ = _tmp17_;
	_tmp19_ = music_view_wrapper_get_library (_tmp18_);
	_tmp20_ = _tmp19_;
	music_library_add_playlist (_tmp20_, p);
	_g_object_unref0 (p);
}

static void
music_media_menu_queue_clicked (MusicMediaMenu* self)
{
	MusicPlaybackManager* _tmp0_;
	MusicPlaybackManager* _tmp1_;
	MusicGenericList* _tmp2_;
	GeeCollection* _tmp3_;
	GeeCollection* _tmp4_;
	GeeCollection* _tmp5_;
	GeeCollection* _tmp6_;
	GeeCollection* _tmp7_;
	g_return_if_fail (self != NULL);
	_tmp0_ = music_app_get_player ();
	_tmp1_ = _tmp0_;
	_tmp2_ = self->priv->_generic_list;
	_tmp3_ = music_generic_list_get_selected_medias (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = gee_collection_get_read_only_view (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = _tmp6_;
	music_playback_manager_queue_media (_tmp1_, _tmp7_);
	_g_object_unref0 (_tmp7_);
	_g_object_unref0 (_tmp4_);
}

static void
music_media_menu_rate_media_clicked (MusicMediaMenu* self)
{
	gint new_rating = 0;
	MusicRatingMenuItem* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GeeCollection* selected = NULL;
	MusicGenericList* _tmp3_;
	GeeCollection* _tmp4_;
	GeeCollection* _tmp5_;
	GeeCollection* _tmp6_;
	GeeCollection* _tmp7_;
	GeeCollection* _tmp8_;
	MusicGenericList* _tmp15_;
	MusicViewWrapper* _tmp16_;
	MusicViewWrapper* _tmp17_;
	MusicLibrary* _tmp18_;
	MusicLibrary* _tmp19_;
	GeeCollection* _tmp20_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->rate_media;
	_tmp1_ = music_rating_menu_item_get_rating_value (_tmp0_);
	_tmp2_ = _tmp1_;
	new_rating = _tmp2_;
	_tmp3_ = self->priv->_generic_list;
	_tmp4_ = music_generic_list_get_selected_medias (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = gee_collection_get_read_only_view (_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = _tmp7_;
	_g_object_unref0 (_tmp5_);
	selected = _tmp8_;
	{
		GeeIterator* _media_it = NULL;
		GeeCollection* _tmp9_;
		GeeIterator* _tmp10_;
		_tmp9_ = selected;
		_tmp10_ = gee_iterable_iterator ((GeeIterable*) _tmp9_);
		_media_it = _tmp10_;
		while (TRUE) {
			GeeIterator* _tmp11_;
			MusicMedia* media = NULL;
			GeeIterator* _tmp12_;
			gpointer _tmp13_;
			MusicMedia* _tmp14_;
			_tmp11_ = _media_it;
			if (!gee_iterator_next (_tmp11_)) {
				break;
			}
			_tmp12_ = _media_it;
			_tmp13_ = gee_iterator_get (_tmp12_);
			media = (MusicMedia*) _tmp13_;
			_tmp14_ = media;
			music_media_set_rating (_tmp14_, (guint) new_rating);
			_g_object_unref0 (media);
		}
		_g_object_unref0 (_media_it);
	}
	_tmp15_ = self->priv->_generic_list;
	_tmp16_ = music_generic_list_get_parent_wrapper (_tmp15_);
	_tmp17_ = _tmp16_;
	_tmp18_ = music_view_wrapper_get_library (_tmp17_);
	_tmp19_ = _tmp18_;
	_tmp20_ = selected;
	music_library_update_medias (_tmp19_, _tmp20_, FALSE, TRUE);
	_g_object_unref0 (selected);
}

static Block30Data*
block30_data_ref (Block30Data* _data30_)
{
	g_atomic_int_inc (&_data30_->_ref_count_);
	return _data30_;
}

static void
block30_data_unref (void * _userdata_)
{
	Block30Data* _data30_;
	_data30_ = (Block30Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data30_->_ref_count_)) {
		MusicMediaMenu* self;
		self = _data30_->self;
		_g_object_unref0 (_data30_->selected_media);
		_g_object_unref0 (self);
		g_slice_free (Block30Data, _data30_);
	}
}

static void
___lambda53_ (Block30Data* _data30_,
              gboolean delete_files)
{
	MusicMediaMenu* self;
	MusicGenericList* _tmp0_;
	MusicViewWrapper* _tmp1_;
	MusicViewWrapper* _tmp2_;
	MusicLibrary* _tmp3_;
	MusicLibrary* _tmp4_;
	GeeCollection* _tmp5_;
	self = _data30_->self;
	_tmp0_ = self->priv->_generic_list;
	_tmp1_ = music_generic_list_get_parent_wrapper (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = music_view_wrapper_get_library (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = _data30_->selected_media;
	music_library_remove_medias (_tmp4_, _tmp5_, delete_files);
}

static void
____lambda53__music_remove_files_dialog_remove_media (MusicRemoveFilesDialog* _sender,
                                                      gboolean response,
                                                      gpointer self)
{
	___lambda53_ (self, response);
}

static void
music_media_menu_remove_media_clicked (MusicMediaMenu* self)
{
	Block30Data* _data30_;
	MusicGenericList* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp3_;
	GeeCollection* _tmp4_;
	GeeCollection* _tmp5_;
	MusicViewWrapperHint _tmp6_;
	g_return_if_fail (self != NULL);
	_data30_ = g_slice_new0 (Block30Data);
	_data30_->_ref_count_ = 1;
	_data30_->self = g_object_ref (self);
	_tmp0_ = self->priv->_generic_list;
	_tmp1_ = music_generic_list_get_selected_medias (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = gee_collection_get_read_only_view (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = _tmp4_;
	_g_object_unref0 (_tmp2_);
	_data30_->selected_media = _tmp5_;
	_tmp6_ = self->priv->_hint;
	switch (_tmp6_) {
		case MUSIC_VIEW_WRAPPER_HINT_ALBUM_LIST:
		case MUSIC_VIEW_WRAPPER_HINT_MUSIC:
		{
			MusicRemoveFilesDialog* dialog = NULL;
			GeeCollection* _tmp7_;
			MusicRemoveFilesDialog* _tmp8_;
			MusicRemoveFilesDialog* _tmp9_;
			_tmp7_ = _data30_->selected_media;
			_tmp8_ = music_remove_files_dialog_new (_tmp7_);
			g_object_ref_sink (_tmp8_);
			dialog = _tmp8_;
			_tmp9_ = dialog;
			g_signal_connect_data (_tmp9_, "remove-media", (GCallback) ____lambda53__music_remove_files_dialog_remove_media, block30_data_ref (_data30_), (GClosureNotify) block30_data_unref, 0);
			_g_object_unref0 (dialog);
			break;
		}
		case MUSIC_VIEW_WRAPPER_HINT_DEVICE_AUDIO:
		{
			MusicDeviceViewWrapper* dvw = NULL;
			MusicGenericList* _tmp10_;
			MusicViewWrapper* _tmp11_;
			MusicViewWrapper* _tmp12_;
			MusicDeviceViewWrapper* _tmp13_;
			MusicDeviceViewWrapper* _tmp14_;
			MusicLibrary* _tmp15_;
			MusicLibrary* _tmp16_;
			GeeCollection* _tmp17_;
			_tmp10_ = self->priv->_generic_list;
			_tmp11_ = music_generic_list_get_parent_wrapper (_tmp10_);
			_tmp12_ = _tmp11_;
			_tmp13_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, MUSIC_TYPE_DEVICE_VIEW_WRAPPER, MusicDeviceViewWrapper));
			dvw = _tmp13_;
			_tmp14_ = dvw;
			_tmp15_ = music_view_wrapper_get_library ((MusicViewWrapper*) _tmp14_);
			_tmp16_ = _tmp15_;
			_tmp17_ = _data30_->selected_media;
			music_library_remove_medias (_tmp16_, _tmp17_, TRUE);
			_g_object_unref0 (dvw);
			break;
		}
		case MUSIC_VIEW_WRAPPER_HINT_PLAYLIST:
		{
			MusicGenericList* _tmp18_;
			MusicPlaylist* _tmp19_;
			MusicPlaylist* _tmp20_;
			GeeCollection* _tmp21_;
			_tmp18_ = self->priv->_generic_list;
			_tmp19_ = music_generic_list_get_playlist (_tmp18_);
			_tmp20_ = _tmp19_;
			_tmp21_ = _data30_->selected_media;
			music_playlist_remove_medias (_tmp20_, _tmp21_);
			break;
		}
		case MUSIC_VIEW_WRAPPER_HINT_QUEUE:
		{
			MusicPlaybackManager* _tmp22_;
			MusicPlaybackManager* _tmp23_;
			GeeCollection* _tmp24_;
			_tmp22_ = music_app_get_player ();
			_tmp23_ = _tmp22_;
			_tmp24_ = _data30_->selected_media;
			music_playback_manager_unqueue_media (_tmp23_, _tmp24_);
			break;
		}
		default:
		break;
	}
	block30_data_unref (_data30_);
	_data30_ = NULL;
}

MusicViewWrapperHint
music_media_menu_get_hint (MusicMediaMenu* self)
{
	MusicViewWrapperHint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_hint;
	return result;
}

static void
music_media_menu_set_hint (MusicMediaMenu* self,
                           MusicViewWrapperHint value)
{
	MusicViewWrapperHint old_value;
	g_return_if_fail (self != NULL);
	old_value = music_media_menu_get_hint (self);
	if (old_value != value) {
		self->priv->_hint = value;
		g_object_notify_by_pspec ((GObject *) self, music_media_menu_properties[MUSIC_MEDIA_MENU_HINT_PROPERTY]);
	}
}

MusicGenericList*
music_media_menu_get_generic_list (MusicMediaMenu* self)
{
	MusicGenericList* result;
	MusicGenericList* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_generic_list;
	result = _tmp0_;
	return result;
}

static void
music_media_menu_set_generic_list (MusicMediaMenu* self,
                                   MusicGenericList* value)
{
	MusicGenericList* old_value;
	g_return_if_fail (self != NULL);
	old_value = music_media_menu_get_generic_list (self);
	if (old_value != value) {
		MusicGenericList* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_generic_list);
		self->priv->_generic_list = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_media_menu_properties[MUSIC_MEDIA_MENU_GENERIC_LIST_PROPERTY]);
	}
}

static Block31Data*
block31_data_ref (Block31Data* _data31_)
{
	g_atomic_int_inc (&_data31_->_ref_count_);
	return _data31_;
}

static void
block31_data_unref (void * _userdata_)
{
	Block31Data* _data31_;
	_data31_ = (Block31Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data31_->_ref_count_)) {
		MusicMediaMenu* self;
		self = _data31_->self;
		_g_object_unref0 (_data31_->scroll_to_current);
		_g_object_unref0 (self);
		g_slice_free (Block31Data, _data31_);
	}
}

static void
_music_media_menu___lambda60_ (MusicMediaMenu* self)
{
	MusicGenericList* _tmp0_;
	_tmp0_ = self->priv->_generic_list;
	music_generic_list_scroll_to_current_media (_tmp0_, TRUE);
}

static void
__music_media_menu___lambda60__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                       gpointer self)
{
	_music_media_menu___lambda60_ ((MusicMediaMenu*) self);
}

static void
_music_media_menu___lambda61_ (Block31Data* _data31_)
{
	MusicMediaMenu* self;
	GtkMenuItem* _tmp0_;
	self = _data31_->self;
	_tmp0_ = _data31_->scroll_to_current;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, FALSE);
}

static void
__music_media_menu___lambda61__music_playback_manager_playback_stopped (MusicPlaybackManager* _sender,
                                                                        gint64 was_playing,
                                                                        gpointer self)
{
	_music_media_menu___lambda61_ (self);
}

static void
_music_media_menu___lambda62_ (Block31Data* _data31_)
{
	MusicMediaMenu* self;
	GtkMenuItem* _tmp0_;
	self = _data31_->self;
	_tmp0_ = _data31_->scroll_to_current;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, TRUE);
}

static void
__music_media_menu___lambda62__music_playback_manager_playback_started (MusicPlaybackManager* _sender,
                                                                        gpointer self)
{
	_music_media_menu___lambda62_ (self);
}

static void
_music_media_menu_edit_media_clicked_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                             gpointer self)
{
	music_media_menu_edit_media_clicked ((MusicMediaMenu*) self);
}

static void
_music_media_menu_file_browse_clicked_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                              gpointer self)
{
	music_media_menu_file_browse_clicked ((MusicMediaMenu*) self);
}

static void
_music_media_menu_import_to_library_clicked_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                    gpointer self)
{
	music_media_menu_import_to_library_clicked ((MusicMediaMenu*) self);
}

static void
_music_media_menu_queue_clicked_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                        gpointer self)
{
	music_media_menu_queue_clicked ((MusicMediaMenu*) self);
}

static void
_music_media_menu_rate_media_clicked_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                             gpointer self)
{
	music_media_menu_rate_media_clicked ((MusicMediaMenu*) self);
}

static void
_music_media_menu_remove_media_clicked_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                               gpointer self)
{
	music_media_menu_remove_media_clicked ((MusicMediaMenu*) self);
}

static GObject *
music_media_menu_constructor (GType type,
                              guint n_construct_properties,
                              GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicMediaMenu * self;
	Block31Data* _data31_;
	GtkMenuItem* _tmp0_;
	GtkMenuItem* _tmp1_;
	GtkMenuItem* file_browse = NULL;
	GtkMenuItem* _tmp2_;
	GtkMenuItem* _tmp3_;
	GtkMenuItem* _tmp4_;
	MusicRatingMenuItem* _tmp5_;
	GtkMenuItem* _tmp6_;
	GtkMenuItem* _tmp7_;
	GtkMenuItem* _tmp8_;
	GtkMenuItem* _tmp9_;
	MusicViewWrapperHint _tmp10_;
	GtkMenuItem* _tmp78_;
	MusicPlaybackManager* _tmp79_;
	MusicPlaybackManager* _tmp80_;
	MusicPlaybackManager* _tmp81_;
	MusicPlaybackManager* _tmp82_;
	GtkMenuItem* _tmp83_;
	GtkMenuItem* _tmp84_;
	GtkMenuItem* _tmp85_;
	GtkMenuItem* _tmp86_;
	MusicRatingMenuItem* _tmp87_;
	GtkMenuItem* _tmp88_;
	parent_class = G_OBJECT_CLASS (music_media_menu_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_MEDIA_MENU, MusicMediaMenu);
	_data31_ = g_slice_new0 (Block31Data);
	_data31_->_ref_count_ = 1;
	_data31_->self = g_object_ref (self);
	_tmp0_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Scroll to Current Song"));
	g_object_ref_sink (_tmp0_);
	_data31_->scroll_to_current = _tmp0_;
	_tmp1_ = _data31_->scroll_to_current;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, FALSE);
	_tmp2_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Show in File Browser…"));
	g_object_ref_sink (_tmp2_);
	file_browse = _tmp2_;
	_tmp3_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Edit Song Info…"));
	g_object_ref_sink (_tmp3_);
	_g_object_unref0 (self->priv->edit_media);
	self->priv->edit_media = _tmp3_;
	_tmp4_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Other Actions"));
	g_object_ref_sink (_tmp4_);
	_g_object_unref0 (self->priv->contractor_entry);
	self->priv->contractor_entry = _tmp4_;
	_tmp5_ = music_rating_menu_item_new ();
	g_object_ref_sink (_tmp5_);
	_g_object_unref0 (self->priv->rate_media);
	self->priv->rate_media = _tmp5_;
	_tmp6_ = (GtkMenuItem*) gtk_menu_item_new_with_label (C_ ("Action item (verb)", "Queue"));
	g_object_ref_sink (_tmp6_);
	_g_object_unref0 (self->priv->queue_media);
	self->priv->queue_media = _tmp6_;
	_tmp7_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Add to Playlist"));
	g_object_ref_sink (_tmp7_);
	_g_object_unref0 (self->priv->add_to_playlist);
	self->priv->add_to_playlist = _tmp7_;
	_tmp8_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Remove Song…"));
	g_object_ref_sink (_tmp8_);
	_g_object_unref0 (self->priv->remove_media);
	self->priv->remove_media = _tmp8_;
	_tmp9_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Import to Library"));
	g_object_ref_sink (_tmp9_);
	_g_object_unref0 (self->priv->import_to_library);
	self->priv->import_to_library = _tmp9_;
	_tmp10_ = self->priv->_hint;
	switch (_tmp10_) {
		case MUSIC_VIEW_WRAPPER_HINT_ALBUM_LIST:
		{
			GtkMenuItem* _tmp11_;
			GtkMenuItem* _tmp12_;
			GtkMenuItem* _tmp13_;
			MusicRatingMenuItem* _tmp14_;
			GtkSeparatorMenuItem* _tmp15_;
			GtkSeparatorMenuItem* _tmp16_;
			GtkMenuItem* _tmp17_;
			GtkMenuItem* _tmp18_;
			GtkSeparatorMenuItem* _tmp19_;
			GtkSeparatorMenuItem* _tmp20_;
			GtkMenuItem* _tmp21_;
			GtkMenuItem* _tmp22_;
			_tmp11_ = self->priv->edit_media;
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp11_);
			_tmp12_ = file_browse;
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp12_);
			_tmp13_ = self->priv->contractor_entry;
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp13_);
			_tmp14_ = self->priv->rate_media;
			gtk_menu_shell_append ((GtkMenuShell*) self, (GtkMenuItem*) _tmp14_);
			_tmp15_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
			g_object_ref_sink (_tmp15_);
			_tmp16_ = _tmp15_;
			gtk_menu_shell_append ((GtkMenuShell*) self, (GtkMenuItem*) _tmp16_);
			_g_object_unref0 (_tmp16_);
			_tmp17_ = self->priv->queue_media;
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp17_);
			_tmp18_ = self->priv->add_to_playlist;
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp18_);
			_tmp19_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
			g_object_ref_sink (_tmp19_);
			_tmp20_ = _tmp19_;
			gtk_menu_shell_append ((GtkMenuShell*) self, (GtkMenuItem*) _tmp20_);
			_g_object_unref0 (_tmp20_);
			_tmp21_ = self->priv->remove_media;
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp21_);
			_tmp22_ = self->priv->remove_media;
			gtk_menu_item_set_label (_tmp22_, _ ("Remove from Library…"));
			break;
		}
		case MUSIC_VIEW_WRAPPER_HINT_MUSIC:
		case MUSIC_VIEW_WRAPPER_HINT_PLAYLIST:
		{
			GtkMenuItem* _tmp23_;
			GtkSeparatorMenuItem* _tmp24_;
			GtkSeparatorMenuItem* _tmp25_;
			GtkMenuItem* _tmp26_;
			GtkMenuItem* _tmp27_;
			GtkMenuItem* _tmp28_;
			MusicRatingMenuItem* _tmp29_;
			GtkSeparatorMenuItem* _tmp30_;
			GtkSeparatorMenuItem* _tmp31_;
			GtkMenuItem* _tmp32_;
			GtkMenuItem* _tmp33_;
			GtkSeparatorMenuItem* _tmp34_;
			GtkSeparatorMenuItem* _tmp35_;
			GtkMenuItem* _tmp36_;
			MusicViewWrapperHint _tmp37_;
			_tmp23_ = _data31_->scroll_to_current;
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp23_);
			_tmp24_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
			g_object_ref_sink (_tmp24_);
			_tmp25_ = _tmp24_;
			gtk_menu_shell_append ((GtkMenuShell*) self, (GtkMenuItem*) _tmp25_);
			_g_object_unref0 (_tmp25_);
			_tmp26_ = self->priv->edit_media;
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp26_);
			_tmp27_ = file_browse;
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp27_);
			_tmp28_ = self->priv->contractor_entry;
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp28_);
			_tmp29_ = self->priv->rate_media;
			gtk_menu_shell_append ((GtkMenuShell*) self, (GtkMenuItem*) _tmp29_);
			_tmp30_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
			g_object_ref_sink (_tmp30_);
			_tmp31_ = _tmp30_;
			gtk_menu_shell_append ((GtkMenuShell*) self, (GtkMenuItem*) _tmp31_);
			_g_object_unref0 (_tmp31_);
			_tmp32_ = self->priv->queue_media;
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp32_);
			_tmp33_ = self->priv->add_to_playlist;
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp33_);
			_tmp34_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
			g_object_ref_sink (_tmp34_);
			_tmp35_ = _tmp34_;
			gtk_menu_shell_append ((GtkMenuShell*) self, (GtkMenuItem*) _tmp35_);
			_g_object_unref0 (_tmp35_);
			_tmp36_ = self->priv->remove_media;
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp36_);
			_tmp37_ = self->priv->_hint;
			if (_tmp37_ == MUSIC_VIEW_WRAPPER_HINT_MUSIC) {
				GtkMenuItem* _tmp38_;
				_tmp38_ = self->priv->remove_media;
				gtk_menu_item_set_label (_tmp38_, _ ("Remove from Library…"));
			}
			break;
		}
		case MUSIC_VIEW_WRAPPER_HINT_DEVICE_AUDIO:
		{
			GtkMenuItem* _tmp39_;
			GtkSeparatorMenuItem* _tmp40_;
			GtkSeparatorMenuItem* _tmp41_;
			GtkMenuItem* _tmp42_;
			GtkMenuItem* _tmp43_;
			MusicRatingMenuItem* _tmp44_;
			GtkSeparatorMenuItem* _tmp45_;
			GtkSeparatorMenuItem* _tmp46_;
			GtkMenuItem* _tmp47_;
			GtkSeparatorMenuItem* _tmp48_;
			GtkSeparatorMenuItem* _tmp49_;
			GtkMenuItem* _tmp50_;
			GtkMenuItem* _tmp51_;
			GtkMenuItem* _tmp52_;
			_tmp39_ = _data31_->scroll_to_current;
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp39_);
			_tmp40_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
			g_object_ref_sink (_tmp40_);
			_tmp41_ = _tmp40_;
			gtk_menu_shell_append ((GtkMenuShell*) self, (GtkMenuItem*) _tmp41_);
			_g_object_unref0 (_tmp41_);
			_tmp42_ = file_browse;
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp42_);
			_tmp43_ = self->priv->contractor_entry;
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp43_);
			_tmp44_ = self->priv->rate_media;
			gtk_menu_shell_append ((GtkMenuShell*) self, (GtkMenuItem*) _tmp44_);
			_tmp45_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
			g_object_ref_sink (_tmp45_);
			_tmp46_ = _tmp45_;
			gtk_menu_shell_append ((GtkMenuShell*) self, (GtkMenuItem*) _tmp46_);
			_g_object_unref0 (_tmp46_);
			_tmp47_ = self->priv->queue_media;
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp47_);
			_tmp48_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
			g_object_ref_sink (_tmp48_);
			_tmp49_ = _tmp48_;
			gtk_menu_shell_append ((GtkMenuShell*) self, (GtkMenuItem*) _tmp49_);
			_g_object_unref0 (_tmp49_);
			_tmp50_ = self->priv->remove_media;
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp50_);
			_tmp51_ = self->priv->import_to_library;
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp51_);
			_tmp52_ = self->priv->remove_media;
			gtk_menu_item_set_label (_tmp52_, _ ("Remove from Device"));
			break;
		}
		case MUSIC_VIEW_WRAPPER_HINT_SMART_PLAYLIST:
		{
			GtkMenuItem* _tmp53_;
			GtkSeparatorMenuItem* _tmp54_;
			GtkSeparatorMenuItem* _tmp55_;
			GtkMenuItem* _tmp56_;
			GtkMenuItem* _tmp57_;
			GtkMenuItem* _tmp58_;
			MusicRatingMenuItem* _tmp59_;
			GtkSeparatorMenuItem* _tmp60_;
			GtkSeparatorMenuItem* _tmp61_;
			GtkMenuItem* _tmp62_;
			GtkMenuItem* _tmp63_;
			_tmp53_ = _data31_->scroll_to_current;
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp53_);
			_tmp54_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
			g_object_ref_sink (_tmp54_);
			_tmp55_ = _tmp54_;
			gtk_menu_shell_append ((GtkMenuShell*) self, (GtkMenuItem*) _tmp55_);
			_g_object_unref0 (_tmp55_);
			_tmp56_ = self->priv->edit_media;
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp56_);
			_tmp57_ = file_browse;
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp57_);
			_tmp58_ = self->priv->contractor_entry;
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp58_);
			_tmp59_ = self->priv->rate_media;
			gtk_menu_shell_append ((GtkMenuShell*) self, (GtkMenuItem*) _tmp59_);
			_tmp60_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
			g_object_ref_sink (_tmp60_);
			_tmp61_ = _tmp60_;
			gtk_menu_shell_append ((GtkMenuShell*) self, (GtkMenuItem*) _tmp61_);
			_g_object_unref0 (_tmp61_);
			_tmp62_ = self->priv->queue_media;
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp62_);
			_tmp63_ = self->priv->add_to_playlist;
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp63_);
			break;
		}
		case MUSIC_VIEW_WRAPPER_HINT_QUEUE:
		{
			GtkMenuItem* _tmp64_;
			GtkSeparatorMenuItem* _tmp65_;
			GtkSeparatorMenuItem* _tmp66_;
			GtkMenuItem* _tmp67_;
			GtkMenuItem* _tmp68_;
			GtkSeparatorMenuItem* _tmp69_;
			GtkSeparatorMenuItem* _tmp70_;
			GtkMenuItem* _tmp71_;
			GtkMenuItem* _tmp72_;
			_tmp64_ = _data31_->scroll_to_current;
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp64_);
			_tmp65_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
			g_object_ref_sink (_tmp65_);
			_tmp66_ = _tmp65_;
			gtk_menu_shell_append ((GtkMenuShell*) self, (GtkMenuItem*) _tmp66_);
			_g_object_unref0 (_tmp66_);
			_tmp67_ = file_browse;
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp67_);
			_tmp68_ = self->priv->contractor_entry;
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp68_);
			_tmp69_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
			g_object_ref_sink (_tmp69_);
			_tmp70_ = _tmp69_;
			gtk_menu_shell_append ((GtkMenuShell*) self, (GtkMenuItem*) _tmp70_);
			_g_object_unref0 (_tmp70_);
			_tmp71_ = self->priv->remove_media;
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp71_);
			_tmp72_ = self->priv->remove_media;
			gtk_menu_item_set_label (_tmp72_, _ ("Remove from Queue"));
			break;
		}
		default:
		case MUSIC_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST:
		{
			GtkMenuItem* _tmp73_;
			GtkSeparatorMenuItem* _tmp74_;
			GtkSeparatorMenuItem* _tmp75_;
			GtkMenuItem* _tmp76_;
			GtkMenuItem* _tmp77_;
			_tmp73_ = _data31_->scroll_to_current;
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp73_);
			_tmp74_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
			g_object_ref_sink (_tmp74_);
			_tmp75_ = _tmp74_;
			gtk_menu_shell_append ((GtkMenuShell*) self, (GtkMenuItem*) _tmp75_);
			_g_object_unref0 (_tmp75_);
			_tmp76_ = file_browse;
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp76_);
			_tmp77_ = self->priv->contractor_entry;
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp77_);
			break;
		}
	}
	gtk_widget_show_all ((GtkWidget*) self);
	_tmp78_ = _data31_->scroll_to_current;
	g_signal_connect_object (_tmp78_, "activate", (GCallback) __music_media_menu___lambda60__gtk_menu_item_activate, self, 0);
	_tmp79_ = music_app_get_player ();
	_tmp80_ = _tmp79_;
	g_signal_connect_data (_tmp80_, "playback-stopped", (GCallback) __music_media_menu___lambda61__music_playback_manager_playback_stopped, block31_data_ref (_data31_), (GClosureNotify) block31_data_unref, 0);
	_tmp81_ = music_app_get_player ();
	_tmp82_ = _tmp81_;
	g_signal_connect_data (_tmp82_, "playback-started", (GCallback) __music_media_menu___lambda62__music_playback_manager_playback_started, block31_data_ref (_data31_), (GClosureNotify) block31_data_unref, 0);
	_tmp83_ = self->priv->edit_media;
	g_signal_connect_object (_tmp83_, "activate", (GCallback) _music_media_menu_edit_media_clicked_gtk_menu_item_activate, self, 0);
	_tmp84_ = file_browse;
	g_signal_connect_object (_tmp84_, "activate", (GCallback) _music_media_menu_file_browse_clicked_gtk_menu_item_activate, self, 0);
	_tmp85_ = self->priv->import_to_library;
	g_signal_connect_object (_tmp85_, "activate", (GCallback) _music_media_menu_import_to_library_clicked_gtk_menu_item_activate, self, 0);
	_tmp86_ = self->priv->queue_media;
	g_signal_connect_object (_tmp86_, "activate", (GCallback) _music_media_menu_queue_clicked_gtk_menu_item_activate, self, 0);
	_tmp87_ = self->priv->rate_media;
	g_signal_connect_object ((GtkMenuItem*) _tmp87_, "activate", (GCallback) _music_media_menu_rate_media_clicked_gtk_menu_item_activate, self, 0);
	_tmp88_ = self->priv->remove_media;
	g_signal_connect_object (_tmp88_, "activate", (GCallback) _music_media_menu_remove_media_clicked_gtk_menu_item_activate, self, 0);
	_g_object_unref0 (file_browse);
	block31_data_unref (_data31_);
	_data31_ = NULL;
	return obj;
}

static void
music_media_menu_class_init (MusicMediaMenuClass * klass,
                             gpointer klass_data)
{
	music_media_menu_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicMediaMenu_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_music_media_menu_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_music_media_menu_set_property;
	G_OBJECT_CLASS (klass)->constructor = music_media_menu_constructor;
	G_OBJECT_CLASS (klass)->finalize = music_media_menu_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_MENU_HINT_PROPERTY, music_media_menu_properties[MUSIC_MEDIA_MENU_HINT_PROPERTY] = g_param_spec_enum ("hint", "hint", "hint", MUSIC_VIEW_WRAPPER_TYPE_HINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_MENU_GENERIC_LIST_PROPERTY, music_media_menu_properties[MUSIC_MEDIA_MENU_GENERIC_LIST_PROPERTY] = g_param_spec_object ("generic-list", "generic-list", "generic-list", MUSIC_TYPE_GENERIC_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}

static void
music_media_menu_instance_init (MusicMediaMenu * self,
                                gpointer klass)
{
	self->priv = music_media_menu_get_instance_private (self);
}

static void
music_media_menu_finalize (GObject * obj)
{
	MusicMediaMenu * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_MEDIA_MENU, MusicMediaMenu);
	_g_object_unref0 (self->priv->_generic_list);
	_g_object_unref0 (self->priv->add_to_playlist);
	_g_object_unref0 (self->priv->contractor_entry);
	_g_object_unref0 (self->priv->edit_media);
	_g_object_unref0 (self->priv->import_to_library);
	_g_object_unref0 (self->priv->queue_media);
	_g_object_unref0 (self->priv->rate_media);
	_g_object_unref0 (self->priv->remove_media);
	G_OBJECT_CLASS (music_media_menu_parent_class)->finalize (obj);
}

static GType
music_media_menu_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicMediaMenuClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_media_menu_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicMediaMenu), 0, (GInstanceInitFunc) music_media_menu_instance_init, NULL };
	GType music_media_menu_type_id;
	music_media_menu_type_id = g_type_register_static (gtk_menu_get_type (), "MusicMediaMenu", &g_define_type_info, 0);
	MusicMediaMenu_private_offset = g_type_add_instance_private (music_media_menu_type_id, sizeof (MusicMediaMenuPrivate));
	return music_media_menu_type_id;
}

GType
music_media_menu_get_type (void)
{
	static volatile gsize music_media_menu_type_id__once = 0;
	if (g_once_init_enter (&music_media_menu_type_id__once)) {
		GType music_media_menu_type_id;
		music_media_menu_type_id = music_media_menu_get_type_once ();
		g_once_init_leave (&music_media_menu_type_id__once, music_media_menu_type_id);
	}
	return music_media_menu_type_id__once;
}

static void
_vala_music_media_menu_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	MusicMediaMenu * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_MEDIA_MENU, MusicMediaMenu);
	switch (property_id) {
		case MUSIC_MEDIA_MENU_HINT_PROPERTY:
		g_value_set_enum (value, music_media_menu_get_hint (self));
		break;
		case MUSIC_MEDIA_MENU_GENERIC_LIST_PROPERTY:
		g_value_set_object (value, music_media_menu_get_generic_list (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_music_media_menu_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	MusicMediaMenu * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_MEDIA_MENU, MusicMediaMenu);
	switch (property_id) {
		case MUSIC_MEDIA_MENU_HINT_PROPERTY:
		music_media_menu_set_hint (self, g_value_get_enum (value));
		break;
		case MUSIC_MEDIA_MENU_GENERIC_LIST_PROPERTY:
		music_media_menu_set_generic_list (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

