/* SimpleOptionChooser.c generated by valac 0.56.1, the Vala compiler
 * generated from SimpleOptionChooser.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 */

#include "music-lib.h"
#include <gee.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>

enum  {
	MUSIC_SIMPLE_OPTION_CHOOSER_0_PROPERTY,
	MUSIC_SIMPLE_OPTION_CHOOSER_OPTIONS_PROPERTY,
	MUSIC_SIMPLE_OPTION_CHOOSER_CURRENT_OPTION_PROPERTY,
	MUSIC_SIMPLE_OPTION_CHOOSER_NUM_PROPERTIES
};
static GParamSpec* music_simple_option_chooser_properties[MUSIC_SIMPLE_OPTION_CHOOSER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	MUSIC_SIMPLE_OPTION_CHOOSER_OPTION_CHANGED_SIGNAL,
	MUSIC_SIMPLE_OPTION_CHOOSER_NUM_SIGNALS
};
static guint music_simple_option_chooser_signals[MUSIC_SIMPLE_OPTION_CHOOSER_NUM_SIGNALS] = {0};

struct _MusicSimpleOptionChooserPrivate {
	GeeArrayList* _options;
	gint _current_option;
};

static gint MusicSimpleOptionChooser_private_offset;
static gpointer music_simple_option_chooser_parent_class = NULL;

static void music_simple_option_chooser_set_current_option (MusicSimpleOptionChooser* self,
                                                     gint value);
static gboolean music_simple_option_chooser_real_button_press_event (GtkWidget* base,
                                                              GdkEventButton* event);
static GObject * music_simple_option_chooser_constructor (GType type,
                                                   guint n_construct_properties,
                                                   GObjectConstructParam * construct_properties);
static void music_simple_option_chooser_finalize (GObject * obj);
static GType music_simple_option_chooser_get_type_once (void);
static void _vala_music_simple_option_chooser_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec);
static void _vala_music_simple_option_chooser_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec);

static inline gpointer
music_simple_option_chooser_get_instance_private (MusicSimpleOptionChooser* self)
{
	return G_STRUCT_MEMBER_P (self, MusicSimpleOptionChooser_private_offset);
}

void
music_simple_option_chooser_set_option (MusicSimpleOptionChooser* self,
                                        gint index,
                                        gboolean by_user)
{
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GtkWidget* _tmp3_;
	GeeArrayList* _tmp5_;
	gpointer _tmp6_;
	GtkImage* _tmp7_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_options;
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (index >= _tmp2_) {
		return;
	}
	music_simple_option_chooser_set_current_option (self, index);
	g_signal_emit (self, music_simple_option_chooser_signals[MUSIC_SIMPLE_OPTION_CHOOSER_OPTION_CHANGED_SIGNAL], 0, by_user);
	_tmp3_ = gtk_bin_get_child ((GtkBin*) self);
	if (_tmp3_ != NULL) {
		GtkWidget* _tmp4_;
		_tmp4_ = gtk_bin_get_child ((GtkBin*) self);
		gtk_container_remove ((GtkContainer*) self, _tmp4_);
	}
	_tmp5_ = self->priv->_options;
	_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, index);
	_tmp7_ = (GtkImage*) _tmp6_;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp7_);
	_g_object_unref0 (_tmp7_);
	gtk_widget_show_all ((GtkWidget*) self);
}

gint
music_simple_option_chooser_append_item (MusicSimpleOptionChooser* self,
                                         const gchar* icon_name,
                                         const gchar* tooltip)
{
	GtkImage* image = NULL;
	GtkImage* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (icon_name != NULL, 0);
	g_return_val_if_fail (tooltip != NULL, 0);
	_tmp0_ = (GtkImage*) gtk_image_new_from_icon_name (icon_name, (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp0_);
	image = _tmp0_;
	gtk_widget_set_tooltip_text ((GtkWidget*) image, tooltip);
	_tmp1_ = self->priv->_options;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, image);
	_tmp2_ = self->priv->_options;
	_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
	_tmp4_ = _tmp3_;
	result = _tmp4_ - 1;
	_g_object_unref0 (image);
	return result;
}

static gboolean
music_simple_option_chooser_real_button_press_event (GtkWidget* base,
                                                     GdkEventButton* event)
{
	MusicSimpleOptionChooser * self;
	gboolean result;
	self = (MusicSimpleOptionChooser*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	if (event->type == GDK_BUTTON_PRESS) {
		gint _tmp0_ = 0;
		gint _tmp1_;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint next = 0;
		_tmp1_ = self->priv->_current_option;
		_tmp2_ = self->priv->_options;
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		if ((_tmp1_ + 1) < _tmp4_) {
			gint _tmp5_;
			_tmp5_ = self->priv->_current_option;
			_tmp0_ = _tmp5_ + 1;
		} else {
			_tmp0_ = 0;
		}
		next = _tmp0_;
		music_simple_option_chooser_set_option (self, next, TRUE);
	}
	result = TRUE;
	return result;
}

MusicSimpleOptionChooser*
music_simple_option_chooser_construct (GType object_type)
{
	MusicSimpleOptionChooser * self = NULL;
	self = (MusicSimpleOptionChooser*) g_object_new (object_type, NULL);
	return self;
}

MusicSimpleOptionChooser*
music_simple_option_chooser_new (void)
{
	return music_simple_option_chooser_construct (MUSIC_TYPE_SIMPLE_OPTION_CHOOSER);
}

GeeArrayList*
music_simple_option_chooser_get_options (MusicSimpleOptionChooser* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_options;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
music_simple_option_chooser_set_options (MusicSimpleOptionChooser* self,
                                         GeeArrayList* value)
{
	GeeArrayList* old_value;
	g_return_if_fail (self != NULL);
	old_value = music_simple_option_chooser_get_options (self);
	if (old_value != value) {
		GeeArrayList* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_options);
		self->priv->_options = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_simple_option_chooser_properties[MUSIC_SIMPLE_OPTION_CHOOSER_OPTIONS_PROPERTY]);
	}
}

gint
music_simple_option_chooser_get_current_option (MusicSimpleOptionChooser* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_current_option;
	return result;
}

static void
music_simple_option_chooser_set_current_option (MusicSimpleOptionChooser* self,
                                                gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = music_simple_option_chooser_get_current_option (self);
	if (old_value != value) {
		self->priv->_current_option = value;
		g_object_notify_by_pspec ((GObject *) self, music_simple_option_chooser_properties[MUSIC_SIMPLE_OPTION_CHOOSER_CURRENT_OPTION_PROPERTY]);
	}
}

static GObject *
music_simple_option_chooser_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicSimpleOptionChooser * self;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	parent_class = G_OBJECT_CLASS (music_simple_option_chooser_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_SIMPLE_OPTION_CHOOSER, MusicSimpleOptionChooser);
	_tmp0_ = gee_array_list_new (gtk_image_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_tmp1_ = _tmp0_;
	music_simple_option_chooser_set_options (self, _tmp1_);
	_g_object_unref0 (_tmp1_);
	music_simple_option_chooser_set_current_option (self, 0);
	return obj;
}

static void
music_simple_option_chooser_class_init (MusicSimpleOptionChooserClass * klass,
                                        gpointer klass_data)
{
	music_simple_option_chooser_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicSimpleOptionChooser_private_offset);
	((GtkWidgetClass *) klass)->button_press_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) music_simple_option_chooser_real_button_press_event;
	G_OBJECT_CLASS (klass)->get_property = _vala_music_simple_option_chooser_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_music_simple_option_chooser_set_property;
	G_OBJECT_CLASS (klass)->constructor = music_simple_option_chooser_constructor;
	G_OBJECT_CLASS (klass)->finalize = music_simple_option_chooser_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_SIMPLE_OPTION_CHOOSER_OPTIONS_PROPERTY, music_simple_option_chooser_properties[MUSIC_SIMPLE_OPTION_CHOOSER_OPTIONS_PROPERTY] = g_param_spec_object ("options", "options", "options", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_SIMPLE_OPTION_CHOOSER_CURRENT_OPTION_PROPERTY, music_simple_option_chooser_properties[MUSIC_SIMPLE_OPTION_CHOOSER_CURRENT_OPTION_PROPERTY] = g_param_spec_int ("current-option", "current-option", "current-option", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	music_simple_option_chooser_signals[MUSIC_SIMPLE_OPTION_CHOOSER_OPTION_CHANGED_SIGNAL] = g_signal_new ("option-changed", MUSIC_TYPE_SIMPLE_OPTION_CHOOSER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
}

static void
music_simple_option_chooser_instance_init (MusicSimpleOptionChooser * self,
                                           gpointer klass)
{
	self->priv = music_simple_option_chooser_get_instance_private (self);
}

static void
music_simple_option_chooser_finalize (GObject * obj)
{
	MusicSimpleOptionChooser * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_SIMPLE_OPTION_CHOOSER, MusicSimpleOptionChooser);
	_g_object_unref0 (self->priv->_options);
	G_OBJECT_CLASS (music_simple_option_chooser_parent_class)->finalize (obj);
}

static GType
music_simple_option_chooser_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicSimpleOptionChooserClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_simple_option_chooser_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicSimpleOptionChooser), 0, (GInstanceInitFunc) music_simple_option_chooser_instance_init, NULL };
	GType music_simple_option_chooser_type_id;
	music_simple_option_chooser_type_id = g_type_register_static (gtk_event_box_get_type (), "MusicSimpleOptionChooser", &g_define_type_info, 0);
	MusicSimpleOptionChooser_private_offset = g_type_add_instance_private (music_simple_option_chooser_type_id, sizeof (MusicSimpleOptionChooserPrivate));
	return music_simple_option_chooser_type_id;
}

GType
music_simple_option_chooser_get_type (void)
{
	static volatile gsize music_simple_option_chooser_type_id__once = 0;
	if (g_once_init_enter (&music_simple_option_chooser_type_id__once)) {
		GType music_simple_option_chooser_type_id;
		music_simple_option_chooser_type_id = music_simple_option_chooser_get_type_once ();
		g_once_init_leave (&music_simple_option_chooser_type_id__once, music_simple_option_chooser_type_id);
	}
	return music_simple_option_chooser_type_id__once;
}

static void
_vala_music_simple_option_chooser_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec)
{
	MusicSimpleOptionChooser * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_SIMPLE_OPTION_CHOOSER, MusicSimpleOptionChooser);
	switch (property_id) {
		case MUSIC_SIMPLE_OPTION_CHOOSER_OPTIONS_PROPERTY:
		g_value_set_object (value, music_simple_option_chooser_get_options (self));
		break;
		case MUSIC_SIMPLE_OPTION_CHOOSER_CURRENT_OPTION_PROPERTY:
		g_value_set_int (value, music_simple_option_chooser_get_current_option (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_music_simple_option_chooser_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec)
{
	MusicSimpleOptionChooser * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_SIMPLE_OPTION_CHOOSER, MusicSimpleOptionChooser);
	switch (property_id) {
		case MUSIC_SIMPLE_OPTION_CHOOSER_OPTIONS_PROPERTY:
		music_simple_option_chooser_set_options (self, g_value_get_object (value));
		break;
		case MUSIC_SIMPLE_OPTION_CHOOSER_CURRENT_OPTION_PROPERTY:
		music_simple_option_chooser_set_current_option (self, g_value_get_int (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

