/* AudioPlayer.c generated by valac 0.56.1, the Vala compiler
 * generated from AudioPlayer.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "audioplayer-device.h"
#include "io.elementary.music-core.h"
#include <glib-object.h>
#include <glib.h>
#include <libpeas/peas.h>

enum  {
	MUSIC_PLUGINS_AUDIO_PLAYER_PLUGIN_0_PROPERTY,
	MUSIC_PLUGINS_AUDIO_PLAYER_PLUGIN_OBJECT_PROPERTY,
	MUSIC_PLUGINS_AUDIO_PLAYER_PLUGIN_NUM_PROPERTIES
};
static GParamSpec* music_plugins_audio_player_plugin_properties[MUSIC_PLUGINS_AUDIO_PLAYER_PLUGIN_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _MusicPluginsAudioPlayerPluginPrivate {
	MusicPluginsInterface* plugins;
	GObject* _object;
	MusicPluginsAudioPlayerDeviceManager* audioplayer_manager;
};

static gint MusicPluginsAudioPlayerPlugin_private_offset;
static gpointer music_plugins_audio_player_plugin_parent_class = NULL;
static PeasActivatableInterface * music_plugins_audio_player_plugin_peas_activatable_parent_iface = NULL;
static GType music_plugins_audio_player_plugin_type_id = 0;

static void music_plugins_audio_player_plugin_real_activate (PeasActivatable* base);
static void __lambda11_ (MusicPluginsAudioPlayerPlugin* self);
static void ___lambda11__music_plugins_interface_hook_function (gpointer self);
static void music_plugins_audio_player_plugin_real_deactivate (PeasActivatable* base);
static void music_plugins_audio_player_plugin_real_update_state (PeasActivatable* base);
static void music_plugins_audio_player_plugin_finalize (GObject * obj);
static void _vala_music_plugins_audio_player_plugin_get_property (GObject * object,
                                                           guint property_id,
                                                           GValue * value,
                                                           GParamSpec * pspec);
static void _vala_music_plugins_audio_player_plugin_set_property (GObject * object,
                                                           guint property_id,
                                                           const GValue * value,
                                                           GParamSpec * pspec);
GType music_plugins_audio_player_device_register_type (GTypeModule * module);
GType music_plugins_audio_player_device_manager_register_type (GTypeModule * module);
GType music_plugins_audio_player_library_register_type (GTypeModule * module);

static inline gpointer
music_plugins_audio_player_plugin_get_instance_private (MusicPluginsAudioPlayerPlugin* self)
{
	return G_STRUCT_MEMBER_P (self, MusicPluginsAudioPlayerPlugin_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
__lambda11_ (MusicPluginsAudioPlayerPlugin* self)
{
	MusicPluginsAudioPlayerDeviceManager* _tmp0_;
	_tmp0_ = music_plugins_audio_player_device_manager_new ();
	_g_object_unref0 (self->priv->audioplayer_manager);
	self->priv->audioplayer_manager = _tmp0_;
}

static void
___lambda11__music_plugins_interface_hook_function (gpointer self)
{
	__lambda11_ ((MusicPluginsAudioPlayerPlugin*) self);
}

static void
music_plugins_audio_player_plugin_real_activate (PeasActivatable* base)
{
	MusicPluginsAudioPlayerPlugin * self;
	GValue value = {0};
	GValue _tmp0_ = {0};
	GObject* _tmp1_;
	MusicPluginsInterface* _tmp2_;
	MusicPluginsInterface* _tmp3_;
	self = (MusicPluginsAudioPlayerPlugin*) base;
	g_message ("AudioPlayer.vala:37: Activating AudioPlayer Device plugin");
	g_value_init (&_tmp0_, G_TYPE_OBJECT);
	value = _tmp0_;
	g_object_get_property ((GObject*) self, "object", &value);
	_tmp1_ = g_value_get_object (&value);
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, MUSIC_PLUGINS_TYPE_INTERFACE, MusicPluginsInterface));
	_g_object_unref0 (self->priv->plugins);
	self->priv->plugins = _tmp2_;
	_tmp3_ = self->priv->plugins;
	music_plugins_interface_register_function (_tmp3_, MUSIC_PLUGINS_INTERFACE_HOOK_WINDOW, ___lambda11__music_plugins_interface_hook_function, self);
	G_IS_VALUE (&value) ? (g_value_unset (&value), NULL) : NULL;
}

static void
music_plugins_audio_player_plugin_real_deactivate (PeasActivatable* base)
{
	MusicPluginsAudioPlayerPlugin * self;
	MusicPluginsAudioPlayerDeviceManager* _tmp0_;
	self = (MusicPluginsAudioPlayerPlugin*) base;
	_tmp0_ = self->priv->audioplayer_manager;
	if (_tmp0_ != NULL) {
		MusicPluginsAudioPlayerDeviceManager* _tmp1_;
		_tmp1_ = self->priv->audioplayer_manager;
		music_plugins_audio_player_device_manager_remove_all (_tmp1_);
	}
}

static void
music_plugins_audio_player_plugin_real_update_state (PeasActivatable* base)
{
	MusicPluginsAudioPlayerPlugin * self;
	self = (MusicPluginsAudioPlayerPlugin*) base;
}

MusicPluginsAudioPlayerPlugin*
music_plugins_audio_player_plugin_construct (GType object_type)
{
	MusicPluginsAudioPlayerPlugin * self = NULL;
	self = (MusicPluginsAudioPlayerPlugin*) g_object_new (object_type, NULL);
	return self;
}

MusicPluginsAudioPlayerPlugin*
music_plugins_audio_player_plugin_new (void)
{
	return music_plugins_audio_player_plugin_construct (MUSIC_PLUGINS_TYPE_AUDIO_PLAYER_PLUGIN);
}

static GObject*
music_plugins_audio_player_plugin_real_get_object (PeasActivatable* base)
{
	GObject* result;
	MusicPluginsAudioPlayerPlugin* self;
	GObject* _tmp0_;
	GObject* _tmp1_;
	self = (MusicPluginsAudioPlayerPlugin*) base;
	_tmp0_ = self->priv->_object;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	result = _tmp1_;
	return result;
}

static void
music_plugins_audio_player_plugin_real_set_object (PeasActivatable* base,
                                                   GObject* value)
{
	MusicPluginsAudioPlayerPlugin* self;
	GObject* old_value;
	self = (MusicPluginsAudioPlayerPlugin*) base;
	old_value = music_plugins_audio_player_plugin_real_get_object (base);
	if (old_value != value) {
		GObject* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_object);
		self->priv->_object = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_plugins_audio_player_plugin_properties[MUSIC_PLUGINS_AUDIO_PLAYER_PLUGIN_OBJECT_PROPERTY]);
	}
	_g_object_unref0 (old_value);
}

static void
music_plugins_audio_player_plugin_class_init (MusicPluginsAudioPlayerPluginClass * klass,
                                              gpointer klass_data)
{
	music_plugins_audio_player_plugin_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicPluginsAudioPlayerPlugin_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_music_plugins_audio_player_plugin_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_music_plugins_audio_player_plugin_set_property;
	G_OBJECT_CLASS (klass)->finalize = music_plugins_audio_player_plugin_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_PLUGINS_AUDIO_PLAYER_PLUGIN_OBJECT_PROPERTY, music_plugins_audio_player_plugin_properties[MUSIC_PLUGINS_AUDIO_PLAYER_PLUGIN_OBJECT_PROPERTY] = g_param_spec_object ("object", "object", "object", G_TYPE_OBJECT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}

static void
music_plugins_audio_player_plugin_peas_activatable_interface_init (PeasActivatableInterface * iface,
                                                                   gpointer iface_data)
{
	music_plugins_audio_player_plugin_peas_activatable_parent_iface = g_type_interface_peek_parent (iface);
	iface->activate = (void (*) (PeasActivatable*)) music_plugins_audio_player_plugin_real_activate;
	iface->deactivate = (void (*) (PeasActivatable*)) music_plugins_audio_player_plugin_real_deactivate;
	iface->update_state = (void (*) (PeasActivatable*)) music_plugins_audio_player_plugin_real_update_state;
}

static void
music_plugins_audio_player_plugin_instance_init (MusicPluginsAudioPlayerPlugin * self,
                                                 gpointer klass)
{
	self->priv = music_plugins_audio_player_plugin_get_instance_private (self);
}

static void
music_plugins_audio_player_plugin_finalize (GObject * obj)
{
	MusicPluginsAudioPlayerPlugin * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_PLUGINS_TYPE_AUDIO_PLAYER_PLUGIN, MusicPluginsAudioPlayerPlugin);
	_g_object_unref0 (self->priv->plugins);
	_g_object_unref0 (self->priv->_object);
	_g_object_unref0 (self->priv->audioplayer_manager);
	G_OBJECT_CLASS (music_plugins_audio_player_plugin_parent_class)->finalize (obj);
}

GType
music_plugins_audio_player_plugin_get_type (void)
{
	return music_plugins_audio_player_plugin_type_id;
}

GType
music_plugins_audio_player_plugin_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicPluginsAudioPlayerPluginClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_plugins_audio_player_plugin_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicPluginsAudioPlayerPlugin), 0, (GInstanceInitFunc) music_plugins_audio_player_plugin_instance_init, NULL };
	static const GInterfaceInfo peas_activatable_info = { (GInterfaceInitFunc) music_plugins_audio_player_plugin_peas_activatable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	music_plugins_audio_player_plugin_type_id = g_type_module_register_type (module, peas_extension_base_get_type (), "MusicPluginsAudioPlayerPlugin", &g_define_type_info, 0);
	g_type_module_add_interface (module, music_plugins_audio_player_plugin_type_id, peas_activatable_get_type (), &peas_activatable_info);
	MusicPluginsAudioPlayerPlugin_private_offset = sizeof (MusicPluginsAudioPlayerPluginPrivate);
	return music_plugins_audio_player_plugin_type_id;
}

static void
_vala_music_plugins_audio_player_plugin_get_property (GObject * object,
                                                      guint property_id,
                                                      GValue * value,
                                                      GParamSpec * pspec)
{
	MusicPluginsAudioPlayerPlugin * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_PLUGINS_TYPE_AUDIO_PLAYER_PLUGIN, MusicPluginsAudioPlayerPlugin);
	switch (property_id) {
		case MUSIC_PLUGINS_AUDIO_PLAYER_PLUGIN_OBJECT_PROPERTY:
		g_value_take_object (value, music_plugins_audio_player_plugin_real_get_object ((PeasActivatable*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_music_plugins_audio_player_plugin_set_property (GObject * object,
                                                      guint property_id,
                                                      const GValue * value,
                                                      GParamSpec * pspec)
{
	MusicPluginsAudioPlayerPlugin * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_PLUGINS_TYPE_AUDIO_PLAYER_PLUGIN, MusicPluginsAudioPlayerPlugin);
	switch (property_id) {
		case MUSIC_PLUGINS_AUDIO_PLAYER_PLUGIN_OBJECT_PROPERTY:
		music_plugins_audio_player_plugin_real_set_object ((PeasActivatable*) self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

void
peas_register_types (GTypeModule* module)
{
	PeasObjectModule* objmodule = NULL;
	PeasObjectModule* _tmp0_;
	g_return_if_fail (module != NULL);
	music_plugins_audio_player_plugin_register_type (module);
	music_plugins_audio_player_device_register_type (module);
	music_plugins_audio_player_device_manager_register_type (module);
	music_plugins_audio_player_library_register_type (module);
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (module, peas_object_module_get_type ()) ? ((PeasObjectModule*) module) : NULL);
	objmodule = _tmp0_;
	peas_object_module_register_extension_type (objmodule, peas_activatable_get_type (), MUSIC_PLUGINS_TYPE_AUDIO_PLAYER_PLUGIN);
	_g_object_unref0 (objmodule);
}

