/* iPodDeviceManager.c generated by valac 0.56.1, the Vala compiler
 * generated from iPodDeviceManager.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "ipod-device.h"
#include <gee.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include "io.elementary.music-core.h"
#include "music-lib.h"
#include <stdlib.h>
#include <string.h>

enum  {
	MUSIC_PLUGINS_IPOD_DEVICE_MANAGER_0_PROPERTY,
	MUSIC_PLUGINS_IPOD_DEVICE_MANAGER_NUM_PROPERTIES
};
static GParamSpec* music_plugins_ipod_device_manager_properties[MUSIC_PLUGINS_IPOD_DEVICE_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _MusicPluginsiPodDeviceManagerPrivate {
	GeeArrayList* devices;
	MusicPluginsiPodStreamer* streamer;
};

static gint MusicPluginsiPodDeviceManager_private_offset;
static gpointer music_plugins_ipod_device_manager_parent_class = NULL;
static GType music_plugins_ipod_device_manager_type_id = 0;

static void _music_plugins_ipod_device_manager_mount_added_music_device_manager_mount_added (MusicDeviceManager* _sender,
                                                                                      GMount* mount,
                                                                                      gpointer self);
static void _music_plugins_ipod_device_manager_mount_removed_music_device_manager_mount_removed (MusicDeviceManager* _sender,
                                                                                          GMount* mount,
                                                                                          gpointer self);
static void music_plugins_ipod_device_manager_real_mount_added (MusicPluginsiPodDeviceManager* self,
                                                         GMount* mount);
static void ____lambda12_ (MusicPluginsiPodDeviceManager* self,
                    MusicDevice* d);
static void _____lambda12__music_device_initialized (MusicDevice* _sender,
                                              MusicDevice* d,
                                              gpointer self);
static void music_plugins_ipod_device_manager_real_mount_changed (MusicPluginsiPodDeviceManager* self,
                                                           GMount* mount);
static void music_plugins_ipod_device_manager_real_mount_pre_unmount (MusicPluginsiPodDeviceManager* self,
                                                               GMount* mount);
static void music_plugins_ipod_device_manager_real_mount_removed (MusicPluginsiPodDeviceManager* self,
                                                           GMount* mount);
static void music_plugins_ipod_device_manager_finalize (GObject * obj);

static inline gpointer
music_plugins_ipod_device_manager_get_instance_private (MusicPluginsiPodDeviceManager* self)
{
	return G_STRUCT_MEMBER_P (self, MusicPluginsiPodDeviceManager_private_offset);
}

static void
_music_plugins_ipod_device_manager_mount_added_music_device_manager_mount_added (MusicDeviceManager* _sender,
                                                                                 GMount* mount,
                                                                                 gpointer self)
{
	music_plugins_ipod_device_manager_mount_added ((MusicPluginsiPodDeviceManager*) self, mount);
}

static void
_music_plugins_ipod_device_manager_mount_removed_music_device_manager_mount_removed (MusicDeviceManager* _sender,
                                                                                     GMount* mount,
                                                                                     gpointer self)
{
	music_plugins_ipod_device_manager_mount_removed ((MusicPluginsiPodDeviceManager*) self, mount);
}

MusicPluginsiPodDeviceManager*
music_plugins_ipod_device_manager_construct (GType object_type)
{
	MusicPluginsiPodDeviceManager * self = NULL;
	GeeArrayList* _tmp0_;
	MusicPluginsiPodStreamer* _tmp1_;
	MusicDeviceManager* device_manager = NULL;
	MusicDeviceManager* _tmp2_;
	MusicDeviceManager* _tmp3_;
	MusicDeviceManager* _tmp4_;
	MusicPlaybackManager* _tmp14_;
	MusicPlaybackManager* _tmp15_;
	MusicPluginsiPodStreamer* _tmp16_;
	self = (MusicPluginsiPodDeviceManager*) g_object_new (object_type, NULL);
	_tmp0_ = gee_array_list_new (MUSIC_PLUGINS_TYPE_IPOD_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->devices);
	self->priv->devices = _tmp0_;
	_tmp1_ = music_plugins_ipod_streamer_new (self);
	_g_object_unref0 (self->priv->streamer);
	self->priv->streamer = _tmp1_;
	_tmp2_ = music_device_manager_get_default ();
	device_manager = _tmp2_;
	_tmp3_ = device_manager;
	g_signal_connect_object (_tmp3_, "mount-added", (GCallback) _music_plugins_ipod_device_manager_mount_added_music_device_manager_mount_added, self, 0);
	_tmp4_ = device_manager;
	g_signal_connect_object (_tmp4_, "mount-removed", (GCallback) _music_plugins_ipod_device_manager_mount_removed_music_device_manager_mount_removed, self, 0);
	{
		GeeIterator* _mount_it = NULL;
		MusicDeviceManager* _tmp5_;
		GeeCollection* _tmp6_;
		GeeCollection* _tmp7_;
		GeeIterator* _tmp8_;
		GeeIterator* _tmp9_;
		_tmp5_ = device_manager;
		_tmp6_ = music_device_manager_get_available_mounts (_tmp5_);
		_tmp7_ = _tmp6_;
		_tmp8_ = gee_iterable_iterator ((GeeIterable*) _tmp7_);
		_tmp9_ = _tmp8_;
		_g_object_unref0 (_tmp7_);
		_mount_it = _tmp9_;
		while (TRUE) {
			GeeIterator* _tmp10_;
			GMount* mount = NULL;
			GeeIterator* _tmp11_;
			gpointer _tmp12_;
			GMount* _tmp13_;
			_tmp10_ = _mount_it;
			if (!gee_iterator_next (_tmp10_)) {
				break;
			}
			_tmp11_ = _mount_it;
			_tmp12_ = gee_iterator_get (_tmp11_);
			mount = (GMount*) _tmp12_;
			_tmp13_ = mount;
			music_plugins_ipod_device_manager_mount_added (self, _tmp13_);
		}
		_g_object_unref0 (_mount_it);
	}
	_tmp14_ = music_app_get_player ();
	_tmp15_ = _tmp14_;
	_tmp16_ = self->priv->streamer;
	music_playback_manager_add_playback (_tmp15_, (MusicPlayback*) _tmp16_);
	_g_object_unref0 (device_manager);
	return self;
}

MusicPluginsiPodDeviceManager*
music_plugins_ipod_device_manager_new (void)
{
	return music_plugins_ipod_device_manager_construct (MUSIC_PLUGINS_TYPE_IPOD_DEVICE_MANAGER);
}

void
music_plugins_ipod_device_manager_remove_all (MusicPluginsiPodDeviceManager* self)
{
	MusicDeviceManager* device_manager = NULL;
	MusicDeviceManager* _tmp0_;
	GeeArrayList* _tmp11_;
	g_return_if_fail (self != NULL);
	_tmp0_ = music_device_manager_get_default ();
	device_manager = _tmp0_;
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp1_;
		gint _dev_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _dev_index = 0;
		_tmp1_ = self->priv->devices;
		_dev_list = _tmp1_;
		_tmp2_ = _dev_list;
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_dev_size = _tmp4_;
		_dev_index = -1;
		while (TRUE) {
			gint _tmp5_;
			gint _tmp6_;
			MusicPluginsiPodDevice* dev = NULL;
			GeeArrayList* _tmp7_;
			gpointer _tmp8_;
			MusicDeviceManager* _tmp9_;
			MusicPluginsiPodDevice* _tmp10_;
			_dev_index = _dev_index + 1;
			_tmp5_ = _dev_index;
			_tmp6_ = _dev_size;
			if (!(_tmp5_ < _tmp6_)) {
				break;
			}
			_tmp7_ = _dev_list;
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _dev_index);
			dev = (MusicPluginsiPodDevice*) _tmp8_;
			_tmp9_ = device_manager;
			_tmp10_ = dev;
			g_signal_emit_by_name (_tmp9_, "device-removed", G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, MUSIC_TYPE_DEVICE, MusicDevice));
			_g_object_unref0 (dev);
		}
	}
	_tmp11_ = gee_array_list_new (MUSIC_PLUGINS_TYPE_IPOD_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->devices);
	self->priv->devices = _tmp11_;
	_g_object_unref0 (device_manager);
}

static void
____lambda12_ (MusicPluginsiPodDeviceManager* self,
               MusicDevice* d)
{
	g_return_if_fail (d != NULL);
	if (G_TYPE_CHECK_INSTANCE_CAST (d, MUSIC_PLUGINS_TYPE_IPOD_DEVICE, MusicPluginsiPodDevice)->is_supported == TRUE) {
		MusicDeviceManager* _tmp0_;
		MusicDeviceManager* _tmp1_;
		_tmp0_ = music_device_manager_get_default ();
		_tmp1_ = _tmp0_;
		music_device_manager_device_initialized (_tmp1_, G_TYPE_CHECK_INSTANCE_CAST (d, MUSIC_TYPE_DEVICE, MusicDevice));
		_g_object_unref0 (_tmp1_);
	}
}

static void
_____lambda12__music_device_initialized (MusicDevice* _sender,
                                         MusicDevice* d,
                                         gpointer self)
{
	____lambda12_ ((MusicPluginsiPodDeviceManager*) self, d);
}

static void
music_plugins_ipod_device_manager_real_mount_added (MusicPluginsiPodDeviceManager* self,
                                                    GMount* mount)
{
	gboolean _tmp16_ = FALSE;
	gboolean _tmp17_ = FALSE;
	gboolean _tmp18_ = FALSE;
	GFile* _tmp19_;
	GFile* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	GFile* _tmp25_;
	GFile* _tmp26_;
	gboolean _tmp27_;
	g_return_if_fail (mount != NULL);
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp0_;
		gint _dev_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _dev_index = 0;
		_tmp0_ = self->priv->devices;
		_dev_list = _tmp0_;
		_tmp1_ = _dev_list;
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
		_tmp3_ = _tmp2_;
		_dev_size = _tmp3_;
		_dev_index = -1;
		while (TRUE) {
			gint _tmp4_;
			gint _tmp5_;
			MusicPluginsiPodDevice* dev = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			MusicPluginsiPodDevice* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
			GFile* _tmp11_;
			GFile* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
			gboolean _tmp15_;
			_dev_index = _dev_index + 1;
			_tmp4_ = _dev_index;
			_tmp5_ = _dev_size;
			if (!(_tmp4_ < _tmp5_)) {
				break;
			}
			_tmp6_ = _dev_list;
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _dev_index);
			dev = (MusicPluginsiPodDevice*) _tmp7_;
			_tmp8_ = dev;
			_tmp9_ = music_device_get_uri ((MusicDevice*) _tmp8_);
			_tmp10_ = _tmp9_;
			_tmp11_ = g_mount_get_default_location (mount);
			_tmp12_ = _tmp11_;
			_tmp13_ = g_file_get_uri (_tmp12_);
			_tmp14_ = _tmp13_;
			_tmp15_ = g_strcmp0 (_tmp10_, _tmp14_) == 0;
			_g_free0 (_tmp14_);
			_g_object_unref0 (_tmp12_);
			_g_free0 (_tmp10_);
			if (_tmp15_) {
				_g_object_unref0 (dev);
				return;
			}
			_g_object_unref0 (dev);
		}
	}
	_tmp19_ = g_mount_get_default_location (mount);
	_tmp20_ = _tmp19_;
	_tmp21_ = g_file_get_uri (_tmp20_);
	_tmp22_ = _tmp21_;
	_tmp23_ = g_strconcat (_tmp22_, "/iTunes_Control", NULL);
	_tmp24_ = _tmp23_;
	_tmp25_ = g_file_new_for_uri (_tmp24_);
	_tmp26_ = _tmp25_;
	_tmp27_ = g_file_query_exists (_tmp26_, NULL);
	_g_object_unref0 (_tmp26_);
	_g_free0 (_tmp24_);
	_g_free0 (_tmp22_);
	_g_object_unref0 (_tmp20_);
	if (_tmp27_) {
		_tmp18_ = TRUE;
	} else {
		GFile* _tmp28_;
		GFile* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
		GFile* _tmp34_;
		GFile* _tmp35_;
		_tmp28_ = g_mount_get_default_location (mount);
		_tmp29_ = _tmp28_;
		_tmp30_ = g_file_get_uri (_tmp29_);
		_tmp31_ = _tmp30_;
		_tmp32_ = g_strconcat (_tmp31_, "/iPod_Control", NULL);
		_tmp33_ = _tmp32_;
		_tmp34_ = g_file_new_for_uri (_tmp33_);
		_tmp35_ = _tmp34_;
		_tmp18_ = g_file_query_exists (_tmp35_, NULL);
		_g_object_unref0 (_tmp35_);
		_g_free0 (_tmp33_);
		_g_free0 (_tmp31_);
		_g_object_unref0 (_tmp29_);
	}
	if (_tmp18_) {
		_tmp17_ = TRUE;
	} else {
		GFile* _tmp36_;
		GFile* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		gchar* _tmp40_;
		gchar* _tmp41_;
		GFile* _tmp42_;
		GFile* _tmp43_;
		_tmp36_ = g_mount_get_default_location (mount);
		_tmp37_ = _tmp36_;
		_tmp38_ = g_file_get_uri (_tmp37_);
		_tmp39_ = _tmp38_;
		_tmp40_ = g_strconcat (_tmp39_, "/iTunes/iTunes_Control", NULL);
		_tmp41_ = _tmp40_;
		_tmp42_ = g_file_new_for_uri (_tmp41_);
		_tmp43_ = _tmp42_;
		_tmp17_ = g_file_query_exists (_tmp43_, NULL);
		_g_object_unref0 (_tmp43_);
		_g_free0 (_tmp41_);
		_g_free0 (_tmp39_);
		_g_object_unref0 (_tmp37_);
	}
	if (_tmp17_) {
		_tmp16_ = TRUE;
	} else {
		GFile* _tmp44_;
		GFile* _tmp45_;
		gchar* _tmp46_;
		gchar* _tmp47_;
		_tmp44_ = g_mount_get_default_location (mount);
		_tmp45_ = _tmp44_;
		_tmp46_ = g_file_get_parse_name (_tmp45_);
		_tmp47_ = _tmp46_;
		_tmp16_ = g_str_has_prefix (_tmp47_, "afc://");
		_g_free0 (_tmp47_);
		_g_object_unref0 (_tmp45_);
	}
	if (_tmp16_) {
		MusicPluginsiPodDevice* added = NULL;
		MusicPluginsiPodDevice* _tmp48_;
		MusicPluginsiPodDevice* _tmp49_;
		GeeArrayList* _tmp50_;
		MusicPluginsiPodDevice* _tmp51_;
		MusicPluginsiPodDevice* _tmp52_;
		_tmp48_ = music_plugins_ipod_device_new (mount);
		added = _tmp48_;
		_tmp49_ = added;
		music_device_set_mount ((MusicDevice*) _tmp49_, mount);
		_tmp50_ = self->priv->devices;
		_tmp51_ = added;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp50_, _tmp51_);
		_tmp52_ = added;
		if (music_device_start_initialization ((MusicDevice*) _tmp52_) == TRUE) {
			MusicPluginsiPodDevice* _tmp53_;
			MusicPluginsiPodDevice* _tmp54_;
			_tmp53_ = added;
			music_device_finish_initialization ((MusicDevice*) _tmp53_);
			_tmp54_ = added;
			g_signal_connect_object ((MusicDevice*) _tmp54_, "initialized", (GCallback) _____lambda12__music_device_initialized, self, 0);
		}
		_g_object_unref0 (added);
	} else {
		GFile* _tmp55_;
		GFile* _tmp56_;
		gchar* _tmp57_;
		gchar* _tmp58_;
		_tmp55_ = g_mount_get_default_location (mount);
		_tmp56_ = _tmp55_;
		_tmp57_ = g_file_get_uri (_tmp56_);
		_tmp58_ = _tmp57_;
		g_debug ("iPodDeviceManager.vala:81: Found device at %s is not an iPod. Not usin" \
"g it", _tmp58_);
		_g_free0 (_tmp58_);
		_g_object_unref0 (_tmp56_);
		return;
	}
}

void
music_plugins_ipod_device_manager_mount_added (MusicPluginsiPodDeviceManager* self,
                                               GMount* mount)
{
	MusicPluginsiPodDeviceManagerClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_PLUGINS_IPOD_DEVICE_MANAGER_GET_CLASS (self);
	if (_klass_->mount_added) {
		_klass_->mount_added (self, mount);
	}
}

static void
music_plugins_ipod_device_manager_real_mount_changed (MusicPluginsiPodDeviceManager* self,
                                                      GMount* mount)
{
	g_return_if_fail (mount != NULL);
}

void
music_plugins_ipod_device_manager_mount_changed (MusicPluginsiPodDeviceManager* self,
                                                 GMount* mount)
{
	MusicPluginsiPodDeviceManagerClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_PLUGINS_IPOD_DEVICE_MANAGER_GET_CLASS (self);
	if (_klass_->mount_changed) {
		_klass_->mount_changed (self, mount);
	}
}

static void
music_plugins_ipod_device_manager_real_mount_pre_unmount (MusicPluginsiPodDeviceManager* self,
                                                          GMount* mount)
{
	g_return_if_fail (mount != NULL);
}

void
music_plugins_ipod_device_manager_mount_pre_unmount (MusicPluginsiPodDeviceManager* self,
                                                     GMount* mount)
{
	MusicPluginsiPodDeviceManagerClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_PLUGINS_IPOD_DEVICE_MANAGER_GET_CLASS (self);
	if (_klass_->mount_pre_unmount) {
		_klass_->mount_pre_unmount (self, mount);
	}
}

static void
music_plugins_ipod_device_manager_real_mount_removed (MusicPluginsiPodDeviceManager* self,
                                                      GMount* mount)
{
	MusicDeviceManager* device_manager = NULL;
	MusicDeviceManager* _tmp0_;
	g_return_if_fail (mount != NULL);
	_tmp0_ = music_device_manager_get_default ();
	device_manager = _tmp0_;
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp1_;
		gint _dev_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _dev_index = 0;
		_tmp1_ = self->priv->devices;
		_dev_list = _tmp1_;
		_tmp2_ = _dev_list;
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_dev_size = _tmp4_;
		_dev_index = -1;
		while (TRUE) {
			gint _tmp5_;
			gint _tmp6_;
			MusicPluginsiPodDevice* dev = NULL;
			GeeArrayList* _tmp7_;
			gpointer _tmp8_;
			MusicPluginsiPodDevice* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
			GFile* _tmp12_;
			GFile* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
			gboolean _tmp16_;
			_dev_index = _dev_index + 1;
			_tmp5_ = _dev_index;
			_tmp6_ = _dev_size;
			if (!(_tmp5_ < _tmp6_)) {
				break;
			}
			_tmp7_ = _dev_list;
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _dev_index);
			dev = (MusicPluginsiPodDevice*) _tmp8_;
			_tmp9_ = dev;
			_tmp10_ = music_device_get_uri ((MusicDevice*) _tmp9_);
			_tmp11_ = _tmp10_;
			_tmp12_ = g_mount_get_default_location (mount);
			_tmp13_ = _tmp12_;
			_tmp14_ = g_file_get_uri (_tmp13_);
			_tmp15_ = _tmp14_;
			_tmp16_ = g_strcmp0 (_tmp11_, _tmp15_) == 0;
			_g_free0 (_tmp15_);
			_g_object_unref0 (_tmp13_);
			_g_free0 (_tmp11_);
			if (_tmp16_) {
				MusicDeviceManager* _tmp17_;
				MusicPluginsiPodDevice* _tmp18_;
				GeeArrayList* _tmp19_;
				MusicPluginsiPodDevice* _tmp20_;
				_tmp17_ = device_manager;
				_tmp18_ = dev;
				g_signal_emit_by_name (_tmp17_, "device-removed", G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, MUSIC_TYPE_DEVICE, MusicDevice));
				_tmp19_ = self->priv->devices;
				_tmp20_ = dev;
				gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp19_, _tmp20_);
				_g_object_unref0 (dev);
				_g_object_unref0 (device_manager);
				return;
			}
			_g_object_unref0 (dev);
		}
	}
	_g_object_unref0 (device_manager);
}

void
music_plugins_ipod_device_manager_mount_removed (MusicPluginsiPodDeviceManager* self,
                                                 GMount* mount)
{
	MusicPluginsiPodDeviceManagerClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_PLUGINS_IPOD_DEVICE_MANAGER_GET_CLASS (self);
	if (_klass_->mount_removed) {
		_klass_->mount_removed (self, mount);
	}
}

MusicPluginsiPodDevice*
music_plugins_ipod_device_manager_get_device_for_uri (MusicPluginsiPodDeviceManager* self,
                                                      const gchar* uri)
{
	MusicPluginsiPodDevice* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (uri != NULL, NULL);
	{
		GeeArrayList* _device_list = NULL;
		GeeArrayList* _tmp0_;
		gint _device_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _device_index = 0;
		_tmp0_ = self->priv->devices;
		_device_list = _tmp0_;
		_tmp1_ = _device_list;
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
		_tmp3_ = _tmp2_;
		_device_size = _tmp3_;
		_device_index = -1;
		while (TRUE) {
			gint _tmp4_;
			gint _tmp5_;
			MusicPluginsiPodDevice* device = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			MusicPluginsiPodDevice* _tmp8_;
			MusicLibrary* _tmp9_;
			MusicLibrary* _tmp10_;
			MusicMedia* _tmp11_;
			MusicMedia* _tmp12_;
			gboolean _tmp13_;
			_device_index = _device_index + 1;
			_tmp4_ = _device_index;
			_tmp5_ = _device_size;
			if (!(_tmp4_ < _tmp5_)) {
				break;
			}
			_tmp6_ = _device_list;
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _device_index);
			device = (MusicPluginsiPodDevice*) _tmp7_;
			_tmp8_ = device;
			_tmp9_ = music_device_get_library ((MusicDevice*) _tmp8_);
			_tmp10_ = _tmp9_;
			_tmp11_ = music_library_media_from_uri (_tmp10_, uri);
			_tmp12_ = _tmp11_;
			_tmp13_ = _tmp12_ != NULL;
			_g_object_unref0 (_tmp12_);
			_g_object_unref0 (_tmp10_);
			if (_tmp13_) {
				result = device;
				return result;
			}
			_g_object_unref0 (device);
		}
	}
	result = NULL;
	return result;
}

static void
music_plugins_ipod_device_manager_class_init (MusicPluginsiPodDeviceManagerClass * klass,
                                              gpointer klass_data)
{
	music_plugins_ipod_device_manager_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicPluginsiPodDeviceManager_private_offset);
	((MusicPluginsiPodDeviceManagerClass *) klass)->mount_added = (void (*) (MusicPluginsiPodDeviceManager*, GMount*)) music_plugins_ipod_device_manager_real_mount_added;
	((MusicPluginsiPodDeviceManagerClass *) klass)->mount_changed = (void (*) (MusicPluginsiPodDeviceManager*, GMount*)) music_plugins_ipod_device_manager_real_mount_changed;
	((MusicPluginsiPodDeviceManagerClass *) klass)->mount_pre_unmount = (void (*) (MusicPluginsiPodDeviceManager*, GMount*)) music_plugins_ipod_device_manager_real_mount_pre_unmount;
	((MusicPluginsiPodDeviceManagerClass *) klass)->mount_removed = (void (*) (MusicPluginsiPodDeviceManager*, GMount*)) music_plugins_ipod_device_manager_real_mount_removed;
	G_OBJECT_CLASS (klass)->finalize = music_plugins_ipod_device_manager_finalize;
}

static void
music_plugins_ipod_device_manager_instance_init (MusicPluginsiPodDeviceManager * self,
                                                 gpointer klass)
{
	self->priv = music_plugins_ipod_device_manager_get_instance_private (self);
}

static void
music_plugins_ipod_device_manager_finalize (GObject * obj)
{
	MusicPluginsiPodDeviceManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_PLUGINS_TYPE_IPOD_DEVICE_MANAGER, MusicPluginsiPodDeviceManager);
	_g_object_unref0 (self->priv->devices);
	_g_object_unref0 (self->priv->streamer);
	G_OBJECT_CLASS (music_plugins_ipod_device_manager_parent_class)->finalize (obj);
}

GType
music_plugins_ipod_device_manager_get_type (void)
{
	return music_plugins_ipod_device_manager_type_id;
}

GType
music_plugins_ipod_device_manager_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicPluginsiPodDeviceManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_plugins_ipod_device_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicPluginsiPodDeviceManager), 0, (GInstanceInitFunc) music_plugins_ipod_device_manager_instance_init, NULL };
	music_plugins_ipod_device_manager_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "MusicPluginsiPodDeviceManager", &g_define_type_info, 0);
	MusicPluginsiPodDeviceManager_private_offset = sizeof (MusicPluginsiPodDeviceManagerPrivate);
	return music_plugins_ipod_device_manager_type_id;
}

