/* iPodStreamer.c generated by valac 0.56.1, the Vala compiler
 * generated from iPodStreamer.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "ipod-device.h"
#include "io.elementary.music-core.h"
#include "music-lib.h"
#include <glib.h>
#include <glib-object.h>
#include <gst/gst.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <gst/pbutils/pbutils.h>
#include <gtk/gtk.h>

enum  {
	MUSIC_PLUGINS_IPOD_STREAMER_0_PROPERTY,
	MUSIC_PLUGINS_IPOD_STREAMER_NUM_PROPERTIES
};
static GParamSpec* music_plugins_ipod_streamer_properties[MUSIC_PLUGINS_IPOD_STREAMER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _gst_tag_list_unref0(var) ((var == NULL) ? NULL : (var = (gst_tag_list_unref (var), NULL)))

struct _MusicPluginsiPodStreamerPrivate {
	MusicPipeline* pipe;
	MusicInstallGstreamerPluginsDialog* dialog;
	MusicPluginsiPodDeviceManager* dm;
};

static gint MusicPluginsiPodStreamer_private_offset;
static gpointer music_plugins_ipod_streamer_parent_class = NULL;
static MusicPlaybackIface * music_plugins_ipod_streamer_music_playback_parent_iface = NULL;
static GType music_plugins_ipod_streamer_type_id = 0;

static gboolean music_plugins_ipod_streamer_bus_callback (MusicPluginsiPodStreamer* self,
                                                   GstBus* bus,
                                                   GstMessage* message);
static gboolean _music_plugins_ipod_streamer_bus_callback_gst_bus_func (GstBus* bus,
                                                                 GstMessage* message,
                                                                 gpointer self);
static gboolean _music_playback_update_position_gsource_func (gpointer self);
static GeeCollection* music_plugins_ipod_streamer_real_get_supported_uri (MusicPlayback* base);
static gboolean music_plugins_ipod_streamer_real_update_position (MusicPlayback* base);
static void music_plugins_ipod_streamer_real_play (MusicPlayback* base);
static void music_plugins_ipod_streamer_real_pause (MusicPlayback* base);
static void music_plugins_ipod_streamer_real_set_state (MusicPlayback* base,
                                                 GstState s);
static void music_plugins_ipod_streamer_real_set_media (MusicPlayback* base,
                                                 MusicMedia* media);
static void music_plugins_ipod_streamer_real_set_position (MusicPlayback* base,
                                                    gint64 pos);
static gint64 music_plugins_ipod_streamer_real_get_position (MusicPlayback* base);
static gint64 music_plugins_ipod_streamer_real_get_duration (MusicPlayback* base);
static void music_plugins_ipod_streamer_real_set_volume (MusicPlayback* base,
                                                  gdouble val);
static gdouble music_plugins_ipod_streamer_real_get_volume (MusicPlayback* base);
static void music_plugins_ipod_streamer_real_enable_equalizer (MusicPlayback* base);
static void music_plugins_ipod_streamer_real_disable_equalizer (MusicPlayback* base);
static void music_plugins_ipod_streamer_real_set_equalizer_gain (MusicPlayback* base,
                                                          gint index,
                                                          gint val);
static void music_plugins_ipod_streamer_finalize (GObject * obj);

static inline gpointer
music_plugins_ipod_streamer_get_instance_private (MusicPluginsiPodStreamer* self)
{
	return G_STRUCT_MEMBER_P (self, MusicPluginsiPodStreamer_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static gboolean
_music_plugins_ipod_streamer_bus_callback_gst_bus_func (GstBus* bus,
                                                        GstMessage* message,
                                                        gpointer self)
{
	gboolean result;
	result = music_plugins_ipod_streamer_bus_callback ((MusicPluginsiPodStreamer*) self, bus, message);
	return result;
}

static gboolean
_music_playback_update_position_gsource_func (gpointer self)
{
	gboolean result;
	result = music_playback_update_position ((MusicPlayback*) self);
	return result;
}

MusicPluginsiPodStreamer*
music_plugins_ipod_streamer_construct (GType object_type,
                                       MusicPluginsiPodDeviceManager* dm)
{
	MusicPluginsiPodStreamer * self = NULL;
	MusicPipeline* _tmp0_;
	MusicPluginsiPodDeviceManager* _tmp1_;
	MusicPipeline* _tmp2_;
	GstBus* _tmp3_;
	g_return_val_if_fail (dm != NULL, NULL);
	self = (MusicPluginsiPodStreamer*) g_object_new (object_type, NULL);
	_tmp0_ = music_pipeline_new ();
	_g_object_unref0 (self->priv->pipe);
	self->priv->pipe = _tmp0_;
	_tmp1_ = _g_object_ref0 (dm);
	_g_object_unref0 (self->priv->dm);
	self->priv->dm = _tmp1_;
	_tmp2_ = self->priv->pipe;
	_tmp3_ = _tmp2_->bus;
	gst_bus_add_watch_full (_tmp3_, G_PRIORITY_DEFAULT, _music_plugins_ipod_streamer_bus_callback_gst_bus_func, g_object_ref (self), g_object_unref);
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 200, _music_playback_update_position_gsource_func, g_object_ref ((MusicPlayback*) self), g_object_unref);
	return self;
}

MusicPluginsiPodStreamer*
music_plugins_ipod_streamer_new (MusicPluginsiPodDeviceManager* dm)
{
	return music_plugins_ipod_streamer_construct (MUSIC_PLUGINS_TYPE_IPOD_STREAMER, dm);
}

static GeeCollection*
music_plugins_ipod_streamer_real_get_supported_uri (MusicPlayback* base)
{
	MusicPluginsiPodStreamer * self;
	GeeLinkedList* uris = NULL;
	GeeLinkedList* _tmp0_;
	GeeCollection* result;
	self = (MusicPluginsiPodStreamer*) base;
	_tmp0_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
	uris = _tmp0_;
	gee_abstract_collection_add ((GeeAbstractCollection*) uris, "afc://");
	result = (GeeCollection*) uris;
	return result;
}

static gboolean
music_plugins_ipod_streamer_real_update_position (MusicPlayback* base)
{
	MusicPluginsiPodStreamer * self;
	gboolean _tmp0_ = FALSE;
	gboolean result;
	self = (MusicPluginsiPodStreamer*) base;
	if (self->set_resume_pos) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp1_ = FALSE;
		MusicPlaybackManager* _tmp2_;
		MusicPlaybackManager* _tmp3_;
		MusicMedia* _tmp4_;
		MusicMedia* _tmp5_;
		_tmp2_ = music_app_get_player ();
		_tmp3_ = _tmp2_;
		_tmp4_ = music_playback_manager_get_current_media (_tmp3_);
		_tmp5_ = _tmp4_;
		if (_tmp5_ != NULL) {
			MusicPlaybackManager* _tmp6_;
			MusicPlaybackManager* _tmp7_;
			MusicMedia* _tmp8_;
			MusicMedia* _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
			_tmp6_ = music_app_get_player ();
			_tmp7_ = _tmp6_;
			_tmp8_ = music_playback_manager_get_current_media (_tmp7_);
			_tmp9_ = _tmp8_;
			_tmp10_ = music_media_get_resume_pos (_tmp9_);
			_tmp11_ = _tmp10_;
			_tmp1_ = music_playback_get_position ((MusicPlayback*) self) >= (((gint64) (_tmp11_ - 1)) * 1000000000);
		} else {
			_tmp1_ = FALSE;
		}
		_tmp0_ = _tmp1_;
	}
	if (_tmp0_) {
		self->set_resume_pos = TRUE;
		g_signal_emit_by_name ((MusicPlayback*) self, "current-position-update", music_playback_get_position ((MusicPlayback*) self));
	} else {
		MusicPlaybackManager* _tmp12_;
		MusicPlaybackManager* _tmp13_;
		MusicMedia* _tmp14_;
		MusicMedia* _tmp15_;
		_tmp12_ = music_app_get_player ();
		_tmp13_ = _tmp12_;
		_tmp14_ = music_playback_manager_get_current_media (_tmp13_);
		_tmp15_ = _tmp14_;
		if (_tmp15_ != NULL) {
			MusicPipeline* _tmp16_;
			GstElement* _tmp17_;
			MusicPlaybackManager* _tmp18_;
			MusicPlaybackManager* _tmp19_;
			MusicMedia* _tmp20_;
			MusicMedia* _tmp21_;
			gint _tmp22_;
			gint _tmp23_;
			_tmp16_ = self->priv->pipe;
			_tmp17_ = _tmp16_->playbin;
			_tmp18_ = music_app_get_player ();
			_tmp19_ = _tmp18_;
			_tmp20_ = music_playback_manager_get_current_media (_tmp19_);
			_tmp21_ = _tmp20_;
			_tmp22_ = music_media_get_resume_pos (_tmp21_);
			_tmp23_ = _tmp22_;
			gst_element_seek_simple (_tmp17_, GST_FORMAT_TIME, GST_SEEK_FLAG_FLUSH, ((gint64) _tmp23_) * 1000000000);
		}
	}
	result = TRUE;
	return result;
}

static void
music_plugins_ipod_streamer_real_play (MusicPlayback* base)
{
	MusicPluginsiPodStreamer * self;
	self = (MusicPluginsiPodStreamer*) base;
	music_playback_set_state ((MusicPlayback*) self, GST_STATE_PLAYING);
}

static void
music_plugins_ipod_streamer_real_pause (MusicPlayback* base)
{
	MusicPluginsiPodStreamer * self;
	self = (MusicPluginsiPodStreamer*) base;
	music_playback_set_state ((MusicPlayback*) self, GST_STATE_PAUSED);
}

static void
music_plugins_ipod_streamer_real_set_state (MusicPlayback* base,
                                            GstState s)
{
	MusicPluginsiPodStreamer * self;
	MusicPipeline* _tmp0_;
	GstElement* _tmp1_;
	self = (MusicPluginsiPodStreamer*) base;
	_tmp0_ = self->priv->pipe;
	_tmp1_ = _tmp0_->playbin;
	gst_element_set_state (_tmp1_, s);
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		g_clear_error (&_inner_error0_);
		g_assert_not_reached ();
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

static void
music_plugins_ipod_streamer_real_set_media (MusicPlayback* base,
                                            MusicMedia* media)
{
	MusicPluginsiPodStreamer * self;
	MusicPluginsiPodDevice* device = NULL;
	MusicPluginsiPodDeviceManager* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	MusicPluginsiPodDevice* _tmp4_;
	MusicPluginsiPodDevice* _tmp5_;
	gchar* uri = NULL;
	const gchar* _tmp6_;
	GFile* _tmp7_;
	GFile* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GMount* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	MusicPipeline* _tmp23_;
	GstElement* _tmp24_;
	gchar* _tmp25_;
	GValue _tmp26_ = {0};
	MusicPlaybackManager* _tmp27_;
	MusicPlaybackManager* _tmp28_;
	MusicMedia* _tmp29_;
	MusicMedia* _tmp30_;
	gint _tmp31_;
	gint _tmp32_;
	MusicPipeline* _tmp33_;
	GstElement* _tmp34_;
	MusicPlaybackManager* _tmp35_;
	MusicPlaybackManager* _tmp36_;
	MusicMedia* _tmp37_;
	MusicMedia* _tmp38_;
	gint _tmp39_;
	gint _tmp40_;
	self = (MusicPluginsiPodStreamer*) base;
	g_return_if_fail (media != NULL);
	music_playback_set_state ((MusicPlayback*) self, GST_STATE_READY);
	_tmp0_ = self->priv->dm;
	_tmp1_ = music_media_get_uri (media);
	_tmp2_ = _tmp1_;
	_tmp3_ = _tmp2_;
	_tmp4_ = music_plugins_ipod_device_manager_get_device_for_uri (_tmp0_, _tmp3_);
	_tmp5_ = _tmp4_;
	_g_free0 (_tmp3_);
	device = _tmp5_;
	_tmp6_ = g_get_home_dir ();
	_tmp7_ = g_file_new_for_path (_tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = g_file_get_uri (_tmp8_);
	_tmp10_ = _tmp9_;
	_tmp11_ = device->mount;
	_tmp12_ = g_mount_get_name (_tmp11_);
	_tmp13_ = _tmp12_;
	_tmp14_ = music_media_get_uri (media);
	_tmp15_ = _tmp14_;
	_tmp16_ = _tmp15_;
	_tmp17_ = music_device_get_uri ((MusicDevice*) device);
	_tmp18_ = _tmp17_;
	_tmp19_ = string_replace (_tmp16_, _tmp18_, "");
	_tmp20_ = _tmp19_;
	_tmp21_ = g_strdup_printf ("%s/.gvfs/%s/%s", _tmp10_, _tmp13_, _tmp20_);
	_tmp22_ = _tmp21_;
	_g_free0 (_tmp20_);
	_g_free0 (_tmp18_);
	_g_free0 (_tmp16_);
	_g_free0 (_tmp13_);
	_g_free0 (_tmp10_);
	_g_object_unref0 (_tmp8_);
	uri = _tmp22_;
	g_debug ("iPodStreamer.vala:78: set uri to %s\n", uri);
	_tmp23_ = self->priv->pipe;
	_tmp24_ = _tmp23_->playbin;
	_tmp25_ = string_replace (uri, "#", "%23");
	g_value_init (&_tmp26_, G_TYPE_STRING);
	g_value_take_string (&_tmp26_, _tmp25_);
	g_object_set_property ((GObject*) _tmp24_, "uri", &_tmp26_);
	G_IS_VALUE (&_tmp26_) ? (g_value_unset (&_tmp26_), NULL) : NULL;
	music_playback_set_state ((MusicPlayback*) self, GST_STATE_PLAYING);
	_tmp27_ = music_app_get_player ();
	_tmp28_ = _tmp27_;
	_tmp29_ = music_playback_manager_get_current_media (_tmp28_);
	_tmp30_ = _tmp29_;
	_tmp31_ = music_media_get_resume_pos (_tmp30_);
	_tmp32_ = _tmp31_;
	g_debug ("iPodStreamer.vala:81: setURI seeking to %d\n", _tmp32_);
	_tmp33_ = self->priv->pipe;
	_tmp34_ = _tmp33_->playbin;
	_tmp35_ = music_app_get_player ();
	_tmp36_ = _tmp35_;
	_tmp37_ = music_playback_manager_get_current_media (_tmp36_);
	_tmp38_ = _tmp37_;
	_tmp39_ = music_media_get_resume_pos (_tmp38_);
	_tmp40_ = _tmp39_;
	gst_element_seek_simple (_tmp34_, GST_FORMAT_TIME, GST_SEEK_FLAG_FLUSH, ((gint64) _tmp40_) * 1000000000);
	music_playback_play ((MusicPlayback*) self);
	_g_free0 (uri);
	_g_object_unref0 (device);
}

static void
music_plugins_ipod_streamer_real_set_position (MusicPlayback* base,
                                               gint64 pos)
{
	MusicPluginsiPodStreamer * self;
	MusicPipeline* _tmp0_;
	GstElement* _tmp1_;
	self = (MusicPluginsiPodStreamer*) base;
	_tmp0_ = self->priv->pipe;
	_tmp1_ = _tmp0_->playbin;
	gst_element_seek (_tmp1_, 1.0, GST_FORMAT_TIME, GST_SEEK_FLAG_FLUSH, GST_SEEK_TYPE_SET, pos, GST_SEEK_TYPE_NONE, music_playback_get_duration ((MusicPlayback*) self));
}

static gint64
music_plugins_ipod_streamer_real_get_position (MusicPlayback* base)
{
	MusicPluginsiPodStreamer * self;
	gint64 rv = 0LL;
	GstFormat f = 0;
	MusicPipeline* _tmp0_;
	GstElement* _tmp1_;
	gint64 _tmp2_ = 0LL;
	gint64 result;
	self = (MusicPluginsiPodStreamer*) base;
	rv = (gint64) 0;
	f = GST_FORMAT_TIME;
	_tmp0_ = self->priv->pipe;
	_tmp1_ = _tmp0_->playbin;
	gst_element_query_position (_tmp1_, f, &_tmp2_);
	rv = _tmp2_;
	result = rv;
	return result;
}

static gint64
music_plugins_ipod_streamer_real_get_duration (MusicPlayback* base)
{
	MusicPluginsiPodStreamer * self;
	gint64 rv = 0LL;
	GstFormat f = 0;
	MusicPipeline* _tmp0_;
	GstElement* _tmp1_;
	gint64 _tmp2_ = 0LL;
	gint64 result;
	self = (MusicPluginsiPodStreamer*) base;
	rv = (gint64) 0;
	f = GST_FORMAT_TIME;
	_tmp0_ = self->priv->pipe;
	_tmp1_ = _tmp0_->playbin;
	gst_element_query_duration (_tmp1_, f, &_tmp2_);
	rv = _tmp2_;
	result = rv;
	return result;
}

static void
music_plugins_ipod_streamer_real_set_volume (MusicPlayback* base,
                                             gdouble val)
{
	MusicPluginsiPodStreamer * self;
	MusicPipeline* _tmp0_;
	GstElement* _tmp1_;
	GValue _tmp2_ = {0};
	self = (MusicPluginsiPodStreamer*) base;
	_tmp0_ = self->priv->pipe;
	_tmp1_ = _tmp0_->playbin;
	g_value_init (&_tmp2_, G_TYPE_DOUBLE);
	g_value_set_double (&_tmp2_, val);
	g_object_set_property ((GObject*) _tmp1_, "volume", &_tmp2_);
	G_IS_VALUE (&_tmp2_) ? (g_value_unset (&_tmp2_), NULL) : NULL;
}

static gdouble
music_plugins_ipod_streamer_real_get_volume (MusicPlayback* base)
{
	MusicPluginsiPodStreamer * self;
	GValue val = {0};
	GValue _tmp0_ = {0};
	MusicPipeline* _tmp1_;
	GstElement* _tmp2_;
	GValue _tmp3_;
	gdouble result;
	self = (MusicPluginsiPodStreamer*) base;
	g_value_init (&_tmp0_, G_TYPE_DOUBLE);
	val = _tmp0_;
	_tmp1_ = self->priv->pipe;
	_tmp2_ = _tmp1_->playbin;
	g_object_get_property ((GObject*) _tmp2_, "volume", &val);
	_tmp3_ = val;
	result = g_value_get_double (&_tmp3_);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	return result;
}

static void
music_plugins_ipod_streamer_real_enable_equalizer (MusicPlayback* base)
{
	MusicPluginsiPodStreamer * self;
	MusicPipeline* _tmp0_;
	self = (MusicPluginsiPodStreamer*) base;
	_tmp0_ = self->priv->pipe;
	music_pipeline_enable_equalizer (_tmp0_);
}

static void
music_plugins_ipod_streamer_real_disable_equalizer (MusicPlayback* base)
{
	MusicPluginsiPodStreamer * self;
	MusicPipeline* _tmp0_;
	self = (MusicPluginsiPodStreamer*) base;
	_tmp0_ = self->priv->pipe;
	music_pipeline_disable_equalizer (_tmp0_);
}

static void
music_plugins_ipod_streamer_real_set_equalizer_gain (MusicPlayback* base,
                                                     gint index,
                                                     gint val)
{
	MusicPluginsiPodStreamer * self;
	MusicPipeline* _tmp0_;
	MusicEqualizer* _tmp1_;
	self = (MusicPluginsiPodStreamer*) base;
	_tmp0_ = self->priv->pipe;
	_tmp1_ = _tmp0_->eq;
	music_equalizer_set_gain (_tmp1_, index, (gdouble) val);
}

static gboolean
music_plugins_ipod_streamer_bus_callback (MusicPluginsiPodStreamer* self,
                                          GstBus* bus,
                                          GstMessage* message)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (bus != NULL, FALSE);
	g_return_val_if_fail (message != NULL, FALSE);
	switch (message->type) {
		case GST_MESSAGE_ERROR:
		{
			GError* err = NULL;
			gchar* debug = NULL;
			GError* _tmp0_ = NULL;
			gchar* _tmp1_ = NULL;
			GError* _tmp2_;
			const gchar* _tmp3_;
			gst_message_parse_error (message, &_tmp0_, &_tmp1_);
			_g_error_free0 (err);
			err = _tmp0_;
			_g_free0 (debug);
			debug = _tmp1_;
			_tmp2_ = err;
			_tmp3_ = _tmp2_->message;
			g_warning ("iPodStreamer.vala:137: Error: %s\n", _tmp3_);
			g_signal_emit_by_name ((MusicPlayback*) self, "error-occured");
			_g_free0 (debug);
			_g_error_free0 (err);
			break;
		}
		case GST_MESSAGE_ELEMENT:
		{
			gboolean _tmp4_ = FALSE;
			gboolean _tmp5_ = FALSE;
			GstStructure* _tmp6_;
			_tmp6_ = gst_message_get_structure (message);
			if (_tmp6_ != NULL) {
				_tmp5_ = gst_is_missing_plugin_message (message);
			} else {
				_tmp5_ = FALSE;
			}
			if (_tmp5_) {
				gboolean _tmp7_ = FALSE;
				MusicInstallGstreamerPluginsDialog* _tmp8_;
				_tmp8_ = self->priv->dialog;
				if (_tmp8_ == NULL) {
					_tmp7_ = TRUE;
				} else {
					MusicInstallGstreamerPluginsDialog* _tmp9_;
					gboolean _tmp10_;
					gboolean _tmp11_;
					_tmp9_ = self->priv->dialog;
					_tmp10_ = gtk_widget_get_visible ((GtkWidget*) _tmp9_);
					_tmp11_ = _tmp10_;
					_tmp7_ = !_tmp11_;
				}
				_tmp4_ = _tmp7_;
			} else {
				_tmp4_ = FALSE;
			}
			if (_tmp4_) {
				MusicInstallGstreamerPluginsDialog* _tmp12_;
				_tmp12_ = music_install_gstreamer_plugins_dialog_new (message);
				g_object_ref_sink (_tmp12_);
				_g_object_unref0 (self->priv->dialog);
				self->priv->dialog = _tmp12_;
			}
			break;
		}
		case GST_MESSAGE_EOS:
		{
			g_signal_emit_by_name ((MusicPlayback*) self, "end-of-stream");
			break;
		}
		case GST_MESSAGE_STATE_CHANGED:
		{
			GstState oldstate = 0;
			GstState newstate = 0;
			GstState pending = 0;
			GstState _tmp13_ = 0;
			GstState _tmp14_ = 0;
			GstState _tmp15_ = 0;
			gst_message_parse_state_changed (message, &_tmp13_, &_tmp14_, &_tmp15_);
			oldstate = _tmp13_;
			newstate = _tmp14_;
			pending = _tmp15_;
			if (newstate != GST_STATE_PLAYING) {
				break;
			}
			break;
		}
		case GST_MESSAGE_TAG:
		{
			GstTagList* tag_list = NULL;
			GstTagList* _tmp16_ = NULL;
			GstTagList* _tmp17_;
			GstTagList* _tmp18_;
			gchar* title = NULL;
			gchar* _tmp19_;
			GstTagList* _tmp20_;
			gchar* _tmp21_ = NULL;
			gst_message_parse_tag (message, &_tmp16_);
			_gst_tag_list_unref0 (tag_list);
			tag_list = _tmp16_;
			_tmp17_ = tag_list;
			if (_tmp17_ == NULL) {
				_gst_tag_list_unref0 (tag_list);
				break;
			}
			_tmp18_ = tag_list;
			if (gst_tag_list_get_tag_size (_tmp18_, GST_TAG_TITLE) <= ((guint) 0)) {
				_gst_tag_list_unref0 (tag_list);
				break;
			}
			_tmp19_ = g_strdup ("");
			title = _tmp19_;
			_tmp20_ = tag_list;
			gst_tag_list_get_string (_tmp20_, GST_TAG_TITLE, &_tmp21_);
			_g_free0 (title);
			title = _tmp21_;
			_g_free0 (title);
			_gst_tag_list_unref0 (tag_list);
			break;
		}
		default:
		{
			break;
		}
	}
	result = TRUE;
	return result;
}

static void
music_plugins_ipod_streamer_class_init (MusicPluginsiPodStreamerClass * klass,
                                        gpointer klass_data)
{
	music_plugins_ipod_streamer_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicPluginsiPodStreamer_private_offset);
	G_OBJECT_CLASS (klass)->finalize = music_plugins_ipod_streamer_finalize;
}

static void
music_plugins_ipod_streamer_music_playback_interface_init (MusicPlaybackIface * iface,
                                                           gpointer iface_data)
{
	music_plugins_ipod_streamer_music_playback_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_supported_uri = (GeeCollection* (*) (MusicPlayback*)) music_plugins_ipod_streamer_real_get_supported_uri;
	iface->update_position = (gboolean (*) (MusicPlayback*)) music_plugins_ipod_streamer_real_update_position;
	iface->play = (void (*) (MusicPlayback*)) music_plugins_ipod_streamer_real_play;
	iface->pause = (void (*) (MusicPlayback*)) music_plugins_ipod_streamer_real_pause;
	iface->set_state = (void (*) (MusicPlayback*, GstState)) music_plugins_ipod_streamer_real_set_state;
	iface->set_media = (void (*) (MusicPlayback*, MusicMedia*)) music_plugins_ipod_streamer_real_set_media;
	iface->set_position = (void (*) (MusicPlayback*, gint64)) music_plugins_ipod_streamer_real_set_position;
	iface->get_position = (gint64 (*) (MusicPlayback*)) music_plugins_ipod_streamer_real_get_position;
	iface->get_duration = (gint64 (*) (MusicPlayback*)) music_plugins_ipod_streamer_real_get_duration;
	iface->set_volume = (void (*) (MusicPlayback*, gdouble)) music_plugins_ipod_streamer_real_set_volume;
	iface->get_volume = (gdouble (*) (MusicPlayback*)) music_plugins_ipod_streamer_real_get_volume;
	iface->enable_equalizer = (void (*) (MusicPlayback*)) music_plugins_ipod_streamer_real_enable_equalizer;
	iface->disable_equalizer = (void (*) (MusicPlayback*)) music_plugins_ipod_streamer_real_disable_equalizer;
	iface->set_equalizer_gain = (void (*) (MusicPlayback*, gint, gint)) music_plugins_ipod_streamer_real_set_equalizer_gain;
}

static void
music_plugins_ipod_streamer_instance_init (MusicPluginsiPodStreamer * self,
                                           gpointer klass)
{
	self->priv = music_plugins_ipod_streamer_get_instance_private (self);
}

static void
music_plugins_ipod_streamer_finalize (GObject * obj)
{
	MusicPluginsiPodStreamer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_PLUGINS_TYPE_IPOD_STREAMER, MusicPluginsiPodStreamer);
	_g_object_unref0 (self->cdda);
	_g_object_unref0 (self->priv->pipe);
	_g_object_unref0 (self->priv->dialog);
	_g_object_unref0 (self->priv->dm);
	G_OBJECT_CLASS (music_plugins_ipod_streamer_parent_class)->finalize (obj);
}

GType
music_plugins_ipod_streamer_get_type (void)
{
	return music_plugins_ipod_streamer_type_id;
}

GType
music_plugins_ipod_streamer_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicPluginsiPodStreamerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_plugins_ipod_streamer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicPluginsiPodStreamer), 0, (GInstanceInitFunc) music_plugins_ipod_streamer_instance_init, NULL };
	static const GInterfaceInfo music_playback_info = { (GInterfaceInitFunc) music_plugins_ipod_streamer_music_playback_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	music_plugins_ipod_streamer_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "MusicPluginsiPodStreamer", &g_define_type_info, 0);
	g_type_module_add_interface (module, music_plugins_ipod_streamer_type_id, MUSIC_TYPE_PLAYBACK, &music_playback_info);
	MusicPluginsiPodStreamer_private_offset = sizeof (MusicPluginsiPodStreamerPrivate);
	return music_plugins_ipod_streamer_type_id;
}

